'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var PropTypes = _interopDefault(require('prop-types'));
var styled = require('styled-components');
var styled__default = _interopDefault(styled);
var React = require('react');
var React__default = _interopDefault(React);

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

var slicedToArray = function () {
  function sliceIterator(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"]) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  return function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if (Symbol.iterator in Object(arr)) {
      return sliceIterator(arr, i);
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };
}();

var taggedTemplateLiteral = function (strings, raw) {
  return Object.freeze(Object.defineProperties(strings, {
    raw: {
      value: Object.freeze(raw)
    }
  }));
};

var toConsumableArray = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
};

var _templateObject = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2 = taggedTemplateLiteral(['\n    display: block;\n    box-shadow: ', ';\n    border-radius: ', ';\n  '], ['\n    display: block;\n    box-shadow: ', ';\n    border-radius: ', ';\n  ']),
    _templateObject3 = taggedTemplateLiteral(['\n    font-family: ', ';\n    font-weight: ', ';\n    background: ', ';\n    color: ', ';\n\n    display: flex;\n    flex-direction: column;\n\n    & > header {\n      position: relative;\n      padding: ', ';\n      border-bottom-width: ', ';\n      border-bottom-style: ', ';\n      border-bottom-color: ', ';\n      color: ', ';\n\n      font-family: ', ';\n      font-size: ', ';\n      font-weight: ', ';\n\n      display: flex;\n      align-items: center;\n      cursor: pointer;\n\n      &:focus {\n        outline: 0;\n      }\n\n      i {\n        position: absolute;\n        ', '\n      }\n    }\n\n    &.disabled > header {\n      color: ', ';\n      cursor: default;\n    }\n\n    &:first-child {\n      border-top-left-radius: ', ';\n      border-top-right-radius: ', ';\n    }\n    &:last-child {\n      border-bottom-left-radius: ', ';\n      border-bottom-right-radius: ', ';\n\n      &.collapsed > header {\n        border-bottom: none;\n      }\n    }\n    &:not(.collapsed) + & > header {\n      border-top-width: ', ';\n      border-top-style: ', ';\n      border-top-color: ', ';\n    }\n    .item-body {\n      flex: 1;\n      -ms-flex: 1 1 auto;\n      overflow: auto;\n      padding: ', ';\n      position: relative;\n    }\n    .collapsed {\n      overflow: hidden;\n      max-height: 0;\n      transition: all 0.5s cubic-bezier(0, 1, 0.3, 1) -100ms;\n    }\n    .expanded {\n      max-height: 1500px;\n      transition: all 0.5s cubic-bezier(1, 0.15, 1, 1);\n    }\n  '], ['\n    font-family: ', ';\n    font-weight: ', ';\n    background: ', ';\n    color: ', ';\n\n    display: flex;\n    flex-direction: column;\n\n    & > header {\n      position: relative;\n      padding: ', ';\n      border-bottom-width: ', ';\n      border-bottom-style: ', ';\n      border-bottom-color: ', ';\n      color: ', ';\n\n      font-family: ', ';\n      font-size: ', ';\n      font-weight: ', ';\n\n      display: flex;\n      align-items: center;\n      cursor: pointer;\n\n      &:focus {\n        outline: 0;\n      }\n\n      i {\n        position: absolute;\n        ', '\n      }\n    }\n\n    &.disabled > header {\n      color: ', ';\n      cursor: default;\n    }\n\n    &:first-child {\n      border-top-left-radius: ', ';\n      border-top-right-radius: ', ';\n    }\n    &:last-child {\n      border-bottom-left-radius: ', ';\n      border-bottom-right-radius: ', ';\n\n      &.collapsed > header {\n        border-bottom: none;\n      }\n    }\n    &:not(.collapsed) + & > header {\n      border-top-width: ', ';\n      border-top-style: ', ';\n      border-top-color: ', ';\n    }\n    .item-body {\n      flex: 1;\n      -ms-flex: 1 1 auto;\n      overflow: auto;\n      padding: ', ';\n      position: relative;\n    }\n    .collapsed {\n      overflow: hidden;\n      max-height: 0;\n      transition: all 0.5s cubic-bezier(0, 1, 0.3, 1) -100ms;\n    }\n    .expanded {\n      max-height: 1500px;\n      transition: all 0.5s cubic-bezier(1, 0.15, 1, 1);\n    }\n  ']);

var AccordionStyle = styled__default.div(_templateObject, function (_ref) {
  var theme = _ref.theme;
  return styled.css(_templateObject2, theme.accordionItemShadow, theme.accordionBorderRadius);
});

var ItemStyle = styled__default.div(_templateObject, function (_ref2) {
  var theme = _ref2.theme;
  return styled.css(_templateObject3, theme.accordionItemFontFamily, theme.accordionItemFontWeight, theme.accordionItemBg, theme.accordionItemFgText, theme.accordionPadding, theme.accordionHeaderBorderWidth, theme.accordionHeaderBorderType, theme.accordionHeaderBorderColor, theme.accordionHeaderFgHeading, theme.accordionHeaderFontFamily, theme.accordionHeaderFontSize, theme.accordionHeaderFontWeight, theme.dir === 'rtl' ? 'left: 1rem;' : 'right: 1rem;', theme.accordionHeaderDisabledFg, theme.accordionBorderRadius, theme.accordionBorderRadius, theme.accordionBorderRadius, theme.accordionBorderRadius, theme.accordionHeaderBorderWidth, theme.accordionHeaderBorderType, theme.accordionHeaderBorderColor, theme.cardPadding);
});

var _ref =
/*#__PURE__*/
React__default.createElement("path", {
  fill: "#99ABB4",
  fillRule: "evenodd",
  stroke: "#99ABB4",
  d: "M8 6.982L2.428 2l-.363.324 5.208 4.658L2 11.676l.363.324z"
});

var _ref$1 =
/*#__PURE__*/
React__default.createElement("path", {
  fill: "#99ABB4",
  fillRule: "evenodd",
  stroke: "#99ABB4",
  d: "M2 7.018L7.572 12l.363-.324-5.208-4.658L8 2.324 7.637 2z"
});

function _extends$3() {
  _extends$3 = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }return target;
  };return _extends$3.apply(this, arguments);
}

var _ref$2 =
/*#__PURE__*/
React__default.createElement("path", {
  fill: "#99ABB4",
  fillRule: "evenodd",
  stroke: "#99ABB4",
  d: "M6.982 2L2 7.572l.324.363 4.658-5.208L11.676 8 12 7.637z"
});

var SvgComponent$2 = function SvgComponent(props) {
  return React__default.createElement("svg", _extends$3({
    width: 14,
    height: 10
  }, props), _ref$2);
};

function _extends$4() {
  _extends$4 = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }return target;
  };return _extends$4.apply(this, arguments);
}

var _ref$3 =
/*#__PURE__*/
React__default.createElement("path", {
  fill: "#99ABB4",
  fillRule: "evenodd",
  stroke: "#99ABB4",
  d: "M7.018 8L12 2.428l-.324-.363-4.658 5.208L2.324 2 2 2.363z"
});

var SvgComponent$3 = function SvgComponent(props) {
  return React__default.createElement("svg", _extends$4({
    width: 14,
    height: 10
  }, props), _ref$3);
};

var _ref$4 =
/*#__PURE__*/
React__default.createElement("path", {
  fill: "#FFF",
  fillRule: "evenodd",
  d: "M12.979 13.651c-.145.22-.508.22-.653 0a.494.494 0 0 1 0-.734 5.058 5.058 0 0 0 1.305-1.761 5.32 5.32 0 0 0 .435-2.128c0-.955-.217-1.835-.652-2.57a4.747 4.747 0 0 0-1.885-1.908c-.218-.146-.29-.44-.145-.733.145-.22.435-.294.725-.147.87.587 1.667 1.32 2.175 2.275.508.954.798 1.982.798 3.083 0 .88-.218 1.761-.508 2.568a5.431 5.431 0 0 1-1.595 2.055zM8.919 0c2.465 0 4.64 1.028 6.308 2.642a9.1 9.1 0 0 1 2.61 6.386c0 2.201-.87 4.256-2.175 5.871L16.822 16l.217-.294c.363-.293.725-.44 1.16-.44.363 0 .798.147 1.088.44l4.278 4.257c.29.367.435.734.435 1.175 0 .367-.145.807-.435 1.1L22.26 23.56c-.29.293-.653.44-1.088.44-.435 0-.797-.147-1.087-.44l-4.278-4.257c-.29-.367-.435-.734-.435-1.175 0-.367.145-.807.435-1.1l.29-.294-1.16-1.101a8.76 8.76 0 0 1-6.019 2.422 8.88 8.88 0 0 1-6.308-2.642C1.015 13.725 0 11.523 0 9.028a9.1 9.1 0 0 1 2.61-6.386A8.88 8.88 0 0 1 8.918 0zm5.583 3.376c-1.45-1.468-3.408-2.348-5.584-2.348-2.175 0-4.133.88-5.583 2.348a7.98 7.98 0 0 0-2.32 5.652 7.98 7.98 0 0 0 2.32 5.65c1.45 1.395 3.408 2.35 5.583 2.35 2.176 0 4.133-.955 5.584-2.35l.072-.146h.073c1.305-1.468 2.175-3.376 2.175-5.504 0-2.202-.943-4.184-2.32-5.652z"
});

var _ref$5 =
/*#__PURE__*/
React__default.createElement("g", {
  fillRule: "evenodd"
}, React__default.createElement("path", {
  d: "M12.78 11.95l5.039-5.058a.554.554 0 0 0 0-.78.548.548 0 0 0-.778 0l-5.038 5.057L6.965 6.11a.548.548 0 0 0-.778 0 .554.554 0 0 0 0 .781l5.038 5.057-5.048 5.068a.554.554 0 0 0 0 .78.548.548 0 0 0 .778 0L12 12.73l5.048 5.068a.548.548 0 0 0 .92-.248.553.553 0 0 0-.142-.533L12.78 11.95z"
}), React__default.createElement("path", {
  fillRule: "nonzero",
  d: "M20.42 3.502A11.874 11.874 0 0 0 5.384 2.016C.66 5.184-1.176 11.26.998 16.53c2.175 5.269 7.754 8.262 13.326 7.149 5.572-1.113 9.585-6.022 9.584-11.725a11.899 11.899 0 0 0-3.488-8.452zm-.778 16.125a10.778 10.778 0 0 1-13.648 1.348C1.707 18.098.04 12.582 2.014 7.8 3.988 3.018 9.052.301 14.11 1.311c5.057 1.01 8.7 5.467 8.7 10.643a10.8 10.8 0 0 1-3.167 7.673z"
}));

function ArrowUp$1() {
  return React__default.createElement(SvgComponent$2, null);
}

function ArrowDown$1() {
  return React__default.createElement(SvgComponent$3, null);
}

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

function AccordionItem() {}

AccordionItem.propTypes = {
  disabled: PropTypes.bool,
  expanded: PropTypes.bool
};

var Accordion = React.forwardRef(function (props, ref) {
  var _useState = React.useState([]),
      _useState2 = slicedToArray(_useState, 2),
      items = _useState2[0],
      setItems = _useState2[1];

  React.useEffect(function () {
    var children = React.Children.map(props.children, function (child) {
      return _extends({}, child.props);
    });
    setItems(children);
  }, [props.children]);

  React.useImperativeHandle(ref, function () {
    return {
      openAll: function openAll() {
        handleAllState(true);
      },
      closeAll: function closeAll() {
        handleAllState(false);
      },
      open: function open(index) {
        handleState(true, index);
      },
      close: function close(index) {
        handleState(false, index);
      },
      toggle: function toggle(index) {
        handleToggle(index);
      }
    };
  }, [items]);

  var handleAllState = function handleAllState(state) {
    var updateItems = [].concat(toConsumableArray(items));
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = updateItems[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var item = _step.value;

        item.expanded = state;
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    setItems(updateItems);
  };
  var handleState = function handleState(state, index) {
    var updateItems = [].concat(toConsumableArray(items));
    if (props.multi) {
      updateItems[index].expanded = state;
    } else {
      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = updateItems.keys()[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var i = _step2.value;

          updateItems[i].expanded = index === i ? state : state ? false : updateItems[i].expanded;
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }
    }
    setItems(updateItems);
  };
  var handleToggle = function handleToggle(index) {
    var updateItems = [].concat(toConsumableArray(items));
    if (props.multi) {
      updateItems[index].expanded = !updateItems[index].expanded;
    } else {
      var _iteratorNormalCompletion3 = true;
      var _didIteratorError3 = false;
      var _iteratorError3 = undefined;

      try {
        for (var _iterator3 = updateItems.keys()[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
          var i = _step3.value;

          updateItems[i].expanded = index === i ? !updateItems[i].expanded : false;
        }
      } catch (err) {
        _didIteratorError3 = true;
        _iteratorError3 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion3 && _iterator3.return) {
            _iterator3.return();
          }
        } finally {
          if (_didIteratorError3) {
            throw _iteratorError3;
          }
        }
      }
    }
    setItems(updateItems);
  };
  return React__default.createElement(
    AccordionStyle,
    { className: props.className, style: props.style },
    items.map(function (item, index) {
      var cssStyle = [];
      item.expanded ? cssStyle.push('expanded') : cssStyle.push('collapsed');
      item.disabled && cssStyle.push('disabled');
      return React__default.createElement(
        ItemStyle,
        { key: index, className: cssStyle.join(' ') },
        React__default.createElement(
          'header',
          { onClick: function onClick() {
              return handleToggle(index);
            } },
          item.title,
          !item.disabled && React__default.createElement(
            'i',
            null,
            item.expanded ? React__default.createElement(ArrowUp$1, null) : React__default.createElement(ArrowDown$1, null)
          )
        ),
        React__default.createElement(
          'div',
          { className: item.expanded ? 'expanded' : 'collapsed' },
          React__default.createElement(
            'div',
            { className: 'item-body' },
            item.children
          )
        )
      );
    })
  );
});
Accordion.propTypes = {
  multi: PropTypes.bool,
  classNames: PropTypes.string,
  style: PropTypes.object
};

exports.AccordionItem = AccordionItem;
exports.Accordion = Accordion;
