'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var PropTypes = _interopDefault(require('prop-types'));
var React = _interopDefault(require('react'));
var styled = require('styled-components');
var styled__default = _interopDefault(styled);

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

var taggedTemplateLiteral = function (strings, raw) {
  return Object.freeze(Object.defineProperties(strings, {
    raw: {
      value: Object.freeze(raw)
    }
  }));
};

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

var badge = PropTypes.shape({
  status: colorState,
  title: PropTypes.string,
  position: position
});
var position = PropTypes.oneOf(['topRight', 'topLeft', 'bottomRight', 'bottomLeft', 'topStart', 'topEnd', 'bottomStart', 'bottomEnd']);

var colorState = PropTypes.oneOf(['Info', 'Success', 'Danger', 'Primary', 'Warning', 'Disabled']);

var placement = PropTypes.oneOf(['start', 'end', 'right', 'left', 'top', 'bottom']);

var trigger = PropTypes.oneOf(['click', 'hover', 'focus']);

var statusArray = ['Info', 'Success', 'Danger', 'Primary', 'Warning'];

var size = PropTypes.oneOf(['XXS', 'XS', 'SM', 'MD', 'LG', 'XL', 'XXL']);

var shape = PropTypes.oneOf(['Rectangle', 'SemiRound', 'Round']);

var itemType = {
  title: PropTypes.string.isRequired,
  link: PropTypes.any,
  expanded: PropTypes.bool,
  group: PropTypes.bool,
  hidden: PropTypes.bool,
  icon: PropTypes.string,
  target: PropTypes.string,
  url: PropTypes.string
};

var buttonTypes = {
  fullWidth: PropTypes.bool,
  hero: PropTypes.bool,
  outline: PropTypes.bool,
  pulse: PropTypes.bool,
  size: PropTypes.oneOf(['XS', 'SM', 'MD', 'LG']),
  shape: shape,
  status: PropTypes.oneOf([].concat(statusArray, ['Secondary']))
};

var _templateObject = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2 = taggedTemplateLiteral(['\n    font-size: ', ';\n    font-family: ', ';\n    line-height: ', ';\n    display: flex;\n    align-items: center;\n  '], ['\n    font-size: ', ';\n    font-family: ', ';\n    line-height: ', ';\n    display: flex;\n    align-items: center;\n  ']),
    _templateObject3 = taggedTemplateLiteral(['\n      padding: 0 ', ';\n      display: flex;\n      flex-wrap: wrap;\n      align-items: center;\n      position: relative;\n      ', '\n\n      &:first-child {\n        ', '\n      }\n\n      a.icon-container {\n        &:hover,\n        &:focus {\n          text-decoration: none;\n        }\n      }\n\n      i.control-icon {\n        &:hover {\n          cursor: pointer;\n        }\n        color: ', ';\n      }\n\n      ', '\n\n        ', '\n        ', '\n        \n      border-', ': 1px solid \n      ', ';\n      background: transparent;\n'], ['\n      padding: 0 ', ';\n      display: flex;\n      flex-wrap: wrap;\n      align-items: center;\n      position: relative;\n      ', '\n\n      &:first-child {\n        ', '\n      }\n\n      a.icon-container {\n        &:hover,\n        &:focus {\n          text-decoration: none;\n        }\n      }\n\n      i.control-icon {\n        &:hover {\n          cursor: pointer;\n        }\n        color: ', ';\n      }\n\n      ', '\n\n        ', '\n        ', '\n        \n      border-', ': 1px solid \n      ', ';\n      background: transparent;\n']),
    _templateObject4 = taggedTemplateLiteral(['\n          justify-content: center;\n          width: 100%;\n        '], ['\n          justify-content: center;\n          width: 100%;\n        ']),
    _templateObject5 = taggedTemplateLiteral(['\n          height: ', ';\n          i.control-icon {\n            font-size: ', ';\n          }\n        '], ['\n          height: ', ';\n          i.control-icon {\n            font-size: ', ';\n          }\n        ']),
    _templateObject6 = taggedTemplateLiteral(['\n            & > * {\n              opacity: 0.5;\n            }\n            cursor: not-allowed;\n\n            a,\n            i {\n              cursor: not-allowed !important;\n            }\n          '], ['\n            & > * {\n              opacity: 0.5;\n            }\n            cursor: not-allowed;\n\n            a,\n            i {\n              cursor: not-allowed !important;\n            }\n          ']),
    _templateObject7 = taggedTemplateLiteral(['\n            i.control-icon {\n              color: ', ';\n            }\n\n            border-', ': 1px solid \n            ', ';\n          '], ['\n            i.control-icon {\n              color: ', ';\n            }\n\n            border-', ': 1px solid \n            ', ';\n          ']);

/* eslint-disable indent */

var ActionsStyle = styled__default.div(_templateObject, function (_ref) {
  var theme = _ref.theme;
  return styled.css(_templateObject2, theme.actionsFontSize, theme.actionsFontFamily, theme.actionsLineHeight);
});

var ActionStyle = styled__default.div(_templateObject, function (_ref2) {
  var theme = _ref2.theme,
      fullWidth = _ref2.fullWidth,
      disabled = _ref2.disabled,
      size = _ref2.size,
      inverse = _ref2.inverse;
  return styled.css(_templateObject3, theme.actionsPadding, fullWidth && styled.css(_templateObject4), theme.dir === 'rtl' ? 'border-right: none !important;' : 'border-left: none !important;', theme.actionsFg, size && styled.css(_templateObject5, theme['actionsSize' + size], theme['actionsSize' + size]), disabled && styled.css(_templateObject6), inverse && styled.css(_templateObject7, theme.actionsBg, theme.dir === 'rtl' ? 'right' : 'left', theme.actionsSeparator), theme.dir === 'rtl' ? 'right' : 'left', theme.actionsSeparator);
});

function getPhysicalPosition(dir, position) {
  if (position1.includes(position) || position3.includes(position)) {
    return position;
  }
  switch (position) {
    case 'start':
      return dir === 'rtl' ? 'right' : 'left';
    case 'end':
      return dir === 'rtl' ? 'left' : 'right';
    case 'topStart':
      return dir === 'rtl' ? 'topRight' : 'topLeft';
    case 'topEnd':
      return dir === 'rtl' ? 'topLeft' : 'topRight';
    case 'bottomStart':
      return dir === 'rtl' ? 'bottomRight' : 'bottomLeft';
    case 'bottomEnd':
      return dir === 'rtl' ? 'bottomLeft' : 'bottomRight';
  }
  return position;
}

var position1 = ['left', 'right', 'top', 'bottom'];
var position3 = ['topRight', 'topLeft', 'bottomRight', 'bottomLeft'];

var _templateObject$1 = taggedTemplateLiteral(['\n  ', '\n  ', '\n'], ['\n  ', '\n  ', '\n']),
    _templateObject2$1 = taggedTemplateLiteral(['\n    color: ', ';\n    position: absolute;\n    padding: 0.25em 0.4em;\n    font-size: 75%;\n    font-weight: 700;\n    line-height: 1;\n    text-align: center;\n    white-space: nowrap;\n    vertical-align: baseline;\n    border-radius: 0.25rem;\n    background-color: ', ';\n  '], ['\n    color: ', ';\n    position: absolute;\n    padding: 0.25em 0.4em;\n    font-size: 75%;\n    font-weight: 700;\n    line-height: 1;\n    text-align: center;\n    white-space: nowrap;\n    vertical-align: baseline;\n    border-radius: 0.25rem;\n    background-color: ', ';\n  ']);

var Badge = styled__default.span(_templateObject$1, function (_ref) {
  var theme = _ref.theme,
      status = _ref.status;
  return styled.css(_templateObject2$1, theme.badgeFgText, theme['badge' + status + 'BgColor']);
}, function (_ref2) {
  var position$$1 = _ref2.position,
      theme = _ref2.theme;

  var placement$$1 = getPhysicalPosition(theme.dir, position$$1);
  switch (placement$$1) {
    case 'topRight':
      return 'top: 0;right: 0;';
    case 'topLeft':
      return 'top: 0;left: 0;';
    case 'bottomRight':
      return 'bottom: 0;right: 0;';
    case 'bottomLeft':
      return 'bottom: 0;left: 0;';
  }
});
Badge.propTypes = {
  position: position,
  status: colorState
};

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

function Actions(_ref) {
  var actions = _ref.actions,
      className = _ref.className,
      style = _ref.style,
      fullWidth = _ref.fullWidth,
      size$$1 = _ref.size,
      inverse = _ref.inverse,
      Link = _ref.Link;

  return React.createElement(
    ActionsStyle,
    { className: className, style: style },
    actions.map(function (action, index) {
      return React.createElement(
        ActionStyle,
        {
          key: index,
          fullWidth: fullWidth,
          size: size$$1,
          inverse: inverse,
          disabled: action.disabled
        },
        action.icon ? action.link ? React.createElement(
          Link,
          _extends({}, action.link, {
            className: 'icon-container'
          }, action.events),
          React.createElement('i', { className: 'control-icon ' + action.icon })
        ) : React.createElement(
          'a',
          _extends({ className: 'icon-container' }, action.events),
          React.createElement('i', { className: 'control-icon ' + action.icon })
        ) : action.content,
        action.badge && React.createElement(
          Badge,
          {
            status: action.badge.status,
            position: action.badge.position
          },
          action.badge.title
        )
      );
    })
  );
}

Actions.propTypes = {
  classNames: PropTypes.string,
  style: PropTypes.object,
  fullWidth: PropTypes.bool,
  size: PropTypes.oneOf(['SM', 'MD', 'LG']),
  inverse: PropTypes.bool,
  actions: PropTypes.arrayOf(PropTypes.shape({
    icon: PropTypes.string,
    content: PropTypes.any,
    disabled: PropTypes.bool,
    badge: badge
  })).isRequired
};

module.exports = Actions;
