'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var styled = require('styled-components');
var styled__default = _interopDefault(styled);
var PropTypes = _interopDefault(require('prop-types'));
var React = require('react');
var React__default = _interopDefault(React);

var slicedToArray = function () {
  function sliceIterator(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"]) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  return function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if (Symbol.iterator in Object(arr)) {
      return sliceIterator(arr, i);
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };
}();

var taggedTemplateLiteral = function (strings, raw) {
  return Object.freeze(Object.defineProperties(strings, {
    raw: {
      value: Object.freeze(raw)
    }
  }));
};

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

var badge = PropTypes.shape({
  status: colorState,
  title: PropTypes.string,
  position: position
});
var position = PropTypes.oneOf(['topRight', 'topLeft', 'bottomRight', 'bottomLeft', 'topStart', 'topEnd', 'bottomStart', 'bottomEnd']);

var colorState = PropTypes.oneOf(['Info', 'Success', 'Danger', 'Primary', 'Warning', 'Disabled']);

var placement = PropTypes.oneOf(['start', 'end', 'right', 'left', 'top', 'bottom']);

var trigger = PropTypes.oneOf(['click', 'hover', 'focus']);

var statusArray = ['Info', 'Success', 'Danger', 'Primary', 'Warning'];

var size = PropTypes.oneOf(['XXS', 'XS', 'SM', 'MD', 'LG', 'XL', 'XXL']);

var shape = PropTypes.oneOf(['Rectangle', 'SemiRound', 'Round']);

var itemType = {
  title: PropTypes.string.isRequired,
  link: PropTypes.any,
  expanded: PropTypes.bool,
  group: PropTypes.bool,
  hidden: PropTypes.bool,
  icon: PropTypes.string,
  target: PropTypes.string,
  url: PropTypes.string
};

var buttonTypes = {
  fullWidth: PropTypes.bool,
  hero: PropTypes.bool,
  outline: PropTypes.bool,
  pulse: PropTypes.bool,
  size: PropTypes.oneOf(['XS', 'SM', 'MD', 'LG']),
  shape: shape,
  status: PropTypes.oneOf([].concat(statusArray, ['Secondary']))
};

var _templateObject = taggedTemplateLiteral(['\n  ', ';\n  ', ';\n'], ['\n  ', ';\n  ', ';\n']),
    _templateObject2 = taggedTemplateLiteral(['\n        background-color: ', ';\n        border-bottom-width: ', ';\n        border-bottom-style: ', ';\n        border-bottom-color: ', ';\n        border-top-left-radius: ', ';\n        border-top-right-radius: ', ';\n      '], ['\n        background-color: ', ';\n        border-bottom-width: ', ';\n        border-bottom-style: ', ';\n        border-bottom-color: ', ';\n        border-top-left-radius: ', ';\n        border-top-right-radius: ', ';\n      ']),
    _templateObject3 = taggedTemplateLiteral(['\n        border-bottom-width: ', ';\n        border-bottom-style: ', ';\n        border-bottom-color: ', ';\n      '], ['\n        border-bottom-width: ', ';\n        border-bottom-style: ', ';\n        border-bottom-color: ', ';\n      ']),
    _templateObject4 = taggedTemplateLiteral(['\n  ', ';\n'], ['\n  ', ';\n']),
    _templateObject5 = taggedTemplateLiteral(['\n    display: flex;\n    flex-direction: column;\n    line-height: ', ';\n    font-weight: ', ';\n    font-size: ', ';\n    color: ', ';\n    background: ', ';\n    box-shadow: ', ';\n    border-radius: ', ';\n    margin-bottom: ', ';\n    border-width: ', ';\n    border-style: ', ';\n    border-color: ', ';\n    ', '\n    ', '\n    & > header {\n      font-family: ', ';\n      font-size: ', ';\n      font-weight: ', ';\n      color: ', ';\n      padding: ', ';\n      ', '\n    }\n    .card-body {\n      padding: ', ';\n      overflow: auto;\n      flex: 1;\n      position: relative;\n    }\n    & > footer {\n      padding: ', ';\n      border-top: 1px solid ', ';\n      border-bottom-left-radius: ', ';\n      border-bottom-right-radius: ', ';\n    }\n  '], ['\n    display: flex;\n    flex-direction: column;\n    line-height: ', ';\n    font-weight: ', ';\n    font-size: ', ';\n    color: ', ';\n    background: ', ';\n    box-shadow: ', ';\n    border-radius: ', ';\n    margin-bottom: ', ';\n    border-width: ', ';\n    border-style: ', ';\n    border-color: ', ';\n    ', '\n    ', '\n    & > header {\n      font-family: ', ';\n      font-size: ', ';\n      font-weight: ', ';\n      color: ', ';\n      padding: ', ';\n      ', '\n    }\n    .card-body {\n      padding: ', ';\n      overflow: auto;\n      flex: 1;\n      position: relative;\n    }\n    & > footer {\n      padding: ', ';\n      border-top: 1px solid ', ';\n      border-bottom-left-radius: ', ';\n      border-bottom-right-radius: ', ';\n    }\n  ']);

var headerBg = styled.css(_templateObject, function (_ref) {
  var theme = _ref.theme,
      status = _ref.status;

  if (status) {
    return styled.css(_templateObject2, theme['cardHeader' + status + 'Bg'], theme.cardHeaderBorderWidth, theme.cardHeaderBorderType, theme['cardHeader' + status + 'Bg'], theme.cardBorderRadius, theme.cardBorderRadius);
  } else {
    return styled.css(_templateObject3, theme.cardHeaderBorderWidth, theme.cardHeaderBorderType, theme.cardHeaderBorderColor);
  }
}, function (_ref2) {
  var accent = _ref2.accent;
  return accent ? 'border-radius: 0' : '';
});

var accent = styled.css(_templateObject4, function (_ref3) {
  var theme = _ref3.theme,
      accent = _ref3.accent;
  return accent ? '\n      border-top:\n      ' + theme.cardBorderRadius + ' \n      solid\n      ' + theme['cardHeader' + accent + 'Bg'] + ';\n      ' : '';
});
var height = styled.css(_templateObject4, function (_ref4) {
  var theme = _ref4.theme,
      size$$1 = _ref4.size;
  return size$$1 ? '\n      height: ' + theme['cardHeight' + size$$1.toUpperCase()] + ';\n      ' : '';
});
var Card = styled__default.div(_templateObject4, function (_ref5) {
  var theme = _ref5.theme;
  return styled.css(_templateObject5, theme.cardLineHeight, theme.cardFontWeight, theme.cardFontSize, theme.cardFgText, theme.cardBg, theme.cardShadow, theme.cardBorderRadius, theme.cardMargin, theme.cardBorderWidth, theme.cardBorderType, theme.cardBorderColor, accent, height, theme.cardHeaderFontFamily, theme.cardHeaderFontSize, theme.cardHeaderFontWeight, theme.cardHeaderFgHeading, theme.cardPadding, headerBg, theme.cardPadding, theme.cardPadding, theme.cardSeparator, theme.cardBorderRadius, theme.cardBorderRadius);
});
Card.propTypes = {
  status: colorState,
  accent: colorState,
  size: size
};

function _extends$1() {
  _extends$1 = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }return target;
  };return _extends$1.apply(this, arguments);
}

var _ref =
/*#__PURE__*/
React__default.createElement("path", {
  fill: "#99ABB4",
  fillRule: "evenodd",
  stroke: "#99ABB4",
  d: "M8 6.982L2.428 2l-.363.324 5.208 4.658L2 11.676l.363.324z"
});

var SvgComponent = function SvgComponent(props) {
  return React__default.createElement("svg", _extends$1({
    width: 10,
    height: 14
  }, props), _ref);
};

function _extends$2() {
  _extends$2 = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }return target;
  };return _extends$2.apply(this, arguments);
}

var _ref$1 =
/*#__PURE__*/
React__default.createElement("path", {
  fill: "#99ABB4",
  fillRule: "evenodd",
  stroke: "#99ABB4",
  d: "M2 7.018L7.572 12l.363-.324-5.208-4.658L8 2.324 7.637 2z"
});

var SvgComponent$1 = function SvgComponent(props) {
  return React__default.createElement("svg", _extends$2({
    width: 10,
    height: 14
  }, props), _ref$1);
};

function _extends$3() {
  _extends$3 = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }return target;
  };return _extends$3.apply(this, arguments);
}

var _ref$2 =
/*#__PURE__*/
React__default.createElement("path", {
  fill: "#99ABB4",
  fillRule: "evenodd",
  stroke: "#99ABB4",
  d: "M6.982 2L2 7.572l.324.363 4.658-5.208L11.676 8 12 7.637z"
});

var SvgComponent$2 = function SvgComponent(props) {
  return React__default.createElement("svg", _extends$3({
    width: 14,
    height: 10
  }, props), _ref$2);
};

function _extends$4() {
  _extends$4 = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }return target;
  };return _extends$4.apply(this, arguments);
}

var _ref$3 =
/*#__PURE__*/
React__default.createElement("path", {
  fill: "#99ABB4",
  fillRule: "evenodd",
  stroke: "#99ABB4",
  d: "M7.018 8L12 2.428l-.324-.363-4.658 5.208L2.324 2 2 2.363z"
});

var SvgComponent$3 = function SvgComponent(props) {
  return React__default.createElement("svg", _extends$4({
    width: 14,
    height: 10
  }, props), _ref$3);
};

var _ref$4 =
/*#__PURE__*/
React__default.createElement("path", {
  fill: "#FFF",
  fillRule: "evenodd",
  d: "M12.979 13.651c-.145.22-.508.22-.653 0a.494.494 0 0 1 0-.734 5.058 5.058 0 0 0 1.305-1.761 5.32 5.32 0 0 0 .435-2.128c0-.955-.217-1.835-.652-2.57a4.747 4.747 0 0 0-1.885-1.908c-.218-.146-.29-.44-.145-.733.145-.22.435-.294.725-.147.87.587 1.667 1.32 2.175 2.275.508.954.798 1.982.798 3.083 0 .88-.218 1.761-.508 2.568a5.431 5.431 0 0 1-1.595 2.055zM8.919 0c2.465 0 4.64 1.028 6.308 2.642a9.1 9.1 0 0 1 2.61 6.386c0 2.201-.87 4.256-2.175 5.871L16.822 16l.217-.294c.363-.293.725-.44 1.16-.44.363 0 .798.147 1.088.44l4.278 4.257c.29.367.435.734.435 1.175 0 .367-.145.807-.435 1.1L22.26 23.56c-.29.293-.653.44-1.088.44-.435 0-.797-.147-1.087-.44l-4.278-4.257c-.29-.367-.435-.734-.435-1.175 0-.367.145-.807.435-1.1l.29-.294-1.16-1.101a8.76 8.76 0 0 1-6.019 2.422 8.88 8.88 0 0 1-6.308-2.642C1.015 13.725 0 11.523 0 9.028a9.1 9.1 0 0 1 2.61-6.386A8.88 8.88 0 0 1 8.918 0zm5.583 3.376c-1.45-1.468-3.408-2.348-5.584-2.348-2.175 0-4.133.88-5.583 2.348a7.98 7.98 0 0 0-2.32 5.652 7.98 7.98 0 0 0 2.32 5.65c1.45 1.395 3.408 2.35 5.583 2.35 2.176 0 4.133-.955 5.584-2.35l.072-.146h.073c1.305-1.468 2.175-3.376 2.175-5.504 0-2.202-.943-4.184-2.32-5.652z"
});

var _ref$5 =
/*#__PURE__*/
React__default.createElement("g", {
  fillRule: "evenodd"
}, React__default.createElement("path", {
  d: "M12.78 11.95l5.039-5.058a.554.554 0 0 0 0-.78.548.548 0 0 0-.778 0l-5.038 5.057L6.965 6.11a.548.548 0 0 0-.778 0 .554.554 0 0 0 0 .781l5.038 5.057-5.048 5.068a.554.554 0 0 0 0 .78.548.548 0 0 0 .778 0L12 12.73l5.048 5.068a.548.548 0 0 0 .92-.248.553.553 0 0 0-.142-.533L12.78 11.95z"
}), React__default.createElement("path", {
  fillRule: "nonzero",
  d: "M20.42 3.502A11.874 11.874 0 0 0 5.384 2.016C.66 5.184-1.176 11.26.998 16.53c2.175 5.269 7.754 8.262 13.326 7.149 5.572-1.113 9.585-6.022 9.584-11.725a11.899 11.899 0 0 0-3.488-8.452zm-.778 16.125a10.778 10.778 0 0 1-13.648 1.348C1.707 18.098.04 12.582 2.014 7.8 3.988 3.018 9.052.301 14.11 1.311c5.057 1.01 8.7 5.467 8.7 10.643a10.8 10.8 0 0 1-3.167 7.673z"
}));

function ArrowRight$1() {
  return React__default.createElement(SvgComponent, null);
}

function ArrowUp$1() {
  return React__default.createElement(SvgComponent$2, null);
}

function ArrowDown$1() {
  return React__default.createElement(SvgComponent$3, null);
}

function ArrowLeft$1() {
  return React__default.createElement(SvgComponent$1, null);
}

var _templateObject$1 = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$1 = taggedTemplateLiteral(['\n    display: block;\n    position: relative;\n    perspective: 1200px;\n    .flip-body {\n      display: flex;\n      transition: transform 0.5s;\n      transform-style: preserve-3d;\n      ', '\n      & > .front,\n      & > .back {\n        flex: 1;\n\n        .flip-button {\n          line-height: ', ';\n          margin-bottom: ', ';\n          padding: ', ';\n          cursor: pointer;\n          position: absolute;\n          ', '\n          ', '\n          opacity: 1;\n          transition: opacity 0s 0.15s;\n        }\n      }\n\n      & > .front {\n        ', '\n        transition: opacity 0s 0.2s;\n        backface-visibility: visible;\n        ', '\n      }\n\n      & > .back {\n        backface-visibility: ', ';\n        transform: rotateY(180deg);\n      }\n    }\n  '], ['\n    display: block;\n    position: relative;\n    perspective: 1200px;\n    .flip-body {\n      display: flex;\n      transition: transform 0.5s;\n      transform-style: preserve-3d;\n      ', '\n      & > .front,\n      & > .back {\n        flex: 1;\n\n        .flip-button {\n          line-height: ', ';\n          margin-bottom: ', ';\n          padding: ', ';\n          cursor: pointer;\n          position: absolute;\n          ', '\n          ', '\n          opacity: 1;\n          transition: opacity 0s 0.15s;\n        }\n      }\n\n      & > .front {\n        ', '\n        transition: opacity 0s 0.2s;\n        backface-visibility: visible;\n        ', '\n      }\n\n      & > .back {\n        backface-visibility: ', ';\n        transform: rotateY(180deg);\n      }\n    }\n  ']),
    _templateObject3$1 = taggedTemplateLiteral(['\n            backface-visibility: hidden;\n            opacity: 0;\n            .flip-button {\n              opacity: 0;\n              z-index: -1;\n            }\n          '], ['\n            backface-visibility: hidden;\n            opacity: 0;\n            .flip-button {\n              opacity: 0;\n              z-index: -1;\n            }\n          ']);

var FlipCardStyled = styled__default.div(_templateObject$1, function (_ref) {
  var theme = _ref.theme,
      flipped = _ref.flipped,
      button = _ref.button;
  return styled.css(_templateObject2$1, flipped ? 'transform: rotateY(-180deg);' : '', theme.cardLineHeight, theme.cardMargin, theme.cardPadding, theme.dir === 'ltr' ? 'right: 0;' : 'left: 0;', button === 'bottom' ? 'bottom: 0;' : 'top: 0;', theme.dir === 'ltr' ? 'margin-right: -100%;' : 'margin-left: -100%;', flipped && styled.css(_templateObject3$1), flipped ? 'visible' : 'hidden');
});
function FlipCard(props) {
  var _useState = React.useState(false),
      _useState2 = slicedToArray(_useState, 2),
      flipped = _useState2[0],
      setFlipped = _useState2[1];

  var handleFlipped = function handleFlipped() {
    setFlipped(!flipped);
  };

  return React__default.createElement(
    FlipCardStyled,
    {
      className: props.className,
      style: props.style,
      flipped: flipped,
      button: props.button
    },
    React__default.createElement(
      'div',
      { className: 'flip-body' },
      React__default.createElement(
        'div',
        { className: 'front' },
        props.children[0],
        React__default.createElement(
          'i',
          { className: 'flip-button', onClick: handleFlipped },
          React__default.createElement(ArrowRight$1, null)
        )
      ),
      React__default.createElement(
        'div',
        { className: 'back' },
        props.children[1],
        React__default.createElement(
          'i',
          { className: 'flip-button', onClick: handleFlipped },
          React__default.createElement(ArrowLeft$1, null)
        )
      )
    )
  );
}
FlipCard.propTypes = {
  classNames: PropTypes.string,
  style: PropTypes.object,
  button: PropTypes.oneOf(['top', 'bottom'])
};

var _templateObject$2 = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$2 = taggedTemplateLiteral(['\n    display: block;\n    position: relative;\n    overflow: hidden;\n    & > .front {\n      display: block;\n      height: 100%;\n    }\n\n    & > .back {\n      position: absolute;\n      top: ', ';\n      right: 0;\n      left: 0;\n      overflow: hidden;\n      transition: ', ';\n      height: calc(100% - ', ');\n      .container {\n        position: absolute;\n        left: 0;\n        top: ', ';\n        width: 100%;\n        transition: top 0.5s;\n      }\n    }\n    .reveal-button {\n      cursor: pointer;\n      position: absolute;\n      transition: transform 0.3s;\n      line-height: ', ';\n      margin-bottom: ', ';\n      padding: ', ';\n      ', ';\n      ', ';\n    }\n  '], ['\n    display: block;\n    position: relative;\n    overflow: hidden;\n    & > .front {\n      display: block;\n      height: 100%;\n    }\n\n    & > .back {\n      position: absolute;\n      top: ', ';\n      right: 0;\n      left: 0;\n      overflow: hidden;\n      transition: ', ';\n      height: calc(100% - ', ');\n      .container {\n        position: absolute;\n        left: 0;\n        top: ', ';\n        width: 100%;\n        transition: top 0.5s;\n      }\n    }\n    .reveal-button {\n      cursor: pointer;\n      position: absolute;\n      transition: transform 0.3s;\n      line-height: ', ';\n      margin-bottom: ', ';\n      padding: ', ';\n      ', ';\n      ', ';\n    }\n  ']);

var RevealCardStyled = styled__default.div(_templateObject$2, function (_ref) {
  var theme = _ref.theme,
      button = _ref.button,
      revealed = _ref.revealed;
  return styled.css(_templateObject2$2, revealed ? '0' : '100%', revealed ? 'none' : 'top 0s 0.5s', theme.cardMargin, revealed ? '0' : '100%', theme.cardLineHeight, theme.cardMargin, theme.cardPadding, theme.dir === 'ltr' ? 'right: 0;' : 'left: 0;', button === 'bottom' ? 'bottom: 0;' : 'top: 0;');
});
function RevealCard(props) {
  var _useState = React.useState(false),
      _useState2 = slicedToArray(_useState, 2),
      revealed = _useState2[0],
      setRevealed = _useState2[1];

  var handleRevealed = function handleRevealed() {
    setRevealed(!revealed);
  };
  return React__default.createElement(
    RevealCardStyled,
    {
      className: props.className,
      style: props.style,
      revealed: revealed,
      button: props.button
    },
    React__default.createElement(
      'div',
      { className: 'front' },
      props.children[0]
    ),
    React__default.createElement(
      'div',
      { className: 'back' },
      React__default.createElement(
        'div',
        { className: 'container' },
        props.children[1]
      )
    ),
    React__default.createElement(
      'div',
      { className: 'reveal-button', onClick: handleRevealed },
      revealed ? React__default.createElement(ArrowDown$1, null) : React__default.createElement(ArrowUp$1, null)
    )
  );
}
RevealCard.propTypes = {
  classNames: PropTypes.string,
  style: PropTypes.object,
  button: PropTypes.oneOf(['top', 'bottom'])
};

exports.Card = Card;
exports.FlipCard = FlipCard;
exports.RevealCard = RevealCard;
