'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var styled = require('styled-components');
var styled__default = _interopDefault(styled);
var PropTypes = _interopDefault(require('prop-types'));
var React = require('react');
var React__default = _interopDefault(React);
var ReactDOM = _interopDefault(require('react-dom'));

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

var slicedToArray = function () {
  function sliceIterator(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"]) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  return function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if (Symbol.iterator in Object(arr)) {
      return sliceIterator(arr, i);
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };
}();

var taggedTemplateLiteral = function (strings, raw) {
  return Object.freeze(Object.defineProperties(strings, {
    raw: {
      value: Object.freeze(raw)
    }
  }));
};

var toConsumableArray = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
};

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

var badge = PropTypes.shape({
  status: colorState,
  title: PropTypes.string,
  position: position
});
var position = PropTypes.oneOf(['topRight', 'topLeft', 'bottomRight', 'bottomLeft', 'topStart', 'topEnd', 'bottomStart', 'bottomEnd']);

var colorState = PropTypes.oneOf(['Info', 'Success', 'Danger', 'Primary', 'Warning', 'Disabled']);

var placement = PropTypes.oneOf(['start', 'end', 'right', 'left', 'top', 'bottom']);

var trigger = PropTypes.oneOf(['click', 'hover', 'focus']);

var statusArray = ['Info', 'Success', 'Danger', 'Primary', 'Warning'];

var size = PropTypes.oneOf(['XXS', 'XS', 'SM', 'MD', 'LG', 'XL', 'XXL']);

var shape = PropTypes.oneOf(['Rectangle', 'SemiRound', 'Round']);

var itemType = {
  title: PropTypes.string.isRequired,
  link: PropTypes.any,
  expanded: PropTypes.bool,
  group: PropTypes.bool,
  hidden: PropTypes.bool,
  icon: PropTypes.string,
  target: PropTypes.string,
  url: PropTypes.string
};

var buttonTypes = {
  fullWidth: PropTypes.bool,
  hero: PropTypes.bool,
  outline: PropTypes.bool,
  pulse: PropTypes.bool,
  size: PropTypes.oneOf(['XS', 'SM', 'MD', 'LG']),
  shape: shape,
  status: PropTypes.oneOf([].concat(statusArray, ['Secondary']))
};

var _templateObject = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2 = taggedTemplateLiteral(['\n      display: flex;\n      min-width: 0%;\n      position: relative;\n      margin-bottom: 1rem;\n      \n      .label {\n        background: ', ';\n        color: ', ';\n        ', '\n        top: 0;\n        transition: transform 150ms cubic-bezier(0.4, 0, 0.2, 1),\n          opacity 150ms cubic-bezier(0.4, 0, 0.2, 1);\n        z-index: 1;\n        transform-origin: top ', ';\n        pointer-events: none;\n        position: absolute;\n        line-height: 1.15;\n        padding: 0 5px;\n        font-size: ', ';\n        transform: translate(\n          ', '', ', \n          calc(', ' + ', ')\n        );\n      }\n\n      input,\n      textarea {\n        &:not([disabled]):focus ~ .label,\n        &[value]:not([value=""]) ~ .label{\n          transform: scale(.90) translate(\n            ', '', ', \n            -50%\n          );\n        }\n        &:not([disabled]):focus ~ .label{\n          color: ', ';\n        }\n        &[value]:not([value=""]) ~ .label{\n          ', ';\n        }\n      }\n\n      input,\n      textarea{\n        background-color: ', ';\n        border-width: ', ';\n        border-color: ', ';\n        border-style: ', ';\n        color: ', ';\n        ', '\n        \n        &:focus {\n          outline: none;\n          background-color: ', ';\n          ', '\n        }\n\n      \n        &[disabled] ~ .label {\n          opacity: 0.5;\n        }\n      \n        ', '\n        ', '\n        ', '\n      }\n    '], ['\n      display: flex;\n      min-width: 0%;\n      position: relative;\n      margin-bottom: 1rem;\n      \n      .label {\n        background: ', ';\n        color: ', ';\n        ', '\n        top: 0;\n        transition: transform 150ms cubic-bezier(0.4, 0, 0.2, 1),\n          opacity 150ms cubic-bezier(0.4, 0, 0.2, 1);\n        z-index: 1;\n        transform-origin: top ', ';\n        pointer-events: none;\n        position: absolute;\n        line-height: 1.15;\n        padding: 0 5px;\n        font-size: ', ';\n        transform: translate(\n          ', '', ', \n          calc(', ' + ', ')\n        );\n      }\n\n      input,\n      textarea {\n        &:not([disabled]):focus ~ .label,\n        &[value]:not([value=""]) ~ .label{\n          transform: scale(.90) translate(\n            ', '', ', \n            -50%\n          );\n        }\n        &:not([disabled]):focus ~ .label{\n          color: ', ';\n        }\n        &[value]:not([value=""]) ~ .label{\n          ', ';\n        }\n      }\n\n      input,\n      textarea{\n        background-color: ', ';\n        border-width: ', ';\n        border-color: ', ';\n        border-style: ', ';\n        color: ', ';\n        ', '\n        \n        &:focus {\n          outline: none;\n          background-color: ', ';\n          ', '\n        }\n\n      \n        &[disabled] ~ .label {\n          opacity: 0.5;\n        }\n      \n        ', '\n        ', '\n        ', '\n      }\n    ']),
    _templateObject3 = taggedTemplateLiteral(['\n            border-color: ', ';\n          '], ['\n            border-color: ', ';\n          ']),
    _templateObject4 = taggedTemplateLiteral(['\n            border-radius: ', ';\n          '], ['\n            border-radius: ', ';\n          ']),
    _templateObject5 = taggedTemplateLiteral(['\n            font-size: ', ';\n            padding: ', ';\n          '], ['\n            font-size: ', ';\n            padding: ', ';\n          ']);

/* eslint-disable indent */
var GroupStyle = styled__default.div(_templateObject, function (_ref) {
  var theme = _ref.theme,
      fieldSize = _ref.fieldSize,
      status = _ref.status,
      shape$$1 = _ref.shape,
      fullWidth = _ref.fullWidth;

  var padding = theme['formControlPadding' + fieldSize].split(' ');
  return styled.css(_templateObject2, theme.formControlBg, theme.formControlPlaceholderColor, theme.dir === 'rtl' ? 'right: 0;' : 'left: 0;', theme.dir === 'rtl' ? 'right' : 'left', theme['formControlFontSize' + fieldSize], theme.dir === 'rtl' && '-', padding[1], padding[0], theme.formControlBorderWidth, theme.dir === 'rtl' && '-', padding[1], status ? theme['formControl' + status + 'BorderColor'] : theme.formControlSelectedBorderColor, status && 'color: ' + theme['formControl' + status + 'BorderColor'], theme.formControlBg, theme.formControlBorderWidth, theme.formControlBorderColor, theme.formControlBorderType, theme.formControlTextPrimaryColor, fullWidth && 'width: 100%;', theme.formControlFocusBg, !status && 'border-color: ' + theme.formControlSelectedBorderColor + ';', status && styled.css(_templateObject3, theme['formControl' + status + 'BorderColor']), shape$$1 && styled.css(_templateObject4, theme['formControl' + shape$$1 + 'BorderRadius']), fieldSize && styled.css(_templateObject5, theme['formControlFontSize' + fieldSize], theme['formControlPadding' + fieldSize]));
});

function InputGroup(props) {
  return React__default.createElement(
    GroupStyle,
    props,
    props.children,
    React__default.createElement(
      'div',
      { className: 'label' },
      props.label
    )
  );
}

InputGroup.defaultProps = {
  fieldSize: 'MD',
  shape: 'Rectangle'
};
InputGroup.propTypes = {
  shape: shape,
  fullWidth: PropTypes.bool,
  fieldSize: PropTypes.oneOf(['SM', 'MD', 'LG']),
  status: PropTypes.oneOf(['Info', 'Warning', 'Success', 'Danger'])
};

function _extends$1() {
  _extends$1 = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends$1.apply(this, arguments);
}

function colorToInt(color) {
  return Math.round(color * 255);
}

function convertToInt(red, green, blue) {
  return colorToInt(red) + "," + colorToInt(green) + "," + colorToInt(blue);
}

function hslToRgb(hue, saturation, lightness, convert) {
  if (convert === void 0) {
    convert = convertToInt;
  }

  if (saturation === 0) {
    // achromatic
    return convert(lightness, lightness, lightness);
  } // formular from https://en.wikipedia.org/wiki/HSL_and_HSV


  var huePrime = hue % 360 / 60;
  var chroma = (1 - Math.abs(2 * lightness - 1)) * saturation;
  var secondComponent = chroma * (1 - Math.abs(huePrime % 2 - 1));
  var red = 0;
  var green = 0;
  var blue = 0;

  if (huePrime >= 0 && huePrime < 1) {
    red = chroma;
    green = secondComponent;
  } else if (huePrime >= 1 && huePrime < 2) {
    red = secondComponent;
    green = chroma;
  } else if (huePrime >= 2 && huePrime < 3) {
    green = chroma;
    blue = secondComponent;
  } else if (huePrime >= 3 && huePrime < 4) {
    green = secondComponent;
    blue = chroma;
  } else if (huePrime >= 4 && huePrime < 5) {
    red = secondComponent;
    blue = chroma;
  } else if (huePrime >= 5 && huePrime < 6) {
    red = chroma;
    blue = secondComponent;
  }

  var lightnessModification = lightness - chroma / 2;
  var finalRed = red + lightnessModification;
  var finalGreen = green + lightnessModification;
  var finalBlue = blue + lightnessModification;
  return convert(finalRed, finalGreen, finalBlue);
}

var namedColorMap = {
  aliceblue: 'f0f8ff',
  antiquewhite: 'faebd7',
  aqua: '00ffff',
  aquamarine: '7fffd4',
  azure: 'f0ffff',
  beige: 'f5f5dc',
  bisque: 'ffe4c4',
  black: '000',
  blanchedalmond: 'ffebcd',
  blue: '0000ff',
  blueviolet: '8a2be2',
  brown: 'a52a2a',
  burlywood: 'deb887',
  cadetblue: '5f9ea0',
  chartreuse: '7fff00',
  chocolate: 'd2691e',
  coral: 'ff7f50',
  cornflowerblue: '6495ed',
  cornsilk: 'fff8dc',
  crimson: 'dc143c',
  cyan: '00ffff',
  darkblue: '00008b',
  darkcyan: '008b8b',
  darkgoldenrod: 'b8860b',
  darkgray: 'a9a9a9',
  darkgreen: '006400',
  darkgrey: 'a9a9a9',
  darkkhaki: 'bdb76b',
  darkmagenta: '8b008b',
  darkolivegreen: '556b2f',
  darkorange: 'ff8c00',
  darkorchid: '9932cc',
  darkred: '8b0000',
  darksalmon: 'e9967a',
  darkseagreen: '8fbc8f',
  darkslateblue: '483d8b',
  darkslategray: '2f4f4f',
  darkslategrey: '2f4f4f',
  darkturquoise: '00ced1',
  darkviolet: '9400d3',
  deeppink: 'ff1493',
  deepskyblue: '00bfff',
  dimgray: '696969',
  dimgrey: '696969',
  dodgerblue: '1e90ff',
  firebrick: 'b22222',
  floralwhite: 'fffaf0',
  forestgreen: '228b22',
  fuchsia: 'ff00ff',
  gainsboro: 'dcdcdc',
  ghostwhite: 'f8f8ff',
  gold: 'ffd700',
  goldenrod: 'daa520',
  gray: '808080',
  green: '008000',
  greenyellow: 'adff2f',
  grey: '808080',
  honeydew: 'f0fff0',
  hotpink: 'ff69b4',
  indianred: 'cd5c5c',
  indigo: '4b0082',
  ivory: 'fffff0',
  khaki: 'f0e68c',
  lavender: 'e6e6fa',
  lavenderblush: 'fff0f5',
  lawngreen: '7cfc00',
  lemonchiffon: 'fffacd',
  lightblue: 'add8e6',
  lightcoral: 'f08080',
  lightcyan: 'e0ffff',
  lightgoldenrodyellow: 'fafad2',
  lightgray: 'd3d3d3',
  lightgreen: '90ee90',
  lightgrey: 'd3d3d3',
  lightpink: 'ffb6c1',
  lightsalmon: 'ffa07a',
  lightseagreen: '20b2aa',
  lightskyblue: '87cefa',
  lightslategray: '789',
  lightslategrey: '789',
  lightsteelblue: 'b0c4de',
  lightyellow: 'ffffe0',
  lime: '0f0',
  limegreen: '32cd32',
  linen: 'faf0e6',
  magenta: 'f0f',
  maroon: '800000',
  mediumaquamarine: '66cdaa',
  mediumblue: '0000cd',
  mediumorchid: 'ba55d3',
  mediumpurple: '9370db',
  mediumseagreen: '3cb371',
  mediumslateblue: '7b68ee',
  mediumspringgreen: '00fa9a',
  mediumturquoise: '48d1cc',
  mediumvioletred: 'c71585',
  midnightblue: '191970',
  mintcream: 'f5fffa',
  mistyrose: 'ffe4e1',
  moccasin: 'ffe4b5',
  navajowhite: 'ffdead',
  navy: '000080',
  oldlace: 'fdf5e6',
  olive: '808000',
  olivedrab: '6b8e23',
  orange: 'ffa500',
  orangered: 'ff4500',
  orchid: 'da70d6',
  palegoldenrod: 'eee8aa',
  palegreen: '98fb98',
  paleturquoise: 'afeeee',
  palevioletred: 'db7093',
  papayawhip: 'ffefd5',
  peachpuff: 'ffdab9',
  peru: 'cd853f',
  pink: 'ffc0cb',
  plum: 'dda0dd',
  powderblue: 'b0e0e6',
  purple: '800080',
  rebeccapurple: '639',
  red: 'f00',
  rosybrown: 'bc8f8f',
  royalblue: '4169e1',
  saddlebrown: '8b4513',
  salmon: 'fa8072',
  sandybrown: 'f4a460',
  seagreen: '2e8b57',
  seashell: 'fff5ee',
  sienna: 'a0522d',
  silver: 'c0c0c0',
  skyblue: '87ceeb',
  slateblue: '6a5acd',
  slategray: '708090',
  slategrey: '708090',
  snow: 'fffafa',
  springgreen: '00ff7f',
  steelblue: '4682b4',
  tan: 'd2b48c',
  teal: '008080',
  thistle: 'd8bfd8',
  tomato: 'ff6347',
  turquoise: '40e0d0',
  violet: 'ee82ee',
  wheat: 'f5deb3',
  white: 'fff',
  whitesmoke: 'f5f5f5',
  yellow: 'ff0',
  yellowgreen: '9acd32'
  /**
   * Checks if a string is a CSS named color and returns its equivalent hex value, otherwise returns the original color.
   * @private
   */

};

function nameToHex(color) {
  if (typeof color !== 'string') return color;
  var normalizedColorName = color.toLowerCase();
  return namedColorMap[normalizedColorName] ? "#" + namedColorMap[normalizedColorName] : color;
}

var hexRegex = /^#[a-fA-F0-9]{6}$/;
var hexRgbaRegex = /^#[a-fA-F0-9]{8}$/;
var reducedHexRegex = /^#[a-fA-F0-9]{3}$/;
var reducedRgbaHexRegex = /^#[a-fA-F0-9]{4}$/;
var rgbRegex = /^rgb\(\s*(\d{1,3})\s*,\s*(\d{1,3})\s*,\s*(\d{1,3})\s*\)$/;
var rgbaRegex = /^rgba\(\s*(\d{1,3})\s*,\s*(\d{1,3})\s*,\s*(\d{1,3})\s*,\s*([-+]?[0-9]*[.]?[0-9]+)\s*\)$/;
var hslRegex = /^hsl\(\s*(\d{0,3}[.]?[0-9]+)\s*,\s*(\d{1,3})%\s*,\s*(\d{1,3})%\s*\)$/;
var hslaRegex = /^hsla\(\s*(\d{0,3}[.]?[0-9]+)\s*,\s*(\d{1,3})%\s*,\s*(\d{1,3})%\s*,\s*([-+]?[0-9]*[.]?[0-9]+)\s*\)$/;
/**
 * Returns an RgbColor or RgbaColor object. This utility function is only useful
 * if want to extract a color component. With the color util `toColorString` you
 * can convert a RgbColor or RgbaColor object back to a string.
 *
 * @example
 * // Assigns `{ red: 255, green: 0, blue: 0 }` to color1
 * const color1 = parseToRgb('rgb(255, 0, 0)');
 * // Assigns `{ red: 92, green: 102, blue: 112, alpha: 0.75 }` to color2
 * const color2 = parseToRgb('hsla(210, 10%, 40%, 0.75)');
 */

function parseToRgb(color) {
  if (typeof color !== 'string') {
    throw new Error('Passed an incorrect argument to a color function, please pass a string representation of a color.');
  }

  var normalizedColor = nameToHex(color);

  if (normalizedColor.match(hexRegex)) {
    return {
      red: parseInt("" + normalizedColor[1] + normalizedColor[2], 16),
      green: parseInt("" + normalizedColor[3] + normalizedColor[4], 16),
      blue: parseInt("" + normalizedColor[5] + normalizedColor[6], 16)
    };
  }

  if (normalizedColor.match(hexRgbaRegex)) {
    var alpha = parseFloat((parseInt("" + normalizedColor[7] + normalizedColor[8], 16) / 255).toFixed(2));
    return {
      red: parseInt("" + normalizedColor[1] + normalizedColor[2], 16),
      green: parseInt("" + normalizedColor[3] + normalizedColor[4], 16),
      blue: parseInt("" + normalizedColor[5] + normalizedColor[6], 16),
      alpha: alpha
    };
  }

  if (normalizedColor.match(reducedHexRegex)) {
    return {
      red: parseInt("" + normalizedColor[1] + normalizedColor[1], 16),
      green: parseInt("" + normalizedColor[2] + normalizedColor[2], 16),
      blue: parseInt("" + normalizedColor[3] + normalizedColor[3], 16)
    };
  }

  if (normalizedColor.match(reducedRgbaHexRegex)) {
    var _alpha = parseFloat((parseInt("" + normalizedColor[4] + normalizedColor[4], 16) / 255).toFixed(2));

    return {
      red: parseInt("" + normalizedColor[1] + normalizedColor[1], 16),
      green: parseInt("" + normalizedColor[2] + normalizedColor[2], 16),
      blue: parseInt("" + normalizedColor[3] + normalizedColor[3], 16),
      alpha: _alpha
    };
  }

  var rgbMatched = rgbRegex.exec(normalizedColor);

  if (rgbMatched) {
    return {
      red: parseInt("" + rgbMatched[1], 10),
      green: parseInt("" + rgbMatched[2], 10),
      blue: parseInt("" + rgbMatched[3], 10)
    };
  }

  var rgbaMatched = rgbaRegex.exec(normalizedColor);

  if (rgbaMatched) {
    return {
      red: parseInt("" + rgbaMatched[1], 10),
      green: parseInt("" + rgbaMatched[2], 10),
      blue: parseInt("" + rgbaMatched[3], 10),
      alpha: parseFloat("" + rgbaMatched[4])
    };
  }

  var hslMatched = hslRegex.exec(normalizedColor);

  if (hslMatched) {
    var hue = parseInt("" + hslMatched[1], 10);
    var saturation = parseInt("" + hslMatched[2], 10) / 100;
    var lightness = parseInt("" + hslMatched[3], 10) / 100;
    var rgbColorString = "rgb(" + hslToRgb(hue, saturation, lightness) + ")";
    var hslRgbMatched = rgbRegex.exec(rgbColorString);

    if (!hslRgbMatched) {
      throw new Error("Couldn't generate valid rgb string from " + normalizedColor + ", it returned " + rgbColorString + ".");
    }

    return {
      red: parseInt("" + hslRgbMatched[1], 10),
      green: parseInt("" + hslRgbMatched[2], 10),
      blue: parseInt("" + hslRgbMatched[3], 10)
    };
  }

  var hslaMatched = hslaRegex.exec(normalizedColor);

  if (hslaMatched) {
    var _hue = parseInt("" + hslaMatched[1], 10);

    var _saturation = parseInt("" + hslaMatched[2], 10) / 100;

    var _lightness = parseInt("" + hslaMatched[3], 10) / 100;

    var _rgbColorString = "rgb(" + hslToRgb(_hue, _saturation, _lightness) + ")";

    var _hslRgbMatched = rgbRegex.exec(_rgbColorString);

    if (!_hslRgbMatched) {
      throw new Error("Couldn't generate valid rgb string from " + normalizedColor + ", it returned " + _rgbColorString + ".");
    }

    return {
      red: parseInt("" + _hslRgbMatched[1], 10),
      green: parseInt("" + _hslRgbMatched[2], 10),
      blue: parseInt("" + _hslRgbMatched[3], 10),
      alpha: parseFloat("" + hslaMatched[4])
    };
  }

  throw new Error("Couldn't parse the color string. Please provide the color as a string in hex, rgb, rgba, hsl or hsla notation.");
}

function rgbToHsl(color) {
  // make sure rgb are contained in a set of [0, 255]
  var red = color.red / 255;
  var green = color.green / 255;
  var blue = color.blue / 255;
  var max = Math.max(red, green, blue);
  var min = Math.min(red, green, blue);
  var lightness = (max + min) / 2;

  if (max === min) {
    // achromatic
    if (color.alpha !== undefined) {
      return {
        hue: 0,
        saturation: 0,
        lightness: lightness,
        alpha: color.alpha
      };
    } else {
      return {
        hue: 0,
        saturation: 0,
        lightness: lightness
      };
    }
  }

  var hue;
  var delta = max - min;
  var saturation = lightness > 0.5 ? delta / (2 - max - min) : delta / (max + min);

  switch (max) {
    case red:
      hue = (green - blue) / delta + (green < blue ? 6 : 0);
      break;

    case green:
      hue = (blue - red) / delta + 2;
      break;

    default:
      // blue case
      hue = (red - green) / delta + 4;
      break;
  }

  hue *= 60;

  if (color.alpha !== undefined) {
    return {
      hue: hue,
      saturation: saturation,
      lightness: lightness,
      alpha: color.alpha
    };
  }

  return {
    hue: hue,
    saturation: saturation,
    lightness: lightness
  };
}

/**
 * Returns an HslColor or HslaColor object. This utility function is only useful
 * if want to extract a color component. With the color util `toColorString` you
 * can convert a HslColor or HslaColor object back to a string.
 *
 * @example
 * // Assigns `{ hue: 0, saturation: 1, lightness: 0.5 }` to color1
 * const color1 = parseToHsl('rgb(255, 0, 0)');
 * // Assigns `{ hue: 128, saturation: 1, lightness: 0.5, alpha: 0.75 }` to color2
 * const color2 = parseToHsl('hsla(128, 100%, 50%, 0.75)');
 */
function parseToHsl(color) {
  // Note: At a later stage we can optimize this function as right now a hsl
  // color would be parsed converted to rgb values and converted back to hsl.
  return rgbToHsl(parseToRgb(color));
}

/**
 * Reduces hex values if possible e.g. #ff8866 to #f86
 * @private
 */
var reduceHexValue = function reduceHexValue(value) {
  if (value.length === 7 && value[1] === value[2] && value[3] === value[4] && value[5] === value[6]) {
    return "#" + value[1] + value[3] + value[5];
  }

  return value;
};

function numberToHex(value) {
  var hex = value.toString(16);
  return hex.length === 1 ? "0" + hex : hex;
}

function colorToHex(color) {
  return numberToHex(Math.round(color * 255));
}

function convertToHex(red, green, blue) {
  return reduceHexValue("#" + colorToHex(red) + colorToHex(green) + colorToHex(blue));
}

function hslToHex(hue, saturation, lightness) {
  return hslToRgb(hue, saturation, lightness, convertToHex);
}

/**
 * Returns a string value for the color. The returned result is the smallest possible hex notation.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: hsl(359, 0.75, 0.4),
 *   background: hsl({ hue: 360, saturation: 0.75, lightness: 0.4 }),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${hsl(359, 0.75, 0.4)};
 *   background: ${hsl({ hue: 360, saturation: 0.75, lightness: 0.4 })};
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "#b3191c";
 *   background: "#b3191c";
 * }
 */
function hsl(value, saturation, lightness) {
  if (typeof value === 'number' && typeof saturation === 'number' && typeof lightness === 'number') {
    return hslToHex(value, saturation, lightness);
  } else if (typeof value === 'object' && saturation === undefined && lightness === undefined) {
    return hslToHex(value.hue, value.saturation, value.lightness);
  }

  throw new Error('Passed invalid arguments to hsl, please pass multiple numbers e.g. hsl(360, 0.75, 0.4) or an object e.g. rgb({ hue: 255, saturation: 0.4, lightness: 0.75 }).');
}

/**
 * Returns a string value for the color. The returned result is the smallest possible rgba or hex notation.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: hsla(359, 0.75, 0.4, 0.7),
 *   background: hsla({ hue: 360, saturation: 0.75, lightness: 0.4, alpha: 0,7 }),
 *   background: hsla(359, 0.75, 0.4, 1),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${hsla(359, 0.75, 0.4, 0.7)};
 *   background: ${hsla({ hue: 360, saturation: 0.75, lightness: 0.4, alpha: 0,7 })};
 *   background: ${hsla(359, 0.75, 0.4, 1)};
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "rgba(179,25,28,0.7)";
 *   background: "rgba(179,25,28,0.7)";
 *   background: "#b3191c";
 * }
 */
function hsla(value, saturation, lightness, alpha) {
  if (typeof value === 'number' && typeof saturation === 'number' && typeof lightness === 'number' && typeof alpha === 'number') {
    return alpha >= 1 ? hslToHex(value, saturation, lightness) : "rgba(" + hslToRgb(value, saturation, lightness) + "," + alpha + ")";
  } else if (typeof value === 'object' && saturation === undefined && lightness === undefined && alpha === undefined) {
    return value.alpha >= 1 ? hslToHex(value.hue, value.saturation, value.lightness) : "rgba(" + hslToRgb(value.hue, value.saturation, value.lightness) + "," + value.alpha + ")";
  }

  throw new Error('Passed invalid arguments to hsla, please pass multiple numbers e.g. hsl(360, 0.75, 0.4, 0.7) or an object e.g. rgb({ hue: 255, saturation: 0.4, lightness: 0.75, alpha: 0.7 }).');
}

/**
 * Returns a string value for the color. The returned result is the smallest possible hex notation.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: rgb(255, 205, 100),
 *   background: rgb({ red: 255, green: 205, blue: 100 }),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${rgb(255, 205, 100)};
 *   background: ${rgb({ red: 255, green: 205, blue: 100 })};
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "#ffcd64";
 *   background: "#ffcd64";
 * }
 */
function rgb(value, green, blue) {
  if (typeof value === 'number' && typeof green === 'number' && typeof blue === 'number') {
    return reduceHexValue("#" + numberToHex(value) + numberToHex(green) + numberToHex(blue));
  } else if (typeof value === 'object' && green === undefined && blue === undefined) {
    return reduceHexValue("#" + numberToHex(value.red) + numberToHex(value.green) + numberToHex(value.blue));
  }

  throw new Error('Passed invalid arguments to rgb, please pass multiple numbers e.g. rgb(255, 205, 100) or an object e.g. rgb({ red: 255, green: 205, blue: 100 }).');
}

/**
 * Returns a string value for the color. The returned result is the smallest possible rgba or hex notation.
 *
 * Can also be used to fade a color by passing a hex value or named CSS color along with an alpha value.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: rgba(255, 205, 100, 0.7),
 *   background: rgba({ red: 255, green: 205, blue: 100, alpha: 0.7 }),
 *   background: rgba(255, 205, 100, 1),
 *   background: rgba('#ffffff', 0.4),
 *   background: rgba('black', 0.7),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${rgba(255, 205, 100, 0.7)};
 *   background: ${rgba({ red: 255, green: 205, blue: 100, alpha: 0.7 })};
 *   background: ${rgba(255, 205, 100, 1)};
 *   background: ${rgba('#ffffff', 0.4)};
 *   background: ${rgba('black', 0.7)};
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "rgba(255,205,100,0.7)";
 *   background: "rgba(255,205,100,0.7)";
 *   background: "#ffcd64";
 *   background: "rgba(255,255,255,0.4)";
 *   background: "rgba(0,0,0,0.7)";
 * }
 */
function rgba(firstValue, secondValue, thirdValue, fourthValue) {
  if (typeof firstValue === 'string' && typeof secondValue === 'number') {
    var rgbValue = parseToRgb(firstValue);
    return "rgba(" + rgbValue.red + "," + rgbValue.green + "," + rgbValue.blue + "," + secondValue + ")";
  } else if (typeof firstValue === 'number' && typeof secondValue === 'number' && typeof thirdValue === 'number' && typeof fourthValue === 'number') {
    return fourthValue >= 1 ? rgb(firstValue, secondValue, thirdValue) : "rgba(" + firstValue + "," + secondValue + "," + thirdValue + "," + fourthValue + ")";
  } else if (typeof firstValue === 'object' && secondValue === undefined && thirdValue === undefined && fourthValue === undefined) {
    return firstValue.alpha >= 1 ? rgb(firstValue.red, firstValue.green, firstValue.blue) : "rgba(" + firstValue.red + "," + firstValue.green + "," + firstValue.blue + "," + firstValue.alpha + ")";
  }

  throw new Error('Passed invalid arguments to rgba, please pass multiple numbers e.g. rgb(255, 205, 100, 0.75) or an object e.g. rgb({ red: 255, green: 205, blue: 100, alpha: 0.75 }).');
}

var isRgb = function isRgb(color) {
  return typeof color.red === 'number' && typeof color.green === 'number' && typeof color.blue === 'number' && (typeof color.alpha !== 'number' || typeof color.alpha === 'undefined');
};

var isRgba = function isRgba(color) {
  return typeof color.red === 'number' && typeof color.green === 'number' && typeof color.blue === 'number' && typeof color.alpha === 'number';
};

var isHsl = function isHsl(color) {
  return typeof color.hue === 'number' && typeof color.saturation === 'number' && typeof color.lightness === 'number' && (typeof color.alpha !== 'number' || typeof color.alpha === 'undefined');
};

var isHsla = function isHsla(color) {
  return typeof color.hue === 'number' && typeof color.saturation === 'number' && typeof color.lightness === 'number' && typeof color.alpha === 'number';
};

var errMsg = 'Passed invalid argument to toColorString, please pass a RgbColor, RgbaColor, HslColor or HslaColor object.';
/**
 * Converts a RgbColor, RgbaColor, HslColor or HslaColor object to a color string.
 * This util is useful in case you only know on runtime which color object is
 * used. Otherwise we recommend to rely on `rgb`, `rgba`, `hsl` or `hsla`.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: toColorString({ red: 255, green: 205, blue: 100 }),
 *   background: toColorString({ red: 255, green: 205, blue: 100, alpha: 0.72 }),
 *   background: toColorString({ hue: 240, saturation: 1, lightness: 0.5 }),
 *   background: toColorString({ hue: 360, saturation: 0.75, lightness: 0.4, alpha: 0.72 }),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${toColorString({ red: 255, green: 205, blue: 100 })};
 *   background: ${toColorString({ red: 255, green: 205, blue: 100, alpha: 0.72 })};
 *   background: ${toColorString({ hue: 240, saturation: 1, lightness: 0.5 })};
 *   background: ${toColorString({ hue: 360, saturation: 0.75, lightness: 0.4, alpha: 0.72 })};
 * `
 *
 * // CSS in JS Output
 * element {
 *   background: "#ffcd64";
 *   background: "rgba(255,205,100,0.72)";
 *   background: "#00f";
 *   background: "rgba(179,25,25,0.72)";
 * }
 */

function toColorString(color) {
  if (typeof color !== 'object') throw new Error(errMsg);
  if (isRgba(color)) return rgba(color);
  if (isRgb(color)) return rgb(color);
  if (isHsla(color)) return hsla(color);
  if (isHsl(color)) return hsl(color);
  throw new Error(errMsg);
}

// Type definitions taken from https://github.com/gcanti/flow-static-land/blob/master/src/Fun.js
// eslint-disable-next-line no-unused-vars
// eslint-disable-next-line no-unused-vars
// eslint-disable-next-line no-redeclare
function curried(f, length, acc) {
  return function fn() {
    // eslint-disable-next-line prefer-rest-params
    var combined = acc.concat(Array.prototype.slice.call(arguments));
    return combined.length >= length ? f.apply(this, combined) : curried(f, length, combined);
  };
} // eslint-disable-next-line no-redeclare


function curry(f) {
  // eslint-disable-line no-redeclare
  return curried(f, f.length, []);
}

/**
 * Changes the hue of the color. Hue is a number between 0 to 360. The first
 * argument for adjustHue is the amount of degrees the color is rotated along
 * the color wheel.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: adjustHue(180, '#448'),
 *   background: adjustHue('180', 'rgba(101,100,205,0.7)'),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${adjustHue(180, '#448')};
 *   background: ${adjustHue('180', 'rgba(101,100,205,0.7)')};
 * `
 *
 * // CSS in JS Output
 * element {
 *   background: "#888844";
 *   background: "rgba(136,136,68,0.7)";
 * }
 */

function adjustHue(degree, color) {
  var hslColor = parseToHsl(color);
  return toColorString(_extends$1({}, hslColor, {
    hue: (hslColor.hue + parseFloat(degree)) % 360
  }));
} // prettier-ignore


var curriedAdjustHue =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(adjustHue);

function guard(lowerBoundary, upperBoundary, value) {
  return Math.max(lowerBoundary, Math.min(upperBoundary, value));
}

/**
 * Returns a string value for the darkened color.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: darken(0.2, '#FFCD64'),
 *   background: darken('0.2', 'rgba(255,205,100,0.7)'),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${darken(0.2, '#FFCD64')};
 *   background: ${darken('0.2', 'rgba(255,205,100,0.7)')};
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "#ffbd31";
 *   background: "rgba(255,189,49,0.7)";
 * }
 */

function darken(amount, color) {
  var hslColor = parseToHsl(color);
  return toColorString(_extends$1({}, hslColor, {
    lightness: guard(0, 1, hslColor.lightness - parseFloat(amount))
  }));
} // prettier-ignore


var curriedDarken =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(darken);

/**
 * Decreases the intensity of a color. Its range is between 0 to 1. The first
 * argument of the desaturate function is the amount by how much the color
 * intensity should be decreased.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: desaturate(0.2, '#CCCD64'),
 *   background: desaturate('0.2', 'rgba(204,205,100,0.7)'),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${desaturate(0.2, '#CCCD64')};
 *   background: ${desaturate('0.2', 'rgba(204,205,100,0.7)')};
 * `
 *
 * // CSS in JS Output
 * element {
 *   background: "#b8b979";
 *   background: "rgba(184,185,121,0.7)";
 * }
 */

function desaturate(amount, color) {
  var hslColor = parseToHsl(color);
  return toColorString(_extends$1({}, hslColor, {
    saturation: guard(0, 1, hslColor.saturation - parseFloat(amount))
  }));
} // prettier-ignore


var curriedDesaturate =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(desaturate);

/**
 * Returns a string value for the lightened color.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: lighten(0.2, '#CCCD64'),
 *   background: lighten('0.2', 'rgba(204,205,100,0.7)'),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${lighten(0.2, '#FFCD64')};
 *   background: ${lighten('0.2', 'rgba(204,205,100,0.7)')};
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "#e5e6b1";
 *   background: "rgba(229,230,177,0.7)";
 * }
 */

function lighten(amount, color) {
  var hslColor = parseToHsl(color);
  return toColorString(_extends$1({}, hslColor, {
    lightness: guard(0, 1, hslColor.lightness + parseFloat(amount))
  }));
} // prettier-ignore


var curriedLighten =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(lighten);

/**
 * Mixes the two provided colors together by calculating the average of each of the RGB components weighted to the first color by the provided weight.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: mix(0.5, '#f00', '#00f')
 *   background: mix(0.25, '#f00', '#00f')
 *   background: mix('0.5', 'rgba(255, 0, 0, 0.5)', '#00f')
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${mix(0.5, '#f00', '#00f')};
 *   background: ${mix(0.25, '#f00', '#00f')};
 *   background: ${mix('0.5', 'rgba(255, 0, 0, 0.5)', '#00f')};
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "#7f007f";
 *   background: "#3f00bf";
 *   background: "rgba(63, 0, 191, 0.75)";
 * }
 */

function mix(weight, color, otherColor) {
  var parsedColor1 = parseToRgb(color);

  var color1 = _extends$1({}, parsedColor1, {
    alpha: typeof parsedColor1.alpha === 'number' ? parsedColor1.alpha : 1
  });

  var parsedColor2 = parseToRgb(otherColor);

  var color2 = _extends$1({}, parsedColor2, {
    alpha: typeof parsedColor2.alpha === 'number' ? parsedColor2.alpha : 1 // The formular is copied from the original Sass implementation:
    // http://sass-lang.com/documentation/Sass/Script/Functions.html#mix-instance_method

  });

  var alphaDelta = color1.alpha - color2.alpha;
  var x = parseFloat(weight) * 2 - 1;
  var y = x * alphaDelta === -1 ? x : x + alphaDelta;
  var z = 1 + x * alphaDelta;
  var weight1 = (y / z + 1) / 2.0;
  var weight2 = 1 - weight1;
  var mixedColor = {
    red: Math.floor(color1.red * weight1 + color2.red * weight2),
    green: Math.floor(color1.green * weight1 + color2.green * weight2),
    blue: Math.floor(color1.blue * weight1 + color2.blue * weight2),
    alpha: color1.alpha + (color2.alpha - color1.alpha) * (parseFloat(weight) / 1.0)
  };
  return rgba(mixedColor);
} // prettier-ignore


var curriedMix =
/*#__PURE__*/
curry
/* ::<number | string, string, string, string> */
(mix);

/**
 * Increases the opacity of a color. Its range for the amount is between 0 to 1.
 *
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: opacify(0.1, 'rgba(255, 255, 255, 0.9)');
 *   background: opacify(0.2, 'hsla(0, 0%, 100%, 0.5)'),
 *   background: opacify('0.5', 'rgba(255, 0, 0, 0.2)'),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${opacify(0.1, 'rgba(255, 255, 255, 0.9)')};
 *   background: ${opacify(0.2, 'hsla(0, 0%, 100%, 0.5)')},
 *   background: ${opacify('0.5', 'rgba(255, 0, 0, 0.2)')},
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "#fff";
 *   background: "rgba(255,255,255,0.7)";
 *   background: "rgba(255,0,0,0.7)";
 * }
 */

function opacify(amount, color) {
  var parsedColor = parseToRgb(color);
  var alpha = typeof parsedColor.alpha === 'number' ? parsedColor.alpha : 1;

  var colorWithAlpha = _extends$1({}, parsedColor, {
    alpha: guard(0, 1, (alpha * 100 + parseFloat(amount) * 100) / 100)
  });

  return rgba(colorWithAlpha);
} // prettier-ignore


var curriedOpacify =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(opacify);

/**
 * Increases the intensity of a color. Its range is between 0 to 1. The first
 * argument of the saturate function is the amount by how much the color
 * intensity should be increased.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: saturate(0.2, '#CCCD64'),
 *   background: saturate('0.2', 'rgba(204,205,100,0.7)'),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${saturate(0.2, '#FFCD64')};
 *   background: ${saturate('0.2', 'rgba(204,205,100,0.7)')};
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "#e0e250";
 *   background: "rgba(224,226,80,0.7)";
 * }
 */

function saturate(amount, color) {
  var hslColor = parseToHsl(color);
  return toColorString(_extends$1({}, hslColor, {
    saturation: guard(0, 1, hslColor.saturation + parseFloat(amount))
  }));
} // prettier-ignore


var curriedSaturate =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(saturate);

/**
 * Sets the hue of a color to the provided value. The hue range can be
 * from 0 and 359.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: setHue(42, '#CCCD64'),
 *   background: setHue('244', 'rgba(204,205,100,0.7)'),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${setHue(42, '#CCCD64')};
 *   background: ${setHue('244', 'rgba(204,205,100,0.7)')};
 * `
 *
 * // CSS in JS Output
 * element {
 *   background: "#cdae64";
 *   background: "rgba(107,100,205,0.7)";
 * }
 */

function setHue(hue, color) {
  return toColorString(_extends$1({}, parseToHsl(color), {
    hue: parseFloat(hue)
  }));
} // prettier-ignore


var curriedSetHue =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(setHue);

/**
 * Sets the lightness of a color to the provided value. The lightness range can be
 * from 0 and 1.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: setLightness(0.2, '#CCCD64'),
 *   background: setLightness('0.75', 'rgba(204,205,100,0.7)'),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${setLightness(0.2, '#CCCD64')};
 *   background: ${setLightness('0.75', 'rgba(204,205,100,0.7)')};
 * `
 *
 * // CSS in JS Output
 * element {
 *   background: "#4d4d19";
 *   background: "rgba(223,224,159,0.7)";
 * }
 */

function setLightness(lightness, color) {
  return toColorString(_extends$1({}, parseToHsl(color), {
    lightness: parseFloat(lightness)
  }));
} // prettier-ignore


var curriedSetLightness =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(setLightness);

/**
 * Sets the saturation of a color to the provided value. The lightness range can be
 * from 0 and 1.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: setSaturation(0.2, '#CCCD64'),
 *   background: setSaturation('0.75', 'rgba(204,205,100,0.7)'),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${setSaturation(0.2, '#CCCD64')};
 *   background: ${setSaturation('0.75', 'rgba(204,205,100,0.7)')};
 * `
 *
 * // CSS in JS Output
 * element {
 *   background: "#adad84";
 *   background: "rgba(228,229,76,0.7)";
 * }
 */

function setSaturation(saturation, color) {
  return toColorString(_extends$1({}, parseToHsl(color), {
    saturation: parseFloat(saturation)
  }));
} // prettier-ignore


var curriedSetSaturation =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(setSaturation);

/**
 * Shades a color by mixing it with black. `shade` can produce
 * hue shifts, where as `darken` manipulates the luminance channel and therefore
 * doesn't produce hue shifts.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: shade(0.25, '#00f')
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${shade(0.25, '#00f')};
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "#00003f";
 * }
 */

function shade(percentage, color) {
  return curriedMix(parseFloat(percentage), 'rgb(0, 0, 0)', color);
} // prettier-ignore


var curriedShade =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(shade);

/**
 * Tints a color by mixing it with white. `tint` can produce
 * hue shifts, where as `lighten` manipulates the luminance channel and therefore
 * doesn't produce hue shifts.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: tint(0.25, '#00f')
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${tint(0.25, '#00f')};
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "#bfbfff";
 * }
 */

function tint(percentage, color) {
  return curriedMix(parseFloat(percentage), 'rgb(255, 255, 255)', color);
} // prettier-ignore


var curriedTint =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(tint);

/**
 * Decreases the opacity of a color. Its range for the amount is between 0 to 1.
 *
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: transparentize(0.1, '#fff');
 *   background: transparentize(0.2, 'hsl(0, 0%, 100%)'),
 *   background: transparentize('0.5', 'rgba(255, 0, 0, 0.8)'),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${transparentize(0.1, '#fff')};
 *   background: ${transparentize(0.2, 'hsl(0, 0%, 100%)')},
 *   background: ${transparentize('0.5', 'rgba(255, 0, 0, 0.8)')},
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "rgba(255,255,255,0.9)";
 *   background: "rgba(255,255,255,0.8)";
 *   background: "rgba(255,0,0,0.3)";
 * }
 */

function transparentize(amount, color) {
  var parsedColor = parseToRgb(color);
  var alpha = typeof parsedColor.alpha === 'number' ? parsedColor.alpha : 1;

  var colorWithAlpha = _extends$1({}, parsedColor, {
    alpha: guard(0, 1, (alpha * 100 - parseFloat(amount) * 100) / 100)
  });

  return rgba(colorWithAlpha);
} // prettier-ignore


var curriedTransparentize =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(transparentize);

var _templateObject$2 = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$1 = taggedTemplateLiteral(['\n    position: relative;\n    display: inline-flex;\n    margin: 0;\n    min-height: inherit;\n    padding: 0.375rem 1.5rem 0.375rem 0;\n\n    input {\n      position: absolute;\n      opacity: 0;\n      &:disabled {\n        & ~ .indicator,\n        & ~ .description {\n          opacity: 0.5;\n        }\n      }\n    }\n    .indicator {\n      border-radius: 0.25rem;\n      flex-shrink: 0;\n      ', '\n    }\n    .description {\n      color: ', ';\n      padding-', ': 0.5rem;\n    }\n    ', '\n  '], ['\n    position: relative;\n    display: inline-flex;\n    margin: 0;\n    min-height: inherit;\n    padding: 0.375rem 1.5rem 0.375rem 0;\n\n    input {\n      position: absolute;\n      opacity: 0;\n      &:disabled {\n        & ~ .indicator,\n        & ~ .description {\n          opacity: 0.5;\n        }\n      }\n    }\n    .indicator {\n      border-radius: 0.25rem;\n      flex-shrink: 0;\n      ', '\n    }\n    .description {\n      color: ', ';\n      padding-', ': 0.5rem;\n    }\n    ', '\n  ']),
    _templateObject3$1 = taggedTemplateLiteral(['\n        &:hover .indicator,\n        input:focus + .indicator {\n          border-color: ', ';\n        }\n      '], ['\n        &:hover .indicator,\n        input:focus + .indicator {\n          border-color: ', ';\n        }\n      ']),
    _templateObject4$1 = taggedTemplateLiteral(['\n    background-color: ', ';\n    width: ', ';\n    height: ', ';\n    border: ', ' solid ', ';\n    &::before {\n      content: \'\';\n      border-style: solid;\n      display: block;\n      margin: 0 auto;\n      transform: rotate(45deg);\n      height: calc(', ' * 0.6);\n      width: calc(', ' * 0.4);\n      border-color: ', ';\n      border-width: 0 ', ' ', ' 0;\n    }\n  '], ['\n    background-color: ', ';\n    width: ', ';\n    height: ', ';\n    border: ', ' solid ', ';\n    &::before {\n      content: \'\';\n      border-style: solid;\n      display: block;\n      margin: 0 auto;\n      transform: rotate(45deg);\n      height: calc(', ' * 0.6);\n      width: calc(', ' * 0.4);\n      border-color: ', ';\n      border-width: 0 ', ' ', ' 0;\n    }\n  ']);

var CheckboxStyle = styled__default.label(_templateObject$2, function (_ref) {
  var theme = _ref.theme,
      checked = _ref.checked,
      disabled = _ref.disabled,
      status = _ref.status;
  return styled.css(_templateObject2$1, indicatorStyle(theme, checked, disabled, status), theme.colorFgHeading, theme.dir === 'rtl' ? 'right' : 'left', !disabled && styled.css(_templateObject3$1, curriedLighten(0.1, theme[hoverBorder(status)])));
});
var hoverBorder = function hoverBorder(status) {
  return status ? 'color' + status : 'checkboxCheckedBorderColor';
};

var indicatorStyle = function indicatorStyle(theme, checked, disabled, status) {
  var state = disabled ? 'Disabled' : checked ? 'Checked' : '';
  var size = theme['checkbox' + state + 'Size'];
  var borderSize = theme['checkbox' + state + 'BorderSize'];
  var checkmark = disabled && checked ? 'Disabled' : checked ? 'Checked' : '';

  var borderColor$$1 = theme['checkbox' + state + 'BorderColor'];
  if (disabled) {
    borderColor$$1 = theme['checkboxBorderColor'];
  }
  if (disabled && checked) {
    borderColor$$1 = theme['checkboxCheckedBorderColor'];
  }
  if (status && checked) {
    borderColor$$1 = theme['color' + status];
  }

  return styled.css(_templateObject4$1, theme['checkbox' + state + 'Bg'], size, size, borderSize, borderColor$$1, size, size, theme['checkbox' + checkmark + 'Checkmark'], borderSize, borderSize);
};

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

var Checkbox = function Checkbox(props) {
  var _useState = React.useState(props.checked ? props.checked : false),
      _useState2 = slicedToArray(_useState, 2),
      value = _useState2[0],
      setValue = _useState2[1];

  var uncontrolled = typeof props.onChange === 'function';
  var onChangeHandler = function onChangeHandler() {
    uncontrolled && props.onChange(!value);
    setValue(!value);
  };

  return React__default.createElement(
    CheckboxStyle,
    {
      disabled: props.disabled,
      checked: uncontrolled ? value : props.checked,
      status: props.status,
      className: props.className,
      style: props.style
    },
    uncontrolled ? React__default.createElement('input', {
      type: 'checkbox',
      disabled: props.disabled,
      onBlur: props.onBlur,
      checked: value,
      onChange: onChangeHandler
    }) : React__default.createElement('input', {
      type: 'checkbox',
      disabled: props.disabled,
      onBlur: props.onBlur
    }),
    React__default.createElement('span', { className: 'indicator' }),
    React__default.createElement(
      'span',
      { className: 'description' },
      props.children
    )
  );
};

Checkbox.propTypes = {
  onChange: PropTypes.func,
  onBlur: PropTypes.func,
  checked: PropTypes.bool,
  disabled: PropTypes.bool,
  className: PropTypes.string,
  style: PropTypes.string,
  status: colorState
};

var _templateObject$3 = taggedTemplateLiteral(['\n  ', ';\n  ', ';\n'], ['\n  ', ';\n  ', ';\n']),
    _templateObject2$2 = taggedTemplateLiteral(['\n        background-color: ', ';\n        border-bottom-width: ', ';\n        border-bottom-style: ', ';\n        border-bottom-color: ', ';\n        border-top-left-radius: ', ';\n        border-top-right-radius: ', ';\n      '], ['\n        background-color: ', ';\n        border-bottom-width: ', ';\n        border-bottom-style: ', ';\n        border-bottom-color: ', ';\n        border-top-left-radius: ', ';\n        border-top-right-radius: ', ';\n      ']),
    _templateObject3$2 = taggedTemplateLiteral(['\n        border-bottom-width: ', ';\n        border-bottom-style: ', ';\n        border-bottom-color: ', ';\n      '], ['\n        border-bottom-width: ', ';\n        border-bottom-style: ', ';\n        border-bottom-color: ', ';\n      ']),
    _templateObject4$2 = taggedTemplateLiteral(['\n  ', ';\n'], ['\n  ', ';\n']),
    _templateObject5$1 = taggedTemplateLiteral(['\n    display: flex;\n    flex-direction: column;\n    line-height: ', ';\n    font-weight: ', ';\n    font-size: ', ';\n    color: ', ';\n    background: ', ';\n    box-shadow: ', ';\n    border-radius: ', ';\n    margin-bottom: ', ';\n    border-width: ', ';\n    border-style: ', ';\n    border-color: ', ';\n    ', '\n    ', '\n    & > header {\n      font-family: ', ';\n      font-size: ', ';\n      font-weight: ', ';\n      color: ', ';\n      padding: ', ';\n      ', '\n    }\n    .card-body {\n      padding: ', ';\n      overflow: auto;\n      flex: 1;\n      position: relative;\n    }\n    & > footer {\n      padding: ', ';\n      border-top: 1px solid ', ';\n      border-bottom-left-radius: ', ';\n      border-bottom-right-radius: ', ';\n    }\n  '], ['\n    display: flex;\n    flex-direction: column;\n    line-height: ', ';\n    font-weight: ', ';\n    font-size: ', ';\n    color: ', ';\n    background: ', ';\n    box-shadow: ', ';\n    border-radius: ', ';\n    margin-bottom: ', ';\n    border-width: ', ';\n    border-style: ', ';\n    border-color: ', ';\n    ', '\n    ', '\n    & > header {\n      font-family: ', ';\n      font-size: ', ';\n      font-weight: ', ';\n      color: ', ';\n      padding: ', ';\n      ', '\n    }\n    .card-body {\n      padding: ', ';\n      overflow: auto;\n      flex: 1;\n      position: relative;\n    }\n    & > footer {\n      padding: ', ';\n      border-top: 1px solid ', ';\n      border-bottom-left-radius: ', ';\n      border-bottom-right-radius: ', ';\n    }\n  ']);

var headerBg = styled.css(_templateObject$3, function (_ref) {
  var theme = _ref.theme,
      status = _ref.status;

  if (status) {
    return styled.css(_templateObject2$2, theme['cardHeader' + status + 'Bg'], theme.cardHeaderBorderWidth, theme.cardHeaderBorderType, theme['cardHeader' + status + 'Bg'], theme.cardBorderRadius, theme.cardBorderRadius);
  } else {
    return styled.css(_templateObject3$2, theme.cardHeaderBorderWidth, theme.cardHeaderBorderType, theme.cardHeaderBorderColor);
  }
}, function (_ref2) {
  var accent = _ref2.accent;
  return accent ? 'border-radius: 0' : '';
});

var accent = styled.css(_templateObject4$2, function (_ref3) {
  var theme = _ref3.theme,
      accent = _ref3.accent;
  return accent ? '\n      border-top:\n      ' + theme.cardBorderRadius + ' \n      solid\n      ' + theme['cardHeader' + accent + 'Bg'] + ';\n      ' : '';
});
var height = styled.css(_templateObject4$2, function (_ref4) {
  var theme = _ref4.theme,
      size$$1 = _ref4.size;
  return size$$1 ? '\n      height: ' + theme['cardHeight' + size$$1.toUpperCase()] + ';\n      ' : '';
});
var Card = styled__default.div(_templateObject4$2, function (_ref5) {
  var theme = _ref5.theme;
  return styled.css(_templateObject5$1, theme.cardLineHeight, theme.cardFontWeight, theme.cardFontSize, theme.cardFgText, theme.cardBg, theme.cardShadow, theme.cardBorderRadius, theme.cardMargin, theme.cardBorderWidth, theme.cardBorderType, theme.cardBorderColor, accent, height, theme.cardHeaderFontFamily, theme.cardHeaderFontSize, theme.cardHeaderFontWeight, theme.cardHeaderFgHeading, theme.cardPadding, headerBg, theme.cardPadding, theme.cardPadding, theme.cardSeparator, theme.cardBorderRadius, theme.cardBorderRadius);
});
Card.propTypes = {
  status: colorState,
  accent: colorState,
  size: size
};

function _extends$2() {
  _extends$2 = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }return target;
  };return _extends$2.apply(this, arguments);
}

var _ref =
/*#__PURE__*/
React__default.createElement("path", {
  fill: "#99ABB4",
  fillRule: "evenodd",
  stroke: "#99ABB4",
  d: "M8 6.982L2.428 2l-.363.324 5.208 4.658L2 11.676l.363.324z"
});

var SvgComponent = function SvgComponent(props) {
  return React__default.createElement("svg", _extends$2({
    width: 10,
    height: 14
  }, props), _ref);
};

function _extends$3() {
  _extends$3 = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }return target;
  };return _extends$3.apply(this, arguments);
}

var _ref$1 =
/*#__PURE__*/
React__default.createElement("path", {
  fill: "#99ABB4",
  fillRule: "evenodd",
  stroke: "#99ABB4",
  d: "M2 7.018L7.572 12l.363-.324-5.208-4.658L8 2.324 7.637 2z"
});

var SvgComponent$1 = function SvgComponent(props) {
  return React__default.createElement("svg", _extends$3({
    width: 10,
    height: 14
  }, props), _ref$1);
};

function _extends$4() {
  _extends$4 = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }return target;
  };return _extends$4.apply(this, arguments);
}

var _ref$2 =
/*#__PURE__*/
React__default.createElement("path", {
  fill: "#99ABB4",
  fillRule: "evenodd",
  stroke: "#99ABB4",
  d: "M6.982 2L2 7.572l.324.363 4.658-5.208L11.676 8 12 7.637z"
});

var SvgComponent$2 = function SvgComponent(props) {
  return React__default.createElement("svg", _extends$4({
    width: 14,
    height: 10
  }, props), _ref$2);
};

function _extends$5() {
  _extends$5 = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }return target;
  };return _extends$5.apply(this, arguments);
}

var _ref$3 =
/*#__PURE__*/
React__default.createElement("path", {
  fill: "#99ABB4",
  fillRule: "evenodd",
  stroke: "#99ABB4",
  d: "M7.018 8L12 2.428l-.324-.363-4.658 5.208L2.324 2 2 2.363z"
});

var SvgComponent$3 = function SvgComponent(props) {
  return React__default.createElement("svg", _extends$5({
    width: 14,
    height: 10
  }, props), _ref$3);
};

var _ref$4 =
/*#__PURE__*/
React__default.createElement("path", {
  fill: "#FFF",
  fillRule: "evenodd",
  d: "M12.979 13.651c-.145.22-.508.22-.653 0a.494.494 0 0 1 0-.734 5.058 5.058 0 0 0 1.305-1.761 5.32 5.32 0 0 0 .435-2.128c0-.955-.217-1.835-.652-2.57a4.747 4.747 0 0 0-1.885-1.908c-.218-.146-.29-.44-.145-.733.145-.22.435-.294.725-.147.87.587 1.667 1.32 2.175 2.275.508.954.798 1.982.798 3.083 0 .88-.218 1.761-.508 2.568a5.431 5.431 0 0 1-1.595 2.055zM8.919 0c2.465 0 4.64 1.028 6.308 2.642a9.1 9.1 0 0 1 2.61 6.386c0 2.201-.87 4.256-2.175 5.871L16.822 16l.217-.294c.363-.293.725-.44 1.16-.44.363 0 .798.147 1.088.44l4.278 4.257c.29.367.435.734.435 1.175 0 .367-.145.807-.435 1.1L22.26 23.56c-.29.293-.653.44-1.088.44-.435 0-.797-.147-1.087-.44l-4.278-4.257c-.29-.367-.435-.734-.435-1.175 0-.367.145-.807.435-1.1l.29-.294-1.16-1.101a8.76 8.76 0 0 1-6.019 2.422 8.88 8.88 0 0 1-6.308-2.642C1.015 13.725 0 11.523 0 9.028a9.1 9.1 0 0 1 2.61-6.386A8.88 8.88 0 0 1 8.918 0zm5.583 3.376c-1.45-1.468-3.408-2.348-5.584-2.348-2.175 0-4.133.88-5.583 2.348a7.98 7.98 0 0 0-2.32 5.652 7.98 7.98 0 0 0 2.32 5.65c1.45 1.395 3.408 2.35 5.583 2.35 2.176 0 4.133-.955 5.584-2.35l.072-.146h.073c1.305-1.468 2.175-3.376 2.175-5.504 0-2.202-.943-4.184-2.32-5.652z"
});

var _ref$5 =
/*#__PURE__*/
React__default.createElement("g", {
  fillRule: "evenodd"
}, React__default.createElement("path", {
  d: "M12.78 11.95l5.039-5.058a.554.554 0 0 0 0-.78.548.548 0 0 0-.778 0l-5.038 5.057L6.965 6.11a.548.548 0 0 0-.778 0 .554.554 0 0 0 0 .781l5.038 5.057-5.048 5.068a.554.554 0 0 0 0 .78.548.548 0 0 0 .778 0L12 12.73l5.048 5.068a.548.548 0 0 0 .92-.248.553.553 0 0 0-.142-.533L12.78 11.95z"
}), React__default.createElement("path", {
  fillRule: "nonzero",
  d: "M20.42 3.502A11.874 11.874 0 0 0 5.384 2.016C.66 5.184-1.176 11.26.998 16.53c2.175 5.269 7.754 8.262 13.326 7.149 5.572-1.113 9.585-6.022 9.584-11.725a11.899 11.899 0 0 0-3.488-8.452zm-.778 16.125a10.778 10.778 0 0 1-13.648 1.348C1.707 18.098.04 12.582 2.014 7.8 3.988 3.018 9.052.301 14.11 1.311c5.057 1.01 8.7 5.467 8.7 10.643a10.8 10.8 0 0 1-3.167 7.673z"
}));

function ArrowRight$1() {
  return React__default.createElement(SvgComponent, null);
}

function ArrowUp$1() {
  return React__default.createElement(SvgComponent$2, null);
}

function ArrowDown$1() {
  return React__default.createElement(SvgComponent$3, null);
}

function ArrowLeft$1() {
  return React__default.createElement(SvgComponent$1, null);
}

var _templateObject$4 = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$3 = taggedTemplateLiteral(['\n    display: block;\n    position: relative;\n    perspective: 1200px;\n    .flip-body {\n      display: flex;\n      transition: transform 0.5s;\n      transform-style: preserve-3d;\n      ', '\n      & > .front,\n      & > .back {\n        flex: 1;\n\n        .flip-button {\n          line-height: ', ';\n          margin-bottom: ', ';\n          padding: ', ';\n          cursor: pointer;\n          position: absolute;\n          ', '\n          ', '\n          opacity: 1;\n          transition: opacity 0s 0.15s;\n        }\n      }\n\n      & > .front {\n        ', '\n        transition: opacity 0s 0.2s;\n        backface-visibility: visible;\n        ', '\n      }\n\n      & > .back {\n        backface-visibility: ', ';\n        transform: rotateY(180deg);\n      }\n    }\n  '], ['\n    display: block;\n    position: relative;\n    perspective: 1200px;\n    .flip-body {\n      display: flex;\n      transition: transform 0.5s;\n      transform-style: preserve-3d;\n      ', '\n      & > .front,\n      & > .back {\n        flex: 1;\n\n        .flip-button {\n          line-height: ', ';\n          margin-bottom: ', ';\n          padding: ', ';\n          cursor: pointer;\n          position: absolute;\n          ', '\n          ', '\n          opacity: 1;\n          transition: opacity 0s 0.15s;\n        }\n      }\n\n      & > .front {\n        ', '\n        transition: opacity 0s 0.2s;\n        backface-visibility: visible;\n        ', '\n      }\n\n      & > .back {\n        backface-visibility: ', ';\n        transform: rotateY(180deg);\n      }\n    }\n  ']),
    _templateObject3$3 = taggedTemplateLiteral(['\n            backface-visibility: hidden;\n            opacity: 0;\n            .flip-button {\n              opacity: 0;\n              z-index: -1;\n            }\n          '], ['\n            backface-visibility: hidden;\n            opacity: 0;\n            .flip-button {\n              opacity: 0;\n              z-index: -1;\n            }\n          ']);

var FlipCardStyled = styled__default.div(_templateObject$4, function (_ref) {
  var theme = _ref.theme,
      flipped = _ref.flipped,
      button = _ref.button;
  return styled.css(_templateObject2$3, flipped ? 'transform: rotateY(-180deg);' : '', theme.cardLineHeight, theme.cardMargin, theme.cardPadding, theme.dir === 'ltr' ? 'right: 0;' : 'left: 0;', button === 'bottom' ? 'bottom: 0;' : 'top: 0;', theme.dir === 'ltr' ? 'margin-right: -100%;' : 'margin-left: -100%;', flipped && styled.css(_templateObject3$3), flipped ? 'visible' : 'hidden');
});
function FlipCard(props) {
  var _useState = React.useState(false),
      _useState2 = slicedToArray(_useState, 2),
      flipped = _useState2[0],
      setFlipped = _useState2[1];

  var handleFlipped = function handleFlipped() {
    setFlipped(!flipped);
  };

  return React__default.createElement(
    FlipCardStyled,
    {
      className: props.className,
      style: props.style,
      flipped: flipped,
      button: props.button
    },
    React__default.createElement(
      'div',
      { className: 'flip-body' },
      React__default.createElement(
        'div',
        { className: 'front' },
        props.children[0],
        React__default.createElement(
          'i',
          { className: 'flip-button', onClick: handleFlipped },
          React__default.createElement(ArrowRight$1, null)
        )
      ),
      React__default.createElement(
        'div',
        { className: 'back' },
        props.children[1],
        React__default.createElement(
          'i',
          { className: 'flip-button', onClick: handleFlipped },
          React__default.createElement(ArrowLeft$1, null)
        )
      )
    )
  );
}
FlipCard.propTypes = {
  classNames: PropTypes.string,
  style: PropTypes.object,
  button: PropTypes.oneOf(['top', 'bottom'])
};

var _templateObject$5 = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$4 = taggedTemplateLiteral(['\n    display: block;\n    position: relative;\n    overflow: hidden;\n    & > .front {\n      display: block;\n      height: 100%;\n    }\n\n    & > .back {\n      position: absolute;\n      top: ', ';\n      right: 0;\n      left: 0;\n      overflow: hidden;\n      transition: ', ';\n      height: calc(100% - ', ');\n      .container {\n        position: absolute;\n        left: 0;\n        top: ', ';\n        width: 100%;\n        transition: top 0.5s;\n      }\n    }\n    .reveal-button {\n      cursor: pointer;\n      position: absolute;\n      transition: transform 0.3s;\n      line-height: ', ';\n      margin-bottom: ', ';\n      padding: ', ';\n      ', ';\n      ', ';\n    }\n  '], ['\n    display: block;\n    position: relative;\n    overflow: hidden;\n    & > .front {\n      display: block;\n      height: 100%;\n    }\n\n    & > .back {\n      position: absolute;\n      top: ', ';\n      right: 0;\n      left: 0;\n      overflow: hidden;\n      transition: ', ';\n      height: calc(100% - ', ');\n      .container {\n        position: absolute;\n        left: 0;\n        top: ', ';\n        width: 100%;\n        transition: top 0.5s;\n      }\n    }\n    .reveal-button {\n      cursor: pointer;\n      position: absolute;\n      transition: transform 0.3s;\n      line-height: ', ';\n      margin-bottom: ', ';\n      padding: ', ';\n      ', ';\n      ', ';\n    }\n  ']);

var RevealCardStyled = styled__default.div(_templateObject$5, function (_ref) {
  var theme = _ref.theme,
      button = _ref.button,
      revealed = _ref.revealed;
  return styled.css(_templateObject2$4, revealed ? '0' : '100%', revealed ? 'none' : 'top 0s 0.5s', theme.cardMargin, revealed ? '0' : '100%', theme.cardLineHeight, theme.cardMargin, theme.cardPadding, theme.dir === 'ltr' ? 'right: 0;' : 'left: 0;', button === 'bottom' ? 'bottom: 0;' : 'top: 0;');
});
function RevealCard(props) {
  var _useState = React.useState(false),
      _useState2 = slicedToArray(_useState, 2),
      revealed = _useState2[0],
      setRevealed = _useState2[1];

  var handleRevealed = function handleRevealed() {
    setRevealed(!revealed);
  };
  return React__default.createElement(
    RevealCardStyled,
    {
      className: props.className,
      style: props.style,
      revealed: revealed,
      button: props.button
    },
    React__default.createElement(
      'div',
      { className: 'front' },
      props.children[0]
    ),
    React__default.createElement(
      'div',
      { className: 'back' },
      React__default.createElement(
        'div',
        { className: 'container' },
        props.children[1]
      )
    ),
    React__default.createElement(
      'div',
      { className: 'reveal-button', onClick: handleRevealed },
      revealed ? React__default.createElement(ArrowDown$1, null) : React__default.createElement(ArrowUp$1, null)
    )
  );
}
RevealCard.propTypes = {
  classNames: PropTypes.string,
  style: PropTypes.object,
  button: PropTypes.oneOf(['top', 'bottom'])
};

var _templateObject$6 = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$5 = taggedTemplateLiteral(['\n    text-transform: uppercase;\n    letter-spacing: 0.4px;\n    border: 2px solid transparent;\n    transition: none;\n    cursor: pointer;\n    -webkit-appearance: none;\n    -moz-appearance: none;\n    text-align: center;\n    text-decoration: none;\n    display: inline-block;\n    white-space: nowrap;\n    vertical-align: middle;\n    user-select: none;\n\n    color: ', ';\n    font-weight: ', ';\n    font-family: ', ';\n    cursor: ', ';\n    ', '\n\n    &:hover,\n    &:focus {\n      text-decoration: none;\n    }\n\n    ', '\n\n    ', '\n\n\n    ', '\n\n\n    ', '\n\n    ', '\n  '], ['\n    text-transform: uppercase;\n    letter-spacing: 0.4px;\n    border: 2px solid transparent;\n    transition: none;\n    cursor: pointer;\n    -webkit-appearance: none;\n    -moz-appearance: none;\n    text-align: center;\n    text-decoration: none;\n    display: inline-block;\n    white-space: nowrap;\n    vertical-align: middle;\n    user-select: none;\n\n    color: ', ';\n    font-weight: ', ';\n    font-family: ', ';\n    cursor: ', ';\n    ', '\n\n    &:hover,\n    &:focus {\n      text-decoration: none;\n    }\n\n    ', '\n\n    ', '\n\n\n    ', '\n\n\n    ', '\n\n    ', '\n  ']),
    _templateObject3$4 = taggedTemplateLiteral(['\n        &:focus,\n        &:hover,\n        &:active,\n        &.focus,\n        &.hover,\n        &.active {\n          color: ', ';\n          cursor: ', ';\n        }\n      '], ['\n        &:focus,\n        &:hover,\n        &:active,\n        &.focus,\n        &.hover,\n        &.active {\n          color: ', ';\n          cursor: ', ';\n        }\n      ']),
    _templateObject4$3 = taggedTemplateLiteral(['\n        padding: ', ' ', ';\n        font-size: ', ';\n        line-height: ', ';\n        border-radius: ', ';\n      '], ['\n        padding: ', ' ', ';\n        font-size: ', ';\n        line-height: ', ';\n        border-radius: ', ';\n      ']),
    _templateObject5$2 = taggedTemplateLiteral(['\n        border-radius: ', ';\n      '], ['\n        border-radius: ', ';\n      ']),
    _templateObject6 = taggedTemplateLiteral(['\n        ', '\n\n        &:focus,\n        &.focus {\n          ', '\n        }\n        &:hover,\n        &.hover {\n          color: ', ';\n          background-color: ', ';\n          border-color: transparent;\n        }\n        &:active,\n        &.active,\n        &:active:focus {\n          color: ', ';\n          background-color: ', ';\n          border-color: transparent;\n          box-shadow: none;\n        }\n\n        &:disabled,\n        &.disabled {\n          opacity: ', ';\n          cursor: not-allowed;\n        }\n\n\n        ', '\n\n/* hero button start */\n      ', '\n\n      '], ['\n        ', '\n\n        &:focus,\n        &.focus {\n          ', '\n        }\n        &:hover,\n        &.hover {\n          color: ', ';\n          background-color: ', ';\n          border-color: transparent;\n        }\n        &:active,\n        &.active,\n        &:active:focus {\n          color: ', ';\n          background-color: ', ';\n          border-color: transparent;\n          box-shadow: none;\n        }\n\n        &:disabled,\n        &.disabled {\n          opacity: ', ';\n          cursor: not-allowed;\n        }\n\n\n        ', '\n\n/* hero button start */\n      ', '\n\n      ']),
    _templateObject7 = taggedTemplateLiteral(['\n                border: 2px solid ', ';\n                color: ', ';\n                background-color: ', ';\n              '], ['\n                border: 2px solid ', ';\n                color: ', ';\n                background-color: ', ';\n              ']),
    _templateObject8 = taggedTemplateLiteral(['\n                  border-color: ', ';\n                  box-shadow: none;\n                '], ['\n                  border-color: ', ';\n                  box-shadow: none;\n                ']),
    _templateObject9 = taggedTemplateLiteral(['\n                  color: ', ';\n                  background-color: ', ';\n                  border-color: transparent;\n                  box-shadow: none;\n                '], ['\n                  color: ', ';\n                  background-color: ', ';\n                  border-color: transparent;\n                  box-shadow: none;\n                ']),
    _templateObject10 = taggedTemplateLiteral(['\n            &:focus,\n            &.focus,\n            &:hover,\n            &.hover,\n            &:active,\n            &.active {\n              color: ', ';\n            }\n          '], ['\n            &:focus,\n            &.focus,\n            &:hover,\n            &.hover,\n            &:active,\n            &.active {\n              color: ', ';\n            }\n          ']),
    _templateObject11 = taggedTemplateLiteral(['\n          background-image: linear-gradient(\n            to right,\n            ', ',\n            ', '\n          );\n          box-shadow: ', ';\n          text-shadow: ', ';\n          line-height: calc((', ' * 1.25) + 4px);\n          &:focus,\n          &.focus,\n          &:hover,\n          &.hover {\n            background-image: ', ';\n          }\n          &:active,\n          &.active {\n            background-image: ', ';\n            box-shadow: none;\n            border-color: transparent;\n          }\n          ', ';\n        '], ['\n          background-image: linear-gradient(\n            to right,\n            ', ',\n            ', '\n          );\n          box-shadow: ', ';\n          text-shadow: ', ';\n          line-height: calc((', ' * 1.25) + 4px);\n          &:focus,\n          &.focus,\n          &:hover,\n          &.hover {\n            background-image: ', ';\n          }\n          &:active,\n          &.active {\n            background-image: ', ';\n            box-shadow: none;\n            border-color: transparent;\n          }\n          ', ';\n        ']),
    _templateObject12 = taggedTemplateLiteral(['\n  0% {\n      box-shadow: none;\n      opacity: ', ';\n    }\n    50% {\n      box-shadow: 0 0 1rem 0 ', ';\n      opacity: 0.8;\n    }\n    100% {\n      box-shadow: none;\n      opacity: ', ';\n    }\n  '], ['\n  0% {\n      box-shadow: none;\n      opacity: ', ';\n    }\n    50% {\n      box-shadow: 0 0 1rem 0 ', ';\n      opacity: 0.8;\n    }\n    100% {\n      box-shadow: none;\n      opacity: ', ';\n    }\n  ']),
    _templateObject13 = taggedTemplateLiteral(['\n    animation: ', ' 1.5s infinite;\n  '], ['\n    animation: ', ' 1.5s infinite;\n  ']),
    _templateObject14 = taggedTemplateLiteral(['\n  &[type=\'button\'],\n  &[type=\'submit\'] {\n    ', '\n  }\n'], ['\n  &[type=\'button\'],\n  &[type=\'submit\'] {\n    ', '\n  }\n']);

/* eslint-disable indent */

var ButtonStyle = styled.css(_templateObject$6, function (_ref) {
  var theme = _ref.theme,
      shape$$1 = _ref.shape,
      size$$1 = _ref.size,
      status = _ref.status,
      fullWidth = _ref.fullWidth,
      outline = _ref.outline,
      hero = _ref.hero,
      pulse = _ref.pulse;
  return styled.css(_templateObject2$5, theme.btnFg, theme.fontWeightBolder, theme.btnFontFamily, theme.btnCursor, !outline && styled.css(_templateObject3$4, theme.btnFg, theme.btnCursor), size$$1 && styled.css(_templateObject4$3, theme['btnPaddingY' + size$$1], theme['btnPaddingX' + size$$1], theme['btnFontSize' + size$$1], theme.btnLineHeight, theme.btnBorderRadius), shape$$1 && styled.css(_templateObject5$2, theme['btn' + shape$$1 + 'BorderRadius']), pulse && btnPulse(theme['btn' + status + 'Bg'], theme.btnDisabledOpacity), status && styled.css(_templateObject6, status === 'Secondary' || outline ? styled.css(_templateObject7, theme[color(status)], theme.btnOutlineFg, outline ? 'transparent' : theme.btnSecondaryBg) : 'background-color: ' + theme['btn' + status + 'Bg'] + ';', status === 'Secondary' || outline ? styled.css(_templateObject8, curriedTint(percentage(status, outline), theme[color(status)])) : styled.css(_templateObject9, theme.btnOutlineHoverFg, curriedTint(percentage(status), theme[color(status)])), theme.btnOutlineHoverFg, curriedTint(percentage(status), theme[color(status)]), theme.btnOutlineHoverFg, curriedShade(percentage(status), theme[color(status)]), theme.btnDisabledOpacity, status === 'Secondary' && styled.css(_templateObject10, theme.btnOutlineFg), hero && styled.css(_templateObject11, leftColor(status, theme), theme[color(status)], heroShadow(status, theme), theme.btnHeroTextShadow, theme['btnFontSize' + size$$1], lightGradient(status, theme), darkGradient(status, theme), status === 'Secondary' ? 'border : 2px solid ' + theme.btnSecondaryBorder : 'border: none')), fullWidth && 'width: 100%;');
});

var lightGradient = function lightGradient(status, theme) {
  return 'linear-gradient(to right, ' + curriedTint(0.14, leftColor(status, theme)) + ', ' + curriedTint(0.14, theme[color(status)]) + ');';
};

var darkGradient = function darkGradient(status, theme) {
  return 'linear-gradient(to right, ' + curriedShade(0.14, leftColor(status, theme)) + ', ' + curriedShade(0.14, theme[color(status)]) + ');';
};

var leftColor = function leftColor(status, theme) {
  return curriedAdjustHue(heroPercentage[status], theme[color(status)]);
};

var heroShadow = function heroShadow(status, theme) {
  var middleColor = curriedMix(0.5, curriedAdjustHue(heroPercentage[status], theme[color(status)]), theme[color(status)]);
  var bevel = theme.btnHeroBevelSize + ' ' + curriedShade(0.14, middleColor);
  var glow = theme.btnHeroGlowSize + ' ' + middleColor;
  var shadow = theme.btnHeroShadow;
  var boxShadow = [bevel, glow];
  shadow !== 'none' && boxShadow.push(shadow);
  return boxShadow.join(',');
};

var heroPercentage = {
  Primary: 20,
  Success: 20,
  Warning: 10,
  Info: -10,
  Danger: -20,
  Secondary: 20
};
var percentage = function percentage(status, outline) {
  return status === 'Secondary' || outline ? 0.2 : 0.14;
};

var color = function color(status) {
  return status === 'Secondary' ? 'btnSecondaryBorder' : 'btn' + status + 'Bg';
};

var btnPulse = function btnPulse(color, opacity) {
  var pulse = styled.keyframes(_templateObject12, opacity, color, opacity);
  return styled.css(_templateObject13, pulse);
};

var defaultProps = {
  size: 'MD',
  status: 'Primary'
};

var Button = styled__default.button(_templateObject$6, ButtonStyle);

Button.defaultProps = defaultProps;
Button.propTypes = buttonTypes;

var ButtonLink = styled__default.a(_templateObject$6, ButtonStyle);

ButtonLink.defaultProps = defaultProps;
ButtonLink.propTypes = buttonTypes;

var ButtonInput = styled__default.input(_templateObject14, ButtonStyle);

ButtonInput.defaultProps = _extends({}, defaultProps, { type: 'button' });
ButtonInput.propTypes = _extends({}, buttonTypes, {
  type: PropTypes.oneOf(['button', 'submit'])
});

var _templateObject$7 = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$6 = taggedTemplateLiteral(['\n    display: block;\n    margin-bottom: 1rem;\n    button {\n      position: relative;\n      width: 100%;\n      text-align: start;\n      overflow: hidden;\n      text-overflow: ellipsis;\n      white-space: nowrap;\n      border: none;\n      transition: all 0.1s;\n      ', '\n\n      &::after {\n        top: 50%;\n        ', ': 0.75rem;\n        position: absolute;\n        display: inline-block;\n        width: 0;\n        height: 0;\n        margin-left: 0.255em;\n        vertical-align: 0.255em;\n        content: \'\';\n        border-top: 0.3em solid;\n        border-right: 0.3em solid transparent;\n        border-bottom: 0;\n        border-left: 0.3em solid transparent;\n      }\n\n      ', '\n    }\n  '], ['\n    display: block;\n    margin-bottom: 1rem;\n    button {\n      position: relative;\n      width: 100%;\n      text-align: start;\n      overflow: hidden;\n      text-overflow: ellipsis;\n      white-space: nowrap;\n      border: none;\n      transition: all 0.1s;\n      ', '\n\n      &::after {\n        top: 50%;\n        ', ': 0.75rem;\n        position: absolute;\n        display: inline-block;\n        width: 0;\n        height: 0;\n        margin-left: 0.255em;\n        vertical-align: 0.255em;\n        content: \'\';\n        border-top: 0.3em solid;\n        border-right: 0.3em solid transparent;\n        border-bottom: 0;\n        border-left: 0.3em solid transparent;\n      }\n\n      ', '\n    }\n  ']),
    _templateObject3$5 = taggedTemplateLiteral(['\n            border-', '-left-radius: 0;\n            border-', '-right-radius: 0;\n          '], ['\n            border-', '-left-radius: 0;\n            border-', '-right-radius: 0;\n          ']),
    _templateObject4$4 = taggedTemplateLiteral(['\n    position: absolute;\n    box-sizing: border-box;\n    z-index: 1000;\n    display: flex;\n    width: 100%;\n    height: 100%;\n    min-width: 1px;\n    min-height: 1px;\n    top: 0px;\n    left: 0px;\n    .overlay-pane {\n      position: absolute;\n      pointer-events: auto;\n      display: flex;\n      max-width: 100%;\n      max-height: 100%;\n      box-sizing: border-box;\n      ', '\n\n      ', ' {\n        background-color: ', ';\n        max-height: ', ';\n        margin-bottom: 0;\n        box-shadow: none;\n        .card-body {\n          padding: 0;\n        }\n        ', ' {\n          padding: ', ';\n        }\n        ', '\n        ', '\n        ', ',\n        ', ' {\n          &.disabled {\n            background-color: ', ';\n            opacity: ', ';\n          }\n        }\n      } \n    }\n  '], ['\n    position: absolute;\n    box-sizing: border-box;\n    z-index: 1000;\n    display: flex;\n    width: 100%;\n    height: 100%;\n    min-width: 1px;\n    min-height: 1px;\n    top: 0px;\n    left: 0px;\n    .overlay-pane {\n      position: absolute;\n      pointer-events: auto;\n      display: flex;\n      max-width: 100%;\n      max-height: 100%;\n      box-sizing: border-box;\n      ', '\n\n      ', ' {\n        background-color: ', ';\n        max-height: ', ';\n        margin-bottom: 0;\n        box-shadow: none;\n        .card-body {\n          padding: 0;\n        }\n        ', ' {\n          padding: ', ';\n        }\n        ', '\n        ', '\n        ', ',\n        ', ' {\n          &.disabled {\n            background-color: ', ';\n            opacity: ', ';\n          }\n        }\n      } \n    }\n  ']),
    _templateObject5$3 = taggedTemplateLiteral(['\n            border: ', ' solid ', ';\n\n            ', ':hover, ', '.selected {\n              background-color: ', ';\n              color: ', ';\n            }\n          '], ['\n            border: ', ' solid ', ';\n\n            ', ':hover, ', '.selected {\n              background-color: ', ';\n              color: ', ';\n            }\n          ']),
    _templateObject6$1 = taggedTemplateLiteral(['\n    display: block;\n\n    &.disabled {\n      pointer-events: none;\n    }\n\n    &:hover {\n      cursor: pointer;\n    }\n\n    ', ' {\n      pointer-events: none;\n      .description {\n        color: inherit;\n      }\n    }\n    &&.selected {\n      ', ' {\n        .indicator {\n          border-color: ', ';\n\n          &::before {\n            border-color: ', ';\n          }\n        }\n      }\n    }\n  '], ['\n    display: block;\n\n    &.disabled {\n      pointer-events: none;\n    }\n\n    &:hover {\n      cursor: pointer;\n    }\n\n    ', ' {\n      pointer-events: none;\n      .description {\n        color: inherit;\n      }\n    }\n    &&.selected {\n      ', ' {\n        .indicator {\n          border-color: ', ';\n\n          &::before {\n            border-color: ', ';\n          }\n        }\n      }\n    }\n  ']),
    _templateObject7$1 = taggedTemplateLiteral(['\n  display: block;\n\n  span {\n    padding: 1.125rem 0.5rem;\n    display: block;\n  }\n\n  &.disabled {\n    pointer-events: none;\n  }\n\n  ', ' {\n    padding: 0.75rem 0.75rem 0.75rem 2.5rem;\n  }\n'], ['\n  display: block;\n\n  span {\n    padding: 1.125rem 0.5rem;\n    display: block;\n  }\n\n  &.disabled {\n    pointer-events: none;\n  }\n\n  ', ' {\n    padding: 0.75rem 0.75rem 0.75rem 2.5rem;\n  }\n']);

var SelectStyle = styled__default.div(_templateObject$7, function (_ref) {
  var theme = _ref.theme,
      opened = _ref.opened,
      placement = _ref.placement;
  return styled.css(_templateObject2$6, ButtonStyle, theme.dir === 'rtl' ? 'left' : 'right', opened && placement && styled.css(_templateObject3$5, placement, placement));
});

var SelectCard = styled__default.div(_templateObject$7, function (_ref2) {
  var theme = _ref2.theme,
      placement = _ref2.placement,
      status = _ref2.status,
      position = _ref2.position;
  return styled.css(_templateObject4$4, !position && 'visibility: hidden;', Card, theme.selectBg, theme.selectMaxHeight, Option, theme.selectOptionPadding, status && styled.css(_templateObject5$3, theme.selectBorderWidth, theme['color' + status], Option, Option, theme['color' + status], theme.colorWhite), getBorder(placement), Option, OptionGroup, theme.selectOptionDisabledBg, theme.selectOptionDisabledOpacity);
});

var getBorder = function getBorder(placement) {
  var pos = placement === 'top' ? 'bottom' : 'top';
  return 'border-' + pos + '-left-radius: 0;border-' + pos + '-right-radius: 0;';
};

var Option = styled__default.div(_templateObject$7, function (_ref3) {
  var theme = _ref3.theme;
  return styled.css(_templateObject6$1, CheckboxStyle, CheckboxStyle, theme.selectCheckboxColor, theme.selectCheckmarkColor);
});

var OptionGroup = styled__default.div(_templateObject7$1, Option);

function Select(props) {
  var _useState = React.useState([].concat(toConsumableArray(props.options))),
      _useState2 = slicedToArray(_useState, 2),
      options = _useState2[0],
      setOptions = _useState2[1];

  var _useState3 = React.useState(false),
      _useState4 = slicedToArray(_useState3, 2),
      opened = _useState4[0],
      setOpened = _useState4[1];

  var _useState5 = React.useState('bottom'),
      _useState6 = slicedToArray(_useState5, 2),
      placement$$1 = _useState6[0],
      setPlacement = _useState6[1];

  var _useState7 = React.useState(),
      _useState8 = slicedToArray(_useState7, 2),
      position$$1 = _useState8[0],
      setPosition = _useState8[1];

  var overlayRef = React.useRef();
  var targetRef = React.useRef();

  React.useEffect(function () {
    if (props.value) {
      var newOptions = [].concat(toConsumableArray(options));
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = newOptions[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var option = _step.value;

          if (props.multiple) {
            option.selected = props.value.includes(option.value);
          } else {
            option.selected = props.value === option.value;
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      setOptions(newOptions);
    }
  }, []);

  React.useEffect(function () {
    window.addEventListener('click', onClickHandle);
    if (opened) {
      positionHandle();
      window.addEventListener('resize', positionHandle);
      document.querySelector('.scrollable-container').addEventListener('scroll', positionHandle);
      if (props.eventListener) {
        document.querySelector(props.eventListener).addEventListener('scroll', positionHandle);
      }
    }
    return function () {
      window.removeEventListener('click', onClickHandle);
      if (opened) {
        window.removeEventListener('resize', positionHandle);
        document.querySelector('.scrollable-container').removeEventListener('scroll', positionHandle);
        if (props.eventListener) {
          document.querySelector(props.eventListener).removeEventListener('scroll', positionHandle);
        }
      }
    };
  }, [opened]);

  var positionHandle = function positionHandle() {
    var target = targetRef.current.getBoundingClientRect();
    var overlay = overlayRef.current.getBoundingClientRect();

    var data = {
      placement: 'bottom',
      position: { top: 0, left: target.left, maxHeight: 'none' }
    };

    if (overlay.height > window.innerHeight - target.bottom) {
      if (overlay.height < target.top) {
        data.placement = 'top';
      } else {
        data.position.maxHeight = window.innerHeight - target.bottom;
      }
    }
    data.position.top = data.placement === 'bottom' ? target.bottom : target.top - overlay.height;

    setPosition(data.position);
    setPlacement(data.placement);
  };

  var onClickHandle = function onClickHandle() {
    setOpened(false);
  };

  var onSelectMultiple = function onSelectMultiple(i) {
    var newOptions = [].concat(toConsumableArray(options));
    newOptions[i].selected = !newOptions[i].selected;
    setOptions(newOptions);
    var selectedView = [];
    var _iteratorNormalCompletion2 = true;
    var _didIteratorError2 = false;
    var _iteratorError2 = undefined;

    try {
      for (var _iterator2 = newOptions[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
        var option = _step2.value;

        option.selected && selectedView.push(option.value);
      }
    } catch (err) {
      _didIteratorError2 = true;
      _iteratorError2 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion2 && _iterator2.return) {
          _iterator2.return();
        }
      } finally {
        if (_didIteratorError2) {
          throw _iteratorError2;
        }
      }
    }

    typeof props.onChange === 'function' && props.onChange(selectedView);
  };

  var onSelectHandle = function onSelectHandle(i) {
    var newOptions = [].concat(toConsumableArray(options));
    var _iteratorNormalCompletion3 = true;
    var _didIteratorError3 = false;
    var _iteratorError3 = undefined;

    try {
      for (var _iterator3 = newOptions.keys()[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
        var key = _step3.value;

        newOptions[key].selected = i === key && newOptions[key].value;
      }
    } catch (err) {
      _didIteratorError3 = true;
      _iteratorError3 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion3 && _iterator3.return) {
          _iterator3.return();
        }
      } finally {
        if (_didIteratorError3) {
          throw _iteratorError3;
        }
      }
    }

    typeof props.onChange === 'function' && props.onChange(newOptions[i].value);
    setOptions(newOptions);
    setOpened(false);
  };

  var placeholder = function placeholder() {
    var selectedView = [];

    var _arr = [].concat(toConsumableArray(options));

    for (var _i = 0; _i < _arr.length; _i++) {
      var option = _arr[_i];
      option.selected && selectedView.push(option.label);
    }
    if (selectedView.length <= 0) {
      return props.placeholder;
    } else if (props.customLabel) {
      return props.customLabel;
    } else {
      return selectedView.join(',');
    }
  };

  return React__default.createElement(
    React.Fragment,
    null,
    opened && ReactDOM.createPortal(React__default.createElement(
      SelectCard,
      {
        placement: placement$$1,
        status: props.status,
        position: position$$1
      },
      React__default.createElement(
        'div',
        {
          className: 'overlay-pane',
          style: position$$1 && _extends({}, position$$1),
          ref: overlayRef,
          onClick: function onClick(e) {
            return e.stopPropagation();
          }
        },
        React__default.createElement(
          Card,
          { style: { width: targetRef.current.offsetWidth } },
          React__default.createElement(
            'div',
            { className: 'card-body' },
            options.map(function (option, index) {
              var className = [];
              option.selected && className.push('selected');
              option.disabled && className.push('disabled');
              return props.multiple ? React__default.createElement(
                Option,
                {
                  key: index,
                  className: className.join(' '),
                  onClick: function onClick() {
                    return onSelectMultiple(index);
                  }
                },
                React__default.createElement(
                  Checkbox,
                  { checked: option.selected },
                  option.label
                )
              ) : React__default.createElement(
                Option,
                {
                  key: index,
                  className: className.join(' '),
                  onClick: function onClick() {
                    return onSelectHandle(index);
                  }
                },
                option.label
              );
            })
          )
        )
      )
    ), document.getElementById('overlay-container')),
    React__default.createElement(
      SelectStyle,
      _extends({}, props, { opened: opened, placement: placement$$1 }),
      React__default.createElement(
        'button',
        {
          onClick: function onClick(e) {
            e.stopPropagation();
            setOpened(!opened);
          },
          ref: targetRef
        },
        placeholder()
      )
    )
  );
}
var defaultProps$1 = {
  size: 'MD',
  status: 'Primary'
};

var propTypes = {
  options: PropTypes.arrayOf(PropTypes.shape({
    value: PropTypes.any,
    label: PropTypes.any,
    selected: PropTypes.bool,
    disabled: PropTypes.bool
  })),
  eventListener: PropTypes.string,
  customLabel: PropTypes.string,
  multiple: PropTypes.bool,
  onChange: PropTypes.func,
  value: PropTypes.oneOfType([PropTypes.any, PropTypes.array]),
  placeholder: PropTypes.any
};

Select.defaultProps = defaultProps$1;
Select.propTypes = _extends({}, propTypes, buttonTypes);

var _templateObject$8 = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$7 = taggedTemplateLiteral(['\n      position: relative;\n      display: inline-flex;\n      margin: 0;\n      min-height: inherit;\n      padding: 0.375rem 1.5rem 0.375rem 0;\n      input {\n        position: absolute;\n        opacity: 0;\n      }\n      ', '\n      .indicator {\n        border-radius: 50%;\n        flex-shrink: 0;\n        display: flex;\n        justify-content: center;\n        align-items: center;\n        background-color: ', ';\n        width: ', ';\n        height: ', ';\n        border: ', ' solid\n          ', ';\n\n        &::before {\n          content: \'\';\n          transition: all 0.1s;\n          border-radius: 50%;\n          background-color: ', ';\n          height: calc(', ' * 0.6);\n          width: calc(', ' * 0.6);\n          border: solid ', ';\n        }\n      }\n      .description {\n        color: ', ';\n        padding-', ': 0.5rem;\n      }\n      ', '\n        ', '\n    '], ['\n      position: relative;\n      display: inline-flex;\n      margin: 0;\n      min-height: inherit;\n      padding: 0.375rem 1.5rem 0.375rem 0;\n      input {\n        position: absolute;\n        opacity: 0;\n      }\n      ', '\n      .indicator {\n        border-radius: 50%;\n        flex-shrink: 0;\n        display: flex;\n        justify-content: center;\n        align-items: center;\n        background-color: ', ';\n        width: ', ';\n        height: ', ';\n        border: ', ' solid\n          ', ';\n\n        &::before {\n          content: \'\';\n          transition: all 0.1s;\n          border-radius: 50%;\n          background-color: ', ';\n          height: calc(', ' * 0.6);\n          width: calc(', ' * 0.6);\n          border: solid ', ';\n        }\n      }\n      .description {\n        color: ', ';\n        padding-', ': 0.5rem;\n      }\n      ', '\n        ', '\n    ']),
    _templateObject3$6 = taggedTemplateLiteral(['\n          .indicator,\n          .description {\n            opacity: 0.5;\n          }\n        '], ['\n          .indicator,\n          .description {\n            opacity: 0.5;\n          }\n        ']),
    _templateObject4$5 = taggedTemplateLiteral(['\n          &:hover .indicator {\n            border-color: ', ';\n          }\n        '], ['\n          &:hover .indicator {\n            border-color: ', ';\n          }\n        ']),
    _templateObject5$4 = taggedTemplateLiteral(['\n            .indicator {\n              border-color: ', ';\n            }\n          '], ['\n            .indicator {\n              border-color: ', ';\n            }\n          ']);

var RadioStyle = styled__default.label(_templateObject$8, function (_ref) {
  var theme = _ref.theme,
      checked = _ref.checked,
      disabled = _ref.disabled,
      status = _ref.status;

  var state = checked ? 'Checked' : disabled ? 'Disabled' : '';
  var size$$1 = theme['radio' + state + 'Size'];
  return styled.css(_templateObject2$7, disabled && styled.css(_templateObject3$6), theme['radio' + state + 'Bg'], size$$1, size$$1, theme['radio' + state + 'BorderSize'], theme['radio' + state + 'BorderColor'], theme['radio' + state + 'Checkmark'], size$$1, size$$1, theme['radio' + state + 'Checkmark'], theme.radioFg, theme.dir === 'rtl' ? 'right' : 'left', !disabled && styled.css(_templateObject4$5, theme[hoverBorder$1(status)]), checked && styled.css(_templateObject5$4, theme[hoverBorder$1(status)]));
});
var hoverBorder$1 = function hoverBorder(status) {
  return status ? 'color' + status : 'radioCheckedBorderColor';
};

function Radio(props) {
  var _useState = React.useState(props.options),
      _useState2 = slicedToArray(_useState, 2),
      options = _useState2[0],
      setOptions = _useState2[1];

  var onClickHandler = function onClickHandler(value) {
    var updateOptions = [].concat(toConsumableArray(options));
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = updateOptions[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var option = _step.value;

        option.checked = option.value === value;
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    setOptions(updateOptions);
    props.onChange(value);
  };

  return options.map(function (option) {
    return React__default.createElement(
      RadioStyle,
      {
        status: option.status,
        checked: option.checked,
        disabled: option.disabled || props.disabled,
        key: option.value,
        className: props.className
      },
      React__default.createElement('input', {
        type: 'radio',
        name: props.name,
        disabled: option.disabled || props.disabled,
        onClick: function onClick() {
          return onClickHandler(option.value);
        }
      }),
      React__default.createElement('span', { className: 'indicator' }),
      React__default.createElement(
        'span',
        { className: 'description' },
        option.label
      )
    );
  });
}

Radio.propTypes = {
  name: PropTypes.string,
  disabled: PropTypes.bool,
  onChange: PropTypes.func.isRequired,
  options: PropTypes.arrayOf(PropTypes.shape({
    value: PropTypes.any.isRequired,
    label: PropTypes.any.isRequired,
    checked: PropTypes.bool,
    disabled: PropTypes.bool,
    status: colorState
  }).isRequired).isRequired
};

exports.InputGroup = InputGroup;
exports.Checkbox = Checkbox;
exports.Select = Select;
exports.Radio = Radio;
