'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = _interopDefault(require('prop-types'));
var styled = require('styled-components');
var styled__default = _interopDefault(styled);

var slicedToArray = function () {
  function sliceIterator(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"]) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  return function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if (Symbol.iterator in Object(arr)) {
      return sliceIterator(arr, i);
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };
}();

var taggedTemplateLiteral = function (strings, raw) {
  return Object.freeze(Object.defineProperties(strings, {
    raw: {
      value: Object.freeze(raw)
    }
  }));
};

var toConsumableArray = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
};

var _templateObject = taggedTemplateLiteral(['\n      @media (max-width: ', 'px) {\n        ', '\n      }\n    '], ['\n      @media (max-width: ', 'px) {\n        ', '\n      }\n    ']),
    _templateObject2 = taggedTemplateLiteral(['\n      @media (min-width: ', 'px) {\n        ', '\n      }\n    '], ['\n      @media (min-width: ', 'px) {\n        ', '\n      }\n    ']),
    _templateObject3 = taggedTemplateLiteral(['\n      @media (min-width: ', 'px) and (max-width: ', 'px) {\n        ', '\n      }\n    '], ['\n      @media (min-width: ', 'px) and (max-width: ', 'px) {\n        ', '\n      }\n    ']);
var breakpoints = {
  xs: 0,
  is: 400,
  sm: 576,
  md: 768,
  lg: 992,
  xl: 1200,
  xxl: 1400,
  xxxl: 1600
};
function breakpointMin(name) {
  return breakpoints[name] != 0 ? breakpoints[name] : null;
}

function breakpointNext(index) {
  return index < Object.keys(breakpoints).length ? Object.keys(breakpoints)[index + 1] : null;
}

function breakpointMax(name) {
  var n = Object.keys(breakpoints).indexOf(name);
  var next = breakpointNext(n);
  return next ? breakpointMin(next) - 0.2 : null;
}

var breakpointDown = function breakpointDown(name) {
  return function () {
    var max = breakpointMax(name);
    if (max) {
      return styled.css(_templateObject, max, styled.css.apply(undefined, arguments));
    } else {
      return styled.css.apply(undefined, arguments);
    }
  };
};

var _templateObject$1 = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$1 = taggedTemplateLiteral(['\n    background: ', ';\n    display: block;\n    color: ', ';\n    .scrollable-container {\n      overflow: auto;\n      height: 100vh;\n      display: block;\n      margin: 0 auto;\n      max-width: ', ';\n      ', '\n    }\n    .layout {\n      display: flex;\n      flex-direction: column;\n      min-width: ', ';\n      min-height: ', ';\n      font-family: ', ';\n      font-size: ', ';\n      line-height: ', ';\n      .layout-header {\n        font-family: ', ';\n        font-size: ', ';\n        line-height: ', ';\n        display: block;\n        nav {\n          box-shadow: ', ';\n          height: ', ';\n          padding: ', ';\n          background: ', ';\n          color: ', ';\n          align-items: center;\n          justify-content: flex-start;\n          display: flex;\n          a {\n            color: ', ';\n            &:hover,\n            &:focus,\n            &:active {\n              color: ', ';\n            }\n          }\n        }\n        &.fixed {\n          position: fixed;\n          left: 0;\n          right: 0;\n          z-index: 1040;\n        }\n        & ~ .layout-container {\n          min-height: calc(\n            ', '\n          );\n        }\n\n        &.fixed ~ .layout-container {\n          padding-top: ', ';\n          min-height: ', ';\n        }\n\n        &.fixed ~ .layout-container > aside > .main-container {\n          height: calc(', ');\n        }\n      }\n\n      .layout-container {\n        display: flex;\n        flex: 1;\n        flex-direction: row;\n        .content {\n          display: flex;\n          flex: 1;\n          flex-direction: column;\n          min-width: 0;\n          .layout-footer {\n            display: block;\n            margin-top: auto;\n            box-shadow: ', ';\n            nav {\n              justify-content: center;\n              display: flex;\n              padding: ', ';\n              background: ', ';\n              color: ', ';\n              border-top: 1px solid ', ';\n              a {\n                color: ', ';\n                &:hover,\n                &:focus,\n                &:active {\n                  color: ', ';\n                }\n              }\n            }\n          }\n          &.center {\n            max-width: 100%;\n            position: relative;\n            margin-left: auto;\n            margin-right: auto;\n            width: ', ';\n            flex: 0 100 ', ' !important;\n          }\n\n          .columns {\n            display: flex;\n            flex: 1;\n            flex-direction: row;\n            width: 100%;\n            .main-container {\n              order: 1;\n              flex: 1 0;\n              min-width: 0;\n              padding: ', ';\n\n              ', '\n\n              ', '\n\n            &.left {\n                order: ', ';\n              }\n              &.start {\n                order: 0;\n              }\n            }\n          }\n        }\n      }\n    }\n    #overlay-container {\n      position: fixed;\n      z-index: 1040;\n      pointer-events: none;\n      top: 0;\n      left: 0;\n      height: 100%;\n      width: 100%;\n    }\n  '], ['\n    background: ', ';\n    display: block;\n    color: ', ';\n    .scrollable-container {\n      overflow: auto;\n      height: 100vh;\n      display: block;\n      margin: 0 auto;\n      max-width: ', ';\n      ', '\n    }\n    .layout {\n      display: flex;\n      flex-direction: column;\n      min-width: ', ';\n      min-height: ', ';\n      font-family: ', ';\n      font-size: ', ';\n      line-height: ', ';\n      .layout-header {\n        font-family: ', ';\n        font-size: ', ';\n        line-height: ', ';\n        display: block;\n        nav {\n          box-shadow: ', ';\n          height: ', ';\n          padding: ', ';\n          background: ', ';\n          color: ', ';\n          align-items: center;\n          justify-content: flex-start;\n          display: flex;\n          a {\n            color: ', ';\n            &:hover,\n            &:focus,\n            &:active {\n              color: ', ';\n            }\n          }\n        }\n        &.fixed {\n          position: fixed;\n          left: 0;\n          right: 0;\n          z-index: 1040;\n        }\n        & ~ .layout-container {\n          min-height: calc(\n            ', '\n          );\n        }\n\n        &.fixed ~ .layout-container {\n          padding-top: ', ';\n          min-height: ', ';\n        }\n\n        &.fixed ~ .layout-container > aside > .main-container {\n          height: calc(', ');\n        }\n      }\n\n      .layout-container {\n        display: flex;\n        flex: 1;\n        flex-direction: row;\n        .content {\n          display: flex;\n          flex: 1;\n          flex-direction: column;\n          min-width: 0;\n          .layout-footer {\n            display: block;\n            margin-top: auto;\n            box-shadow: ', ';\n            nav {\n              justify-content: center;\n              display: flex;\n              padding: ', ';\n              background: ', ';\n              color: ', ';\n              border-top: 1px solid ', ';\n              a {\n                color: ', ';\n                &:hover,\n                &:focus,\n                &:active {\n                  color: ', ';\n                }\n              }\n            }\n          }\n          &.center {\n            max-width: 100%;\n            position: relative;\n            margin-left: auto;\n            margin-right: auto;\n            width: ', ';\n            flex: 0 100 ', ' !important;\n          }\n\n          .columns {\n            display: flex;\n            flex: 1;\n            flex-direction: row;\n            width: 100%;\n            .main-container {\n              order: 1;\n              flex: 1 0;\n              min-width: 0;\n              padding: ', ';\n\n              ', '\n\n              ', '\n\n            &.left {\n                order: ', ';\n              }\n              &.start {\n                order: 0;\n              }\n            }\n          }\n        }\n      }\n    }\n    #overlay-container {\n      position: fixed;\n      z-index: 1040;\n      pointer-events: none;\n      top: 0;\n      left: 0;\n      height: 100%;\n      width: 100%;\n    }\n  ']),
    _templateObject3$1 = taggedTemplateLiteral(['\n      overflow-y: scroll;\n      -webkit-overflow-scrolling: touch;\n    '], ['\n      overflow-y: scroll;\n      -webkit-overflow-scrolling: touch;\n    ']),
    _templateObject4 = taggedTemplateLiteral(['\n              padding: ', ';\n            '], ['\n              padding: ', ';\n            ']);

var LayoutStyle = styled__default.div(_templateObject$1, function (_ref) {
  var theme = _ref.theme;
  return styled.css(_templateObject2$1, theme.layoutBg, theme.layoutFg, theme.layoutWindowModeMaxWidth, breakpointDown('sm')(_templateObject3$1), theme.layoutWindowModeMinWidth, theme.layoutMinHeight, theme.layoutFontFamily, theme.layoutFontSize, theme.layoutLineHeight, theme.headerFontFamily, theme.headerFontSize, theme.headerLineHeight, theme.headerShadow, theme.headerHeight, theme.headerPadding, theme.headerBg, theme.headerFg, theme.headerFg, theme.headerFg, theme.layoutMinHeight + ' - ' + theme.headerHeight, theme.headerHeight, theme.layoutMinHeight, theme.sidebarHeight + ' - ' + theme.headerHeight, theme.footerShadow, theme.footerPadding, theme.footerBg, theme.footerFg, theme.footerSeparator, theme.footerFgHighlight, theme.footerFgHighlight, theme.layoutContentWidth, theme.layoutContentWidth, theme.layoutPadding, breakpointDown('md')(_templateObject4, theme.layoutMediumPadding), breakpointDown('sm')(_templateObject4, theme.layoutSmallPadding), theme.dir === 'rtl' ? '2' : '0');
});

var layoutContext = React__default.createContext({
  addClass: function addClass() {},
  removeClass: function removeClass() {},
  dir: 'ltr'
});

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

function LayoutHeader(props) {
  return React__default.createElement(
    'header',
    { className: props.fixed ? 'fixed layout-header' : 'layout-header' },
    React__default.createElement(
      'nav',
      null,
      props.children
    )
  );
}
LayoutHeader.propTypes = {
  fixed: PropTypes.bool
};
function LayoutFooter(props) {
  return React__default.createElement(
    'footer',
    { className: 'layout-footer' },
    React__default.createElement(
      'nav',
      null,
      props.children
    )
  );
}

function LayoutColumns(props) {
  return React__default.createElement(
    'div',
    { className: 'columns' },
    React__default.createElement(
      'div',
      { className: 'main-container' },
      props.children
    )
  );
}

function LayoutContent(props) {
  return React__default.createElement(
    'div',
    { className: 'content' },
    props.children
  );
}
function LayoutContainer(props) {
  return React__default.createElement(
    'div',
    { className: 'layout-container' },
    props.children
  );
}

function Layout(props) {
  var _useState = React.useState(props.className ? [].concat(toConsumableArray(props.className.split(' '))) : []),
      _useState2 = slicedToArray(_useState, 2),
      className = _useState2[0],
      setClassName = _useState2[1];

  var addClass = function addClass(cssClass) {
    var updatedClass = [].concat(toConsumableArray(className));
    updatedClass.push.apply(updatedClass, toConsumableArray(cssClass));
    setClassName(updatedClass);
  };

  var removeClass = function removeClass(cssClass) {
    var updatedClass = [].concat(toConsumableArray(className));
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = updatedClass.keys()[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var i = _step.value;

        if (cssClass.includes(updatedClass[i])) {
          updatedClass.splice(i, 1);
        }
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    setClassName(updatedClass);
  };

  return React__default.createElement(
    LayoutStyle,
    {
      id: 'oah-layout',
      className: className.join(' '),
      style: props.style
    },
    React__default.createElement(
      layoutContext.Provider,
      { value: { addClass: addClass, removeClass: removeClass, dir: props.dir } },
      React__default.createElement(
        'div',
        { className: 'scrollable-container' },
        React__default.createElement(
          'div',
          { className: 'layout' },
          props.children
        )
      ),
      React__default.createElement('div', { id: 'overlay-container' })
    )
  );
}
Layout.defaultProps = {
  dir: 'ltr'
};

Layout.propTypes = {
  dir: PropTypes.oneOf(['ltr', 'rtl']),
  className: PropTypes.string,
  style: PropTypes.object
};

exports.Layout = Layout;
exports.LayoutHeader = LayoutHeader;
exports.LayoutContent = LayoutContent;
exports.LayoutFooter = LayoutFooter;
exports.LayoutContainer = LayoutContainer;
exports.LayoutColumns = LayoutColumns;
exports.LayoutStyle = LayoutStyle;
exports.LayoutContext = layoutContext;
