'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = _interopDefault(require('prop-types'));
var styled = require('styled-components');
var styled__default = _interopDefault(styled);

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

var slicedToArray = function () {
  function sliceIterator(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"]) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  return function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if (Symbol.iterator in Object(arr)) {
      return sliceIterator(arr, i);
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };
}();

var taggedTemplateLiteral = function (strings, raw) {
  return Object.freeze(Object.defineProperties(strings, {
    raw: {
      value: Object.freeze(raw)
    }
  }));
};

var toConsumableArray = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
};

var _templateObject = taggedTemplateLiteral(['\n  ', ';\n'], ['\n  ', ';\n']),
    _templateObject2 = taggedTemplateLiteral(['\n    font-family: ', ';\n    font-size: ', ';\n    font-weight: ', ';\n    background: ', ';\n    color: ', ';\n    display: block;\n    ul.menu-items {\n      margin: 0;\n      padding: 0;\n    }\n\n    .menu-group {\n      font-weight: ', ';\n      font-size: ', ';\n      color: ', ';\n      padding: ', ';\n    }\n\n    .menu-item {\n      a {\n        padding: ', ';\n        border-radius: ', ';\n      }\n\n      a:hover,\n      a.active {\n        background-color: ', ';\n        color: ', ';\n        font-weight: ', ';\n        .menu-icon {\n          color: ', ';\n        }\n        .chevron {\n          path {\n            fill: ', ';\n            stroke: ', ';\n          }\n        }\n      }\n\n      .menu-icon {\n        font-size: ', ';\n        width: auto;\n        margin: ', ';\n        text-align: center;\n        color: ', ';\n      }\n\n      .chevron {\n        path {\n          fill: ', ';\n          stroke: ', ';\n        }\n\n        ', '\n      }\n    }\n\n    .menu-items > .menu-item {\n      border-bottom: 1px solid ', ';\n      &:first-child {\n        border-top: 1px solid ', ';\n      }\n    }\n\n    .menu-item > .menu-items {\n      background-color: ', ';\n    }\n\n    .menu-item > .menu-items > .menu-item {\n      border: none;\n      background: ', ';\n      color: ', ';\n      padding: ', ';\n      &:first-child {\n        margin-top: ', ';\n      }\n      &:last-child {\n        margin-bottom: ', ';\n      }\n\n      a {\n        border: ', ';\n        padding: ', ';\n      }\n\n      a:hover {\n        color: ', ';\n        background: ', ';\n      }\n\n      a.active {\n        background-color: ', ';\n        color: ', ';\n        border-color: ', ';\n        box-shadow: none;\n        transition: all 300ms cubic-bezier(0.4, 0, 0.6, 1) 0ms;\n      }\n    }\n    .menu-items,\n    .menu-item > .menu-items {\n      list-style-type: none;\n      overflow: hidden;\n    }\n\n    .menu-item a {\n      display: flex;\n      color: inherit;\n      text-decoration: none;\n      align-items: center;\n\n      .menu-title {\n        flex: 1;\n        ', ';\n      }\n    }\n\n    &.inverse {\n      .menu-item {\n        a {\n          color: ', ';\n        }\n\n        a:hover {\n          background-color: ', ';\n          color: ', ';\n        }\n\n        a.active {\n          background-color: ', ';\n          color: ', ';\n        }\n      }\n\n      .menu-group {\n        color: ', ';\n      }\n    }\n  '], ['\n    font-family: ', ';\n    font-size: ', ';\n    font-weight: ', ';\n    background: ', ';\n    color: ', ';\n    display: block;\n    ul.menu-items {\n      margin: 0;\n      padding: 0;\n    }\n\n    .menu-group {\n      font-weight: ', ';\n      font-size: ', ';\n      color: ', ';\n      padding: ', ';\n    }\n\n    .menu-item {\n      a {\n        padding: ', ';\n        border-radius: ', ';\n      }\n\n      a:hover,\n      a.active {\n        background-color: ', ';\n        color: ', ';\n        font-weight: ', ';\n        .menu-icon {\n          color: ', ';\n        }\n        .chevron {\n          path {\n            fill: ', ';\n            stroke: ', ';\n          }\n        }\n      }\n\n      .menu-icon {\n        font-size: ', ';\n        width: auto;\n        margin: ', ';\n        text-align: center;\n        color: ', ';\n      }\n\n      .chevron {\n        path {\n          fill: ', ';\n          stroke: ', ';\n        }\n\n        ', '\n      }\n    }\n\n    .menu-items > .menu-item {\n      border-bottom: 1px solid ', ';\n      &:first-child {\n        border-top: 1px solid ', ';\n      }\n    }\n\n    .menu-item > .menu-items {\n      background-color: ', ';\n    }\n\n    .menu-item > .menu-items > .menu-item {\n      border: none;\n      background: ', ';\n      color: ', ';\n      padding: ', ';\n      &:first-child {\n        margin-top: ', ';\n      }\n      &:last-child {\n        margin-bottom: ', ';\n      }\n\n      a {\n        border: ', ';\n        padding: ', ';\n      }\n\n      a:hover {\n        color: ', ';\n        background: ', ';\n      }\n\n      a.active {\n        background-color: ', ';\n        color: ', ';\n        border-color: ', ';\n        box-shadow: none;\n        transition: all 300ms cubic-bezier(0.4, 0, 0.6, 1) 0ms;\n      }\n    }\n    .menu-items,\n    .menu-item > .menu-items {\n      list-style-type: none;\n      overflow: hidden;\n    }\n\n    .menu-item a {\n      display: flex;\n      color: inherit;\n      text-decoration: none;\n      align-items: center;\n\n      .menu-title {\n        flex: 1;\n        ', ';\n      }\n    }\n\n    &.inverse {\n      .menu-item {\n        a {\n          color: ', ';\n        }\n\n        a:hover {\n          background-color: ', ';\n          color: ', ';\n        }\n\n        a.active {\n          background-color: ', ';\n          color: ', ';\n        }\n      }\n\n      .menu-group {\n        color: ', ';\n      }\n    }\n  ']),
    _templateObject3 = taggedTemplateLiteral(['\n  ul {\n    &.expanded {\n      max-height: 1500px;\n      transition: max-height 0.5s cubic-bezier(1, 0.15, 1, 1);\n    }\n\n    &.collapsed {\n      max-height: 0;\n      transition: max-height 0.5s cubic-bezier(0, 1, 0.3, 1) -100ms;\n    }\n  }\n'], ['\n  ul {\n    &.expanded {\n      max-height: 1500px;\n      transition: max-height 0.5s cubic-bezier(1, 0.15, 1, 1);\n    }\n\n    &.collapsed {\n      max-height: 0;\n      transition: max-height 0.5s cubic-bezier(0, 1, 0.3, 1) -100ms;\n    }\n  }\n']);

var MenuStyle = styled__default.div(_templateObject, function (_ref) {
  var theme = _ref.theme;
  return styled.css(_templateObject2, theme.menuFontFamily, theme.menuFontSize, theme.menuFontWeight, theme.menuBg, theme.menuFg, theme.menuGroupFontWeight, theme.menuGroupFontSize, theme.menuGroupFg, theme.menuGroupPadding, theme.menuItemPadding, theme.menuSubmenuItemBorderRadius, theme.menuActiveBg, theme.menuActiveFg, theme.menuActiveFontWeight, theme.menuIconActiveColor, theme.menuIconActiveColor, theme.menuIconActiveColor, theme.menuIconFontSize, theme.menuIconMargin, theme.menuIconColor, theme.menuIconColor, theme.menuIconColor, theme.dir === 'rtl' && 'transform: rotateY(180deg);', theme.menuItemSeparator, theme.menuItemSeparator, theme.menuSubmenuBg, theme.menuSubmenuBg, theme.menuSubmenuFg, theme.menuSubmenuItemContainerPadding, theme.menuSubmenuPadding, theme.menuSubmenuPadding, theme.menuSubmenuItemBorderWidth + ' solid ' + theme.menuSubmenuBg, theme.menuSubmenuItemPadding, theme.menuSubmenuHoverFg, theme.menuSubmenuHoverBg, theme.menuSubmenuActiveBg, theme.menuSubmenuActiveFg, theme.menuSubmenuActiveBorderColor, theme.dir === 'rtl' ? 'text-align: right' : '', theme.menuBg, theme.menuActiveFg, theme.menuActiveBg, theme.menuActiveFg, theme.menuActiveBg, theme.menuBg);
});
var ItemStyle = styled__default.li(_templateObject3);

var _ref =
/*#__PURE__*/
React__default.createElement("path", {
  fill: "#99ABB4",
  fillRule: "evenodd",
  stroke: "#99ABB4",
  d: "M8 6.982L2.428 2l-.363.324 5.208 4.658L2 11.676l.363.324z"
});

function _extends$2() {
  _extends$2 = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }return target;
  };return _extends$2.apply(this, arguments);
}

var _ref$1 =
/*#__PURE__*/
React__default.createElement("path", {
  fill: "#99ABB4",
  fillRule: "evenodd",
  stroke: "#99ABB4",
  d: "M2 7.018L7.572 12l.363-.324-5.208-4.658L8 2.324 7.637 2z"
});

var SvgComponent$1 = function SvgComponent(props) {
  return React__default.createElement("svg", _extends$2({
    width: 10,
    height: 14
  }, props), _ref$1);
};

var _ref$2 =
/*#__PURE__*/
React__default.createElement("path", {
  fill: "#99ABB4",
  fillRule: "evenodd",
  stroke: "#99ABB4",
  d: "M6.982 2L2 7.572l.324.363 4.658-5.208L11.676 8 12 7.637z"
});

function _extends$4() {
  _extends$4 = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }return target;
  };return _extends$4.apply(this, arguments);
}

var _ref$3 =
/*#__PURE__*/
React__default.createElement("path", {
  fill: "#99ABB4",
  fillRule: "evenodd",
  stroke: "#99ABB4",
  d: "M7.018 8L12 2.428l-.324-.363-4.658 5.208L2.324 2 2 2.363z"
});

var SvgComponent$3 = function SvgComponent(props) {
  return React__default.createElement("svg", _extends$4({
    width: 14,
    height: 10
  }, props), _ref$3);
};

var _ref$4 =
/*#__PURE__*/
React__default.createElement("path", {
  fill: "#FFF",
  fillRule: "evenodd",
  d: "M12.979 13.651c-.145.22-.508.22-.653 0a.494.494 0 0 1 0-.734 5.058 5.058 0 0 0 1.305-1.761 5.32 5.32 0 0 0 .435-2.128c0-.955-.217-1.835-.652-2.57a4.747 4.747 0 0 0-1.885-1.908c-.218-.146-.29-.44-.145-.733.145-.22.435-.294.725-.147.87.587 1.667 1.32 2.175 2.275.508.954.798 1.982.798 3.083 0 .88-.218 1.761-.508 2.568a5.431 5.431 0 0 1-1.595 2.055zM8.919 0c2.465 0 4.64 1.028 6.308 2.642a9.1 9.1 0 0 1 2.61 6.386c0 2.201-.87 4.256-2.175 5.871L16.822 16l.217-.294c.363-.293.725-.44 1.16-.44.363 0 .798.147 1.088.44l4.278 4.257c.29.367.435.734.435 1.175 0 .367-.145.807-.435 1.1L22.26 23.56c-.29.293-.653.44-1.088.44-.435 0-.797-.147-1.087-.44l-4.278-4.257c-.29-.367-.435-.734-.435-1.175 0-.367.145-.807.435-1.1l.29-.294-1.16-1.101a8.76 8.76 0 0 1-6.019 2.422 8.88 8.88 0 0 1-6.308-2.642C1.015 13.725 0 11.523 0 9.028a9.1 9.1 0 0 1 2.61-6.386A8.88 8.88 0 0 1 8.918 0zm5.583 3.376c-1.45-1.468-3.408-2.348-5.584-2.348-2.175 0-4.133.88-5.583 2.348a7.98 7.98 0 0 0-2.32 5.652 7.98 7.98 0 0 0 2.32 5.65c1.45 1.395 3.408 2.35 5.583 2.35 2.176 0 4.133-.955 5.584-2.35l.072-.146h.073c1.305-1.468 2.175-3.376 2.175-5.504 0-2.202-.943-4.184-2.32-5.652z"
});

var _ref$5 =
/*#__PURE__*/
React__default.createElement("g", {
  fillRule: "evenodd"
}, React__default.createElement("path", {
  d: "M12.78 11.95l5.039-5.058a.554.554 0 0 0 0-.78.548.548 0 0 0-.778 0l-5.038 5.057L6.965 6.11a.548.548 0 0 0-.778 0 .554.554 0 0 0 0 .781l5.038 5.057-5.048 5.068a.554.554 0 0 0 0 .78.548.548 0 0 0 .778 0L12 12.73l5.048 5.068a.548.548 0 0 0 .92-.248.553.553 0 0 0-.142-.533L12.78 11.95z"
}), React__default.createElement("path", {
  fillRule: "nonzero",
  d: "M20.42 3.502A11.874 11.874 0 0 0 5.384 2.016C.66 5.184-1.176 11.26.998 16.53c2.175 5.269 7.754 8.262 13.326 7.149 5.572-1.113 9.585-6.022 9.584-11.725a11.899 11.899 0 0 0-3.488-8.452zm-.778 16.125a10.778 10.778 0 0 1-13.648 1.348C1.707 18.098.04 12.582 2.014 7.8 3.988 3.018 9.052.301 14.11 1.311c5.057 1.01 8.7 5.467 8.7 10.643a10.8 10.8 0 0 1-3.167 7.673z"
}));

function ArrowDown$1() {
  return React__default.createElement(SvgComponent$3, null);
}

function ArrowLeft$1() {
  return React__default.createElement(SvgComponent$1, null);
}

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

var Item = function Item(_ref) {
  var item = _ref.item,
      toggleSidebar = _ref.toggleSidebar,
      toggleSubMenu = _ref.toggleSubMenu,
      selectItem = _ref.selectItem,
      id = _ref.id,
      Link = _ref.Link;

  React.useEffect(function () {
    var link = window.location.pathname;
    if (link === item.link || link === item.link + '/' || link + '/' === item.link) {
      selectItem(id);
    }
  }, []);

  var isActive = function isActive(_ref2) {
    var isCurrent = _ref2.isCurrent;

    isCurrent && !item.selected && selectItem(id);
  };

  var handleToggleSubMenu = function handleToggleSubMenu() {
    toggleSubMenu(item);
  };

  return React__default.createElement(
    ItemStyle,
    { className: item.group ? 'menu-item menu-group' : 'menu-item' },
    item.group ? React__default.createElement(
      'span',
      null,
      item.icon && React__default.createElement('i', { className: 'menu-icon ' + item.icon }),
      item.title
    ) : item.link && !item.children ? React__default.createElement(
      Link,
      {
        to: item.link,
        getProps: isActive,
        title: item.title,
        target: item.target,
        className: item.selected ? 'active' : '',
        onClick: toggleSidebar
      },
      React__default.createElement('i', { className: 'menu-icon ' + item.icon }),
      React__default.createElement(
        'span',
        { className: 'menu-title' },
        item.title
      )
    ) : item.url && !item.children ? React__default.createElement(
      'a',
      { href: item.url, target: item.target, title: item.title },
      React__default.createElement('i', { className: 'menu-icon ' + item.icon }),
      React__default.createElement(
        'span',
        { className: 'menu-title' },
        item.title
      )
    ) : item.children ? React__default.createElement(
      React.Fragment,
      null,
      React__default.createElement(
        'a',
        {
          href: item.link,
          title: item.title,
          onClick: function onClick(e) {
            e.preventDefault();
            handleToggleSubMenu();
          },
          className: item.selected ? 'active' : ''
        },
        React__default.createElement('i', { className: 'menu-icon ' + item.icon }),
        React__default.createElement(
          'span',
          { className: 'menu-title' },
          item.title
        ),
        React__default.createElement(
          'i',
          { className: 'chevron' },
          item.expanded ? React__default.createElement(ArrowDown$1, null) : React__default.createElement(ArrowLeft$1, null)
        )
      ),
      React__default.createElement(
        'ul',
        {
          className: item.expanded ? 'menu-items expanded' : 'menu-items collapsed'
        },
        item.children.map(function (item2, index) {
          return !item.hidden && React__default.createElement(Item, {
            key: index,
            item: item2,
            id: id + ',' + index,
            Link: Link,
            selectItem: selectItem,
            toggleSidebar: toggleSidebar,
            toggleSubMenu: toggleSubMenu
          });
        })
      )
    ) : ''
  );
};

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

var badge = PropTypes.shape({
  status: colorState,
  title: PropTypes.string,
  position: position
});
var position = PropTypes.oneOf(['topRight', 'topLeft', 'bottomRight', 'bottomLeft', 'topStart', 'topEnd', 'bottomStart', 'bottomEnd']);

var colorState = PropTypes.oneOf(['Info', 'Success', 'Danger', 'Primary', 'Warning', 'Disabled']);

var placement = PropTypes.oneOf(['start', 'end', 'right', 'left', 'top', 'bottom']);

var trigger = PropTypes.oneOf(['click', 'hover', 'focus']);

var statusArray = ['Info', 'Success', 'Danger', 'Primary', 'Warning'];

var size = PropTypes.oneOf(['XXS', 'XS', 'SM', 'MD', 'LG', 'XL', 'XXL']);

var shape = PropTypes.oneOf(['Rectangle', 'SemiRound', 'Round']);

var itemType = {
  title: PropTypes.string.isRequired,
  link: PropTypes.any,
  expanded: PropTypes.bool,
  group: PropTypes.bool,
  hidden: PropTypes.bool,
  icon: PropTypes.string,
  target: PropTypes.string,
  url: PropTypes.string
};
function menuItemsType() {
  return PropTypes.arrayOf(PropTypes.shape(_extends({}, itemType, {
    children: menuItemsType
  }))).apply(undefined, arguments);
}

var buttonTypes = {
  fullWidth: PropTypes.bool,
  hero: PropTypes.bool,
  outline: PropTypes.bool,
  pulse: PropTypes.bool,
  size: PropTypes.oneOf(['XS', 'SM', 'MD', 'LG']),
  shape: shape,
  status: PropTypes.oneOf([].concat(statusArray, ['Secondary']))
};

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

var Menu = React.forwardRef(function (props, ref) {
  var _useState = React.useState(props.items),
      _useState2 = slicedToArray(_useState, 2),
      items = _useState2[0],
      setItems = _useState2[1];

  React.useImperativeHandle(ref, function () {
    return {
      collapseAll: function collapseAll() {
        setItems(toggleSubMenu([].concat(toConsumableArray(items)), false));
      },
      expandAll: function expandAll() {
        setItems(toggleSubMenu([].concat(toConsumableArray(items)), true));
      }
    };
  }, [items]);

  var onSelectItem = function onSelectItem(index) {
    var indexArray = Number.isInteger(index) ? [index] : index.split(',');
    setItems(updateSelected([].concat(toConsumableArray(items)), indexArray));
  };

  var updateSelected = function updateSelected(updateItems, ia) {
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = updateItems.keys()[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var i = _step.value;

        var state = i === Number(ia[0]);
        updateItems[i].selected = state;
        if (state) {
          updateItems[i].expanded = true;
        }
        if (updateItems[i].children) {
          if (state) {
            updateSelected(updateItems[i].children, ia.splice(1));
          } else {
            updateSelected(updateItems[i].children, []);
          }
        }
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    return updateItems;
  };

  var onToggleSubMenu = function onToggleSubMenu(item) {
    setItems(toggleSubMenu([].concat(toConsumableArray(items)), item));
  };

  var toggleSubMenu = function toggleSubMenu(updateItems, action) {
    var _iteratorNormalCompletion2 = true;
    var _didIteratorError2 = false;
    var _iteratorError2 = undefined;

    try {
      for (var _iterator2 = updateItems[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
        var item = _step2.value;

        if (typeof action === 'boolean') {
          item.expanded = action;
        } else if (item === action) {
          item.expanded = !item.expanded;
          break;
        }
        if (item.children) {
          toggleSubMenu(item.children, action);
        }
      }
    } catch (err) {
      _didIteratorError2 = true;
      _iteratorError2 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion2 && _iterator2.return) {
          _iterator2.return();
        }
      } finally {
        if (_didIteratorError2) {
          throw _iteratorError2;
        }
      }
    }

    return updateItems;
  };

  return React__default.createElement(
    MenuStyle,
    { className: props.className, style: props.style },
    React__default.createElement(
      'ul',
      { className: 'menu-items' },
      items.map(function (item, index) {
        return !item.hidden && React__default.createElement(Item, {
          key: index,
          id: index,
          item: item,
          Link: props.Link,
          selectItem: function selectItem(i) {
            return onSelectItem(i);
          },
          toggleSidebar: props.toggleSidebar,
          toggleSubMenu: function toggleSubMenu(item) {
            return onToggleSubMenu(item);
          }
        });
      })
    )
  );
});

Menu.propTypes = {
  items: menuItemsType,
  toggleSidebar: PropTypes.func,
  Link: PropTypes.object.isRequired,
  className: PropTypes.string,
  style: PropTypes.string
};

module.exports = Menu;
