'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = _interopDefault(require('prop-types'));
var styled = require('styled-components');
var styled__default = _interopDefault(styled);
var ReactDOM = _interopDefault(require('react-dom'));

var slicedToArray = function () {
  function sliceIterator(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"]) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  return function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if (Symbol.iterator in Object(arr)) {
      return sliceIterator(arr, i);
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };
}();

var taggedTemplateLiteral = function (strings, raw) {
  return Object.freeze(Object.defineProperties(strings, {
    raw: {
      value: Object.freeze(raw)
    }
  }));
};

var _templateObject = taggedTemplateLiteral(['\n  display: block;\n  position: fixed;\n  z-index: 1050;\n  top: 0;\n  left: 50%;\n  overflow: hidden;\n  width: 50%;\n  height: 100vh;\n  pointer-events: none;\n\n  &::before {\n    content: \'\';\n    position: absolute;\n    top: 0;\n    left: 0;\n    width: 100%;\n    height: 100%;\n    transform: scale3d(0, 1, 1);\n    transform-origin: 0 50%;\n    transition: transform 0.3s;\n    transition-timing-function: cubic-bezier(0.86, 0, 0.07, 1);\n  }\n\n  .search {\n    position: relative;\n    padding: 2.5rem 1.5rem 0;\n    background: transparent;\n\n    button {\n      position: absolute;\n      top: 2rem;\n      ', '\n      font-size: 2.5rem;\n      opacity: 0;\n      transition: opacity 0.5s;\n    }\n\n    .form {\n      width: 85%;\n      transform: translate3d(-150%, 0, 0);\n      transition: transform 0.3s;\n    }\n\n    input {\n      font-size: 2.5rem;\n      width: 100%;\n    }\n\n    span {\n      font-size: 85%;\n    }\n  }\n\n  &.show {\n    pointer-events: auto;\n\n    &::before {\n      transform: scale3d(1, 1, 1);\n    }\n\n    .search {\n      .form {\n        transform: translate3d(0, 0, 0);\n        transition-delay: 0.15s;\n        transition-timing-function: cubic-bezier(0.86, 0, 0.07, 1);\n      }\n\n      button {\n        opacity: 1;\n        z-index: 100;\n      }\n    }\n  }\n\n  @media screen and (max-width: 40rem) {\n    span {\n      width: 90%;\n    }\n\n    input {\n      font-size: 2rem;\n      width: 90%;\n    }\n  }\n'], ['\n  display: block;\n  position: fixed;\n  z-index: 1050;\n  top: 0;\n  left: 50%;\n  overflow: hidden;\n  width: 50%;\n  height: 100vh;\n  pointer-events: none;\n\n  &::before {\n    content: \'\';\n    position: absolute;\n    top: 0;\n    left: 0;\n    width: 100%;\n    height: 100%;\n    transform: scale3d(0, 1, 1);\n    transform-origin: 0 50%;\n    transition: transform 0.3s;\n    transition-timing-function: cubic-bezier(0.86, 0, 0.07, 1);\n  }\n\n  .search {\n    position: relative;\n    padding: 2.5rem 1.5rem 0;\n    background: transparent;\n\n    button {\n      position: absolute;\n      top: 2rem;\n      ', '\n      font-size: 2.5rem;\n      opacity: 0;\n      transition: opacity 0.5s;\n    }\n\n    .form {\n      width: 85%;\n      transform: translate3d(-150%, 0, 0);\n      transition: transform 0.3s;\n    }\n\n    input {\n      font-size: 2.5rem;\n      width: 100%;\n    }\n\n    span {\n      font-size: 85%;\n    }\n  }\n\n  &.show {\n    pointer-events: auto;\n\n    &::before {\n      transform: scale3d(1, 1, 1);\n    }\n\n    .search {\n      .form {\n        transform: translate3d(0, 0, 0);\n        transition-delay: 0.15s;\n        transition-timing-function: cubic-bezier(0.86, 0, 0.07, 1);\n      }\n\n      button {\n        opacity: 1;\n        z-index: 100;\n      }\n    }\n  }\n\n  @media screen and (max-width: 40rem) {\n    span {\n      width: 90%;\n    }\n\n    input {\n      font-size: 2rem;\n      width: 90%;\n    }\n  }\n']);

var columnCurtain = styled.css(_templateObject, function (_ref) {
  var theme = _ref.theme;
  return theme.dir === 'rtl' ? 'left: 3rem;' : 'right: 3rem;';
});

var _templateObject$1 = taggedTemplateLiteral(['\n  .search {\n    position: fixed;\n    z-index: 1050;\n    top: 0;\n    left: 100%;\n    overflow: hidden;\n    height: 100vh;\n    width: 100%;\n    padding: 3rem;\n    pointer-events: none;\n    transition: transform 0.3s;\n    transition-delay: 0.4s;\n    transition-timing-function: ease-out;\n\n    &::after {\n      content: \'\';\n      position: absolute;\n      top: 0;\n      left: 0;\n      width: 100%;\n      height: 100%;\n      transition: transform 0.3s;\n      transition-timing-function: ease-out;\n    }\n\n    button {\n      font-size: 2.5rem;\n      position: absolute;\n      top: 3rem;\n      ', '\n      transition: opacity 0.1s;\n      transition-delay: 0.3s;\n    }\n\n    .form {\n      width: 50%;\n      opacity: 0;\n      transform: scale3d(0.8, 0.8, 1);\n      transition: opacity 0.5s, transform 0.5s;\n    }\n\n    input {\n      width: 100%;\n      font-size: 6vw;\n    }\n  }\n\n  &.show {\n    .search {\n      width: 100%;\n      pointer-events: auto;\n      transform: translate3d(-100%, 0, 0);\n      transition-delay: 0s;\n\n      &::after {\n        transform: translate3d(100%, 0, 0);\n        transition-delay: 0.4s;\n      }\n\n      button {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n\n      .form {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n    }\n  }\n\n  @media screen and (max-width: 40em) {\n    span {\n      width: 90%;\n    }\n\n    input {\n      font-size: 2em;\n      width: 90%;\n    }\n  }\n'], ['\n  .search {\n    position: fixed;\n    z-index: 1050;\n    top: 0;\n    left: 100%;\n    overflow: hidden;\n    height: 100vh;\n    width: 100%;\n    padding: 3rem;\n    pointer-events: none;\n    transition: transform 0.3s;\n    transition-delay: 0.4s;\n    transition-timing-function: ease-out;\n\n    &::after {\n      content: \'\';\n      position: absolute;\n      top: 0;\n      left: 0;\n      width: 100%;\n      height: 100%;\n      transition: transform 0.3s;\n      transition-timing-function: ease-out;\n    }\n\n    button {\n      font-size: 2.5rem;\n      position: absolute;\n      top: 3rem;\n      ', '\n      transition: opacity 0.1s;\n      transition-delay: 0.3s;\n    }\n\n    .form {\n      width: 50%;\n      opacity: 0;\n      transform: scale3d(0.8, 0.8, 1);\n      transition: opacity 0.5s, transform 0.5s;\n    }\n\n    input {\n      width: 100%;\n      font-size: 6vw;\n    }\n  }\n\n  &.show {\n    .search {\n      width: 100%;\n      pointer-events: auto;\n      transform: translate3d(-100%, 0, 0);\n      transition-delay: 0s;\n\n      &::after {\n        transform: translate3d(100%, 0, 0);\n        transition-delay: 0.4s;\n      }\n\n      button {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n\n      .form {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n    }\n  }\n\n  @media screen and (max-width: 40em) {\n    span {\n      width: 90%;\n    }\n\n    input {\n      font-size: 2em;\n      width: 90%;\n    }\n  }\n']);

var curtain = styled.css(_templateObject$1, function (_ref) {
  var theme = _ref.theme;
  return theme.dir === 'rtl' ? 'left: 3rem;' : 'right: 3rem;';
});

var _templateObject$2 = taggedTemplateLiteral(['\n  0% {\n    opacity: 1;\n    transform: scale3d(1, 0, 1);\n  }\n  50% {\n    transform: scale3d(1, 1, 1);\n    transform-origin: 50% 0;\n    transition-timing-function: ease-out;\n  }\n  50.1% {\n    transform-origin: 50% 100%;\n    transition-timing-function: ease-out;\n  }\n  100% {\n    opacity: 1;\n    transform: scale3d(1, 0, 1);\n    transform-origin: 50% 100%;\n    transition-timing-function: ease-out;\n  }   \n'], ['\n  0% {\n    opacity: 1;\n    transform: scale3d(1, 0, 1);\n  }\n  50% {\n    transform: scale3d(1, 1, 1);\n    transform-origin: 50% 0;\n    transition-timing-function: ease-out;\n  }\n  50.1% {\n    transform-origin: 50% 100%;\n    transition-timing-function: ease-out;\n  }\n  100% {\n    opacity: 1;\n    transform: scale3d(1, 0, 1);\n    transform-origin: 50% 100%;\n    transition-timing-function: ease-out;\n  }   \n']),
    _templateObject2 = taggedTemplateLiteral(['\n  .search {\n    display: flex;\n    flex-direction: column;\n    justify-content: center;\n    align-items: center;\n    text-align: center;\n    z-index: 1050;\n    position: fixed;\n    top: 0;\n    left: 0;\n    width: 100%;\n    height: 100vh;\n    background: 0 0;\n    pointer-events: none;\n\n    &::before {\n      content: \'\';\n      position: absolute;\n      top: 0;\n      right: 0;\n      width: 100%;\n      height: 100%;\n      opacity: 0;\n      transition: opacity 0.4s;\n    }\n\n    button {\n      font-size: 2.5rem;\n      position: absolute;\n      top: 3rem;\n      ', '\n      display: block;\n      opacity: 0;\n      transition: opacity 0.4s;\n    }\n\n    .form {\n      position: relative;\n      margin: 5rem 0 2rem;\n    }\n\n    input {\n      font-size: 6vw;\n      width: 60%;\n      padding: 0.25rem;\n      text-align: center;\n      opacity: 0;\n      transition: opacity 0.4s;\n    }\n\n    span {\n      position: relative;\n      z-index: 9;\n      display: block;\n      width: 60%;\n      padding: 0.85rem 0;\n      opacity: 0;\n      transform: translate3d(0, -50px, 0);\n      transition: opacity 0.4s, transform 0.4s;\n    }\n\n    .form-content {\n      position: relative;\n      z-index: 10;\n      overflow: hidden;\n      transform: translate3d(0, -50px, 0);\n      transition: transform 0.4s;\n\n      &::after {\n        content: \'\';\n        position: absolute;\n        top: 0;\n        left: 20%;\n        width: 60%;\n        height: 105%;\n        opacity: 0;\n        transform-origin: 50% 0;\n      }\n    }\n  }\n\n  &.show {\n    .search {\n      pointer-events: auto;\n\n      &::before {\n        opacity: 1;\n      }\n\n      button {\n        opacity: 1;\n      }\n\n      .form-content {\n        transform: translate3d(0, 0, 0);\n        transition: none;\n\n        &::after {\n          animation: ', ' 0.8s cubic-bezier(0.4, 0, 0.2, 1) forwards;\n        }\n      }\n\n      input {\n        opacity: 1;\n        transition: opacity 0s 0.4s;\n      }\n\n      span {\n        opacity: 1;\n        transform: translate3d(0, 0, 0);\n        transition-delay: 0.4s;\n        transition-timing-function: ease-out;\n      }\n    }\n  }\n\n  @media screen and (max-width: 40rem) {\n    .form {\n      margin: 2rem 0;\n    }\n\n    input {\n      width: 100%;\n      left: 0;\n    }\n  }\n'], ['\n  .search {\n    display: flex;\n    flex-direction: column;\n    justify-content: center;\n    align-items: center;\n    text-align: center;\n    z-index: 1050;\n    position: fixed;\n    top: 0;\n    left: 0;\n    width: 100%;\n    height: 100vh;\n    background: 0 0;\n    pointer-events: none;\n\n    &::before {\n      content: \'\';\n      position: absolute;\n      top: 0;\n      right: 0;\n      width: 100%;\n      height: 100%;\n      opacity: 0;\n      transition: opacity 0.4s;\n    }\n\n    button {\n      font-size: 2.5rem;\n      position: absolute;\n      top: 3rem;\n      ', '\n      display: block;\n      opacity: 0;\n      transition: opacity 0.4s;\n    }\n\n    .form {\n      position: relative;\n      margin: 5rem 0 2rem;\n    }\n\n    input {\n      font-size: 6vw;\n      width: 60%;\n      padding: 0.25rem;\n      text-align: center;\n      opacity: 0;\n      transition: opacity 0.4s;\n    }\n\n    span {\n      position: relative;\n      z-index: 9;\n      display: block;\n      width: 60%;\n      padding: 0.85rem 0;\n      opacity: 0;\n      transform: translate3d(0, -50px, 0);\n      transition: opacity 0.4s, transform 0.4s;\n    }\n\n    .form-content {\n      position: relative;\n      z-index: 10;\n      overflow: hidden;\n      transform: translate3d(0, -50px, 0);\n      transition: transform 0.4s;\n\n      &::after {\n        content: \'\';\n        position: absolute;\n        top: 0;\n        left: 20%;\n        width: 60%;\n        height: 105%;\n        opacity: 0;\n        transform-origin: 50% 0;\n      }\n    }\n  }\n\n  &.show {\n    .search {\n      pointer-events: auto;\n\n      &::before {\n        opacity: 1;\n      }\n\n      button {\n        opacity: 1;\n      }\n\n      .form-content {\n        transform: translate3d(0, 0, 0);\n        transition: none;\n\n        &::after {\n          animation: ', ' 0.8s cubic-bezier(0.4, 0, 0.2, 1) forwards;\n        }\n      }\n\n      input {\n        opacity: 1;\n        transition: opacity 0s 0.4s;\n      }\n\n      span {\n        opacity: 1;\n        transform: translate3d(0, 0, 0);\n        transition-delay: 0.4s;\n        transition-timing-function: ease-out;\n      }\n    }\n  }\n\n  @media screen and (max-width: 40rem) {\n    .form {\n      margin: 2rem 0;\n    }\n\n    input {\n      width: 100%;\n      left: 0;\n    }\n  }\n']);

var scaleUpDown = styled.keyframes(_templateObject$2);

var modalDrop = styled.css(_templateObject2, function (_ref) {
  var theme = _ref.theme;
  return theme.dir === 'rtl' ? 'left: 3rem;' : 'right: 3rem;';
}, scaleUpDown);

var _templateObject$3 = taggedTemplateLiteral(['\n  .search {\n    display: flex;\n    flex-direction: column;\n    justify-content: center;\n    align-items: center;\n    text-align: center;\n    position: fixed;\n    z-index: 1050;\n    top: 0;\n    left: 0;\n    width: 100%;\n    height: 100vh;\n    pointer-events: none;\n    opacity: 0;\n    transition: opacity 0.5s;\n\n    button {\n      position: absolute;\n      top: 3rem;\n      ', '\n      font-size: 2.5rem;\n      opacity: 0;\n      transition: opacity 0.5s;\n    }\n\n    .form {\n      margin: 5rem 0;\n      opacity: 0;\n      transform: scale3d(0.8, 0.8, 1);\n      transition: opacity 0.5s, transform 0.5s;\n    }\n\n    input {\n      font-size: 10vw;\n      width: 75%;\n      transform: scale3d(0, 1, 1);\n      transform-origin: 0 50%;\n      transition: transform 0.3s;\n    }\n  }\n\n  &.show {\n    .search {\n      pointer-events: auto;\n      opacity: 1;\n\n      button {\n        opacity: 1;\n      }\n\n      .form {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n\n      input {\n        transform: scale3d(1, 1, 1);\n        transition-duration: 0.5s;\n      }\n    }\n  }\n\n  @media screen and (max-width: 40rem) {\n    span {\n      text-align: left;\n    }\n  }\n'], ['\n  .search {\n    display: flex;\n    flex-direction: column;\n    justify-content: center;\n    align-items: center;\n    text-align: center;\n    position: fixed;\n    z-index: 1050;\n    top: 0;\n    left: 0;\n    width: 100%;\n    height: 100vh;\n    pointer-events: none;\n    opacity: 0;\n    transition: opacity 0.5s;\n\n    button {\n      position: absolute;\n      top: 3rem;\n      ', '\n      font-size: 2.5rem;\n      opacity: 0;\n      transition: opacity 0.5s;\n    }\n\n    .form {\n      margin: 5rem 0;\n      opacity: 0;\n      transform: scale3d(0.8, 0.8, 1);\n      transition: opacity 0.5s, transform 0.5s;\n    }\n\n    input {\n      font-size: 10vw;\n      width: 75%;\n      transform: scale3d(0, 1, 1);\n      transform-origin: 0 50%;\n      transition: transform 0.3s;\n    }\n  }\n\n  &.show {\n    .search {\n      pointer-events: auto;\n      opacity: 1;\n\n      button {\n        opacity: 1;\n      }\n\n      .form {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n\n      input {\n        transform: scale3d(1, 1, 1);\n        transition-duration: 0.5s;\n      }\n    }\n  }\n\n  @media screen and (max-width: 40rem) {\n    span {\n      text-align: left;\n    }\n  }\n']);

var modalMove = styled.css(_templateObject$3, function (_ref) {
  var theme = _ref.theme;
  return theme.dir === 'rtl' ? 'left: 3rem;' : 'right: 3rem;';
});

var _templateObject$4 = taggedTemplateLiteral(['\n  .search {\n    text-align: center;\n    position: fixed;\n    z-index: 1050;\n    top: 0;\n    left: 0;\n    overflow: hidden;\n    width: 100%;\n    height: 100vh;\n    background: none;\n    pointer-events: none;\n\n    &::before {\n      content: \'\';\n      position: absolute;\n      top: 0;\n      left: 0;\n      width: 100%;\n      height: 100%;\n      pointer-events: none;\n      opacity: 0;\n      transition: opacity 0.6s;\n      transition-timing-function: cubic-bezier(0.2, 1, 0.3, 1);\n    }\n\n    button {\n      font-size: 2.5rem;\n      position: absolute;\n      top: 3rem;\n      ', '\n      display: block;\n      z-index: 100;\n      opacity: 0;\n      transform: scale3d(0.8, 0.8, 1);\n      transition: opacity 0.6s, transform 0.6s;\n      transition-timing-function: cubic-bezier(0.2, 1, 0.3, 1);\n    }\n\n    .form-wrapper {\n      position: absolute;\n      display: flex;\n      justify-content: center;\n      align-items: center;\n      width: 100%;\n      height: 50%;\n      transition: transform 0.6s;\n      transition-timing-function: cubic-bezier(0.2, 1, 0.3, 1);\n      transform: translate3d(0, -100%, 0);\n    }\n\n    .form {\n      width: 75%;\n      margin: 0 auto;\n    }\n\n    input {\n      font-size: 7vw;\n      width: 100%;\n    }\n  }\n\n  &.show {\n    .search {\n      pointer-events: auto;\n\n      &::before {\n        opacity: 1;\n      }\n\n      button {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n\n      .form-wrapper {\n        transform: translate3d(0, 0, 0);\n      }\n    }\n  }\n'], ['\n  .search {\n    text-align: center;\n    position: fixed;\n    z-index: 1050;\n    top: 0;\n    left: 0;\n    overflow: hidden;\n    width: 100%;\n    height: 100vh;\n    background: none;\n    pointer-events: none;\n\n    &::before {\n      content: \'\';\n      position: absolute;\n      top: 0;\n      left: 0;\n      width: 100%;\n      height: 100%;\n      pointer-events: none;\n      opacity: 0;\n      transition: opacity 0.6s;\n      transition-timing-function: cubic-bezier(0.2, 1, 0.3, 1);\n    }\n\n    button {\n      font-size: 2.5rem;\n      position: absolute;\n      top: 3rem;\n      ', '\n      display: block;\n      z-index: 100;\n      opacity: 0;\n      transform: scale3d(0.8, 0.8, 1);\n      transition: opacity 0.6s, transform 0.6s;\n      transition-timing-function: cubic-bezier(0.2, 1, 0.3, 1);\n    }\n\n    .form-wrapper {\n      position: absolute;\n      display: flex;\n      justify-content: center;\n      align-items: center;\n      width: 100%;\n      height: 50%;\n      transition: transform 0.6s;\n      transition-timing-function: cubic-bezier(0.2, 1, 0.3, 1);\n      transform: translate3d(0, -100%, 0);\n    }\n\n    .form {\n      width: 75%;\n      margin: 0 auto;\n    }\n\n    input {\n      font-size: 7vw;\n      width: 100%;\n    }\n  }\n\n  &.show {\n    .search {\n      pointer-events: auto;\n\n      &::before {\n        opacity: 1;\n      }\n\n      button {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n\n      .form-wrapper {\n        transform: translate3d(0, 0, 0);\n      }\n    }\n  }\n']);

var modalHalf = styled.css(_templateObject$4, function (_ref) {
  var theme = _ref.theme;
  return theme.dir === 'rtl' ? 'left: 3rem;' : 'right: 3rem;';
});

var _templateObject$5 = taggedTemplateLiteral(['\n  display: block;\n\n  .search {\n    display: flex;\n    flex-direction: column;\n    justify-content: center;\n    align-items: center;\n    text-align: center;\n    position: fixed;\n    z-index: 1050;\n    top: 0;\n    left: 0;\n    width: 100%;\n    height: 100vh;\n    pointer-events: none;\n    opacity: 0;\n    transition: opacity 0.5s;\n\n    &::before,\n    &::after {\n      content: \'\';\n      position: absolute;\n      width: calc(100% + 15px);\n      height: calc(100% + 15px);\n      pointer-events: none;\n    }\n\n    &::before {\n      top: 0;\n      left: 0;\n      border-right-width: 0;\n      border-bottom-width: 0;\n      transform: translate3d(-15px, -15px, 0);\n    }\n\n    &::after {\n      right: 0;\n      bottom: 0;\n      border-top-width: 0;\n      border-left-width: 0;\n      transform: translate3d(15px, 15px, 0);\n    }\n\n    button {\n      position: absolute;\n      top: 3rem;\n      ', '\n      font-size: 2.5rem;\n    }\n\n    input {\n      font-size: 10vw;\n      width: 75%;\n    }\n\n    button {\n      opacity: 0;\n      transform: scale3d(0.8, 0.8, 1);\n      transition: opacity 0.5s, transform 0.5s;\n    }\n\n    .form {\n      opacity: 0;\n      transform: scale3d(0.8, 0.8, 1);\n      transition: opacity 0.5s, transform 0.5s;\n    }\n  }\n\n  &.show {\n    .search {\n      pointer-events: auto;\n      opacity: 1;\n\n      &::before,\n      &::after {\n        transform: translate3d(0, 0, 0);\n        transition: transform 0.5s;\n      }\n\n      button {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n\n      .form {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n    }\n  }\n\n  @media screen and (max-width: 40rem) {\n    .form {\n      margin: 5rem 0 1rem;\n    }\n\n    span {\n      text-align: left;\n    }\n  }\n'], ['\n  display: block;\n\n  .search {\n    display: flex;\n    flex-direction: column;\n    justify-content: center;\n    align-items: center;\n    text-align: center;\n    position: fixed;\n    z-index: 1050;\n    top: 0;\n    left: 0;\n    width: 100%;\n    height: 100vh;\n    pointer-events: none;\n    opacity: 0;\n    transition: opacity 0.5s;\n\n    &::before,\n    &::after {\n      content: \'\';\n      position: absolute;\n      width: calc(100% + 15px);\n      height: calc(100% + 15px);\n      pointer-events: none;\n    }\n\n    &::before {\n      top: 0;\n      left: 0;\n      border-right-width: 0;\n      border-bottom-width: 0;\n      transform: translate3d(-15px, -15px, 0);\n    }\n\n    &::after {\n      right: 0;\n      bottom: 0;\n      border-top-width: 0;\n      border-left-width: 0;\n      transform: translate3d(15px, 15px, 0);\n    }\n\n    button {\n      position: absolute;\n      top: 3rem;\n      ', '\n      font-size: 2.5rem;\n    }\n\n    input {\n      font-size: 10vw;\n      width: 75%;\n    }\n\n    button {\n      opacity: 0;\n      transform: scale3d(0.8, 0.8, 1);\n      transition: opacity 0.5s, transform 0.5s;\n    }\n\n    .form {\n      opacity: 0;\n      transform: scale3d(0.8, 0.8, 1);\n      transition: opacity 0.5s, transform 0.5s;\n    }\n  }\n\n  &.show {\n    .search {\n      pointer-events: auto;\n      opacity: 1;\n\n      &::before,\n      &::after {\n        transform: translate3d(0, 0, 0);\n        transition: transform 0.5s;\n      }\n\n      button {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n\n      .form {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n    }\n  }\n\n  @media screen and (max-width: 40rem) {\n    .form {\n      margin: 5rem 0 1rem;\n    }\n\n    span {\n      text-align: left;\n    }\n  }\n']);

var modalZoomin = styled.css(_templateObject$5, function (_ref) {
  var theme = _ref.theme;
  return theme.dir === 'rtl' ? 'left: 3rem;' : 'right: 3rem;';
});

var _templateObject$6 = taggedTemplateLiteral(['\n  position: absolute;\n  display: block;\n  width: 100vw;\n  height: 100vh;\n  pointer-events: none;\n  opacity: 0;\n  transition-property: opacity;\n  transition-delay: 0.4s;\n\n  .search {\n    display: flex;\n    flex-direction: column;\n    justify-content: center;\n    align-items: center;\n    text-align: center;\n    z-index: 1050;\n    position: fixed;\n    top: 0;\n    left: 0;\n    width: 100%;\n    height: 50vh;\n    pointer-events: none;\n    opacity: 0;\n    transition: opacity 0.5s;\n    transition-timing-function: cubic-bezier(0.2, 1, 0.3, 1);\n\n    button {\n      position: absolute;\n      top: 3rem;\n      ', '\n      font-size: 2.5rem;\n      opacity: 0;\n      transform: scale3d(0.8, 0.8, 1);\n      transition: opacity 0.5s, transform 0.5s;\n      transition-timing-function: cubic-bezier(0.2, 1, 0.3, 1);\n    }\n\n    .form {\n      margin: 5rem 0;\n      opacity: 0;\n      transform: scale3d(0.7, 0.7, 1);\n      transition: opacity 0.5s, transform 0.5s;\n      transition-timing-function: cubic-bezier(0.2, 1, 0.3, 1);\n    }\n\n    input {\n      font-size: 7vw;\n      width: 75%;\n    }\n  }\n\n  &.show {\n    opacity: 1;\n    transition-delay: 0s;\n\n    .search {\n      pointer-events: auto;\n      opacity: 1;\n\n      button {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n\n      .form {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n    }\n  }\n'], ['\n  position: absolute;\n  display: block;\n  width: 100vw;\n  height: 100vh;\n  pointer-events: none;\n  opacity: 0;\n  transition-property: opacity;\n  transition-delay: 0.4s;\n\n  .search {\n    display: flex;\n    flex-direction: column;\n    justify-content: center;\n    align-items: center;\n    text-align: center;\n    z-index: 1050;\n    position: fixed;\n    top: 0;\n    left: 0;\n    width: 100%;\n    height: 50vh;\n    pointer-events: none;\n    opacity: 0;\n    transition: opacity 0.5s;\n    transition-timing-function: cubic-bezier(0.2, 1, 0.3, 1);\n\n    button {\n      position: absolute;\n      top: 3rem;\n      ', '\n      font-size: 2.5rem;\n      opacity: 0;\n      transform: scale3d(0.8, 0.8, 1);\n      transition: opacity 0.5s, transform 0.5s;\n      transition-timing-function: cubic-bezier(0.2, 1, 0.3, 1);\n    }\n\n    .form {\n      margin: 5rem 0;\n      opacity: 0;\n      transform: scale3d(0.7, 0.7, 1);\n      transition: opacity 0.5s, transform 0.5s;\n      transition-timing-function: cubic-bezier(0.2, 1, 0.3, 1);\n    }\n\n    input {\n      font-size: 7vw;\n      width: 75%;\n    }\n  }\n\n  &.show {\n    opacity: 1;\n    transition-delay: 0s;\n\n    .search {\n      pointer-events: auto;\n      opacity: 1;\n\n      button {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n\n      .form {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n    }\n  }\n']);

var rotateLayout = styled.css(_templateObject$6, function (_ref) {
  var theme = _ref.theme;
  return theme.dir === 'rtl' ? 'left: 3rem;' : 'right: 3rem;';
});

var _templateObject$7 = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$1 = taggedTemplateLiteral(['\n    button {\n      path {\n        fill: ', ';\n      }\n      margin: 0 auto;\n      padding: 0;\n      cursor: pointer;\n      border: none;\n      background: none;\n\n      &:focus {\n        box-shadow: none;\n        outline: none;\n      }\n    }\n  '], ['\n    button {\n      path {\n        fill: ', ';\n      }\n      margin: 0 auto;\n      padding: 0;\n      cursor: pointer;\n      border: none;\n      background: none;\n\n      &:focus {\n        box-shadow: none;\n        outline: none;\n      }\n    }\n  ']),
    _templateObject3 = taggedTemplateLiteral(['\n  \n    .search {\n      background: ', ';\n\n      button {\n        g {\n          fill: ', ';\n        }\n        margin: 0;\n        padding: 0;\n        cursor: pointer;\n        border: none;\n        background: none;\n\n        &:focus {\n          box-shadow: none;\n          outline: none;\n        }\n      }\n\n      span {\n        color: ', ';\n        font-size: 90%;\n        font-weight: bold;\n        display: block;\n        width: 75%;\n        margin: 0 auto;\n        padding: 0.85rem 0;\n        text-align: right;\n      }\n\n      input {\n        color: ', ';\n        border-bottom: 4px solid ', ';\n        border-top: 0;\n        border-right: 0;\n        border-left: 0;\n        background: transparent;\n        border-radius: 0;\n        line-height: 1;\n        display: inline-block;\n        box-sizing: border-box;\n        padding: 0.05rem 0;\n        -webkit-appearance: none;\n\n        &::placeholder {\n          color: ', ';\n          opacity: 0.3;\n        }\n        &:focus {\n          outline: none;\n        }\n\n\n        &::-ms-clear {\n          display: none;\n        }\n      }\n    }\n\n    &.rotate-layout {\n      ', '\n      background: ', ';\n    }\n\n    &.modal-zoomin {\n      ', '\n      .search::before,\n      .search::after {\n        border: 1.5rem solid ', ';\n      }\n    }\n\n    &.modal-half {\n      ', '\n      .form-wrapper {\n        background: ', ';\n      }\n      .search::before {\n        background: ', ';\n      }\n    }\n    &.modal-move {\n      ', '\n    }\n\n    &.modal-drop {\n      .form-content::after {\n        background: ', ';\n      }\n      .search::before {\n        background: ', ';\n      }\n      ', '\n    }\n\n    &.curtain {\n      ', '\n      .search::after {\n        background: ', ';\n      }\n      .search {\n        background: ', ';\n      }\n    }\n\n    &.column-curtain {\n      ', '\n      &::before {\n        background: ', ';\n      }\n      &::after {\n        background: transparent;\n      }\n      &.show::after {\n        background: ', ';\n      }\n    }\n  '], ['\n  \n    .search {\n      background: ', ';\n\n      button {\n        g {\n          fill: ', ';\n        }\n        margin: 0;\n        padding: 0;\n        cursor: pointer;\n        border: none;\n        background: none;\n\n        &:focus {\n          box-shadow: none;\n          outline: none;\n        }\n      }\n\n      span {\n        color: ', ';\n        font-size: 90%;\n        font-weight: bold;\n        display: block;\n        width: 75%;\n        margin: 0 auto;\n        padding: 0.85rem 0;\n        text-align: right;\n      }\n\n      input {\n        color: ', ';\n        border-bottom: 4px solid ', ';\n        border-top: 0;\n        border-right: 0;\n        border-left: 0;\n        background: transparent;\n        border-radius: 0;\n        line-height: 1;\n        display: inline-block;\n        box-sizing: border-box;\n        padding: 0.05rem 0;\n        -webkit-appearance: none;\n\n        &::placeholder {\n          color: ', ';\n          opacity: 0.3;\n        }\n        &:focus {\n          outline: none;\n        }\n\n\n        &::-ms-clear {\n          display: none;\n        }\n      }\n    }\n\n    &.rotate-layout {\n      ', '\n      background: ', ';\n    }\n\n    &.modal-zoomin {\n      ', '\n      .search::before,\n      .search::after {\n        border: 1.5rem solid ', ';\n      }\n    }\n\n    &.modal-half {\n      ', '\n      .form-wrapper {\n        background: ', ';\n      }\n      .search::before {\n        background: ', ';\n      }\n    }\n    &.modal-move {\n      ', '\n    }\n\n    &.modal-drop {\n      .form-content::after {\n        background: ', ';\n      }\n      .search::before {\n        background: ', ';\n      }\n      ', '\n    }\n\n    &.curtain {\n      ', '\n      .search::after {\n        background: ', ';\n      }\n      .search {\n        background: ', ';\n      }\n    }\n\n    &.column-curtain {\n      ', '\n      &::before {\n        background: ', ';\n      }\n      &::after {\n        background: transparent;\n      }\n      &.show::after {\n        background: ', ';\n      }\n    }\n  ']);

var SearchStyle = styled__default.div(_templateObject$7, function (_ref) {
  var theme = _ref.theme;
  return styled.css(_templateObject2$1, theme.searchBtnOpenFg);
});

var SearchFieldStyle = styled__default.div(_templateObject$7, function (_ref2) {
  var theme = _ref2.theme;
  return styled.css(_templateObject3, theme.searchBg, theme.searchBtnCloseFg, theme.searchInfo, theme.searchText, theme.searchDash, theme.searchPlaceholder, rotateLayout, theme.searchBg, modalZoomin, theme.searchBgSecondary, modalHalf, theme.searchBg, theme.searchBgSecondary, modalMove, theme.searchDash, theme.searchBg, modalDrop, curtain, theme.searchBg, theme.searchBg, columnCurtain, theme.searchBg, theme.searchBgSecondary);
});

var _ref =
/*#__PURE__*/
React__default.createElement("path", {
  fill: "#99ABB4",
  fillRule: "evenodd",
  stroke: "#99ABB4",
  d: "M8 6.982L2.428 2l-.363.324 5.208 4.658L2 11.676l.363.324z"
});

var _ref$1 =
/*#__PURE__*/
React__default.createElement("path", {
  fill: "#99ABB4",
  fillRule: "evenodd",
  stroke: "#99ABB4",
  d: "M2 7.018L7.572 12l.363-.324-5.208-4.658L8 2.324 7.637 2z"
});

var _ref$2 =
/*#__PURE__*/
React__default.createElement("path", {
  fill: "#99ABB4",
  fillRule: "evenodd",
  stroke: "#99ABB4",
  d: "M6.982 2L2 7.572l.324.363 4.658-5.208L11.676 8 12 7.637z"
});

var _ref$3 =
/*#__PURE__*/
React__default.createElement("path", {
  fill: "#99ABB4",
  fillRule: "evenodd",
  stroke: "#99ABB4",
  d: "M7.018 8L12 2.428l-.324-.363-4.658 5.208L2.324 2 2 2.363z"
});

function _extends$5() {
  _extends$5 = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }return target;
  };return _extends$5.apply(this, arguments);
}

var _ref$4 =
/*#__PURE__*/
React__default.createElement("path", {
  fill: "#FFF",
  fillRule: "evenodd",
  d: "M12.979 13.651c-.145.22-.508.22-.653 0a.494.494 0 0 1 0-.734 5.058 5.058 0 0 0 1.305-1.761 5.32 5.32 0 0 0 .435-2.128c0-.955-.217-1.835-.652-2.57a4.747 4.747 0 0 0-1.885-1.908c-.218-.146-.29-.44-.145-.733.145-.22.435-.294.725-.147.87.587 1.667 1.32 2.175 2.275.508.954.798 1.982.798 3.083 0 .88-.218 1.761-.508 2.568a5.431 5.431 0 0 1-1.595 2.055zM8.919 0c2.465 0 4.64 1.028 6.308 2.642a9.1 9.1 0 0 1 2.61 6.386c0 2.201-.87 4.256-2.175 5.871L16.822 16l.217-.294c.363-.293.725-.44 1.16-.44.363 0 .798.147 1.088.44l4.278 4.257c.29.367.435.734.435 1.175 0 .367-.145.807-.435 1.1L22.26 23.56c-.29.293-.653.44-1.088.44-.435 0-.797-.147-1.087-.44l-4.278-4.257c-.29-.367-.435-.734-.435-1.175 0-.367.145-.807.435-1.1l.29-.294-1.16-1.101a8.76 8.76 0 0 1-6.019 2.422 8.88 8.88 0 0 1-6.308-2.642C1.015 13.725 0 11.523 0 9.028a9.1 9.1 0 0 1 2.61-6.386A8.88 8.88 0 0 1 8.918 0zm5.583 3.376c-1.45-1.468-3.408-2.348-5.584-2.348-2.175 0-4.133.88-5.583 2.348a7.98 7.98 0 0 0-2.32 5.652 7.98 7.98 0 0 0 2.32 5.65c1.45 1.395 3.408 2.35 5.583 2.35 2.176 0 4.133-.955 5.584-2.35l.072-.146h.073c1.305-1.468 2.175-3.376 2.175-5.504 0-2.202-.943-4.184-2.32-5.652z"
});

var SvgComponent$4 = function SvgComponent(props) {
  return React__default.createElement("svg", _extends$5({
    width: 24,
    height: 24
  }, props), _ref$4);
};

function _extends$6() {
  _extends$6 = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }return target;
  };return _extends$6.apply(this, arguments);
}

var _ref$5 =
/*#__PURE__*/
React__default.createElement("g", {
  fillRule: "evenodd"
}, React__default.createElement("path", {
  d: "M12.78 11.95l5.039-5.058a.554.554 0 0 0 0-.78.548.548 0 0 0-.778 0l-5.038 5.057L6.965 6.11a.548.548 0 0 0-.778 0 .554.554 0 0 0 0 .781l5.038 5.057-5.048 5.068a.554.554 0 0 0 0 .78.548.548 0 0 0 .778 0L12 12.73l5.048 5.068a.548.548 0 0 0 .92-.248.553.553 0 0 0-.142-.533L12.78 11.95z"
}), React__default.createElement("path", {
  fillRule: "nonzero",
  d: "M20.42 3.502A11.874 11.874 0 0 0 5.384 2.016C.66 5.184-1.176 11.26.998 16.53c2.175 5.269 7.754 8.262 13.326 7.149 5.572-1.113 9.585-6.022 9.584-11.725a11.899 11.899 0 0 0-3.488-8.452zm-.778 16.125a10.778 10.778 0 0 1-13.648 1.348C1.707 18.098.04 12.582 2.014 7.8 3.988 3.018 9.052.301 14.11 1.311c5.057 1.01 8.7 5.467 8.7 10.643a10.8 10.8 0 0 1-3.167 7.673z"
}));

var SvgComponent$5 = function SvgComponent(props) {
  return React__default.createElement("svg", _extends$6({
    width: 24,
    height: 24
  }, props), _ref$5);
};

function CloseCircled$1() {
  return React__default.createElement(SvgComponent$5, null);
}
function SearchIcon() {
  return React__default.createElement(SvgComponent$4, null);
}

var _templateObject$8 = taggedTemplateLiteral(['\n  position: absolute;\n  pointer-events: auto;\n  box-sizing: border-box;\n  z-index: 1000;\n  display: flex;\n  max-width: 100%;\n  max-height: 100%;\n'], ['\n  position: absolute;\n  pointer-events: auto;\n  box-sizing: border-box;\n  z-index: 1000;\n  display: flex;\n  max-width: 100%;\n  max-height: 100%;\n']);

var OverlayStyle = styled__default.div(_templateObject$8);

function Overlay(props) {
  var _useState = React.useState(),
      _useState2 = slicedToArray(_useState, 2),
      parent = _useState2[0],
      setParent = _useState2[1];

  React.useEffect(function () {
    var overlayParent = document.getElementById('overlay-container');
    setParent(overlayParent);
  }, []);
  return parent !== undefined && ReactDOM.createPortal(React__default.createElement(
    OverlayStyle,
    props,
    props.children
  ), parent);
}

Overlay.propTypes = {
  children: PropTypes.node
};

var layoutContext = React__default.createContext({
  addClass: function addClass() {},
  removeClass: function removeClass() {},
  dir: 'ltr'
});

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

function Search$1(props) {
  var _useState = React.useState(''),
      _useState2 = slicedToArray(_useState, 2),
      value = _useState2[0],
      setValue = _useState2[1];

  var _useState3 = React.useState(),
      _useState4 = slicedToArray(_useState3, 2),
      show = _useState4[0],
      setShow = _useState4[1];

  var inputRef = React.useRef();
  var layout = React.useContext(layoutContext);

  React.useEffect(function () {
    if (show === 'show') {
      inputRef.current.focus();
    } else if (show === undefined) {
      layout.removeClass([props.type]);
    }
  }, [show]);

  var handleOpen = function handleOpen() {
    setShow('');
    layout.addClass([props.type, 'with-search']);
    setTimeout(function () {
      setShow('show');
    }, 50);
  };

  var handleClose = function handleClose() {
    layout.removeClass(['with-search']);
    setShow('');
    setTimeout(function () {
      setShow(undefined);
    }, 200);
  };

  var onChangeHandle = function onChangeHandle(e) {
    typeof props.onChange === 'function' && props.onChange(e.target.value);
    setValue(e.target.value);
  };

  return React__default.createElement(
    SearchStyle,
    { className: props.className },
    React__default.createElement(
      'button',
      { onClick: handleOpen },
      React__default.createElement(SearchIcon, null)
    ),
    show !== undefined && React__default.createElement(
      Overlay,
      null,
      React__default.createElement(
        SearchFieldStyle,
        { className: props.type + ' ' + show },
        React__default.createElement(
          'div',
          {
            className: 'search',
            onKeyUp: function onKeyUp(e) {
              e.preventDefault();
              e.key === 'Escape' && handleClose();
            }
          },
          React__default.createElement(
            'button',
            { onClick: handleClose },
            React__default.createElement(CloseCircled$1, null)
          ),
          React__default.createElement(
            'div',
            { className: 'form-wrapper' },
            React__default.createElement(
              'div',
              { className: 'form' },
              React__default.createElement(
                'div',
                { className: 'form-content' },
                React__default.createElement('input', {
                  ref: inputRef,
                  onKeyUp: function onKeyUp(e) {
                    e.preventDefault();
                    if (e.key === 'Enter') {
                      handleClose();
                      props.submit(value);
                    }
                  },
                  onChange: onChangeHandle,
                  placeholder: props.placeholder,
                  className: 'search-input',
                  autoComplete: 'off',
                  tabIndex: '-1',
                  value: value
                })
              ),
              React__default.createElement(
                'span',
                { className: 'info' },
                props.hint
              )
            )
          )
        )
      )
    )
  );
}
Search$1.propTypes = {
  hint: PropTypes.string,
  placeholder: PropTypes.string,
  submit: PropTypes.func.isRequired,
  onChange: PropTypes.func,
  type: PropTypes.oneOf(['rotate-layout', 'modal-zoomin', 'modal-move', 'modal-drop', 'modal-half', 'curtain', 'column-curtain']).isRequired
};

module.exports = Search$1;
