'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = _interopDefault(require('prop-types'));
var styled = require('styled-components');
var styled__default = _interopDefault(styled);

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

var slicedToArray = function () {
  function sliceIterator(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"]) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  return function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if (Symbol.iterator in Object(arr)) {
      return sliceIterator(arr, i);
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };
}();

var taggedTemplateLiteral = function (strings, raw) {
  return Object.freeze(Object.defineProperties(strings, {
    raw: {
      value: Object.freeze(raw)
    }
  }));
};

var _templateObject = taggedTemplateLiteral(['\n      @media (max-width: ', 'px) {\n        ', '\n      }\n    '], ['\n      @media (max-width: ', 'px) {\n        ', '\n      }\n    ']),
    _templateObject2 = taggedTemplateLiteral(['\n      @media (min-width: ', 'px) {\n        ', '\n      }\n    '], ['\n      @media (min-width: ', 'px) {\n        ', '\n      }\n    ']),
    _templateObject3 = taggedTemplateLiteral(['\n      @media (min-width: ', 'px) and (max-width: ', 'px) {\n        ', '\n      }\n    '], ['\n      @media (min-width: ', 'px) and (max-width: ', 'px) {\n        ', '\n      }\n    ']);
var breakpoints = {
  xs: 0,
  is: 400,
  sm: 576,
  md: 768,
  lg: 992,
  xl: 1200,
  xxl: 1400,
  xxxl: 1600
};
function ifWidthInBreakpoint() {
  var breakpoint = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

  var bp = Object.keys(breakpoints);
  var value = false;
  if (breakpoint === []) {
    return value;
  }
  breakpoint.filter(function (b) {
    return ~bp.indexOf(b);
  }).sort(function (b1, b2) {
    return bp.indexOf(b1) - bp.indexOf(b2);
  }).map(function (b) {
    var next = breakpointNext(bp.indexOf(b));
    if (window.innerWidth >= breakpoints[b] && (next == null || window.innerWidth < breakpoints[next])) {
      value = true;
    }
  });
  return value;
}
function breakpointMin(name) {
  return breakpoints[name] != 0 ? breakpoints[name] : null;
}

function breakpointNext(index) {
  return index < Object.keys(breakpoints).length ? Object.keys(breakpoints)[index + 1] : null;
}

function breakpointMax(name) {
  var n = Object.keys(breakpoints).indexOf(name);
  var next = breakpointNext(n);
  return next ? breakpointMin(next) - 0.2 : null;
}

var breakpointDown = function breakpointDown(name) {
  return function () {
    var max = breakpointMax(name);
    if (max) {
      return styled.css(_templateObject, max, styled.css.apply(undefined, arguments));
    } else {
      return styled.css.apply(undefined, arguments);
    }
  };
};

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

var _templateObject$1 = taggedTemplateLiteral(['\n  ', ';\n'], ['\n  ', ';\n']),
    _templateObject2$1 = taggedTemplateLiteral(['\n    font-family: ', ';\n    font-size: ', ';\n    font-weight: ', ';\n    background: ', ';\n    color: ', ';\n    display: block;\n    ul.menu-items {\n      margin: 0;\n      padding: 0;\n    }\n\n    .menu-group {\n      font-weight: ', ';\n      font-size: ', ';\n      color: ', ';\n      padding: ', ';\n    }\n\n    .menu-item {\n      a {\n        padding: ', ';\n        border-radius: ', ';\n      }\n\n      a:hover,\n      a.active {\n        background-color: ', ';\n        color: ', ';\n        font-weight: ', ';\n        .menu-icon {\n          color: ', ';\n        }\n        .chevron {\n          path {\n            fill: ', ';\n            stroke: ', ';\n          }\n        }\n      }\n\n      .menu-icon {\n        font-size: ', ';\n        width: auto;\n        margin: ', ';\n        text-align: center;\n        color: ', ';\n      }\n\n      .chevron {\n        path {\n          fill: ', ';\n          stroke: ', ';\n        }\n\n        ', '\n      }\n    }\n\n    .menu-items > .menu-item {\n      border-bottom: 1px solid ', ';\n      &:first-child {\n        border-top: 1px solid ', ';\n      }\n    }\n\n    .menu-item > .menu-items {\n      background-color: ', ';\n    }\n\n    .menu-item > .menu-items > .menu-item {\n      border: none;\n      background: ', ';\n      color: ', ';\n      padding: ', ';\n      &:first-child {\n        margin-top: ', ';\n      }\n      &:last-child {\n        margin-bottom: ', ';\n      }\n\n      a {\n        border: ', ';\n        padding: ', ';\n      }\n\n      a:hover {\n        color: ', ';\n        background: ', ';\n      }\n\n      a.active {\n        background-color: ', ';\n        color: ', ';\n        border-color: ', ';\n        box-shadow: none;\n        transition: all 300ms cubic-bezier(0.4, 0, 0.6, 1) 0ms;\n      }\n    }\n    .menu-items,\n    .menu-item > .menu-items {\n      list-style-type: none;\n      overflow: hidden;\n    }\n\n    .menu-item a {\n      display: flex;\n      color: inherit;\n      text-decoration: none;\n      align-items: center;\n\n      .menu-title {\n        flex: 1;\n        ', ';\n      }\n    }\n\n    &.inverse {\n      .menu-item {\n        a {\n          color: ', ';\n        }\n\n        a:hover {\n          background-color: ', ';\n          color: ', ';\n        }\n\n        a.active {\n          background-color: ', ';\n          color: ', ';\n        }\n      }\n\n      .menu-group {\n        color: ', ';\n      }\n    }\n  '], ['\n    font-family: ', ';\n    font-size: ', ';\n    font-weight: ', ';\n    background: ', ';\n    color: ', ';\n    display: block;\n    ul.menu-items {\n      margin: 0;\n      padding: 0;\n    }\n\n    .menu-group {\n      font-weight: ', ';\n      font-size: ', ';\n      color: ', ';\n      padding: ', ';\n    }\n\n    .menu-item {\n      a {\n        padding: ', ';\n        border-radius: ', ';\n      }\n\n      a:hover,\n      a.active {\n        background-color: ', ';\n        color: ', ';\n        font-weight: ', ';\n        .menu-icon {\n          color: ', ';\n        }\n        .chevron {\n          path {\n            fill: ', ';\n            stroke: ', ';\n          }\n        }\n      }\n\n      .menu-icon {\n        font-size: ', ';\n        width: auto;\n        margin: ', ';\n        text-align: center;\n        color: ', ';\n      }\n\n      .chevron {\n        path {\n          fill: ', ';\n          stroke: ', ';\n        }\n\n        ', '\n      }\n    }\n\n    .menu-items > .menu-item {\n      border-bottom: 1px solid ', ';\n      &:first-child {\n        border-top: 1px solid ', ';\n      }\n    }\n\n    .menu-item > .menu-items {\n      background-color: ', ';\n    }\n\n    .menu-item > .menu-items > .menu-item {\n      border: none;\n      background: ', ';\n      color: ', ';\n      padding: ', ';\n      &:first-child {\n        margin-top: ', ';\n      }\n      &:last-child {\n        margin-bottom: ', ';\n      }\n\n      a {\n        border: ', ';\n        padding: ', ';\n      }\n\n      a:hover {\n        color: ', ';\n        background: ', ';\n      }\n\n      a.active {\n        background-color: ', ';\n        color: ', ';\n        border-color: ', ';\n        box-shadow: none;\n        transition: all 300ms cubic-bezier(0.4, 0, 0.6, 1) 0ms;\n      }\n    }\n    .menu-items,\n    .menu-item > .menu-items {\n      list-style-type: none;\n      overflow: hidden;\n    }\n\n    .menu-item a {\n      display: flex;\n      color: inherit;\n      text-decoration: none;\n      align-items: center;\n\n      .menu-title {\n        flex: 1;\n        ', ';\n      }\n    }\n\n    &.inverse {\n      .menu-item {\n        a {\n          color: ', ';\n        }\n\n        a:hover {\n          background-color: ', ';\n          color: ', ';\n        }\n\n        a.active {\n          background-color: ', ';\n          color: ', ';\n        }\n      }\n\n      .menu-group {\n        color: ', ';\n      }\n    }\n  ']),
    _templateObject3$1 = taggedTemplateLiteral(['\n  ul {\n    &.expanded {\n      max-height: 1500px;\n      transition: max-height 0.5s cubic-bezier(1, 0.15, 1, 1);\n    }\n\n    &.collapsed {\n      max-height: 0;\n      transition: max-height 0.5s cubic-bezier(0, 1, 0.3, 1) -100ms;\n    }\n  }\n'], ['\n  ul {\n    &.expanded {\n      max-height: 1500px;\n      transition: max-height 0.5s cubic-bezier(1, 0.15, 1, 1);\n    }\n\n    &.collapsed {\n      max-height: 0;\n      transition: max-height 0.5s cubic-bezier(0, 1, 0.3, 1) -100ms;\n    }\n  }\n']);

var MenuStyle = styled__default.div(_templateObject$1, function (_ref) {
  var theme = _ref.theme;
  return styled.css(_templateObject2$1, theme.menuFontFamily, theme.menuFontSize, theme.menuFontWeight, theme.menuBg, theme.menuFg, theme.menuGroupFontWeight, theme.menuGroupFontSize, theme.menuGroupFg, theme.menuGroupPadding, theme.menuItemPadding, theme.menuSubmenuItemBorderRadius, theme.menuActiveBg, theme.menuActiveFg, theme.menuActiveFontWeight, theme.menuIconActiveColor, theme.menuIconActiveColor, theme.menuIconActiveColor, theme.menuIconFontSize, theme.menuIconMargin, theme.menuIconColor, theme.menuIconColor, theme.menuIconColor, theme.dir === 'rtl' && 'transform: rotateY(180deg);', theme.menuItemSeparator, theme.menuItemSeparator, theme.menuSubmenuBg, theme.menuSubmenuBg, theme.menuSubmenuFg, theme.menuSubmenuItemContainerPadding, theme.menuSubmenuPadding, theme.menuSubmenuPadding, theme.menuSubmenuItemBorderWidth + ' solid ' + theme.menuSubmenuBg, theme.menuSubmenuItemPadding, theme.menuSubmenuHoverFg, theme.menuSubmenuHoverBg, theme.menuSubmenuActiveBg, theme.menuSubmenuActiveFg, theme.menuSubmenuActiveBorderColor, theme.dir === 'rtl' ? 'text-align: right' : '', theme.menuBg, theme.menuActiveFg, theme.menuActiveBg, theme.menuActiveFg, theme.menuActiveBg, theme.menuBg);
});
var ItemStyle = styled__default.li(_templateObject3$1);

var _templateObject$2 = taggedTemplateLiteral(['\n  ', ' {\n    width: ', ';\n\n    .menu-item a.active {\n      position: relative;\n\n      &::before {\n        position: absolute;\n        content: \'\';\n        ', '\n        top: 0;\n        height: 100%;\n        width: 4px;\n        background: ', ';\n      }\n    }\n\n    > .menu-items > .menu-item > a {\n      span,\n      .chevron {\n        display: none;\n      }\n    }\n\n    .menu-items > .menu-item {\n      transition: border-color 1s ease;\n\n      &.menu-group {\n        display: block;\n        color: transparent;\n        width: 0;\n        padding: 0;\n        overflow: hidden;\n      }\n\n      i {\n        margin-right: 0;\n      }\n\n      a {\n        justify-content: center;\n      }\n\n      & > .expanded {\n        display: none;\n      }\n    }\n  }\n  ', '\n'], ['\n  ', ' {\n    width: ', ';\n\n    .menu-item a.active {\n      position: relative;\n\n      &::before {\n        position: absolute;\n        content: \'\';\n        ', '\n        top: 0;\n        height: 100%;\n        width: 4px;\n        background: ', ';\n      }\n    }\n\n    > .menu-items > .menu-item > a {\n      span,\n      .chevron {\n        display: none;\n      }\n    }\n\n    .menu-items > .menu-item {\n      transition: border-color 1s ease;\n\n      &.menu-group {\n        display: block;\n        color: transparent;\n        width: 0;\n        padding: 0;\n        overflow: hidden;\n      }\n\n      i {\n        margin-right: 0;\n      }\n\n      a {\n        justify-content: center;\n      }\n\n      & > .expanded {\n        display: none;\n      }\n    }\n  }\n  ', '\n']),
    _templateObject2$2 = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject3$2 = taggedTemplateLiteral(['\n    position: fixed;\n    height: 100%;\n    z-index: 999;\n    top: ', ';\n    bottom: 0;\n    ', '\n    ', '\n  '], ['\n    position: fixed;\n    height: 100%;\n    z-index: 999;\n    top: ', ';\n    bottom: 0;\n    ', '\n    ', '\n  ']),
    _templateObject4 = taggedTemplateLiteral(['\n  font-size: ', ';\n  font-weight: ', ';\n  box-shadow: ', ';\n  display: flex;\n  flex-direction: column;\n  overflow: hidden;\n  z-index: auto;\n  transition: width .3s cubic-bezier(0.4, 0, 0.6, 1) 0ms;\n\n  order: ', ';\n    \n  ', '\n  .main-container {\n    ', '\n    height: ', ';\n    background: ', ';\n    transform: translate3d(0, 0, 0);\n    display: flex;\n    flex-direction: column;\n    transition: width .3s cubic-bezier(0.4, 0, 0.6, 1) 0ms;\n    ', '\n  }\n\n  .scrollable {\n    ', '\n    flex: 1;\n    position: relative;\n    -webkit-transform: translate3d(0, 0, 0);\n    ', '\n  }\n  \n  ', '\n\n  ', '\n\n\n  header,\n  footer\n   {\n     ', '\n    display: block;\n    \n  }\n\n  header{\n    height: ', ';\n  }\n\n  footer {\n    margin-top: auto;\n    height: ', ';\n  }\n\n  ', '{\n    margin: 0 -', ' -', ';\n  }\n'], ['\n  font-size: ', ';\n  font-weight: ', ';\n  box-shadow: ', ';\n  display: flex;\n  flex-direction: column;\n  overflow: hidden;\n  z-index: auto;\n  transition: width .3s cubic-bezier(0.4, 0, 0.6, 1) 0ms;\n\n  order: ', ';\n    \n  ', '\n  .main-container {\n    ', '\n    height: ', ';\n    background: ', ';\n    transform: translate3d(0, 0, 0);\n    display: flex;\n    flex-direction: column;\n    transition: width .3s cubic-bezier(0.4, 0, 0.6, 1) 0ms;\n    ', '\n  }\n\n  .scrollable {\n    ', '\n    flex: 1;\n    position: relative;\n    -webkit-transform: translate3d(0, 0, 0);\n    ', '\n  }\n  \n  ', '\n\n  ', '\n\n\n  header,\n  footer\n   {\n     ', '\n    display: block;\n    \n  }\n\n  header{\n    height: ', ';\n  }\n\n  footer {\n    margin-top: auto;\n    height: ', ';\n  }\n\n  ', '{\n    margin: 0 -', ' -', ';\n  }\n']),
    _templateObject5 = taggedTemplateLiteral(['\n      overflow-y: scroll;\n      -webkit-overflow-scrolling: touch;\n      '], ['\n      overflow-y: scroll;\n      -webkit-overflow-scrolling: touch;\n      ']);
/* eslint-disable indent */

var compacted = styled.css(_templateObject$2, MenuStyle, function (_ref) {
  var theme = _ref.theme;
  return theme.sidebarWidthCompact;
}, function (_ref2) {
  var theme = _ref2.theme;
  return theme.dir === 'rtl' ? 'right: 0;' : 'left: 0;';
}, function (_ref3) {
  var theme = _ref3.theme;
  return theme.colorFgHighlight;
}, function (_ref4) {
  var property = _ref4.property,
      theme = _ref4.theme,
      fixed = _ref4.fixed;

  if (fixed) {
    switch (property) {
      case 'right':
        return '\n          & ~ .content {\n            margin-right: ' + theme.sidebarWidthCompact + ';\n          }\n          & ~ .content.center {\n            padding-right: ' + theme.sidebarWidthCompact + ';\n          }\n        ';
      case 'left':
        return '\n          & ~ .content {\n            margin-left: ' + theme.sidebarWidthCompact + ';\n          }\n          & ~ .content.center {\n            padding-left: ' + theme.sidebarWidthCompact + ';\n          }\n        ';
      case 'start':
        return '\n          & ~ .content {\n            ' + (theme.dir == 'rtl' ? 'margin-right:' : 'margin-left:') + ' ' + theme.sidebarWidthCompact + ';\n          }\n          & ~ .content.center {\n            ' + (theme.dir == 'rtl' ? 'padding-right:' : 'padding-left:') + ' ' + theme.sidebarWidthCompact + ';\n          }\n        ';
      case 'end':
        return '\n          & ~ .content {\n            ' + (theme.dir == 'rtl' ? 'margin-left:' : 'margin-right:') + ' ' + theme.sidebarWidthCompact + ';\n          }\n          & ~ .content.center {\n            ' + (theme.dir == 'rtl' ? 'padding-left:' : 'padding-right:') + ' ' + theme.sidebarWidthCompact + ';\n          }\n        ';
      default:
        break;
    }
  }
});

var fixedStyle = styled.css(_templateObject2$2, function (_ref5) {
  var theme = _ref5.theme,
      property = _ref5.property,
      state = _ref5.state;
  return styled.css(_templateObject3$2, theme.headerHeight, state === 'hidden' && ['left', 'start'].includes(property) ? '\n        & + .content {\n          margin-left: 0;\n        }\n      ' : state === 'hidden' && ['right', 'end'].includes(property) ? '\n        & + .content {\n          margin-right: 0;\n        }\n      ' : '', property === 'right' ? 'right: 0;' : property === 'left' ? 'left: 0;' : property === 'start' ? theme.dir == 'rtl' ? 'right: 0;' : 'left: 0;' : property === 'end' ? theme.dir == 'rtl' ? 'left: 0;' : 'right: 0;' : '');
});

var SidebarStyle = styled__default.aside(_templateObject2$2, function (_ref6) {
  var theme = _ref6.theme,
      property = _ref6.property,
      state = _ref6.state,
      containerFixed = _ref6.containerFixed,
      fixed = _ref6.fixed;
  return styled.css(_templateObject4, theme.sidebarFontSize, theme.sidebarFontWeight, theme.sidebarShadow, property === 'right' ? theme.dir == 'rtl' ? '0' : '4' : property === 'left' ? theme.dir == 'rtl' ? '4' : '0' : property === 'end' ? '4' : '0', state === 'hidden' ? 'width: 0;padding: 0;' : state === 'compacted' ? 'width: ' + theme.sidebarWidthCompact + ';' : 'width: ' + theme.sidebarWidth + ';', state === 'hidden' ? 'width: 0;padding: 0;' : state === 'compacted' ? 'width: ' + theme.sidebarWidthCompact + ';' : 'width: ' + theme.sidebarWidth + ';', theme.sidebarHeight, theme.sidebarBg, containerFixed && 'position: fixed;', state === 'hidden' ? 'width: 0;padding: 0;overflow: hidden;' : 'overflow-y: auto;overflow-x: hidden;padding: ' + theme.sidebarPadding + ';', breakpointDown('sm')(_templateObject5), fixed && fixedStyle, state === 'compacted' && compacted, state === 'hidden' ? 'width: 0;padding: 0;overflow: hidden;' : 'padding: ' + theme.sidebarPadding + ';', theme.sidebarHeaderHeight, theme.sidebarFooterHeight, MenuStyle, theme.sidebarPadding, theme.sidebarPadding);
});

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

var Sidebar = React.forwardRef(function (props, ref) {
  var _useState = React.useState(props.fixed),
      _useState2 = slicedToArray(_useState, 2),
      fixed = _useState2[0],
      setFixed = _useState2[1];

  var _useState3 = React.useState(props.state),
      _useState4 = slicedToArray(_useState3, 2),
      state = _useState4[0],
      setState = _useState4[1];

  React.useImperativeHandle(ref, function () {
    return {
      toggle: function toggle() {
        switch (state) {
          case 'expanded':
            setState('compacted');
            break;
          case 'compacted':
            setState('expanded');
            break;
          case 'hidden':
            setState('visible');
            break;
          case 'visible':
            setState('hidden');
            break;
        }
      },
      hide: function hide() {
        if (state === 'visible') {
          setState('hidden');
        }
      }
    };
  }, [state]);

  var mouseEnter = function mouseEnter() {
    if (state === 'compacted') {
      setState('expanded');
    }
  };
  var mouseLeave = function mouseLeave() {
    if (state === 'expanded' && ifWidthInBreakpoint(props.compactedBreakpoints)) {
      setState('compacted');
    }
  };

  React.useEffect(function () {
    var onMediaQueryChanges = function onMediaQueryChanges() {
      if (ifWidthInBreakpoint(props.collapsedBreakpoints)) {
        setState('hidden');
        setFixed(true);
      } else if (ifWidthInBreakpoint(props.compactedBreakpoints)) {
        setState('compacted');
        setFixed(true);
      } else {
        setState('expanded');
        setFixed(false);
      }
    };
    if (props.responsive) {
      onMediaQueryChanges();
      window.addEventListener('resize', onMediaQueryChanges);
    }
    return function () {
      window.removeEventListener('resize', onMediaQueryChanges);
    };
  }, []);

  var className = props.className ? props.className.split(' ') : [];
  className.push(state, props.property);
  fixed && className.push('fixed');

  return React__default.createElement(
    SidebarStyle,
    {
      className: className.join(' '),
      state: state,
      property: props.property,
      fixed: fixed,
      containerFixed: props.containerFixed,
      onMouseEnter: mouseEnter,
      onMouseLeave: mouseLeave
    },
    React__default.createElement(
      'div',
      { className: 'main-container' },
      props.children
    )
  );
});

function SidebarBody(props) {
  return React__default.createElement(
    'div',
    { className: 'scrollable' },
    props.children
  );
}

Sidebar.defaultProps = {
  compactedBreakpoints: ['xs', 'is', 'sm', 'md', 'lg'],
  collapsedBreakpoints: ['xs', 'is'],
  property: 'start',
  state: 'expanded'
};

Sidebar.propTypes = {
  state: PropTypes.oneOf(['hidden', 'visible', 'compacted', 'expanded']),
  property: PropTypes.oneOf(['right', 'left', 'start', 'end']),
  compactedBreakpoints: PropTypes.arrayOf(PropTypes.string),
  collapsedBreakpoints: PropTypes.arrayOf(PropTypes.string),
  fixed: PropTypes.bool,
  containerFixed: PropTypes.bool,
  responsive: PropTypes.bool
};

exports.Sidebar = Sidebar;
exports.SidebarBody = SidebarBody;
