'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = _interopDefault(require('prop-types'));
var styled = require('styled-components');
var styled__default = _interopDefault(styled);

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

var slicedToArray = function () {
  function sliceIterator(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"]) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  return function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if (Symbol.iterator in Object(arr)) {
      return sliceIterator(arr, i);
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };
}();

var taggedTemplateLiteral = function (strings, raw) {
  return Object.freeze(Object.defineProperties(strings, {
    raw: {
      value: Object.freeze(raw)
    }
  }));
};

var toConsumableArray = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
};

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

var badge = PropTypes.shape({
  status: colorState,
  title: PropTypes.string,
  position: position
});
var position = PropTypes.oneOf(['topRight', 'topLeft', 'bottomRight', 'bottomLeft', 'topStart', 'topEnd', 'bottomStart', 'bottomEnd']);

var colorState = PropTypes.oneOf(['Info', 'Success', 'Danger', 'Primary', 'Warning', 'Disabled']);

var placement = PropTypes.oneOf(['start', 'end', 'right', 'left', 'top', 'bottom']);

var trigger = PropTypes.oneOf(['click', 'hover', 'focus']);

var statusArray = ['Info', 'Success', 'Danger', 'Primary', 'Warning'];

var size = PropTypes.oneOf(['XXS', 'XS', 'SM', 'MD', 'LG', 'XL', 'XXL']);

var shape = PropTypes.oneOf(['Rectangle', 'SemiRound', 'Round']);

var itemType = {
  title: PropTypes.string.isRequired,
  link: PropTypes.any,
  expanded: PropTypes.bool,
  group: PropTypes.bool,
  hidden: PropTypes.bool,
  icon: PropTypes.string,
  target: PropTypes.string,
  url: PropTypes.string
};

var buttonTypes = {
  fullWidth: PropTypes.bool,
  hero: PropTypes.bool,
  outline: PropTypes.bool,
  pulse: PropTypes.bool,
  size: PropTypes.oneOf(['XS', 'SM', 'MD', 'LG']),
  shape: shape,
  status: PropTypes.oneOf([].concat(statusArray, ['Secondary']))
};

var _templateObject = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2 = taggedTemplateLiteral(['\n    display: block;\n    .tabs {\n      font-family: ', ';\n      font-size: ', ';\n      padding: 0 ', ';\n      border-bottom: 1px solid ', ';\n      display: flex;\n      flex-direction: row;\n      list-style-type: none;\n      margin: 0;\n      ', '\n\n      .tab {\n        background: ', ';\n        cursor: pointer;\n        margin-bottom: -1px;\n        text-align: center;\n        position: relative;\n        &.active a::before {\n          display: block;\n        }\n        a {\n          padding: ', ';\n          color: ', ';\n          display: flex;\n          align-items: center;\n          position: relative;\n          text-decoration: none;\n          &:hover {\n            color: ', ';\n          }\n\n          &::before {\n            display: none;\n            position: absolute;\n            content: \'\';\n            width: 100%;\n            height: 6px;\n            border-radius: 3px;\n            bottom: -2px;\n            left: 0;\n            background: ', ';\n            background-image: linear-gradient(\n              to right,\n              ', ',\n              ', '\n            );\n          }\n          i {\n            font-size: 1.5rem;\n          }\n\n          i + span {\n            ', '\n          }\n        }\n\n        &.active {\n          background: ', ';\n\n          a {\n            font-weight: ', ';\n            color: ', ';\n          }\n        }\n\n        &.responsive {\n          @media screen and (max-width: ', ') {\n            a span {\n              display: none;\n            }\n          }\n        }\n      }\n    }\n    .tab-content {\n      flex: 1;\n      -ms-flex: 1 1 auto;\n      overflow: auto;\n      font-family: ', ';\n      font-size: ', ';\n      color: ', ';\n      background-color: ', ';\n      padding: ', ';\n    }\n  '], ['\n    display: block;\n    .tabs {\n      font-family: ', ';\n      font-size: ', ';\n      padding: 0 ', ';\n      border-bottom: 1px solid ', ';\n      display: flex;\n      flex-direction: row;\n      list-style-type: none;\n      margin: 0;\n      ', '\n\n      .tab {\n        background: ', ';\n        cursor: pointer;\n        margin-bottom: -1px;\n        text-align: center;\n        position: relative;\n        &.active a::before {\n          display: block;\n        }\n        a {\n          padding: ', ';\n          color: ', ';\n          display: flex;\n          align-items: center;\n          position: relative;\n          text-decoration: none;\n          &:hover {\n            color: ', ';\n          }\n\n          &::before {\n            display: none;\n            position: absolute;\n            content: \'\';\n            width: 100%;\n            height: 6px;\n            border-radius: 3px;\n            bottom: -2px;\n            left: 0;\n            background: ', ';\n            background-image: linear-gradient(\n              to right,\n              ', ',\n              ', '\n            );\n          }\n          i {\n            font-size: 1.5rem;\n          }\n\n          i + span {\n            ', '\n          }\n        }\n\n        &.active {\n          background: ', ';\n\n          a {\n            font-weight: ', ';\n            color: ', ';\n          }\n        }\n\n        &.responsive {\n          @media screen and (max-width: ', ') {\n            a span {\n              display: none;\n            }\n          }\n        }\n      }\n    }\n    .tab-content {\n      flex: 1;\n      -ms-flex: 1 1 auto;\n      overflow: auto;\n      font-family: ', ';\n      font-size: ', ';\n      color: ', ';\n      background-color: ', ';\n      padding: ', ';\n    }\n  ']),
    _templateObject3 = taggedTemplateLiteral(['\n              ', '\n            '], ['\n              ', '\n            ']);

/* eslint-disable indent */
var TabsStyle = styled__default.div(_templateObject, function (_ref) {
  var theme = _ref.theme,
      fullWidth = _ref.fullWidth;
  return styled.css(_templateObject2, theme.tabsFontFamily, theme.tabsFontSize, theme.tabsPadding, theme.tabsSeparator, fullWidth && 'justify-content: space-around;', theme.tabsHeaderBg, theme.tabsPadding, theme.tabsFg, theme.tabsFgHeading, theme.tabsSelected, theme.tabsSelectedSecondColor, theme.tabsSelected, function (_ref2) {
    var theme = _ref2.theme;
    return styled.css(_templateObject3, theme.dir === 'rtl' ? 'margin-right: 0.5rem;' : 'margin-left: 0.5rem;');
  }, theme.tabsActiveBg, theme.tabsActiveFontWeight, theme.tabsFgHeading, theme.tabsIconOnlyMaxWidth, theme.tabsContentFontFamily, theme.tabsContentFontSize, theme.tabsFgText, theme.tabsBg, theme.tabsContentPadding);
});

function getPhysicalPosition(dir, position) {
  if (position1.includes(position) || position3.includes(position)) {
    return position;
  }
  switch (position) {
    case 'start':
      return dir === 'rtl' ? 'right' : 'left';
    case 'end':
      return dir === 'rtl' ? 'left' : 'right';
    case 'topStart':
      return dir === 'rtl' ? 'topRight' : 'topLeft';
    case 'topEnd':
      return dir === 'rtl' ? 'topLeft' : 'topRight';
    case 'bottomStart':
      return dir === 'rtl' ? 'bottomRight' : 'bottomLeft';
    case 'bottomEnd':
      return dir === 'rtl' ? 'bottomLeft' : 'bottomRight';
  }
  return position;
}

var position1 = ['left', 'right', 'top', 'bottom'];
var position3 = ['topRight', 'topLeft', 'bottomRight', 'bottomLeft'];

var _templateObject$1 = taggedTemplateLiteral(['\n  ', '\n  ', '\n'], ['\n  ', '\n  ', '\n']),
    _templateObject2$1 = taggedTemplateLiteral(['\n    color: ', ';\n    position: absolute;\n    padding: 0.25em 0.4em;\n    font-size: 75%;\n    font-weight: 700;\n    line-height: 1;\n    text-align: center;\n    white-space: nowrap;\n    vertical-align: baseline;\n    border-radius: 0.25rem;\n    background-color: ', ';\n  '], ['\n    color: ', ';\n    position: absolute;\n    padding: 0.25em 0.4em;\n    font-size: 75%;\n    font-weight: 700;\n    line-height: 1;\n    text-align: center;\n    white-space: nowrap;\n    vertical-align: baseline;\n    border-radius: 0.25rem;\n    background-color: ', ';\n  ']);

var Badge = styled__default.span(_templateObject$1, function (_ref) {
  var theme = _ref.theme,
      status = _ref.status;
  return styled.css(_templateObject2$1, theme.badgeFgText, theme['badge' + status + 'BgColor']);
}, function (_ref2) {
  var position$$1 = _ref2.position,
      theme = _ref2.theme;

  var placement$$1 = getPhysicalPosition(theme.dir, position$$1);
  switch (placement$$1) {
    case 'topRight':
      return 'top: 0;right: 0;';
    case 'topLeft':
      return 'top: 0;left: 0;';
    case 'bottomRight':
      return 'bottom: 0;right: 0;';
    case 'bottomLeft':
      return 'bottom: 0;left: 0;';
  }
});
Badge.propTypes = {
  position: position,
  status: colorState
};

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

function Tab(props) {
  return React__default.createElement(
    'div',
    { className: 'tab-content' },
    props.children
  );
}

Tab.propTypes = {
  title: PropTypes.string.isRequired,
  icon: PropTypes.string,
  responsive: PropTypes.bool,
  className: PropTypes.string,
  style: PropTypes.string,
  badge: badge
};

function Tabs(props) {
  var _useState = React.useState([]),
      _useState2 = slicedToArray(_useState, 2),
      tabs = _useState2[0],
      setTabs = _useState2[1];

  var _useState3 = React.useState(props.activeIndex),
      _useState4 = slicedToArray(_useState3, 2),
      active = _useState4[0],
      setActive = _useState4[1];

  var selectTab = function selectTab(index) {
    typeof props.onSelect === 'function' && props.onSelect(index);
    setActive(index);
  };

  React.useEffect(function () {
    var children = React.Children.map(props.children, function (child) {
      return _extends({}, child.props);
    });
    setTabs(children);
    if (!props.activeIndex) {
      setActive(0);
    }
  }, [props.children]);
  return React__default.createElement(
    TabsStyle,
    {
      className: props.className,
      style: props.style,
      fullWidth: props.fullWidth
    },
    React__default.createElement(
      'ul',
      { className: 'tabs' },
      tabs.map(function (tab, index) {
        var cssClass = ['tab'];
        if (index === active) {
          cssClass.push('active');
        }
        if (tab.responsive) {
          cssClass.push('responsive');
        }
        if (tab.className) {
          cssClass.push.apply(cssClass, toConsumableArray(tab.className.split(' ')));
        }
        return React__default.createElement(
          'li',
          {
            key: index,
            className: cssClass.join(' '),
            onClick: function onClick() {
              return selectTab(index);
            }
          },
          React__default.createElement(
            'a',
            null,
            tab.icon && React__default.createElement('i', { className: tab.icon }),
            tab.title && React__default.createElement(
              'span',
              null,
              tab.title
            )
          ),
          tab.badge && React__default.createElement(
            Badge,
            { status: tab.badge.status, position: tab.badge.position },
            tab.badge.title
          )
        );
      })
    ),
    React.Children.map(props.children, function (child, i) {
      if (i === active) {
        return child;
      }
    })
  );
}

Tabs.propType = {
  classNames: PropTypes.string,
  style: PropTypes.object,
  fullWidth: PropTypes.bool,
  onSelect: PropTypes.func,
  activeIndex: PropTypes.number
};

exports.Tabs = Tabs;
exports.Tab = Tab;
