'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var ReactDOM = _interopDefault(require('react-dom'));
var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = _interopDefault(require('prop-types'));
var styled = require('styled-components');
var styled__default = _interopDefault(styled);

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

var slicedToArray = function () {
  function sliceIterator(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"]) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  return function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if (Symbol.iterator in Object(arr)) {
      return sliceIterator(arr, i);
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };
}();

var taggedTemplateLiteral = function (strings, raw) {
  return Object.freeze(Object.defineProperties(strings, {
    raw: {
      value: Object.freeze(raw)
    }
  }));
};

var toConsumableArray = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
};

var _templateObject = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2 = taggedTemplateLiteral(['\n      position: absolute;\n      box-sizing: border-box;\n      z-index: 1000;\n      display: flex;\n      width: 100%;\n      height: 100%;\n      min-width: 1px;\n      min-height: 1px;\n      top: 0px;\n      left: 0px;\n      .overlay-pane {\n        ', '\n        position: absolute;\n        pointer-events: auto;\n        display: flex;\n        max-width: 100%;\n        max-height: 100%;\n        box-sizing: border-box;\n        ', '\n        .tooltip {\n          background: ', ';\n          z-index: 10000;\n          border-radius: 5px;\n          .content {\n            padding: 0.5rem 1.25rem;\n            display: flex;\n            align-items: center;\n            font-size: ', ';\n            color: ', ';\n          }\n\n          .arrow {\n            position: absolute;\n            width: 0;\n            height: 0;\n            border-bottom: ', 'px solid ', ';\n            border-left: ', 'px solid transparent;\n            border-right: ', 'px solid transparent;\n          }\n\n          .icon {\n            font-size: 1.25rem;\n          }\n\n          span {\n            line-height: 1.25rem;\n          }\n\n          .icon + span {\n            margin-left: 0.5rem;\n          }\n          ', '\n        }\n      }\n    '], ['\n      position: absolute;\n      box-sizing: border-box;\n      z-index: 1000;\n      display: flex;\n      width: 100%;\n      height: 100%;\n      min-width: 1px;\n      min-height: 1px;\n      top: 0px;\n      left: 0px;\n      .overlay-pane {\n        ', '\n        position: absolute;\n        pointer-events: auto;\n        display: flex;\n        max-width: 100%;\n        max-height: 100%;\n        box-sizing: border-box;\n        ', '\n        .tooltip {\n          background: ', ';\n          z-index: 10000;\n          border-radius: 5px;\n          .content {\n            padding: 0.5rem 1.25rem;\n            display: flex;\n            align-items: center;\n            font-size: ', ';\n            color: ', ';\n          }\n\n          .arrow {\n            position: absolute;\n            width: 0;\n            height: 0;\n            border-bottom: ', 'px solid ', ';\n            border-left: ', 'px solid transparent;\n            border-right: ', 'px solid transparent;\n          }\n\n          .icon {\n            font-size: 1.25rem;\n          }\n\n          span {\n            line-height: 1.25rem;\n          }\n\n          .icon + span {\n            margin-left: 0.5rem;\n          }\n          ', '\n        }\n      }\n    ']),
    _templateObject3 = taggedTemplateLiteral(['\n        .content {\n          flex-direction: row-reverse;\n        }\n        .icon + span {\n          margin-right: 0.5rem;\n        }\n        .arrow {\n          left: ', 'px;\n          top: calc(50% - ', 'px);\n          transform: rotate(270deg);\n        }\n      '], ['\n        .content {\n          flex-direction: row-reverse;\n        }\n        .icon + span {\n          margin-right: 0.5rem;\n        }\n        .arrow {\n          left: ', 'px;\n          top: calc(50% - ', 'px);\n          transform: rotate(270deg);\n        }\n      ']),
    _templateObject4 = taggedTemplateLiteral(['\n        .arrow {\n          right: ', 'px;\n          top: calc(50% - ', 'px);\n          transform: rotate(90deg);\n        }\n      '], ['\n        .arrow {\n          right: ', 'px;\n          top: calc(50% - ', 'px);\n          transform: rotate(90deg);\n        }\n      ']),
    _templateObject5 = taggedTemplateLiteral(['\n        .arrow {\n          bottom: calc(-', 'px + 1px);\n          left: calc(50% - ', 'px);\n          transform: rotate(180deg);\n        }\n      '], ['\n        .arrow {\n          bottom: calc(-', 'px + 1px);\n          left: calc(50% - ', 'px);\n          transform: rotate(180deg);\n        }\n      ']),
    _templateObject6 = taggedTemplateLiteral(['\n        .arrow {\n          top: calc(-', 'px + 2px);\n          left: calc(50% - ', 'px);\n        }\n      '], ['\n        .arrow {\n          top: calc(-', 'px + 2px);\n          left: calc(50% - ', 'px);\n        }\n      ']);

var TooltipStyle = styled__default.div(_templateObject, function (_ref) {
  var theme = _ref.theme,
      status = _ref.status,
      placement = _ref.placement,
      position = _ref.position;

  var arrowSize = 5;
  var color = status ? theme['tooltip' + status + 'Bg'] : theme.tooltipBg;
  var arrowRound = Math.round(-arrowSize - arrowSize / 2 + 1.5);

  return styled.css(_templateObject2, overlayPane(placement), !position && 'visibility: hidden;', color, theme.tooltipFontSize, status ? theme.tooltipStatusFg : theme.tooltipFg, arrowSize, color, arrowSize, arrowSize, placementArrow(placement, arrowSize, arrowRound));
});
var overlayPane = function overlayPane(placement) {
  switch (placement) {
    case 'right':
      return 'transform: translateX(5px);';
    case 'left':
      return 'transform: translateX(-5px);';
    case 'top':
      return 'transform: translateY(-5px);';
    case 'bottom':
      return 'transform: translateY(5px);';
  }
};
var placementArrow = function placementArrow(placement, arrowSize, arrowRound) {
  switch (placement) {
    case 'right':
      return styled.css(_templateObject3, arrowRound, arrowSize / 2.5);
    case 'left':
      return styled.css(_templateObject4, arrowRound, arrowSize / 2.5);
    case 'top':
      return styled.css(_templateObject5, arrowSize, arrowSize);
    case 'bottom':
      return styled.css(_templateObject6, arrowSize, arrowSize);
  }
};

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

var badge = PropTypes.shape({
  status: colorState,
  title: PropTypes.string,
  position: position
});
var position = PropTypes.oneOf(['topRight', 'topLeft', 'bottomRight', 'bottomLeft', 'topStart', 'topEnd', 'bottomStart', 'bottomEnd']);

var colorState = PropTypes.oneOf(['Info', 'Success', 'Danger', 'Primary', 'Warning', 'Disabled']);

var placement = PropTypes.oneOf(['start', 'end', 'right', 'left', 'top', 'bottom']);

var trigger = PropTypes.oneOf(['click', 'hover', 'focus']);

var statusArray = ['Info', 'Success', 'Danger', 'Primary', 'Warning'];

var size = PropTypes.oneOf(['XXS', 'XS', 'SM', 'MD', 'LG', 'XL', 'XXL']);

var shape = PropTypes.oneOf(['Rectangle', 'SemiRound', 'Round']);

var itemType = {
  title: PropTypes.string.isRequired,
  link: PropTypes.any,
  expanded: PropTypes.bool,
  group: PropTypes.bool,
  hidden: PropTypes.bool,
  icon: PropTypes.string,
  target: PropTypes.string,
  url: PropTypes.string
};

var buttonTypes = {
  fullWidth: PropTypes.bool,
  hero: PropTypes.bool,
  outline: PropTypes.bool,
  pulse: PropTypes.bool,
  size: PropTypes.oneOf(['XS', 'SM', 'MD', 'LG']),
  shape: shape,
  status: PropTypes.oneOf([].concat(statusArray, ['Secondary']))
};

var layoutContext = React__default.createContext({
  addClass: function addClass() {},
  removeClass: function removeClass() {},
  dir: 'ltr'
});

function getPhysicalPosition(dir, position) {
  if (position1.includes(position) || position3.includes(position)) {
    return position;
  }
  switch (position) {
    case 'start':
      return dir === 'rtl' ? 'right' : 'left';
    case 'end':
      return dir === 'rtl' ? 'left' : 'right';
    case 'topStart':
      return dir === 'rtl' ? 'topRight' : 'topLeft';
    case 'topEnd':
      return dir === 'rtl' ? 'topLeft' : 'topRight';
    case 'bottomStart':
      return dir === 'rtl' ? 'bottomRight' : 'bottomLeft';
    case 'bottomEnd':
      return dir === 'rtl' ? 'bottomLeft' : 'bottomRight';
  }
  return position;
}

var position1 = ['left', 'right', 'top', 'bottom'];
var position3 = ['topRight', 'topLeft', 'bottomRight', 'bottomLeft'];

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

function usePopoverPosition(props, targetRef, overlayRef) {
  var layout = React.useContext(layoutContext);

  var _useState = React.useState(),
      _useState2 = slicedToArray(_useState, 2),
      position = _useState2[0],
      setPosition = _useState2[1];

  var _useState3 = React.useState(false),
      _useState4 = slicedToArray(_useState3, 2),
      show = _useState4[0],
      setShow = _useState4[1];

  var _useState5 = React.useState(),
      _useState6 = slicedToArray(_useState5, 2),
      placement = _useState6[0],
      setPlacement = _useState6[1];

  React.useEffect(function () {
    if (show) {
      positionHandle();
      window.addEventListener('resize', positionHandle);
      document.querySelector('.scrollable-container').addEventListener('scroll', positionHandle);
      if (props.eventListener) {
        document.querySelector(props.eventListener).addEventListener('scroll', positionHandle);
      }

      return function () {
        window.removeEventListener('resize', positionHandle);
        document.querySelector('.scrollable-container').removeEventListener('scroll', positionHandle);
        if (props.eventListener) {
          document.querySelector(props.eventListener).removeEventListener('scroll', positionHandle);
        }
      };
    }
  }, [show, overlayRef.current]);

  var positionHandle = function positionHandle() {
    var placement = getPhysicalPosition(layout.dir, props.placement);
    var data = getAdjustmentPlacement(placement, targetRef, overlayRef);
    setPosition(data.position);
    setPlacement(data.placement);
  };

  return [position, placement, show, setShow];
}

var getAdjustmentPlacement = function getAdjustmentPlacement(placement, targetRef, overlayRef) {
  var key = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 1;

  var target = targetRef.current.getBoundingClientRect();
  var overlay = overlayRef.current.getBoundingClientRect();

  if (key > 4) {
    var maxPlacement = getMaxPlacement(target, overlay);
    var _position = getPositionOfPlacement(maxPlacement, target, overlay);
    return { placement: maxPlacement, position: _position };
  }
  var position = getPositionOfPlacement(placement, target, overlay);
  var topBottom = position.top < 0 || position.bottom < 0;
  var leftRight = position.left < 0 || position.right < 0;
  switch (placement) {
    case 'left':
      if (position.left - 15 < 0 || topBottom) {
        return getAdjustmentPlacement('top', targetRef, overlayRef, key + 1);
      }
      break;
    case 'top':
      if (position.top - 15 < 0 || leftRight) {
        return getAdjustmentPlacement('right', targetRef, overlayRef, key + 1);
      }
      break;
    case 'right':
      if (window.innerWidth - position.left - 15 < overlay.width || topBottom) {
        return getAdjustmentPlacement('bottom', targetRef, overlayRef, key + 1);
      }
      break;
    case 'bottom':
      if (window.innerHeight - position.top - 15 < overlay.height || leftRight) {
        return getAdjustmentPlacement('left', targetRef, overlayRef, key + 1);
      }
      break;
  }
  return { placement: placement, position: position };
};

var getMaxPlacement = function getMaxPlacement(target, overlay) {
  var positions = {
    top: target.top - overlay.height,
    bottom: window.innerHeight - target.bottom - overlay.height,
    left: target.left - overlay.width,
    right: window.innerWidth - target.right - overlay.width
  };
  var arr = Object.values(positions);
  var max = Math.max.apply(Math, toConsumableArray(arr));
  for (var key in positions) {
    if (positions.hasOwnProperty(key) && positions[key] === max) {
      return key;
    }
  }
};

var getPositionOfPlacement = function getPositionOfPlacement(placement, target, overlay) {
  var topBottom = {
    top: target.top + target.height / 2 - overlay.height / 2,
    bottom: window.innerHeight - (target.top + target.height / 2 + overlay.height / 2)
  };
  var leftRight = {
    left: target.left + (target.width / 2 - overlay.width / 2),
    right: window.innerWidth - (target.left + target.width / 2 + overlay.width / 2)
  };
  switch (placement) {
    case 'left':
      return _extends({
        left: target.left - overlay.width
      }, topBottom);
    case 'right':
      return _extends({
        left: target.right
      }, topBottom);
    case 'top':
      return _extends({
        top: target.top - overlay.height
      }, leftRight);
    case 'bottom':
      return _extends({
        top: target.bottom
      }, leftRight);
  }
};

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

function Tooltip(props) {
  var overlayRef = React.useRef();
  var targetRef = React.useRef();

  var _usePopoverPosition = usePopoverPosition(props, targetRef, overlayRef),
      _usePopoverPosition2 = slicedToArray(_usePopoverPosition, 4),
      position$$1 = _usePopoverPosition2[0],
      placement$$1 = _usePopoverPosition2[1],
      show = _usePopoverPosition2[2],
      setShow = _usePopoverPosition2[3];

  return React__default.createElement(
    React.Fragment,
    null,
    show && ReactDOM.createPortal(React__default.createElement(
      TooltipStyle,
      {
        position: position$$1,
        placement: placement$$1,
        status: props.status
      },
      React__default.createElement(
        'div',
        {
          className: 'overlay-pane',
          style: position$$1 && { top: position$$1.top, left: position$$1.left },
          ref: overlayRef
        },
        React__default.createElement(
          'div',
          { className: 'tooltip' },
          React__default.createElement('span', { className: 'arrow' }),
          React__default.createElement(
            'div',
            { className: 'content' },
            props.icon && React__default.createElement('i', { className: 'icon ' + props.icon }),
            props.content && React__default.createElement(
              'span',
              null,
              props.content
            )
          )
        )
      )
    ), document.getElementById('overlay-container')),
    React__default.createElement(
      'div',
      {
        style: props.style,
        className: props.className,
        ref: targetRef,
        onFocus: function onFocus() {
          return props.trigger === 'focus' && setShow(true);
        },
        onBlur: function onBlur() {
          return props.trigger === 'focus' && setShow(false);
        },
        onClick: function onClick() {
          return props.trigger === 'click' && setShow(!show);
        },
        onMouseEnter: function onMouseEnter() {
          return props.trigger === 'hover' && setShow(true);
        },
        onMouseLeave: function onMouseLeave() {
          return props.trigger === 'hover' && setShow(false);
        }
      },
      props.children
    )
  );
}

Tooltip.propTypes = {
  eventListener: PropTypes.string,
  trigger: trigger.isRequired,
  placement: placement.isRequired,
  status: PropTypes.oneOf(statusArray),
  icon: PropTypes.string,
  content: PropTypes.string,
  children: PropTypes.node.isRequired,
  style: PropTypes.object,
  className: PropTypes.string
};

module.exports = Tooltip;
