'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var PropTypes = _interopDefault(require('prop-types'));
var styled = require('styled-components');
var styled__default = _interopDefault(styled);
var React = require('react');
var React__default = _interopDefault(React);
var ReactDOM = _interopDefault(require('react-dom'));

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

var slicedToArray = function () {
  function sliceIterator(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"]) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  return function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if (Symbol.iterator in Object(arr)) {
      return sliceIterator(arr, i);
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };
}();

var taggedTemplateLiteral = function (strings, raw) {
  return Object.freeze(Object.defineProperties(strings, {
    raw: {
      value: Object.freeze(raw)
    }
  }));
};

var toConsumableArray = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
};

var _templateObject = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2 = taggedTemplateLiteral(['\n    display: block;\n    box-shadow: ', ';\n    border-radius: ', ';\n  '], ['\n    display: block;\n    box-shadow: ', ';\n    border-radius: ', ';\n  ']),
    _templateObject3 = taggedTemplateLiteral(['\n    font-family: ', ';\n    font-weight: ', ';\n    background: ', ';\n    color: ', ';\n\n    display: flex;\n    flex-direction: column;\n\n    & > header {\n      position: relative;\n      padding: ', ';\n      border-bottom-width: ', ';\n      border-bottom-style: ', ';\n      border-bottom-color: ', ';\n      color: ', ';\n\n      font-family: ', ';\n      font-size: ', ';\n      font-weight: ', ';\n\n      display: flex;\n      align-items: center;\n      cursor: pointer;\n\n      &:focus {\n        outline: 0;\n      }\n\n      i {\n        position: absolute;\n        ', '\n      }\n    }\n\n    &.disabled > header {\n      color: ', ';\n      cursor: default;\n    }\n\n    &:first-child {\n      border-top-left-radius: ', ';\n      border-top-right-radius: ', ';\n    }\n    &:last-child {\n      border-bottom-left-radius: ', ';\n      border-bottom-right-radius: ', ';\n\n      &.collapsed > header {\n        border-bottom: none;\n      }\n    }\n    &:not(.collapsed) + & > header {\n      border-top-width: ', ';\n      border-top-style: ', ';\n      border-top-color: ', ';\n    }\n    .item-body {\n      flex: 1;\n      -ms-flex: 1 1 auto;\n      overflow: auto;\n      padding: ', ';\n      position: relative;\n    }\n    .collapsed {\n      overflow: hidden;\n      max-height: 0;\n      transition: all 0.5s cubic-bezier(0, 1, 0.3, 1) -100ms;\n    }\n    .expanded {\n      max-height: 1500px;\n      transition: all 0.5s cubic-bezier(1, 0.15, 1, 1);\n    }\n  '], ['\n    font-family: ', ';\n    font-weight: ', ';\n    background: ', ';\n    color: ', ';\n\n    display: flex;\n    flex-direction: column;\n\n    & > header {\n      position: relative;\n      padding: ', ';\n      border-bottom-width: ', ';\n      border-bottom-style: ', ';\n      border-bottom-color: ', ';\n      color: ', ';\n\n      font-family: ', ';\n      font-size: ', ';\n      font-weight: ', ';\n\n      display: flex;\n      align-items: center;\n      cursor: pointer;\n\n      &:focus {\n        outline: 0;\n      }\n\n      i {\n        position: absolute;\n        ', '\n      }\n    }\n\n    &.disabled > header {\n      color: ', ';\n      cursor: default;\n    }\n\n    &:first-child {\n      border-top-left-radius: ', ';\n      border-top-right-radius: ', ';\n    }\n    &:last-child {\n      border-bottom-left-radius: ', ';\n      border-bottom-right-radius: ', ';\n\n      &.collapsed > header {\n        border-bottom: none;\n      }\n    }\n    &:not(.collapsed) + & > header {\n      border-top-width: ', ';\n      border-top-style: ', ';\n      border-top-color: ', ';\n    }\n    .item-body {\n      flex: 1;\n      -ms-flex: 1 1 auto;\n      overflow: auto;\n      padding: ', ';\n      position: relative;\n    }\n    .collapsed {\n      overflow: hidden;\n      max-height: 0;\n      transition: all 0.5s cubic-bezier(0, 1, 0.3, 1) -100ms;\n    }\n    .expanded {\n      max-height: 1500px;\n      transition: all 0.5s cubic-bezier(1, 0.15, 1, 1);\n    }\n  ']);

var AccordionStyle = styled__default.div(_templateObject, function (_ref) {
  var theme = _ref.theme;
  return styled.css(_templateObject2, theme.accordionItemShadow, theme.accordionBorderRadius);
});

var ItemStyle = styled__default.div(_templateObject, function (_ref2) {
  var theme = _ref2.theme;
  return styled.css(_templateObject3, theme.accordionItemFontFamily, theme.accordionItemFontWeight, theme.accordionItemBg, theme.accordionItemFgText, theme.accordionPadding, theme.accordionHeaderBorderWidth, theme.accordionHeaderBorderType, theme.accordionHeaderBorderColor, theme.accordionHeaderFgHeading, theme.accordionHeaderFontFamily, theme.accordionHeaderFontSize, theme.accordionHeaderFontWeight, theme.dir === 'rtl' ? 'left: 1rem;' : 'right: 1rem;', theme.accordionHeaderDisabledFg, theme.accordionBorderRadius, theme.accordionBorderRadius, theme.accordionBorderRadius, theme.accordionBorderRadius, theme.accordionHeaderBorderWidth, theme.accordionHeaderBorderType, theme.accordionHeaderBorderColor, theme.cardPadding);
});

function _extends$1() {
  _extends$1 = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }return target;
  };return _extends$1.apply(this, arguments);
}

var _ref =
/*#__PURE__*/
React__default.createElement("path", {
  fill: "#99ABB4",
  fillRule: "evenodd",
  stroke: "#99ABB4",
  d: "M8 6.982L2.428 2l-.363.324 5.208 4.658L2 11.676l.363.324z"
});

var SvgComponent = function SvgComponent(props) {
  return React__default.createElement("svg", _extends$1({
    width: 10,
    height: 14
  }, props), _ref);
};

function _extends$2() {
  _extends$2 = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }return target;
  };return _extends$2.apply(this, arguments);
}

var _ref$1 =
/*#__PURE__*/
React__default.createElement("path", {
  fill: "#99ABB4",
  fillRule: "evenodd",
  stroke: "#99ABB4",
  d: "M2 7.018L7.572 12l.363-.324-5.208-4.658L8 2.324 7.637 2z"
});

var SvgComponent$1 = function SvgComponent(props) {
  return React__default.createElement("svg", _extends$2({
    width: 10,
    height: 14
  }, props), _ref$1);
};

function _extends$3() {
  _extends$3 = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }return target;
  };return _extends$3.apply(this, arguments);
}

var _ref$2 =
/*#__PURE__*/
React__default.createElement("path", {
  fill: "#99ABB4",
  fillRule: "evenodd",
  stroke: "#99ABB4",
  d: "M6.982 2L2 7.572l.324.363 4.658-5.208L11.676 8 12 7.637z"
});

var SvgComponent$2 = function SvgComponent(props) {
  return React__default.createElement("svg", _extends$3({
    width: 14,
    height: 10
  }, props), _ref$2);
};

function _extends$4() {
  _extends$4 = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }return target;
  };return _extends$4.apply(this, arguments);
}

var _ref$3 =
/*#__PURE__*/
React__default.createElement("path", {
  fill: "#99ABB4",
  fillRule: "evenodd",
  stroke: "#99ABB4",
  d: "M7.018 8L12 2.428l-.324-.363-4.658 5.208L2.324 2 2 2.363z"
});

var SvgComponent$3 = function SvgComponent(props) {
  return React__default.createElement("svg", _extends$4({
    width: 14,
    height: 10
  }, props), _ref$3);
};

function _extends$5() {
  _extends$5 = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }return target;
  };return _extends$5.apply(this, arguments);
}

var _ref$4 =
/*#__PURE__*/
React__default.createElement("path", {
  fill: "#FFF",
  fillRule: "evenodd",
  d: "M12.979 13.651c-.145.22-.508.22-.653 0a.494.494 0 0 1 0-.734 5.058 5.058 0 0 0 1.305-1.761 5.32 5.32 0 0 0 .435-2.128c0-.955-.217-1.835-.652-2.57a4.747 4.747 0 0 0-1.885-1.908c-.218-.146-.29-.44-.145-.733.145-.22.435-.294.725-.147.87.587 1.667 1.32 2.175 2.275.508.954.798 1.982.798 3.083 0 .88-.218 1.761-.508 2.568a5.431 5.431 0 0 1-1.595 2.055zM8.919 0c2.465 0 4.64 1.028 6.308 2.642a9.1 9.1 0 0 1 2.61 6.386c0 2.201-.87 4.256-2.175 5.871L16.822 16l.217-.294c.363-.293.725-.44 1.16-.44.363 0 .798.147 1.088.44l4.278 4.257c.29.367.435.734.435 1.175 0 .367-.145.807-.435 1.1L22.26 23.56c-.29.293-.653.44-1.088.44-.435 0-.797-.147-1.087-.44l-4.278-4.257c-.29-.367-.435-.734-.435-1.175 0-.367.145-.807.435-1.1l.29-.294-1.16-1.101a8.76 8.76 0 0 1-6.019 2.422 8.88 8.88 0 0 1-6.308-2.642C1.015 13.725 0 11.523 0 9.028a9.1 9.1 0 0 1 2.61-6.386A8.88 8.88 0 0 1 8.918 0zm5.583 3.376c-1.45-1.468-3.408-2.348-5.584-2.348-2.175 0-4.133.88-5.583 2.348a7.98 7.98 0 0 0-2.32 5.652 7.98 7.98 0 0 0 2.32 5.65c1.45 1.395 3.408 2.35 5.583 2.35 2.176 0 4.133-.955 5.584-2.35l.072-.146h.073c1.305-1.468 2.175-3.376 2.175-5.504 0-2.202-.943-4.184-2.32-5.652z"
});

var SvgComponent$4 = function SvgComponent(props) {
  return React__default.createElement("svg", _extends$5({
    width: 24,
    height: 24
  }, props), _ref$4);
};

function _extends$6() {
  _extends$6 = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }return target;
  };return _extends$6.apply(this, arguments);
}

var _ref$5 =
/*#__PURE__*/
React__default.createElement("g", {
  fillRule: "evenodd"
}, React__default.createElement("path", {
  d: "M12.78 11.95l5.039-5.058a.554.554 0 0 0 0-.78.548.548 0 0 0-.778 0l-5.038 5.057L6.965 6.11a.548.548 0 0 0-.778 0 .554.554 0 0 0 0 .781l5.038 5.057-5.048 5.068a.554.554 0 0 0 0 .78.548.548 0 0 0 .778 0L12 12.73l5.048 5.068a.548.548 0 0 0 .92-.248.553.553 0 0 0-.142-.533L12.78 11.95z"
}), React__default.createElement("path", {
  fillRule: "nonzero",
  d: "M20.42 3.502A11.874 11.874 0 0 0 5.384 2.016C.66 5.184-1.176 11.26.998 16.53c2.175 5.269 7.754 8.262 13.326 7.149 5.572-1.113 9.585-6.022 9.584-11.725a11.899 11.899 0 0 0-3.488-8.452zm-.778 16.125a10.778 10.778 0 0 1-13.648 1.348C1.707 18.098.04 12.582 2.014 7.8 3.988 3.018 9.052.301 14.11 1.311c5.057 1.01 8.7 5.467 8.7 10.643a10.8 10.8 0 0 1-3.167 7.673z"
}));

var SvgComponent$5 = function SvgComponent(props) {
  return React__default.createElement("svg", _extends$6({
    width: 24,
    height: 24
  }, props), _ref$5);
};

function ArrowRight$1() {
  return React__default.createElement(SvgComponent, null);
}

function ArrowUp$1() {
  return React__default.createElement(SvgComponent$2, null);
}

function ArrowDown$1() {
  return React__default.createElement(SvgComponent$3, null);
}

function ArrowLeft$1() {
  return React__default.createElement(SvgComponent$1, null);
}
function CloseCircled$1() {
  return React__default.createElement(SvgComponent$5, null);
}
function SearchIcon() {
  return React__default.createElement(SvgComponent$4, null);
}

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

function AccordionItem() {}

AccordionItem.propTypes = {
  disabled: PropTypes.bool,
  expanded: PropTypes.bool
};

var Accordion = React.forwardRef(function (props, ref) {
  var _useState = React.useState([]),
      _useState2 = slicedToArray(_useState, 2),
      items = _useState2[0],
      setItems = _useState2[1];

  React.useEffect(function () {
    var children = React.Children.map(props.children, function (child) {
      return _extends({}, child.props);
    });
    setItems(children);
  }, [props.children]);

  React.useImperativeHandle(ref, function () {
    return {
      openAll: function openAll() {
        handleAllState(true);
      },
      closeAll: function closeAll() {
        handleAllState(false);
      },
      open: function open(index) {
        handleState(true, index);
      },
      close: function close(index) {
        handleState(false, index);
      },
      toggle: function toggle(index) {
        handleToggle(index);
      }
    };
  }, [items]);

  var handleAllState = function handleAllState(state) {
    var updateItems = [].concat(toConsumableArray(items));
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = updateItems[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var item = _step.value;

        item.expanded = state;
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    setItems(updateItems);
  };
  var handleState = function handleState(state, index) {
    var updateItems = [].concat(toConsumableArray(items));
    if (props.multi) {
      updateItems[index].expanded = state;
    } else {
      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = updateItems.keys()[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var i = _step2.value;

          updateItems[i].expanded = index === i ? state : state ? false : updateItems[i].expanded;
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }
    }
    setItems(updateItems);
  };
  var handleToggle = function handleToggle(index) {
    var updateItems = [].concat(toConsumableArray(items));
    if (props.multi) {
      updateItems[index].expanded = !updateItems[index].expanded;
    } else {
      var _iteratorNormalCompletion3 = true;
      var _didIteratorError3 = false;
      var _iteratorError3 = undefined;

      try {
        for (var _iterator3 = updateItems.keys()[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
          var i = _step3.value;

          updateItems[i].expanded = index === i ? !updateItems[i].expanded : false;
        }
      } catch (err) {
        _didIteratorError3 = true;
        _iteratorError3 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion3 && _iterator3.return) {
            _iterator3.return();
          }
        } finally {
          if (_didIteratorError3) {
            throw _iteratorError3;
          }
        }
      }
    }
    setItems(updateItems);
  };
  return React__default.createElement(
    AccordionStyle,
    { className: props.className, style: props.style },
    items.map(function (item, index) {
      var cssStyle = [];
      item.expanded ? cssStyle.push('expanded') : cssStyle.push('collapsed');
      item.disabled && cssStyle.push('disabled');
      return React__default.createElement(
        ItemStyle,
        { key: index, className: cssStyle.join(' ') },
        React__default.createElement(
          'header',
          { onClick: function onClick() {
              return handleToggle(index);
            } },
          item.title,
          !item.disabled && React__default.createElement(
            'i',
            null,
            item.expanded ? React__default.createElement(ArrowUp$1, null) : React__default.createElement(ArrowDown$1, null)
          )
        ),
        React__default.createElement(
          'div',
          { className: item.expanded ? 'expanded' : 'collapsed' },
          React__default.createElement(
            'div',
            { className: 'item-body' },
            item.children
          )
        )
      );
    })
  );
});
Accordion.propTypes = {
  multi: PropTypes.bool,
  classNames: PropTypes.string,
  style: PropTypes.object
};

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

var badge = PropTypes.shape({
  status: colorState,
  title: PropTypes.string,
  position: position
});
var position = PropTypes.oneOf(['topRight', 'topLeft', 'bottomRight', 'bottomLeft', 'topStart', 'topEnd', 'bottomStart', 'bottomEnd']);

var colorState = PropTypes.oneOf(['Info', 'Success', 'Danger', 'Primary', 'Warning', 'Disabled']);

var placement = PropTypes.oneOf(['start', 'end', 'right', 'left', 'top', 'bottom']);

var trigger = PropTypes.oneOf(['click', 'hover', 'focus']);

var statusArray = ['Info', 'Success', 'Danger', 'Primary', 'Warning'];

var size = PropTypes.oneOf(['XXS', 'XS', 'SM', 'MD', 'LG', 'XL', 'XXL']);

var shape = PropTypes.oneOf(['Rectangle', 'SemiRound', 'Round']);

var itemType = {
  title: PropTypes.string.isRequired,
  link: PropTypes.any,
  expanded: PropTypes.bool,
  group: PropTypes.bool,
  hidden: PropTypes.bool,
  icon: PropTypes.string,
  target: PropTypes.string,
  url: PropTypes.string
};
function menuItemsType() {
  return PropTypes.arrayOf(PropTypes.shape(_extends({}, itemType, {
    children: menuItemsType
  }))).apply(undefined, arguments);
}

var buttonTypes = {
  fullWidth: PropTypes.bool,
  hero: PropTypes.bool,
  outline: PropTypes.bool,
  pulse: PropTypes.bool,
  size: PropTypes.oneOf(['XS', 'SM', 'MD', 'LG']),
  shape: shape,
  status: PropTypes.oneOf([].concat(statusArray, ['Secondary']))
};

var _templateObject$1 = taggedTemplateLiteral(['\n  ', ';\n  ', ';\n'], ['\n  ', ';\n  ', ';\n']),
    _templateObject2$1 = taggedTemplateLiteral(['\n        background-color: ', ';\n        border-bottom-width: ', ';\n        border-bottom-style: ', ';\n        border-bottom-color: ', ';\n        border-top-left-radius: ', ';\n        border-top-right-radius: ', ';\n      '], ['\n        background-color: ', ';\n        border-bottom-width: ', ';\n        border-bottom-style: ', ';\n        border-bottom-color: ', ';\n        border-top-left-radius: ', ';\n        border-top-right-radius: ', ';\n      ']),
    _templateObject3$1 = taggedTemplateLiteral(['\n        border-bottom-width: ', ';\n        border-bottom-style: ', ';\n        border-bottom-color: ', ';\n      '], ['\n        border-bottom-width: ', ';\n        border-bottom-style: ', ';\n        border-bottom-color: ', ';\n      ']),
    _templateObject4 = taggedTemplateLiteral(['\n  ', ';\n'], ['\n  ', ';\n']),
    _templateObject5 = taggedTemplateLiteral(['\n    display: flex;\n    flex-direction: column;\n    line-height: ', ';\n    font-weight: ', ';\n    font-size: ', ';\n    color: ', ';\n    background: ', ';\n    box-shadow: ', ';\n    border-radius: ', ';\n    margin-bottom: ', ';\n    border-width: ', ';\n    border-style: ', ';\n    border-color: ', ';\n    ', '\n    ', '\n    & > header {\n      font-family: ', ';\n      font-size: ', ';\n      font-weight: ', ';\n      color: ', ';\n      padding: ', ';\n      ', '\n    }\n    .card-body {\n      padding: ', ';\n      overflow: auto;\n      flex: 1;\n      position: relative;\n    }\n    & > footer {\n      padding: ', ';\n      border-top: 1px solid ', ';\n      border-bottom-left-radius: ', ';\n      border-bottom-right-radius: ', ';\n    }\n  '], ['\n    display: flex;\n    flex-direction: column;\n    line-height: ', ';\n    font-weight: ', ';\n    font-size: ', ';\n    color: ', ';\n    background: ', ';\n    box-shadow: ', ';\n    border-radius: ', ';\n    margin-bottom: ', ';\n    border-width: ', ';\n    border-style: ', ';\n    border-color: ', ';\n    ', '\n    ', '\n    & > header {\n      font-family: ', ';\n      font-size: ', ';\n      font-weight: ', ';\n      color: ', ';\n      padding: ', ';\n      ', '\n    }\n    .card-body {\n      padding: ', ';\n      overflow: auto;\n      flex: 1;\n      position: relative;\n    }\n    & > footer {\n      padding: ', ';\n      border-top: 1px solid ', ';\n      border-bottom-left-radius: ', ';\n      border-bottom-right-radius: ', ';\n    }\n  ']);

var headerBg = styled.css(_templateObject$1, function (_ref) {
  var theme = _ref.theme,
      status = _ref.status;

  if (status) {
    return styled.css(_templateObject2$1, theme['cardHeader' + status + 'Bg'], theme.cardHeaderBorderWidth, theme.cardHeaderBorderType, theme['cardHeader' + status + 'Bg'], theme.cardBorderRadius, theme.cardBorderRadius);
  } else {
    return styled.css(_templateObject3$1, theme.cardHeaderBorderWidth, theme.cardHeaderBorderType, theme.cardHeaderBorderColor);
  }
}, function (_ref2) {
  var accent = _ref2.accent;
  return accent ? 'border-radius: 0' : '';
});

var accent = styled.css(_templateObject4, function (_ref3) {
  var theme = _ref3.theme,
      accent = _ref3.accent;
  return accent ? '\n      border-top:\n      ' + theme.cardBorderRadius + ' \n      solid\n      ' + theme['cardHeader' + accent + 'Bg'] + ';\n      ' : '';
});
var height = styled.css(_templateObject4, function (_ref4) {
  var theme = _ref4.theme,
      size$$1 = _ref4.size;
  return size$$1 ? '\n      height: ' + theme['cardHeight' + size$$1.toUpperCase()] + ';\n      ' : '';
});
var Card = styled__default.div(_templateObject4, function (_ref5) {
  var theme = _ref5.theme;
  return styled.css(_templateObject5, theme.cardLineHeight, theme.cardFontWeight, theme.cardFontSize, theme.cardFgText, theme.cardBg, theme.cardShadow, theme.cardBorderRadius, theme.cardMargin, theme.cardBorderWidth, theme.cardBorderType, theme.cardBorderColor, accent, height, theme.cardHeaderFontFamily, theme.cardHeaderFontSize, theme.cardHeaderFontWeight, theme.cardHeaderFgHeading, theme.cardPadding, headerBg, theme.cardPadding, theme.cardPadding, theme.cardSeparator, theme.cardBorderRadius, theme.cardBorderRadius);
});
Card.propTypes = {
  status: colorState,
  accent: colorState,
  size: size
};

var _templateObject$2 = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$2 = taggedTemplateLiteral(['\n    display: block;\n    position: relative;\n    perspective: 1200px;\n    .flip-body {\n      display: flex;\n      transition: transform 0.5s;\n      transform-style: preserve-3d;\n      ', '\n      & > .front,\n      & > .back {\n        flex: 1;\n\n        .flip-button {\n          line-height: ', ';\n          margin-bottom: ', ';\n          padding: ', ';\n          cursor: pointer;\n          position: absolute;\n          ', '\n          ', '\n          opacity: 1;\n          transition: opacity 0s 0.15s;\n        }\n      }\n\n      & > .front {\n        ', '\n        transition: opacity 0s 0.2s;\n        backface-visibility: visible;\n        ', '\n      }\n\n      & > .back {\n        backface-visibility: ', ';\n        transform: rotateY(180deg);\n      }\n    }\n  '], ['\n    display: block;\n    position: relative;\n    perspective: 1200px;\n    .flip-body {\n      display: flex;\n      transition: transform 0.5s;\n      transform-style: preserve-3d;\n      ', '\n      & > .front,\n      & > .back {\n        flex: 1;\n\n        .flip-button {\n          line-height: ', ';\n          margin-bottom: ', ';\n          padding: ', ';\n          cursor: pointer;\n          position: absolute;\n          ', '\n          ', '\n          opacity: 1;\n          transition: opacity 0s 0.15s;\n        }\n      }\n\n      & > .front {\n        ', '\n        transition: opacity 0s 0.2s;\n        backface-visibility: visible;\n        ', '\n      }\n\n      & > .back {\n        backface-visibility: ', ';\n        transform: rotateY(180deg);\n      }\n    }\n  ']),
    _templateObject3$2 = taggedTemplateLiteral(['\n            backface-visibility: hidden;\n            opacity: 0;\n            .flip-button {\n              opacity: 0;\n              z-index: -1;\n            }\n          '], ['\n            backface-visibility: hidden;\n            opacity: 0;\n            .flip-button {\n              opacity: 0;\n              z-index: -1;\n            }\n          ']);

var FlipCardStyled = styled__default.div(_templateObject$2, function (_ref) {
  var theme = _ref.theme,
      flipped = _ref.flipped,
      button = _ref.button;
  return styled.css(_templateObject2$2, flipped ? 'transform: rotateY(-180deg);' : '', theme.cardLineHeight, theme.cardMargin, theme.cardPadding, theme.dir === 'ltr' ? 'right: 0;' : 'left: 0;', button === 'bottom' ? 'bottom: 0;' : 'top: 0;', theme.dir === 'ltr' ? 'margin-right: -100%;' : 'margin-left: -100%;', flipped && styled.css(_templateObject3$2), flipped ? 'visible' : 'hidden');
});
function FlipCard(props) {
  var _useState = React.useState(false),
      _useState2 = slicedToArray(_useState, 2),
      flipped = _useState2[0],
      setFlipped = _useState2[1];

  var handleFlipped = function handleFlipped() {
    setFlipped(!flipped);
  };

  return React__default.createElement(
    FlipCardStyled,
    {
      className: props.className,
      style: props.style,
      flipped: flipped,
      button: props.button
    },
    React__default.createElement(
      'div',
      { className: 'flip-body' },
      React__default.createElement(
        'div',
        { className: 'front' },
        props.children[0],
        React__default.createElement(
          'i',
          { className: 'flip-button', onClick: handleFlipped },
          React__default.createElement(ArrowRight$1, null)
        )
      ),
      React__default.createElement(
        'div',
        { className: 'back' },
        props.children[1],
        React__default.createElement(
          'i',
          { className: 'flip-button', onClick: handleFlipped },
          React__default.createElement(ArrowLeft$1, null)
        )
      )
    )
  );
}
FlipCard.propTypes = {
  classNames: PropTypes.string,
  style: PropTypes.object,
  button: PropTypes.oneOf(['top', 'bottom'])
};

var _templateObject$3 = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$3 = taggedTemplateLiteral(['\n    display: block;\n    position: relative;\n    overflow: hidden;\n    & > .front {\n      display: block;\n      height: 100%;\n    }\n\n    & > .back {\n      position: absolute;\n      top: ', ';\n      right: 0;\n      left: 0;\n      overflow: hidden;\n      transition: ', ';\n      height: calc(100% - ', ');\n      .container {\n        position: absolute;\n        left: 0;\n        top: ', ';\n        width: 100%;\n        transition: top 0.5s;\n      }\n    }\n    .reveal-button {\n      cursor: pointer;\n      position: absolute;\n      transition: transform 0.3s;\n      line-height: ', ';\n      margin-bottom: ', ';\n      padding: ', ';\n      ', ';\n      ', ';\n    }\n  '], ['\n    display: block;\n    position: relative;\n    overflow: hidden;\n    & > .front {\n      display: block;\n      height: 100%;\n    }\n\n    & > .back {\n      position: absolute;\n      top: ', ';\n      right: 0;\n      left: 0;\n      overflow: hidden;\n      transition: ', ';\n      height: calc(100% - ', ');\n      .container {\n        position: absolute;\n        left: 0;\n        top: ', ';\n        width: 100%;\n        transition: top 0.5s;\n      }\n    }\n    .reveal-button {\n      cursor: pointer;\n      position: absolute;\n      transition: transform 0.3s;\n      line-height: ', ';\n      margin-bottom: ', ';\n      padding: ', ';\n      ', ';\n      ', ';\n    }\n  ']);

var RevealCardStyled = styled__default.div(_templateObject$3, function (_ref) {
  var theme = _ref.theme,
      button = _ref.button,
      revealed = _ref.revealed;
  return styled.css(_templateObject2$3, revealed ? '0' : '100%', revealed ? 'none' : 'top 0s 0.5s', theme.cardMargin, revealed ? '0' : '100%', theme.cardLineHeight, theme.cardMargin, theme.cardPadding, theme.dir === 'ltr' ? 'right: 0;' : 'left: 0;', button === 'bottom' ? 'bottom: 0;' : 'top: 0;');
});
function RevealCard(props) {
  var _useState = React.useState(false),
      _useState2 = slicedToArray(_useState, 2),
      revealed = _useState2[0],
      setRevealed = _useState2[1];

  var handleRevealed = function handleRevealed() {
    setRevealed(!revealed);
  };
  return React__default.createElement(
    RevealCardStyled,
    {
      className: props.className,
      style: props.style,
      revealed: revealed,
      button: props.button
    },
    React__default.createElement(
      'div',
      { className: 'front' },
      props.children[0]
    ),
    React__default.createElement(
      'div',
      { className: 'back' },
      React__default.createElement(
        'div',
        { className: 'container' },
        props.children[1]
      )
    ),
    React__default.createElement(
      'div',
      { className: 'reveal-button', onClick: handleRevealed },
      revealed ? React__default.createElement(ArrowDown$1, null) : React__default.createElement(ArrowUp$1, null)
    )
  );
}
RevealCard.propTypes = {
  classNames: PropTypes.string,
  style: PropTypes.object,
  button: PropTypes.oneOf(['top', 'bottom'])
};

var _templateObject$4 = taggedTemplateLiteral(['\n      @media (max-width: ', 'px) {\n        ', '\n      }\n    '], ['\n      @media (max-width: ', 'px) {\n        ', '\n      }\n    ']),
    _templateObject2$4 = taggedTemplateLiteral(['\n      @media (min-width: ', 'px) {\n        ', '\n      }\n    '], ['\n      @media (min-width: ', 'px) {\n        ', '\n      }\n    ']),
    _templateObject3$3 = taggedTemplateLiteral(['\n      @media (min-width: ', 'px) and (max-width: ', 'px) {\n        ', '\n      }\n    '], ['\n      @media (min-width: ', 'px) and (max-width: ', 'px) {\n        ', '\n      }\n    ']);
var gridSize = 12;
var gridGutter = 24;
var breakpoints = {
  xs: 0,
  is: 400,
  sm: 576,
  md: 768,
  lg: 992,
  xl: 1200,
  xxl: 1400,
  xxxl: 1600
};

var maxContainer = {
  is: 380,
  sm: 540,
  md: 720,
  lg: 960,
  xl: 1140,
  xxl: 1320,
  xxxl: 1500
};
function getGridSize(theme) {
  return theme.gridSize ? theme.gridSize : gridSize;
}
function getGridGutter(theme) {
  return theme.gridGutter ? theme.gridGutter : gridGutter;
}
function ifWidthInBreakpoint() {
  var breakpoint = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

  var bp = Object.keys(breakpoints);
  var value = false;
  if (breakpoint === []) {
    return value;
  }
  breakpoint.filter(function (b) {
    return ~bp.indexOf(b);
  }).sort(function (b1, b2) {
    return bp.indexOf(b1) - bp.indexOf(b2);
  }).map(function (b) {
    var next = breakpointNext(bp.indexOf(b));
    if (window.innerWidth >= breakpoints[b] && (next == null || window.innerWidth < breakpoints[next])) {
      value = true;
    }
  });
  return value;
}
function breakpointMin(name) {
  return breakpoints[name] != 0 ? breakpoints[name] : null;
}

function breakpointNext(index) {
  return index < Object.keys(breakpoints).length ? Object.keys(breakpoints)[index + 1] : null;
}

function breakpointMax(name) {
  var n = Object.keys(breakpoints).indexOf(name);
  var next = breakpointNext(n);
  return next ? breakpointMin(next) - 0.2 : null;
}

var breakpointDown = function breakpointDown(name) {
  return function () {
    var max = breakpointMax(name);
    if (max) {
      return styled.css(_templateObject$4, max, styled.css.apply(undefined, arguments));
    } else {
      return styled.css.apply(undefined, arguments);
    }
  };
};
var breakpointUp = function breakpointUp(name) {
  return function () {
    var min = breakpointMin(name);
    if (min) {
      return styled.css(_templateObject2$4, min, styled.css.apply(undefined, arguments));
    } else {
      return styled.css.apply(undefined, arguments);
    }
  };
};

var _templateObject$5 = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$5 = taggedTemplateLiteral(['\n        max-width: ', 'px;\n      '], ['\n        max-width: ', 'px;\n      ']),
    _templateObject3$4 = taggedTemplateLiteral(['\n  ', '\n  margin-right: auto;\n  margin-left: auto;\n  width: 100%;\n  ', '\n'], ['\n  ', '\n  margin-right: auto;\n  margin-left: auto;\n  width: 100%;\n  ', '\n']),
    _templateObject4$1 = taggedTemplateLiteral(['\n    padding-right: ', 'px;\n    padding-left: ', 'px;\n  '], ['\n    padding-right: ', 'px;\n    padding-left: ', 'px;\n  ']);

var width = styled.css(_templateObject$5, function (p) {
  return !p.fluid && Object.keys(maxContainer).map(function (key) {
    return breakpointUp(key)(_templateObject2$5, maxContainer[key]);
  });
});

var Container = styled__default.div(_templateObject3$4, function (_ref) {
  var theme = _ref.theme;
  return styled.css(_templateObject4$1, getGridGutter(theme) / 2, getGridGutter(theme) / 2);
}, width);

Container.propTypes = {
  fluid: PropTypes.bool,
  gutter: PropTypes.number,
  children: PropTypes.node
};

var _templateObject$6 = taggedTemplateLiteral(['\n  display: flex;\n  flex-wrap: wrap;\n  ', '\n'], ['\n  display: flex;\n  flex-wrap: wrap;\n  ', '\n']),
    _templateObject2$6 = taggedTemplateLiteral(['\n    margin-right: ', 'px;\n    margin-left: ', 'px;\n    ', '\n  \n    ', '\n  \n    ', '\n  \n    ', '\n  \n    ', '\n  \n    ', '\n  \n    ', '\n  \n    ', '\n  \n    ', '\n  '], ['\n    margin-right: ', 'px;\n    margin-left: ', 'px;\n    ', '\n  \n    ', '\n  \n    ', '\n  \n    ', '\n  \n    ', '\n  \n    ', '\n  \n    ', '\n  \n    ', '\n  \n    ', '\n  ']),
    _templateObject3$5 = taggedTemplateLiteral(['\n      justify-content: flex-start;\n    '], ['\n      justify-content: flex-start;\n    ']),
    _templateObject4$2 = taggedTemplateLiteral(['\n      justify-content: center;\n    '], ['\n      justify-content: center;\n    ']),
    _templateObject5$1 = taggedTemplateLiteral(['\n      justify-content: flex-end;\n    '], ['\n      justify-content: flex-end;\n    ']),
    _templateObject6 = taggedTemplateLiteral(['\n      align-items: flex-start;\n    '], ['\n      align-items: flex-start;\n    ']),
    _templateObject7 = taggedTemplateLiteral(['\n      align-items: center;\n    '], ['\n      align-items: center;\n    ']),
    _templateObject8 = taggedTemplateLiteral(['\n      align-items: flex-end;\n    '], ['\n      align-items: flex-end;\n    ']),
    _templateObject9 = taggedTemplateLiteral(['\n      justify-content: space-around;\n    '], ['\n      justify-content: space-around;\n    ']),
    _templateObject10 = taggedTemplateLiteral(['\n      justify-content: space-between;\n    '], ['\n      justify-content: space-between;\n    ']);

var valueType = PropTypes.oneOf(Object.keys(breakpoints));

var Row = styled__default.div(_templateObject$6, function (p) {
  return styled.css(_templateObject2$6, getGridGutter(p.theme) / -2, getGridGutter(p.theme) / -2, p.reverse && 'flex-direction: row-reverse;', p.start && breakpointUp(p.start)(_templateObject3$5), p.center && breakpointUp(p.center)(_templateObject4$2), p.end && breakpointUp(p.end)(_templateObject5$1), p.top && breakpointUp(p.top)(_templateObject6), p.middle && breakpointUp(p.middle)(_templateObject7), p.bottom && breakpointUp(p.bottom)(_templateObject8), p.around && breakpointUp(p.around)(_templateObject9), p.between && breakpointUp(p.between)(_templateObject10));
});

Row.propTypes = {
  reverse: PropTypes.bool,
  start: valueType,
  center: valueType,
  end: valueType,
  top: valueType,
  middle: valueType,
  bottom: valueType,
  around: valueType,
  between: valueType,
  children: PropTypes.node
};

var _templateObject$7 = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$7 = taggedTemplateLiteral(['\n            flex: 0 0 ', '%;\n            max-width: ', '%;\n            display: block;'], ['\n            flex: 0 0 ', '%;\n            max-width: ', '%;\n            display: block;']),
    _templateObject3$6 = taggedTemplateLiteral(['\n            flex-grow: 1;\n            flex-basis: 0;\n            max-width: 100%;\n            display: block;'], ['\n            flex-grow: 1;\n            flex-basis: 0;\n            max-width: 100%;\n            display: block;']),
    _templateObject4$3 = taggedTemplateLiteral(['display: none;'], ['display: none;']),
    _templateObject5$2 = taggedTemplateLiteral(['\n          margin-', ': \n          ', '%;'], ['\n          margin-', ': \n          ', '%;']),
    _templateObject6$1 = taggedTemplateLiteral(['\n  position: relative;\n  width: 100%;\n  min-height: 1px;\n  padding-right: ', 'px;\n  padding-left: ', 'px;\n  ', '\n  ', '\n  ', '\n  ', '\n  ', '\n'], ['\n  position: relative;\n  width: 100%;\n  min-height: 1px;\n  padding-right: ', 'px;\n  padding-left: ', 'px;\n  ', '\n  ', '\n  ', '\n  ', '\n  ', '\n']);

var valueType$1 = PropTypes.oneOfType([PropTypes.number, PropTypes.bool]);
var BP = Object.keys(breakpoints);
var offsetProps = BP.map(function (d) {
  return d + 'Offset';
});
var DimensionPropTypes = BP.reduce(function (propTypes, dimension) {
  propTypes[dimension] = valueType$1;
  propTypes[dimension + 'Offset'] = PropTypes.number;
  return propTypes;
}, {});

var colData = styled.css(_templateObject$7, function (p) {
  return Object.keys(p).filter(function (k) {
    return ~BP.indexOf(k);
  }).sort(function (k1, k2) {
    return BP.indexOf(k1) - BP.indexOf(k2);
  }).map(function (k) {
    if (Number.isInteger(p[k])) {
      return breakpointUp(k)(_templateObject2$7, 100 / getGridSize(p.theme) * p[k], 100 / getGridSize(p.theme) * p[k]);
    } else if (p[k]) {
      return breakpointUp(k)(_templateObject3$6);
    } else {
      return breakpointUp(k)(_templateObject4$3);
    }
  });
});
var offset = styled.css(_templateObject$7, function (p) {
  return Object.keys(p).filter(function (k) {
    return ~offsetProps.indexOf(k);
  }).map(function (k) {
    return breakpointUp(k.replace(/Offset$/, ''))(_templateObject5$2, p.theme.dir == 'rtl' ? 'right' : 'left', 100 / getGridSize(p.theme) * p[k]);
  });
});
var Col = styled__default.div(_templateObject$7, function (_ref) {
  var theme = _ref.theme,
      first = _ref.first,
      last = _ref.last,
      order = _ref.order;
  return styled.css(_templateObject6$1, getGridGutter(theme) / 2, getGridGutter(theme) / 2, colData, offset, first && 'order: -1;', last && 'order: ' + (getGridSize(theme) + 1) + ';', order && 'order: ' + order + ';');
});

Col.propTypes = _extends({}, DimensionPropTypes, {
  first: PropTypes.bool,
  last: PropTypes.bool,
  order: PropTypes.number,
  children: PropTypes.node
});

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

var _templateObject$8 = taggedTemplateLiteral(['\n  ', ';\n'], ['\n  ', ';\n']),
    _templateObject2$8 = taggedTemplateLiteral(['\n    font-family: ', ';\n    font-size: ', ';\n    font-weight: ', ';\n    background: ', ';\n    color: ', ';\n    display: block;\n    ul.menu-items {\n      margin: 0;\n      padding: 0;\n    }\n\n    .menu-group {\n      font-weight: ', ';\n      font-size: ', ';\n      color: ', ';\n      padding: ', ';\n    }\n\n    .menu-item {\n      a {\n        padding: ', ';\n        border-radius: ', ';\n      }\n\n      a:hover,\n      a.active {\n        background-color: ', ';\n        color: ', ';\n        font-weight: ', ';\n        .menu-icon {\n          color: ', ';\n        }\n        .chevron {\n          path {\n            fill: ', ';\n            stroke: ', ';\n          }\n        }\n      }\n\n      .menu-icon {\n        font-size: ', ';\n        width: auto;\n        margin: ', ';\n        text-align: center;\n        color: ', ';\n      }\n\n      .chevron {\n        path {\n          fill: ', ';\n          stroke: ', ';\n        }\n\n        ', '\n      }\n    }\n\n    .menu-items > .menu-item {\n      border-bottom: 1px solid ', ';\n      &:first-child {\n        border-top: 1px solid ', ';\n      }\n    }\n\n    .menu-item > .menu-items {\n      background-color: ', ';\n    }\n\n    .menu-item > .menu-items > .menu-item {\n      border: none;\n      background: ', ';\n      color: ', ';\n      padding: ', ';\n      &:first-child {\n        margin-top: ', ';\n      }\n      &:last-child {\n        margin-bottom: ', ';\n      }\n\n      a {\n        border: ', ';\n        padding: ', ';\n      }\n\n      a:hover {\n        color: ', ';\n        background: ', ';\n      }\n\n      a.active {\n        background-color: ', ';\n        color: ', ';\n        border-color: ', ';\n        box-shadow: none;\n        transition: all 300ms cubic-bezier(0.4, 0, 0.6, 1) 0ms;\n      }\n    }\n    .menu-items,\n    .menu-item > .menu-items {\n      list-style-type: none;\n      overflow: hidden;\n    }\n\n    .menu-item a {\n      display: flex;\n      color: inherit;\n      text-decoration: none;\n      align-items: center;\n\n      .menu-title {\n        flex: 1;\n        ', ';\n      }\n    }\n\n    &.inverse {\n      .menu-item {\n        a {\n          color: ', ';\n        }\n\n        a:hover {\n          background-color: ', ';\n          color: ', ';\n        }\n\n        a.active {\n          background-color: ', ';\n          color: ', ';\n        }\n      }\n\n      .menu-group {\n        color: ', ';\n      }\n    }\n  '], ['\n    font-family: ', ';\n    font-size: ', ';\n    font-weight: ', ';\n    background: ', ';\n    color: ', ';\n    display: block;\n    ul.menu-items {\n      margin: 0;\n      padding: 0;\n    }\n\n    .menu-group {\n      font-weight: ', ';\n      font-size: ', ';\n      color: ', ';\n      padding: ', ';\n    }\n\n    .menu-item {\n      a {\n        padding: ', ';\n        border-radius: ', ';\n      }\n\n      a:hover,\n      a.active {\n        background-color: ', ';\n        color: ', ';\n        font-weight: ', ';\n        .menu-icon {\n          color: ', ';\n        }\n        .chevron {\n          path {\n            fill: ', ';\n            stroke: ', ';\n          }\n        }\n      }\n\n      .menu-icon {\n        font-size: ', ';\n        width: auto;\n        margin: ', ';\n        text-align: center;\n        color: ', ';\n      }\n\n      .chevron {\n        path {\n          fill: ', ';\n          stroke: ', ';\n        }\n\n        ', '\n      }\n    }\n\n    .menu-items > .menu-item {\n      border-bottom: 1px solid ', ';\n      &:first-child {\n        border-top: 1px solid ', ';\n      }\n    }\n\n    .menu-item > .menu-items {\n      background-color: ', ';\n    }\n\n    .menu-item > .menu-items > .menu-item {\n      border: none;\n      background: ', ';\n      color: ', ';\n      padding: ', ';\n      &:first-child {\n        margin-top: ', ';\n      }\n      &:last-child {\n        margin-bottom: ', ';\n      }\n\n      a {\n        border: ', ';\n        padding: ', ';\n      }\n\n      a:hover {\n        color: ', ';\n        background: ', ';\n      }\n\n      a.active {\n        background-color: ', ';\n        color: ', ';\n        border-color: ', ';\n        box-shadow: none;\n        transition: all 300ms cubic-bezier(0.4, 0, 0.6, 1) 0ms;\n      }\n    }\n    .menu-items,\n    .menu-item > .menu-items {\n      list-style-type: none;\n      overflow: hidden;\n    }\n\n    .menu-item a {\n      display: flex;\n      color: inherit;\n      text-decoration: none;\n      align-items: center;\n\n      .menu-title {\n        flex: 1;\n        ', ';\n      }\n    }\n\n    &.inverse {\n      .menu-item {\n        a {\n          color: ', ';\n        }\n\n        a:hover {\n          background-color: ', ';\n          color: ', ';\n        }\n\n        a.active {\n          background-color: ', ';\n          color: ', ';\n        }\n      }\n\n      .menu-group {\n        color: ', ';\n      }\n    }\n  ']),
    _templateObject3$7 = taggedTemplateLiteral(['\n  ul {\n    &.expanded {\n      max-height: 1500px;\n      transition: max-height 0.5s cubic-bezier(1, 0.15, 1, 1);\n    }\n\n    &.collapsed {\n      max-height: 0;\n      transition: max-height 0.5s cubic-bezier(0, 1, 0.3, 1) -100ms;\n    }\n  }\n'], ['\n  ul {\n    &.expanded {\n      max-height: 1500px;\n      transition: max-height 0.5s cubic-bezier(1, 0.15, 1, 1);\n    }\n\n    &.collapsed {\n      max-height: 0;\n      transition: max-height 0.5s cubic-bezier(0, 1, 0.3, 1) -100ms;\n    }\n  }\n']);

var MenuStyle = styled__default.div(_templateObject$8, function (_ref) {
  var theme = _ref.theme;
  return styled.css(_templateObject2$8, theme.menuFontFamily, theme.menuFontSize, theme.menuFontWeight, theme.menuBg, theme.menuFg, theme.menuGroupFontWeight, theme.menuGroupFontSize, theme.menuGroupFg, theme.menuGroupPadding, theme.menuItemPadding, theme.menuSubmenuItemBorderRadius, theme.menuActiveBg, theme.menuActiveFg, theme.menuActiveFontWeight, theme.menuIconActiveColor, theme.menuIconActiveColor, theme.menuIconActiveColor, theme.menuIconFontSize, theme.menuIconMargin, theme.menuIconColor, theme.menuIconColor, theme.menuIconColor, theme.dir === 'rtl' && 'transform: rotateY(180deg);', theme.menuItemSeparator, theme.menuItemSeparator, theme.menuSubmenuBg, theme.menuSubmenuBg, theme.menuSubmenuFg, theme.menuSubmenuItemContainerPadding, theme.menuSubmenuPadding, theme.menuSubmenuPadding, theme.menuSubmenuItemBorderWidth + ' solid ' + theme.menuSubmenuBg, theme.menuSubmenuItemPadding, theme.menuSubmenuHoverFg, theme.menuSubmenuHoverBg, theme.menuSubmenuActiveBg, theme.menuSubmenuActiveFg, theme.menuSubmenuActiveBorderColor, theme.dir === 'rtl' ? 'text-align: right' : '', theme.menuBg, theme.menuActiveFg, theme.menuActiveBg, theme.menuActiveFg, theme.menuActiveBg, theme.menuBg);
});
var ItemStyle$1 = styled__default.li(_templateObject3$7);

var _templateObject$9 = taggedTemplateLiteral(['\n  ', ' {\n    width: ', ';\n\n    .menu-item a.active {\n      position: relative;\n\n      &::before {\n        position: absolute;\n        content: \'\';\n        ', '\n        top: 0;\n        height: 100%;\n        width: 4px;\n        background: ', ';\n      }\n    }\n\n    > .menu-items > .menu-item > a {\n      span,\n      .chevron {\n        display: none;\n      }\n    }\n\n    .menu-items > .menu-item {\n      transition: border-color 1s ease;\n\n      &.menu-group {\n        display: block;\n        color: transparent;\n        width: 0;\n        padding: 0;\n        overflow: hidden;\n      }\n\n      i {\n        margin-right: 0;\n      }\n\n      a {\n        justify-content: center;\n      }\n\n      & > .expanded {\n        display: none;\n      }\n    }\n  }\n  ', '\n'], ['\n  ', ' {\n    width: ', ';\n\n    .menu-item a.active {\n      position: relative;\n\n      &::before {\n        position: absolute;\n        content: \'\';\n        ', '\n        top: 0;\n        height: 100%;\n        width: 4px;\n        background: ', ';\n      }\n    }\n\n    > .menu-items > .menu-item > a {\n      span,\n      .chevron {\n        display: none;\n      }\n    }\n\n    .menu-items > .menu-item {\n      transition: border-color 1s ease;\n\n      &.menu-group {\n        display: block;\n        color: transparent;\n        width: 0;\n        padding: 0;\n        overflow: hidden;\n      }\n\n      i {\n        margin-right: 0;\n      }\n\n      a {\n        justify-content: center;\n      }\n\n      & > .expanded {\n        display: none;\n      }\n    }\n  }\n  ', '\n']),
    _templateObject2$9 = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject3$8 = taggedTemplateLiteral(['\n    position: fixed;\n    height: 100%;\n    z-index: 999;\n    top: ', ';\n    bottom: 0;\n    ', '\n    ', '\n  '], ['\n    position: fixed;\n    height: 100%;\n    z-index: 999;\n    top: ', ';\n    bottom: 0;\n    ', '\n    ', '\n  ']),
    _templateObject4$4 = taggedTemplateLiteral(['\n  font-size: ', ';\n  font-weight: ', ';\n  box-shadow: ', ';\n  display: flex;\n  flex-direction: column;\n  overflow: hidden;\n  z-index: auto;\n  transition: width .3s cubic-bezier(0.4, 0, 0.6, 1) 0ms;\n\n  order: ', ';\n    \n  ', '\n  .main-container {\n    ', '\n    height: ', ';\n    background: ', ';\n    transform: translate3d(0, 0, 0);\n    display: flex;\n    flex-direction: column;\n    transition: width .3s cubic-bezier(0.4, 0, 0.6, 1) 0ms;\n    ', '\n  }\n\n  .scrollable {\n    ', '\n    flex: 1;\n    position: relative;\n    -webkit-transform: translate3d(0, 0, 0);\n    ', '\n  }\n  \n  ', '\n\n  ', '\n\n\n  header,\n  footer\n   {\n     ', '\n    display: block;\n    \n  }\n\n  header{\n    height: ', ';\n  }\n\n  footer {\n    margin-top: auto;\n    height: ', ';\n  }\n\n  ', '{\n    margin: 0 -', ' -', ';\n  }\n'], ['\n  font-size: ', ';\n  font-weight: ', ';\n  box-shadow: ', ';\n  display: flex;\n  flex-direction: column;\n  overflow: hidden;\n  z-index: auto;\n  transition: width .3s cubic-bezier(0.4, 0, 0.6, 1) 0ms;\n\n  order: ', ';\n    \n  ', '\n  .main-container {\n    ', '\n    height: ', ';\n    background: ', ';\n    transform: translate3d(0, 0, 0);\n    display: flex;\n    flex-direction: column;\n    transition: width .3s cubic-bezier(0.4, 0, 0.6, 1) 0ms;\n    ', '\n  }\n\n  .scrollable {\n    ', '\n    flex: 1;\n    position: relative;\n    -webkit-transform: translate3d(0, 0, 0);\n    ', '\n  }\n  \n  ', '\n\n  ', '\n\n\n  header,\n  footer\n   {\n     ', '\n    display: block;\n    \n  }\n\n  header{\n    height: ', ';\n  }\n\n  footer {\n    margin-top: auto;\n    height: ', ';\n  }\n\n  ', '{\n    margin: 0 -', ' -', ';\n  }\n']),
    _templateObject5$3 = taggedTemplateLiteral(['\n      overflow-y: scroll;\n      -webkit-overflow-scrolling: touch;\n      '], ['\n      overflow-y: scroll;\n      -webkit-overflow-scrolling: touch;\n      ']);
/* eslint-disable indent */

var compacted = styled.css(_templateObject$9, MenuStyle, function (_ref) {
  var theme = _ref.theme;
  return theme.sidebarWidthCompact;
}, function (_ref2) {
  var theme = _ref2.theme;
  return theme.dir === 'rtl' ? 'right: 0;' : 'left: 0;';
}, function (_ref3) {
  var theme = _ref3.theme;
  return theme.colorFgHighlight;
}, function (_ref4) {
  var property = _ref4.property,
      theme = _ref4.theme,
      fixed = _ref4.fixed;

  if (fixed) {
    switch (property) {
      case 'right':
        return '\n          & ~ .content {\n            margin-right: ' + theme.sidebarWidthCompact + ';\n          }\n          & ~ .content.center {\n            padding-right: ' + theme.sidebarWidthCompact + ';\n          }\n        ';
      case 'left':
        return '\n          & ~ .content {\n            margin-left: ' + theme.sidebarWidthCompact + ';\n          }\n          & ~ .content.center {\n            padding-left: ' + theme.sidebarWidthCompact + ';\n          }\n        ';
      case 'start':
        return '\n          & ~ .content {\n            ' + (theme.dir == 'rtl' ? 'margin-right:' : 'margin-left:') + ' ' + theme.sidebarWidthCompact + ';\n          }\n          & ~ .content.center {\n            ' + (theme.dir == 'rtl' ? 'padding-right:' : 'padding-left:') + ' ' + theme.sidebarWidthCompact + ';\n          }\n        ';
      case 'end':
        return '\n          & ~ .content {\n            ' + (theme.dir == 'rtl' ? 'margin-left:' : 'margin-right:') + ' ' + theme.sidebarWidthCompact + ';\n          }\n          & ~ .content.center {\n            ' + (theme.dir == 'rtl' ? 'padding-left:' : 'padding-right:') + ' ' + theme.sidebarWidthCompact + ';\n          }\n        ';
      default:
        break;
    }
  }
});

var fixedStyle = styled.css(_templateObject2$9, function (_ref5) {
  var theme = _ref5.theme,
      property = _ref5.property,
      state = _ref5.state;
  return styled.css(_templateObject3$8, theme.headerHeight, state === 'hidden' && ['left', 'start'].includes(property) ? '\n        & + .content {\n          margin-left: 0;\n        }\n      ' : state === 'hidden' && ['right', 'end'].includes(property) ? '\n        & + .content {\n          margin-right: 0;\n        }\n      ' : '', property === 'right' ? 'right: 0;' : property === 'left' ? 'left: 0;' : property === 'start' ? theme.dir == 'rtl' ? 'right: 0;' : 'left: 0;' : property === 'end' ? theme.dir == 'rtl' ? 'left: 0;' : 'right: 0;' : '');
});

var SidebarStyle = styled__default.aside(_templateObject2$9, function (_ref6) {
  var theme = _ref6.theme,
      property = _ref6.property,
      state = _ref6.state,
      containerFixed = _ref6.containerFixed,
      fixed = _ref6.fixed;
  return styled.css(_templateObject4$4, theme.sidebarFontSize, theme.sidebarFontWeight, theme.sidebarShadow, property === 'right' ? theme.dir == 'rtl' ? '0' : '4' : property === 'left' ? theme.dir == 'rtl' ? '4' : '0' : property === 'end' ? '4' : '0', state === 'hidden' ? 'width: 0;padding: 0;' : state === 'compacted' ? 'width: ' + theme.sidebarWidthCompact + ';' : 'width: ' + theme.sidebarWidth + ';', state === 'hidden' ? 'width: 0;padding: 0;' : state === 'compacted' ? 'width: ' + theme.sidebarWidthCompact + ';' : 'width: ' + theme.sidebarWidth + ';', theme.sidebarHeight, theme.sidebarBg, containerFixed && 'position: fixed;', state === 'hidden' ? 'width: 0;padding: 0;overflow: hidden;' : 'overflow-y: auto;overflow-x: hidden;padding: ' + theme.sidebarPadding + ';', breakpointDown('sm')(_templateObject5$3), fixed && fixedStyle, state === 'compacted' && compacted, state === 'hidden' ? 'width: 0;padding: 0;overflow: hidden;' : 'padding: ' + theme.sidebarPadding + ';', theme.sidebarHeaderHeight, theme.sidebarFooterHeight, MenuStyle, theme.sidebarPadding, theme.sidebarPadding);
});

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

var Sidebar = React.forwardRef(function (props, ref) {
  var _useState = React.useState(props.fixed),
      _useState2 = slicedToArray(_useState, 2),
      fixed = _useState2[0],
      setFixed = _useState2[1];

  var _useState3 = React.useState(props.state),
      _useState4 = slicedToArray(_useState3, 2),
      state = _useState4[0],
      setState = _useState4[1];

  React.useImperativeHandle(ref, function () {
    return {
      toggle: function toggle() {
        switch (state) {
          case 'expanded':
            setState('compacted');
            break;
          case 'compacted':
            setState('expanded');
            break;
          case 'hidden':
            setState('visible');
            break;
          case 'visible':
            setState('hidden');
            break;
        }
      },
      hide: function hide() {
        if (state === 'visible') {
          setState('hidden');
        }
      }
    };
  }, [state]);

  var mouseEnter = function mouseEnter() {
    if (state === 'compacted') {
      setState('expanded');
    }
  };
  var mouseLeave = function mouseLeave() {
    if (state === 'expanded' && ifWidthInBreakpoint(props.compactedBreakpoints)) {
      setState('compacted');
    }
  };

  React.useEffect(function () {
    var onMediaQueryChanges = function onMediaQueryChanges() {
      if (ifWidthInBreakpoint(props.collapsedBreakpoints)) {
        setState('hidden');
        setFixed(true);
      } else if (ifWidthInBreakpoint(props.compactedBreakpoints)) {
        setState('compacted');
        setFixed(true);
      } else {
        setState('expanded');
        setFixed(false);
      }
    };
    if (props.responsive) {
      onMediaQueryChanges();
      window.addEventListener('resize', onMediaQueryChanges);
    }
    return function () {
      window.removeEventListener('resize', onMediaQueryChanges);
    };
  }, []);

  var className = props.className ? props.className.split(' ') : [];
  className.push(state, props.property);
  fixed && className.push('fixed');

  return React__default.createElement(
    SidebarStyle,
    {
      className: className.join(' '),
      state: state,
      property: props.property,
      fixed: fixed,
      containerFixed: props.containerFixed,
      onMouseEnter: mouseEnter,
      onMouseLeave: mouseLeave
    },
    React__default.createElement(
      'div',
      { className: 'main-container' },
      props.children
    )
  );
});

function SidebarBody(props) {
  return React__default.createElement(
    'div',
    { className: 'scrollable' },
    props.children
  );
}

Sidebar.defaultProps = {
  compactedBreakpoints: ['xs', 'is', 'sm', 'md', 'lg'],
  collapsedBreakpoints: ['xs', 'is'],
  property: 'start',
  state: 'expanded'
};

Sidebar.propTypes = {
  state: PropTypes.oneOf(['hidden', 'visible', 'compacted', 'expanded']),
  property: PropTypes.oneOf(['right', 'left', 'start', 'end']),
  compactedBreakpoints: PropTypes.arrayOf(PropTypes.string),
  collapsedBreakpoints: PropTypes.arrayOf(PropTypes.string),
  fixed: PropTypes.bool,
  containerFixed: PropTypes.bool,
  responsive: PropTypes.bool
};

var _templateObject$a = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$a = taggedTemplateLiteral(['\n    display: block;\n    .tabs {\n      font-family: ', ';\n      font-size: ', ';\n      padding: 0 ', ';\n      border-bottom: 1px solid ', ';\n      display: flex;\n      flex-direction: row;\n      list-style-type: none;\n      margin: 0;\n      ', '\n\n      .tab {\n        background: ', ';\n        cursor: pointer;\n        margin-bottom: -1px;\n        text-align: center;\n        position: relative;\n        &.active a::before {\n          display: block;\n        }\n        a {\n          padding: ', ';\n          color: ', ';\n          display: flex;\n          align-items: center;\n          position: relative;\n          text-decoration: none;\n          &:hover {\n            color: ', ';\n          }\n\n          &::before {\n            display: none;\n            position: absolute;\n            content: \'\';\n            width: 100%;\n            height: 6px;\n            border-radius: 3px;\n            bottom: -2px;\n            left: 0;\n            background: ', ';\n            background-image: linear-gradient(\n              to right,\n              ', ',\n              ', '\n            );\n          }\n          i {\n            font-size: 1.5rem;\n          }\n\n          i + span {\n            ', '\n          }\n        }\n\n        &.active {\n          background: ', ';\n\n          a {\n            font-weight: ', ';\n            color: ', ';\n          }\n        }\n\n        &.responsive {\n          @media screen and (max-width: ', ') {\n            a span {\n              display: none;\n            }\n          }\n        }\n      }\n    }\n    .tab-content {\n      flex: 1;\n      -ms-flex: 1 1 auto;\n      overflow: auto;\n      font-family: ', ';\n      font-size: ', ';\n      color: ', ';\n      background-color: ', ';\n      padding: ', ';\n    }\n  '], ['\n    display: block;\n    .tabs {\n      font-family: ', ';\n      font-size: ', ';\n      padding: 0 ', ';\n      border-bottom: 1px solid ', ';\n      display: flex;\n      flex-direction: row;\n      list-style-type: none;\n      margin: 0;\n      ', '\n\n      .tab {\n        background: ', ';\n        cursor: pointer;\n        margin-bottom: -1px;\n        text-align: center;\n        position: relative;\n        &.active a::before {\n          display: block;\n        }\n        a {\n          padding: ', ';\n          color: ', ';\n          display: flex;\n          align-items: center;\n          position: relative;\n          text-decoration: none;\n          &:hover {\n            color: ', ';\n          }\n\n          &::before {\n            display: none;\n            position: absolute;\n            content: \'\';\n            width: 100%;\n            height: 6px;\n            border-radius: 3px;\n            bottom: -2px;\n            left: 0;\n            background: ', ';\n            background-image: linear-gradient(\n              to right,\n              ', ',\n              ', '\n            );\n          }\n          i {\n            font-size: 1.5rem;\n          }\n\n          i + span {\n            ', '\n          }\n        }\n\n        &.active {\n          background: ', ';\n\n          a {\n            font-weight: ', ';\n            color: ', ';\n          }\n        }\n\n        &.responsive {\n          @media screen and (max-width: ', ') {\n            a span {\n              display: none;\n            }\n          }\n        }\n      }\n    }\n    .tab-content {\n      flex: 1;\n      -ms-flex: 1 1 auto;\n      overflow: auto;\n      font-family: ', ';\n      font-size: ', ';\n      color: ', ';\n      background-color: ', ';\n      padding: ', ';\n    }\n  ']),
    _templateObject3$9 = taggedTemplateLiteral(['\n              ', '\n            '], ['\n              ', '\n            ']);

/* eslint-disable indent */
var TabsStyle = styled__default.div(_templateObject$a, function (_ref) {
  var theme = _ref.theme,
      fullWidth = _ref.fullWidth;
  return styled.css(_templateObject2$a, theme.tabsFontFamily, theme.tabsFontSize, theme.tabsPadding, theme.tabsSeparator, fullWidth && 'justify-content: space-around;', theme.tabsHeaderBg, theme.tabsPadding, theme.tabsFg, theme.tabsFgHeading, theme.tabsSelected, theme.tabsSelectedSecondColor, theme.tabsSelected, function (_ref2) {
    var theme = _ref2.theme;
    return styled.css(_templateObject3$9, theme.dir === 'rtl' ? 'margin-right: 0.5rem;' : 'margin-left: 0.5rem;');
  }, theme.tabsActiveBg, theme.tabsActiveFontWeight, theme.tabsFgHeading, theme.tabsIconOnlyMaxWidth, theme.tabsContentFontFamily, theme.tabsContentFontSize, theme.tabsFgText, theme.tabsBg, theme.tabsContentPadding);
});

function getPhysicalPosition(dir, position) {
  if (position1.includes(position) || position3.includes(position)) {
    return position;
  }
  switch (position) {
    case 'start':
      return dir === 'rtl' ? 'right' : 'left';
    case 'end':
      return dir === 'rtl' ? 'left' : 'right';
    case 'topStart':
      return dir === 'rtl' ? 'topRight' : 'topLeft';
    case 'topEnd':
      return dir === 'rtl' ? 'topLeft' : 'topRight';
    case 'bottomStart':
      return dir === 'rtl' ? 'bottomRight' : 'bottomLeft';
    case 'bottomEnd':
      return dir === 'rtl' ? 'bottomLeft' : 'bottomRight';
  }
  return position;
}
function getLogicalPosition(dir, position) {
  if (position2.includes(position) || position4.includes(position)) {
    return position;
  }
  switch (position) {
    case 'right':
      return dir === 'rtl' ? 'start' : 'end';
    case 'left':
      return dir === 'rtl' ? 'end' : 'start';
    case 'topRight':
      return dir === 'rtl' ? 'topStart' : 'topEnd';
    case 'topLeft':
      return dir === 'rtl' ? 'topEnd' : 'topStart';
    case 'bottomRight':
      return dir === 'rtl' ? 'bottomStart' : 'bottomEnd';
    case 'bottomLeft':
      return dir === 'rtl' ? 'bottomEnd' : 'bottomStart';
  }
  return position;
}

function isRightPosition(dir, position) {
  var physicalPosition = getPhysicalPosition(dir, position);
  return physicalPosition === 'topRight' || physicalPosition === 'bottomRight';
}

function isTopPosition(dir, position) {
  var physicalPosition = getLogicalPosition(dir, position);
  return physicalPosition === 'topEnd' || physicalPosition === 'topStart';
}

var position1 = ['left', 'right', 'top', 'bottom'];
var position2 = ['start', 'end'];
var position3 = ['topRight', 'topLeft', 'bottomRight', 'bottomLeft'];
var position4 = ['topStart', 'topEnd', 'bottomStart', 'bottomEnd'];

var _templateObject$b = taggedTemplateLiteral(['\n  ', '\n  ', '\n'], ['\n  ', '\n  ', '\n']),
    _templateObject2$b = taggedTemplateLiteral(['\n    color: ', ';\n    position: absolute;\n    padding: 0.25em 0.4em;\n    font-size: 75%;\n    font-weight: 700;\n    line-height: 1;\n    text-align: center;\n    white-space: nowrap;\n    vertical-align: baseline;\n    border-radius: 0.25rem;\n    background-color: ', ';\n  '], ['\n    color: ', ';\n    position: absolute;\n    padding: 0.25em 0.4em;\n    font-size: 75%;\n    font-weight: 700;\n    line-height: 1;\n    text-align: center;\n    white-space: nowrap;\n    vertical-align: baseline;\n    border-radius: 0.25rem;\n    background-color: ', ';\n  ']);

var Badge = styled__default.span(_templateObject$b, function (_ref) {
  var theme = _ref.theme,
      status = _ref.status;
  return styled.css(_templateObject2$b, theme.badgeFgText, theme['badge' + status + 'BgColor']);
}, function (_ref2) {
  var position$$1 = _ref2.position,
      theme = _ref2.theme;

  var placement$$1 = getPhysicalPosition(theme.dir, position$$1);
  switch (placement$$1) {
    case 'topRight':
      return 'top: 0;right: 0;';
    case 'topLeft':
      return 'top: 0;left: 0;';
    case 'bottomRight':
      return 'bottom: 0;right: 0;';
    case 'bottomLeft':
      return 'bottom: 0;left: 0;';
  }
});
Badge.propTypes = {
  position: position,
  status: colorState
};

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

function Tab(props) {
  return React__default.createElement(
    'div',
    { className: 'tab-content' },
    props.children
  );
}

Tab.propTypes = {
  title: PropTypes.string.isRequired,
  icon: PropTypes.string,
  responsive: PropTypes.bool,
  className: PropTypes.string,
  style: PropTypes.string,
  badge: badge
};

function Tabs(props) {
  var _useState = React.useState([]),
      _useState2 = slicedToArray(_useState, 2),
      tabs = _useState2[0],
      setTabs = _useState2[1];

  var _useState3 = React.useState(props.activeIndex),
      _useState4 = slicedToArray(_useState3, 2),
      active = _useState4[0],
      setActive = _useState4[1];

  var selectTab = function selectTab(index) {
    typeof props.onSelect === 'function' && props.onSelect(index);
    setActive(index);
  };

  React.useEffect(function () {
    var children = React.Children.map(props.children, function (child) {
      return _extends({}, child.props);
    });
    setTabs(children);
    if (!props.activeIndex) {
      setActive(0);
    }
  }, [props.children]);
  return React__default.createElement(
    TabsStyle,
    {
      className: props.className,
      style: props.style,
      fullWidth: props.fullWidth
    },
    React__default.createElement(
      'ul',
      { className: 'tabs' },
      tabs.map(function (tab, index) {
        var cssClass = ['tab'];
        if (index === active) {
          cssClass.push('active');
        }
        if (tab.responsive) {
          cssClass.push('responsive');
        }
        if (tab.className) {
          cssClass.push.apply(cssClass, toConsumableArray(tab.className.split(' ')));
        }
        return React__default.createElement(
          'li',
          {
            key: index,
            className: cssClass.join(' '),
            onClick: function onClick() {
              return selectTab(index);
            }
          },
          React__default.createElement(
            'a',
            null,
            tab.icon && React__default.createElement('i', { className: tab.icon }),
            tab.title && React__default.createElement(
              'span',
              null,
              tab.title
            )
          ),
          tab.badge && React__default.createElement(
            Badge,
            { status: tab.badge.status, position: tab.badge.position },
            tab.badge.title
          )
        );
      })
    ),
    React.Children.map(props.children, function (child, i) {
      if (i === active) {
        return child;
      }
    })
  );
}

Tabs.propType = {
  classNames: PropTypes.string,
  style: PropTypes.object,
  fullWidth: PropTypes.bool,
  onSelect: PropTypes.func,
  activeIndex: PropTypes.number
};

var _templateObject$c = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$c = taggedTemplateLiteral(['\n    background: ', ';\n    display: block;\n    color: ', ';\n    .scrollable-container {\n      overflow: auto;\n      height: 100vh;\n      display: block;\n      margin: 0 auto;\n      max-width: ', ';\n      ', '\n    }\n    .layout {\n      display: flex;\n      flex-direction: column;\n      min-width: ', ';\n      min-height: ', ';\n      font-family: ', ';\n      font-size: ', ';\n      line-height: ', ';\n      .layout-header {\n        font-family: ', ';\n        font-size: ', ';\n        line-height: ', ';\n        display: block;\n        nav {\n          box-shadow: ', ';\n          height: ', ';\n          padding: ', ';\n          background: ', ';\n          color: ', ';\n          align-items: center;\n          justify-content: flex-start;\n          display: flex;\n          a {\n            color: ', ';\n            &:hover,\n            &:focus,\n            &:active {\n              color: ', ';\n            }\n          }\n        }\n        &.fixed {\n          position: fixed;\n          left: 0;\n          right: 0;\n          z-index: 1040;\n        }\n        & ~ .layout-container {\n          min-height: calc(\n            ', '\n          );\n        }\n\n        &.fixed ~ .layout-container {\n          padding-top: ', ';\n          min-height: ', ';\n        }\n\n        &.fixed ~ .layout-container > aside > .main-container {\n          height: calc(', ');\n        }\n      }\n\n      .layout-container {\n        display: flex;\n        flex: 1;\n        flex-direction: row;\n        .content {\n          display: flex;\n          flex: 1;\n          flex-direction: column;\n          min-width: 0;\n          .layout-footer {\n            display: block;\n            margin-top: auto;\n            box-shadow: ', ';\n            nav {\n              justify-content: center;\n              display: flex;\n              padding: ', ';\n              background: ', ';\n              color: ', ';\n              border-top: 1px solid ', ';\n              a {\n                color: ', ';\n                &:hover,\n                &:focus,\n                &:active {\n                  color: ', ';\n                }\n              }\n            }\n          }\n          &.center {\n            max-width: 100%;\n            position: relative;\n            margin-left: auto;\n            margin-right: auto;\n            width: ', ';\n            flex: 0 100 ', ' !important;\n          }\n\n          .columns {\n            display: flex;\n            flex: 1;\n            flex-direction: row;\n            width: 100%;\n            .main-container {\n              order: 1;\n              flex: 1 0;\n              min-width: 0;\n              padding: ', ';\n\n              ', '\n\n              ', '\n\n            &.left {\n                order: ', ';\n              }\n              &.start {\n                order: 0;\n              }\n            }\n          }\n        }\n      }\n    }\n    #overlay-container {\n      position: fixed;\n      z-index: 1040;\n      pointer-events: none;\n      top: 0;\n      left: 0;\n      height: 100%;\n      width: 100%;\n    }\n  '], ['\n    background: ', ';\n    display: block;\n    color: ', ';\n    .scrollable-container {\n      overflow: auto;\n      height: 100vh;\n      display: block;\n      margin: 0 auto;\n      max-width: ', ';\n      ', '\n    }\n    .layout {\n      display: flex;\n      flex-direction: column;\n      min-width: ', ';\n      min-height: ', ';\n      font-family: ', ';\n      font-size: ', ';\n      line-height: ', ';\n      .layout-header {\n        font-family: ', ';\n        font-size: ', ';\n        line-height: ', ';\n        display: block;\n        nav {\n          box-shadow: ', ';\n          height: ', ';\n          padding: ', ';\n          background: ', ';\n          color: ', ';\n          align-items: center;\n          justify-content: flex-start;\n          display: flex;\n          a {\n            color: ', ';\n            &:hover,\n            &:focus,\n            &:active {\n              color: ', ';\n            }\n          }\n        }\n        &.fixed {\n          position: fixed;\n          left: 0;\n          right: 0;\n          z-index: 1040;\n        }\n        & ~ .layout-container {\n          min-height: calc(\n            ', '\n          );\n        }\n\n        &.fixed ~ .layout-container {\n          padding-top: ', ';\n          min-height: ', ';\n        }\n\n        &.fixed ~ .layout-container > aside > .main-container {\n          height: calc(', ');\n        }\n      }\n\n      .layout-container {\n        display: flex;\n        flex: 1;\n        flex-direction: row;\n        .content {\n          display: flex;\n          flex: 1;\n          flex-direction: column;\n          min-width: 0;\n          .layout-footer {\n            display: block;\n            margin-top: auto;\n            box-shadow: ', ';\n            nav {\n              justify-content: center;\n              display: flex;\n              padding: ', ';\n              background: ', ';\n              color: ', ';\n              border-top: 1px solid ', ';\n              a {\n                color: ', ';\n                &:hover,\n                &:focus,\n                &:active {\n                  color: ', ';\n                }\n              }\n            }\n          }\n          &.center {\n            max-width: 100%;\n            position: relative;\n            margin-left: auto;\n            margin-right: auto;\n            width: ', ';\n            flex: 0 100 ', ' !important;\n          }\n\n          .columns {\n            display: flex;\n            flex: 1;\n            flex-direction: row;\n            width: 100%;\n            .main-container {\n              order: 1;\n              flex: 1 0;\n              min-width: 0;\n              padding: ', ';\n\n              ', '\n\n              ', '\n\n            &.left {\n                order: ', ';\n              }\n              &.start {\n                order: 0;\n              }\n            }\n          }\n        }\n      }\n    }\n    #overlay-container {\n      position: fixed;\n      z-index: 1040;\n      pointer-events: none;\n      top: 0;\n      left: 0;\n      height: 100%;\n      width: 100%;\n    }\n  ']),
    _templateObject3$a = taggedTemplateLiteral(['\n      overflow-y: scroll;\n      -webkit-overflow-scrolling: touch;\n    '], ['\n      overflow-y: scroll;\n      -webkit-overflow-scrolling: touch;\n    ']),
    _templateObject4$5 = taggedTemplateLiteral(['\n              padding: ', ';\n            '], ['\n              padding: ', ';\n            ']);

var LayoutStyle = styled__default.div(_templateObject$c, function (_ref) {
  var theme = _ref.theme;
  return styled.css(_templateObject2$c, theme.layoutBg, theme.layoutFg, theme.layoutWindowModeMaxWidth, breakpointDown('sm')(_templateObject3$a), theme.layoutWindowModeMinWidth, theme.layoutMinHeight, theme.layoutFontFamily, theme.layoutFontSize, theme.layoutLineHeight, theme.headerFontFamily, theme.headerFontSize, theme.headerLineHeight, theme.headerShadow, theme.headerHeight, theme.headerPadding, theme.headerBg, theme.headerFg, theme.headerFg, theme.headerFg, theme.layoutMinHeight + ' - ' + theme.headerHeight, theme.headerHeight, theme.layoutMinHeight, theme.sidebarHeight + ' - ' + theme.headerHeight, theme.footerShadow, theme.footerPadding, theme.footerBg, theme.footerFg, theme.footerSeparator, theme.footerFgHighlight, theme.footerFgHighlight, theme.layoutContentWidth, theme.layoutContentWidth, theme.layoutPadding, breakpointDown('md')(_templateObject4$5, theme.layoutMediumPadding), breakpointDown('sm')(_templateObject4$5, theme.layoutSmallPadding), theme.dir === 'rtl' ? '2' : '0');
});

var layoutContext = React__default.createContext({
  addClass: function addClass() {},
  removeClass: function removeClass() {},
  dir: 'ltr'
});

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

function LayoutHeader(props) {
  return React__default.createElement(
    'header',
    { className: props.fixed ? 'fixed layout-header' : 'layout-header' },
    React__default.createElement(
      'nav',
      null,
      props.children
    )
  );
}
LayoutHeader.propTypes = {
  fixed: PropTypes.bool
};
function LayoutFooter(props) {
  return React__default.createElement(
    'footer',
    { className: 'layout-footer' },
    React__default.createElement(
      'nav',
      null,
      props.children
    )
  );
}

function LayoutColumns(props) {
  return React__default.createElement(
    'div',
    { className: 'columns' },
    React__default.createElement(
      'div',
      { className: 'main-container' },
      props.children
    )
  );
}

function LayoutContent(props) {
  return React__default.createElement(
    'div',
    { className: 'content' },
    props.children
  );
}
function LayoutContainer(props) {
  return React__default.createElement(
    'div',
    { className: 'layout-container' },
    props.children
  );
}

function Layout(props) {
  var _useState = React.useState(props.className ? [].concat(toConsumableArray(props.className.split(' '))) : []),
      _useState2 = slicedToArray(_useState, 2),
      className = _useState2[0],
      setClassName = _useState2[1];

  var addClass = function addClass(cssClass) {
    var updatedClass = [].concat(toConsumableArray(className));
    updatedClass.push.apply(updatedClass, toConsumableArray(cssClass));
    setClassName(updatedClass);
  };

  var removeClass = function removeClass(cssClass) {
    var updatedClass = [].concat(toConsumableArray(className));
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = updatedClass.keys()[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var i = _step.value;

        if (cssClass.includes(updatedClass[i])) {
          updatedClass.splice(i, 1);
        }
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    setClassName(updatedClass);
  };

  return React__default.createElement(
    LayoutStyle,
    {
      id: 'oah-layout',
      className: className.join(' '),
      style: props.style
    },
    React__default.createElement(
      layoutContext.Provider,
      { value: { addClass: addClass, removeClass: removeClass, dir: props.dir } },
      React__default.createElement(
        'div',
        { className: 'scrollable-container' },
        React__default.createElement(
          'div',
          { className: 'layout' },
          props.children
        )
      ),
      React__default.createElement('div', { id: 'overlay-container' })
    )
  );
}
Layout.defaultProps = {
  dir: 'ltr'
};

Layout.propTypes = {
  dir: PropTypes.oneOf(['ltr', 'rtl']),
  className: PropTypes.string,
  style: PropTypes.object
};

var _templateObject$d = taggedTemplateLiteral(['\n  display: flex;\n  flex-direction: column;\n  flex: 1 1 auto;\n  overflow: auto;\n'], ['\n  display: flex;\n  flex-direction: column;\n  flex: 1 1 auto;\n  overflow: auto;\n']),
    _templateObject2$d = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject3$b = taggedTemplateLiteral(['\n    border-bottom: 1px solid ', ';\n    padding: ', ';\n    flex-shrink: 0;\n\n    &:first-child {\n      border-top: 1px solid ', ';\n    }\n  '], ['\n    border-bottom: 1px solid ', ';\n    padding: ', ';\n    flex-shrink: 0;\n\n    &:first-child {\n      border-top: 1px solid ', ';\n    }\n  ']);

var List = styled__default.div(_templateObject$d);
var ListItem = styled__default.div(_templateObject2$d, function (_ref) {
  var theme = _ref.theme;
  return styled.css(_templateObject3$b, theme.listItemBorderColor, theme.listItemPadding, theme.listItemBorderColor);
});

var _templateObject$e = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$e = taggedTemplateLiteral(['\n      display: flex;\n      min-width: 0%;\n      position: relative;\n      margin-bottom: 1rem;\n      \n      .label {\n        background: ', ';\n        color: ', ';\n        ', '\n        top: 0;\n        transition: transform 150ms cubic-bezier(0.4, 0, 0.2, 1),\n          opacity 150ms cubic-bezier(0.4, 0, 0.2, 1);\n        z-index: 1;\n        transform-origin: top ', ';\n        pointer-events: none;\n        position: absolute;\n        line-height: 1.15;\n        padding: 0 5px;\n        font-size: ', ';\n        transform: translate(\n          ', '', ', \n          calc(', ' + ', ')\n        );\n      }\n\n      input,\n      textarea {\n        &:not([disabled]):focus ~ .label,\n        &[value]:not([value=""]) ~ .label{\n          transform: scale(.90) translate(\n            ', '', ', \n            -50%\n          );\n        }\n        &:not([disabled]):focus ~ .label{\n          color: ', ';\n        }\n        &[value]:not([value=""]) ~ .label{\n          ', ';\n        }\n      }\n\n      input,\n      textarea{\n        background-color: ', ';\n        border-width: ', ';\n        border-color: ', ';\n        border-style: ', ';\n        color: ', ';\n        ', '\n        \n        &:focus {\n          outline: none;\n          background-color: ', ';\n          ', '\n        }\n\n      \n        &[disabled] ~ .label {\n          opacity: 0.5;\n        }\n      \n        ', '\n        ', '\n        ', '\n      }\n    '], ['\n      display: flex;\n      min-width: 0%;\n      position: relative;\n      margin-bottom: 1rem;\n      \n      .label {\n        background: ', ';\n        color: ', ';\n        ', '\n        top: 0;\n        transition: transform 150ms cubic-bezier(0.4, 0, 0.2, 1),\n          opacity 150ms cubic-bezier(0.4, 0, 0.2, 1);\n        z-index: 1;\n        transform-origin: top ', ';\n        pointer-events: none;\n        position: absolute;\n        line-height: 1.15;\n        padding: 0 5px;\n        font-size: ', ';\n        transform: translate(\n          ', '', ', \n          calc(', ' + ', ')\n        );\n      }\n\n      input,\n      textarea {\n        &:not([disabled]):focus ~ .label,\n        &[value]:not([value=""]) ~ .label{\n          transform: scale(.90) translate(\n            ', '', ', \n            -50%\n          );\n        }\n        &:not([disabled]):focus ~ .label{\n          color: ', ';\n        }\n        &[value]:not([value=""]) ~ .label{\n          ', ';\n        }\n      }\n\n      input,\n      textarea{\n        background-color: ', ';\n        border-width: ', ';\n        border-color: ', ';\n        border-style: ', ';\n        color: ', ';\n        ', '\n        \n        &:focus {\n          outline: none;\n          background-color: ', ';\n          ', '\n        }\n\n      \n        &[disabled] ~ .label {\n          opacity: 0.5;\n        }\n      \n        ', '\n        ', '\n        ', '\n      }\n    ']),
    _templateObject3$c = taggedTemplateLiteral(['\n            border-color: ', ';\n          '], ['\n            border-color: ', ';\n          ']),
    _templateObject4$6 = taggedTemplateLiteral(['\n            border-radius: ', ';\n          '], ['\n            border-radius: ', ';\n          ']),
    _templateObject5$4 = taggedTemplateLiteral(['\n            font-size: ', ';\n            padding: ', ';\n          '], ['\n            font-size: ', ';\n            padding: ', ';\n          ']);

/* eslint-disable indent */
var GroupStyle = styled__default.div(_templateObject$e, function (_ref) {
  var theme = _ref.theme,
      fieldSize = _ref.fieldSize,
      status = _ref.status,
      shape$$1 = _ref.shape,
      fullWidth = _ref.fullWidth;

  var padding = theme['formControlPadding' + fieldSize].split(' ');
  return styled.css(_templateObject2$e, theme.formControlBg, theme.formControlPlaceholderColor, theme.dir === 'rtl' ? 'right: 0;' : 'left: 0;', theme.dir === 'rtl' ? 'right' : 'left', theme['formControlFontSize' + fieldSize], theme.dir === 'rtl' && '-', padding[1], padding[0], theme.formControlBorderWidth, theme.dir === 'rtl' && '-', padding[1], status ? theme['formControl' + status + 'BorderColor'] : theme.formControlSelectedBorderColor, status && 'color: ' + theme['formControl' + status + 'BorderColor'], theme.formControlBg, theme.formControlBorderWidth, theme.formControlBorderColor, theme.formControlBorderType, theme.formControlTextPrimaryColor, fullWidth && 'width: 100%;', theme.formControlFocusBg, !status && 'border-color: ' + theme.formControlSelectedBorderColor + ';', status && styled.css(_templateObject3$c, theme['formControl' + status + 'BorderColor']), shape$$1 && styled.css(_templateObject4$6, theme['formControl' + shape$$1 + 'BorderRadius']), fieldSize && styled.css(_templateObject5$4, theme['formControlFontSize' + fieldSize], theme['formControlPadding' + fieldSize]));
});

function InputGroup(props) {
  return React__default.createElement(
    GroupStyle,
    props,
    props.children,
    React__default.createElement(
      'div',
      { className: 'label' },
      props.label
    )
  );
}

InputGroup.defaultProps = {
  fieldSize: 'MD',
  shape: 'Rectangle'
};
InputGroup.propTypes = {
  shape: shape,
  fullWidth: PropTypes.bool,
  fieldSize: PropTypes.oneOf(['SM', 'MD', 'LG']),
  status: PropTypes.oneOf(['Info', 'Warning', 'Success', 'Danger'])
};

function _extends$7() {
  _extends$7 = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends$7.apply(this, arguments);
}

function colorToInt(color) {
  return Math.round(color * 255);
}

function convertToInt(red, green, blue) {
  return colorToInt(red) + "," + colorToInt(green) + "," + colorToInt(blue);
}

function hslToRgb(hue, saturation, lightness, convert) {
  if (convert === void 0) {
    convert = convertToInt;
  }

  if (saturation === 0) {
    // achromatic
    return convert(lightness, lightness, lightness);
  } // formular from https://en.wikipedia.org/wiki/HSL_and_HSV


  var huePrime = hue % 360 / 60;
  var chroma = (1 - Math.abs(2 * lightness - 1)) * saturation;
  var secondComponent = chroma * (1 - Math.abs(huePrime % 2 - 1));
  var red = 0;
  var green = 0;
  var blue = 0;

  if (huePrime >= 0 && huePrime < 1) {
    red = chroma;
    green = secondComponent;
  } else if (huePrime >= 1 && huePrime < 2) {
    red = secondComponent;
    green = chroma;
  } else if (huePrime >= 2 && huePrime < 3) {
    green = chroma;
    blue = secondComponent;
  } else if (huePrime >= 3 && huePrime < 4) {
    green = secondComponent;
    blue = chroma;
  } else if (huePrime >= 4 && huePrime < 5) {
    red = secondComponent;
    blue = chroma;
  } else if (huePrime >= 5 && huePrime < 6) {
    red = chroma;
    blue = secondComponent;
  }

  var lightnessModification = lightness - chroma / 2;
  var finalRed = red + lightnessModification;
  var finalGreen = green + lightnessModification;
  var finalBlue = blue + lightnessModification;
  return convert(finalRed, finalGreen, finalBlue);
}

var namedColorMap = {
  aliceblue: 'f0f8ff',
  antiquewhite: 'faebd7',
  aqua: '00ffff',
  aquamarine: '7fffd4',
  azure: 'f0ffff',
  beige: 'f5f5dc',
  bisque: 'ffe4c4',
  black: '000',
  blanchedalmond: 'ffebcd',
  blue: '0000ff',
  blueviolet: '8a2be2',
  brown: 'a52a2a',
  burlywood: 'deb887',
  cadetblue: '5f9ea0',
  chartreuse: '7fff00',
  chocolate: 'd2691e',
  coral: 'ff7f50',
  cornflowerblue: '6495ed',
  cornsilk: 'fff8dc',
  crimson: 'dc143c',
  cyan: '00ffff',
  darkblue: '00008b',
  darkcyan: '008b8b',
  darkgoldenrod: 'b8860b',
  darkgray: 'a9a9a9',
  darkgreen: '006400',
  darkgrey: 'a9a9a9',
  darkkhaki: 'bdb76b',
  darkmagenta: '8b008b',
  darkolivegreen: '556b2f',
  darkorange: 'ff8c00',
  darkorchid: '9932cc',
  darkred: '8b0000',
  darksalmon: 'e9967a',
  darkseagreen: '8fbc8f',
  darkslateblue: '483d8b',
  darkslategray: '2f4f4f',
  darkslategrey: '2f4f4f',
  darkturquoise: '00ced1',
  darkviolet: '9400d3',
  deeppink: 'ff1493',
  deepskyblue: '00bfff',
  dimgray: '696969',
  dimgrey: '696969',
  dodgerblue: '1e90ff',
  firebrick: 'b22222',
  floralwhite: 'fffaf0',
  forestgreen: '228b22',
  fuchsia: 'ff00ff',
  gainsboro: 'dcdcdc',
  ghostwhite: 'f8f8ff',
  gold: 'ffd700',
  goldenrod: 'daa520',
  gray: '808080',
  green: '008000',
  greenyellow: 'adff2f',
  grey: '808080',
  honeydew: 'f0fff0',
  hotpink: 'ff69b4',
  indianred: 'cd5c5c',
  indigo: '4b0082',
  ivory: 'fffff0',
  khaki: 'f0e68c',
  lavender: 'e6e6fa',
  lavenderblush: 'fff0f5',
  lawngreen: '7cfc00',
  lemonchiffon: 'fffacd',
  lightblue: 'add8e6',
  lightcoral: 'f08080',
  lightcyan: 'e0ffff',
  lightgoldenrodyellow: 'fafad2',
  lightgray: 'd3d3d3',
  lightgreen: '90ee90',
  lightgrey: 'd3d3d3',
  lightpink: 'ffb6c1',
  lightsalmon: 'ffa07a',
  lightseagreen: '20b2aa',
  lightskyblue: '87cefa',
  lightslategray: '789',
  lightslategrey: '789',
  lightsteelblue: 'b0c4de',
  lightyellow: 'ffffe0',
  lime: '0f0',
  limegreen: '32cd32',
  linen: 'faf0e6',
  magenta: 'f0f',
  maroon: '800000',
  mediumaquamarine: '66cdaa',
  mediumblue: '0000cd',
  mediumorchid: 'ba55d3',
  mediumpurple: '9370db',
  mediumseagreen: '3cb371',
  mediumslateblue: '7b68ee',
  mediumspringgreen: '00fa9a',
  mediumturquoise: '48d1cc',
  mediumvioletred: 'c71585',
  midnightblue: '191970',
  mintcream: 'f5fffa',
  mistyrose: 'ffe4e1',
  moccasin: 'ffe4b5',
  navajowhite: 'ffdead',
  navy: '000080',
  oldlace: 'fdf5e6',
  olive: '808000',
  olivedrab: '6b8e23',
  orange: 'ffa500',
  orangered: 'ff4500',
  orchid: 'da70d6',
  palegoldenrod: 'eee8aa',
  palegreen: '98fb98',
  paleturquoise: 'afeeee',
  palevioletred: 'db7093',
  papayawhip: 'ffefd5',
  peachpuff: 'ffdab9',
  peru: 'cd853f',
  pink: 'ffc0cb',
  plum: 'dda0dd',
  powderblue: 'b0e0e6',
  purple: '800080',
  rebeccapurple: '639',
  red: 'f00',
  rosybrown: 'bc8f8f',
  royalblue: '4169e1',
  saddlebrown: '8b4513',
  salmon: 'fa8072',
  sandybrown: 'f4a460',
  seagreen: '2e8b57',
  seashell: 'fff5ee',
  sienna: 'a0522d',
  silver: 'c0c0c0',
  skyblue: '87ceeb',
  slateblue: '6a5acd',
  slategray: '708090',
  slategrey: '708090',
  snow: 'fffafa',
  springgreen: '00ff7f',
  steelblue: '4682b4',
  tan: 'd2b48c',
  teal: '008080',
  thistle: 'd8bfd8',
  tomato: 'ff6347',
  turquoise: '40e0d0',
  violet: 'ee82ee',
  wheat: 'f5deb3',
  white: 'fff',
  whitesmoke: 'f5f5f5',
  yellow: 'ff0',
  yellowgreen: '9acd32'
  /**
   * Checks if a string is a CSS named color and returns its equivalent hex value, otherwise returns the original color.
   * @private
   */

};

function nameToHex(color) {
  if (typeof color !== 'string') return color;
  var normalizedColorName = color.toLowerCase();
  return namedColorMap[normalizedColorName] ? "#" + namedColorMap[normalizedColorName] : color;
}

var hexRegex = /^#[a-fA-F0-9]{6}$/;
var hexRgbaRegex = /^#[a-fA-F0-9]{8}$/;
var reducedHexRegex = /^#[a-fA-F0-9]{3}$/;
var reducedRgbaHexRegex = /^#[a-fA-F0-9]{4}$/;
var rgbRegex = /^rgb\(\s*(\d{1,3})\s*,\s*(\d{1,3})\s*,\s*(\d{1,3})\s*\)$/;
var rgbaRegex = /^rgba\(\s*(\d{1,3})\s*,\s*(\d{1,3})\s*,\s*(\d{1,3})\s*,\s*([-+]?[0-9]*[.]?[0-9]+)\s*\)$/;
var hslRegex = /^hsl\(\s*(\d{0,3}[.]?[0-9]+)\s*,\s*(\d{1,3})%\s*,\s*(\d{1,3})%\s*\)$/;
var hslaRegex = /^hsla\(\s*(\d{0,3}[.]?[0-9]+)\s*,\s*(\d{1,3})%\s*,\s*(\d{1,3})%\s*,\s*([-+]?[0-9]*[.]?[0-9]+)\s*\)$/;
/**
 * Returns an RgbColor or RgbaColor object. This utility function is only useful
 * if want to extract a color component. With the color util `toColorString` you
 * can convert a RgbColor or RgbaColor object back to a string.
 *
 * @example
 * // Assigns `{ red: 255, green: 0, blue: 0 }` to color1
 * const color1 = parseToRgb('rgb(255, 0, 0)');
 * // Assigns `{ red: 92, green: 102, blue: 112, alpha: 0.75 }` to color2
 * const color2 = parseToRgb('hsla(210, 10%, 40%, 0.75)');
 */

function parseToRgb(color) {
  if (typeof color !== 'string') {
    throw new Error('Passed an incorrect argument to a color function, please pass a string representation of a color.');
  }

  var normalizedColor = nameToHex(color);

  if (normalizedColor.match(hexRegex)) {
    return {
      red: parseInt("" + normalizedColor[1] + normalizedColor[2], 16),
      green: parseInt("" + normalizedColor[3] + normalizedColor[4], 16),
      blue: parseInt("" + normalizedColor[5] + normalizedColor[6], 16)
    };
  }

  if (normalizedColor.match(hexRgbaRegex)) {
    var alpha = parseFloat((parseInt("" + normalizedColor[7] + normalizedColor[8], 16) / 255).toFixed(2));
    return {
      red: parseInt("" + normalizedColor[1] + normalizedColor[2], 16),
      green: parseInt("" + normalizedColor[3] + normalizedColor[4], 16),
      blue: parseInt("" + normalizedColor[5] + normalizedColor[6], 16),
      alpha: alpha
    };
  }

  if (normalizedColor.match(reducedHexRegex)) {
    return {
      red: parseInt("" + normalizedColor[1] + normalizedColor[1], 16),
      green: parseInt("" + normalizedColor[2] + normalizedColor[2], 16),
      blue: parseInt("" + normalizedColor[3] + normalizedColor[3], 16)
    };
  }

  if (normalizedColor.match(reducedRgbaHexRegex)) {
    var _alpha = parseFloat((parseInt("" + normalizedColor[4] + normalizedColor[4], 16) / 255).toFixed(2));

    return {
      red: parseInt("" + normalizedColor[1] + normalizedColor[1], 16),
      green: parseInt("" + normalizedColor[2] + normalizedColor[2], 16),
      blue: parseInt("" + normalizedColor[3] + normalizedColor[3], 16),
      alpha: _alpha
    };
  }

  var rgbMatched = rgbRegex.exec(normalizedColor);

  if (rgbMatched) {
    return {
      red: parseInt("" + rgbMatched[1], 10),
      green: parseInt("" + rgbMatched[2], 10),
      blue: parseInt("" + rgbMatched[3], 10)
    };
  }

  var rgbaMatched = rgbaRegex.exec(normalizedColor);

  if (rgbaMatched) {
    return {
      red: parseInt("" + rgbaMatched[1], 10),
      green: parseInt("" + rgbaMatched[2], 10),
      blue: parseInt("" + rgbaMatched[3], 10),
      alpha: parseFloat("" + rgbaMatched[4])
    };
  }

  var hslMatched = hslRegex.exec(normalizedColor);

  if (hslMatched) {
    var hue = parseInt("" + hslMatched[1], 10);
    var saturation = parseInt("" + hslMatched[2], 10) / 100;
    var lightness = parseInt("" + hslMatched[3], 10) / 100;
    var rgbColorString = "rgb(" + hslToRgb(hue, saturation, lightness) + ")";
    var hslRgbMatched = rgbRegex.exec(rgbColorString);

    if (!hslRgbMatched) {
      throw new Error("Couldn't generate valid rgb string from " + normalizedColor + ", it returned " + rgbColorString + ".");
    }

    return {
      red: parseInt("" + hslRgbMatched[1], 10),
      green: parseInt("" + hslRgbMatched[2], 10),
      blue: parseInt("" + hslRgbMatched[3], 10)
    };
  }

  var hslaMatched = hslaRegex.exec(normalizedColor);

  if (hslaMatched) {
    var _hue = parseInt("" + hslaMatched[1], 10);

    var _saturation = parseInt("" + hslaMatched[2], 10) / 100;

    var _lightness = parseInt("" + hslaMatched[3], 10) / 100;

    var _rgbColorString = "rgb(" + hslToRgb(_hue, _saturation, _lightness) + ")";

    var _hslRgbMatched = rgbRegex.exec(_rgbColorString);

    if (!_hslRgbMatched) {
      throw new Error("Couldn't generate valid rgb string from " + normalizedColor + ", it returned " + _rgbColorString + ".");
    }

    return {
      red: parseInt("" + _hslRgbMatched[1], 10),
      green: parseInt("" + _hslRgbMatched[2], 10),
      blue: parseInt("" + _hslRgbMatched[3], 10),
      alpha: parseFloat("" + hslaMatched[4])
    };
  }

  throw new Error("Couldn't parse the color string. Please provide the color as a string in hex, rgb, rgba, hsl or hsla notation.");
}

function rgbToHsl(color) {
  // make sure rgb are contained in a set of [0, 255]
  var red = color.red / 255;
  var green = color.green / 255;
  var blue = color.blue / 255;
  var max = Math.max(red, green, blue);
  var min = Math.min(red, green, blue);
  var lightness = (max + min) / 2;

  if (max === min) {
    // achromatic
    if (color.alpha !== undefined) {
      return {
        hue: 0,
        saturation: 0,
        lightness: lightness,
        alpha: color.alpha
      };
    } else {
      return {
        hue: 0,
        saturation: 0,
        lightness: lightness
      };
    }
  }

  var hue;
  var delta = max - min;
  var saturation = lightness > 0.5 ? delta / (2 - max - min) : delta / (max + min);

  switch (max) {
    case red:
      hue = (green - blue) / delta + (green < blue ? 6 : 0);
      break;

    case green:
      hue = (blue - red) / delta + 2;
      break;

    default:
      // blue case
      hue = (red - green) / delta + 4;
      break;
  }

  hue *= 60;

  if (color.alpha !== undefined) {
    return {
      hue: hue,
      saturation: saturation,
      lightness: lightness,
      alpha: color.alpha
    };
  }

  return {
    hue: hue,
    saturation: saturation,
    lightness: lightness
  };
}

/**
 * Returns an HslColor or HslaColor object. This utility function is only useful
 * if want to extract a color component. With the color util `toColorString` you
 * can convert a HslColor or HslaColor object back to a string.
 *
 * @example
 * // Assigns `{ hue: 0, saturation: 1, lightness: 0.5 }` to color1
 * const color1 = parseToHsl('rgb(255, 0, 0)');
 * // Assigns `{ hue: 128, saturation: 1, lightness: 0.5, alpha: 0.75 }` to color2
 * const color2 = parseToHsl('hsla(128, 100%, 50%, 0.75)');
 */
function parseToHsl(color) {
  // Note: At a later stage we can optimize this function as right now a hsl
  // color would be parsed converted to rgb values and converted back to hsl.
  return rgbToHsl(parseToRgb(color));
}

/**
 * Reduces hex values if possible e.g. #ff8866 to #f86
 * @private
 */
var reduceHexValue = function reduceHexValue(value) {
  if (value.length === 7 && value[1] === value[2] && value[3] === value[4] && value[5] === value[6]) {
    return "#" + value[1] + value[3] + value[5];
  }

  return value;
};

function numberToHex(value) {
  var hex = value.toString(16);
  return hex.length === 1 ? "0" + hex : hex;
}

function colorToHex(color) {
  return numberToHex(Math.round(color * 255));
}

function convertToHex(red, green, blue) {
  return reduceHexValue("#" + colorToHex(red) + colorToHex(green) + colorToHex(blue));
}

function hslToHex(hue, saturation, lightness) {
  return hslToRgb(hue, saturation, lightness, convertToHex);
}

/**
 * Returns a string value for the color. The returned result is the smallest possible hex notation.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: hsl(359, 0.75, 0.4),
 *   background: hsl({ hue: 360, saturation: 0.75, lightness: 0.4 }),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${hsl(359, 0.75, 0.4)};
 *   background: ${hsl({ hue: 360, saturation: 0.75, lightness: 0.4 })};
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "#b3191c";
 *   background: "#b3191c";
 * }
 */
function hsl(value, saturation, lightness) {
  if (typeof value === 'number' && typeof saturation === 'number' && typeof lightness === 'number') {
    return hslToHex(value, saturation, lightness);
  } else if (typeof value === 'object' && saturation === undefined && lightness === undefined) {
    return hslToHex(value.hue, value.saturation, value.lightness);
  }

  throw new Error('Passed invalid arguments to hsl, please pass multiple numbers e.g. hsl(360, 0.75, 0.4) or an object e.g. rgb({ hue: 255, saturation: 0.4, lightness: 0.75 }).');
}

/**
 * Returns a string value for the color. The returned result is the smallest possible rgba or hex notation.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: hsla(359, 0.75, 0.4, 0.7),
 *   background: hsla({ hue: 360, saturation: 0.75, lightness: 0.4, alpha: 0,7 }),
 *   background: hsla(359, 0.75, 0.4, 1),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${hsla(359, 0.75, 0.4, 0.7)};
 *   background: ${hsla({ hue: 360, saturation: 0.75, lightness: 0.4, alpha: 0,7 })};
 *   background: ${hsla(359, 0.75, 0.4, 1)};
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "rgba(179,25,28,0.7)";
 *   background: "rgba(179,25,28,0.7)";
 *   background: "#b3191c";
 * }
 */
function hsla(value, saturation, lightness, alpha) {
  if (typeof value === 'number' && typeof saturation === 'number' && typeof lightness === 'number' && typeof alpha === 'number') {
    return alpha >= 1 ? hslToHex(value, saturation, lightness) : "rgba(" + hslToRgb(value, saturation, lightness) + "," + alpha + ")";
  } else if (typeof value === 'object' && saturation === undefined && lightness === undefined && alpha === undefined) {
    return value.alpha >= 1 ? hslToHex(value.hue, value.saturation, value.lightness) : "rgba(" + hslToRgb(value.hue, value.saturation, value.lightness) + "," + value.alpha + ")";
  }

  throw new Error('Passed invalid arguments to hsla, please pass multiple numbers e.g. hsl(360, 0.75, 0.4, 0.7) or an object e.g. rgb({ hue: 255, saturation: 0.4, lightness: 0.75, alpha: 0.7 }).');
}

/**
 * Returns a string value for the color. The returned result is the smallest possible hex notation.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: rgb(255, 205, 100),
 *   background: rgb({ red: 255, green: 205, blue: 100 }),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${rgb(255, 205, 100)};
 *   background: ${rgb({ red: 255, green: 205, blue: 100 })};
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "#ffcd64";
 *   background: "#ffcd64";
 * }
 */
function rgb(value, green, blue) {
  if (typeof value === 'number' && typeof green === 'number' && typeof blue === 'number') {
    return reduceHexValue("#" + numberToHex(value) + numberToHex(green) + numberToHex(blue));
  } else if (typeof value === 'object' && green === undefined && blue === undefined) {
    return reduceHexValue("#" + numberToHex(value.red) + numberToHex(value.green) + numberToHex(value.blue));
  }

  throw new Error('Passed invalid arguments to rgb, please pass multiple numbers e.g. rgb(255, 205, 100) or an object e.g. rgb({ red: 255, green: 205, blue: 100 }).');
}

/**
 * Returns a string value for the color. The returned result is the smallest possible rgba or hex notation.
 *
 * Can also be used to fade a color by passing a hex value or named CSS color along with an alpha value.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: rgba(255, 205, 100, 0.7),
 *   background: rgba({ red: 255, green: 205, blue: 100, alpha: 0.7 }),
 *   background: rgba(255, 205, 100, 1),
 *   background: rgba('#ffffff', 0.4),
 *   background: rgba('black', 0.7),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${rgba(255, 205, 100, 0.7)};
 *   background: ${rgba({ red: 255, green: 205, blue: 100, alpha: 0.7 })};
 *   background: ${rgba(255, 205, 100, 1)};
 *   background: ${rgba('#ffffff', 0.4)};
 *   background: ${rgba('black', 0.7)};
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "rgba(255,205,100,0.7)";
 *   background: "rgba(255,205,100,0.7)";
 *   background: "#ffcd64";
 *   background: "rgba(255,255,255,0.4)";
 *   background: "rgba(0,0,0,0.7)";
 * }
 */
function rgba(firstValue, secondValue, thirdValue, fourthValue) {
  if (typeof firstValue === 'string' && typeof secondValue === 'number') {
    var rgbValue = parseToRgb(firstValue);
    return "rgba(" + rgbValue.red + "," + rgbValue.green + "," + rgbValue.blue + "," + secondValue + ")";
  } else if (typeof firstValue === 'number' && typeof secondValue === 'number' && typeof thirdValue === 'number' && typeof fourthValue === 'number') {
    return fourthValue >= 1 ? rgb(firstValue, secondValue, thirdValue) : "rgba(" + firstValue + "," + secondValue + "," + thirdValue + "," + fourthValue + ")";
  } else if (typeof firstValue === 'object' && secondValue === undefined && thirdValue === undefined && fourthValue === undefined) {
    return firstValue.alpha >= 1 ? rgb(firstValue.red, firstValue.green, firstValue.blue) : "rgba(" + firstValue.red + "," + firstValue.green + "," + firstValue.blue + "," + firstValue.alpha + ")";
  }

  throw new Error('Passed invalid arguments to rgba, please pass multiple numbers e.g. rgb(255, 205, 100, 0.75) or an object e.g. rgb({ red: 255, green: 205, blue: 100, alpha: 0.75 }).');
}

var isRgb = function isRgb(color) {
  return typeof color.red === 'number' && typeof color.green === 'number' && typeof color.blue === 'number' && (typeof color.alpha !== 'number' || typeof color.alpha === 'undefined');
};

var isRgba = function isRgba(color) {
  return typeof color.red === 'number' && typeof color.green === 'number' && typeof color.blue === 'number' && typeof color.alpha === 'number';
};

var isHsl = function isHsl(color) {
  return typeof color.hue === 'number' && typeof color.saturation === 'number' && typeof color.lightness === 'number' && (typeof color.alpha !== 'number' || typeof color.alpha === 'undefined');
};

var isHsla = function isHsla(color) {
  return typeof color.hue === 'number' && typeof color.saturation === 'number' && typeof color.lightness === 'number' && typeof color.alpha === 'number';
};

var errMsg = 'Passed invalid argument to toColorString, please pass a RgbColor, RgbaColor, HslColor or HslaColor object.';
/**
 * Converts a RgbColor, RgbaColor, HslColor or HslaColor object to a color string.
 * This util is useful in case you only know on runtime which color object is
 * used. Otherwise we recommend to rely on `rgb`, `rgba`, `hsl` or `hsla`.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: toColorString({ red: 255, green: 205, blue: 100 }),
 *   background: toColorString({ red: 255, green: 205, blue: 100, alpha: 0.72 }),
 *   background: toColorString({ hue: 240, saturation: 1, lightness: 0.5 }),
 *   background: toColorString({ hue: 360, saturation: 0.75, lightness: 0.4, alpha: 0.72 }),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${toColorString({ red: 255, green: 205, blue: 100 })};
 *   background: ${toColorString({ red: 255, green: 205, blue: 100, alpha: 0.72 })};
 *   background: ${toColorString({ hue: 240, saturation: 1, lightness: 0.5 })};
 *   background: ${toColorString({ hue: 360, saturation: 0.75, lightness: 0.4, alpha: 0.72 })};
 * `
 *
 * // CSS in JS Output
 * element {
 *   background: "#ffcd64";
 *   background: "rgba(255,205,100,0.72)";
 *   background: "#00f";
 *   background: "rgba(179,25,25,0.72)";
 * }
 */

function toColorString(color) {
  if (typeof color !== 'object') throw new Error(errMsg);
  if (isRgba(color)) return rgba(color);
  if (isRgb(color)) return rgb(color);
  if (isHsla(color)) return hsla(color);
  if (isHsl(color)) return hsl(color);
  throw new Error(errMsg);
}

// Type definitions taken from https://github.com/gcanti/flow-static-land/blob/master/src/Fun.js
// eslint-disable-next-line no-unused-vars
// eslint-disable-next-line no-unused-vars
// eslint-disable-next-line no-redeclare
function curried(f, length, acc) {
  return function fn() {
    // eslint-disable-next-line prefer-rest-params
    var combined = acc.concat(Array.prototype.slice.call(arguments));
    return combined.length >= length ? f.apply(this, combined) : curried(f, length, combined);
  };
} // eslint-disable-next-line no-redeclare


function curry(f) {
  // eslint-disable-line no-redeclare
  return curried(f, f.length, []);
}

/**
 * Changes the hue of the color. Hue is a number between 0 to 360. The first
 * argument for adjustHue is the amount of degrees the color is rotated along
 * the color wheel.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: adjustHue(180, '#448'),
 *   background: adjustHue('180', 'rgba(101,100,205,0.7)'),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${adjustHue(180, '#448')};
 *   background: ${adjustHue('180', 'rgba(101,100,205,0.7)')};
 * `
 *
 * // CSS in JS Output
 * element {
 *   background: "#888844";
 *   background: "rgba(136,136,68,0.7)";
 * }
 */

function adjustHue(degree, color) {
  var hslColor = parseToHsl(color);
  return toColorString(_extends$7({}, hslColor, {
    hue: (hslColor.hue + parseFloat(degree)) % 360
  }));
} // prettier-ignore


var curriedAdjustHue =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(adjustHue);

function guard(lowerBoundary, upperBoundary, value) {
  return Math.max(lowerBoundary, Math.min(upperBoundary, value));
}

/**
 * Returns a string value for the darkened color.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: darken(0.2, '#FFCD64'),
 *   background: darken('0.2', 'rgba(255,205,100,0.7)'),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${darken(0.2, '#FFCD64')};
 *   background: ${darken('0.2', 'rgba(255,205,100,0.7)')};
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "#ffbd31";
 *   background: "rgba(255,189,49,0.7)";
 * }
 */

function darken(amount, color) {
  var hslColor = parseToHsl(color);
  return toColorString(_extends$7({}, hslColor, {
    lightness: guard(0, 1, hslColor.lightness - parseFloat(amount))
  }));
} // prettier-ignore


var curriedDarken =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(darken);

/**
 * Decreases the intensity of a color. Its range is between 0 to 1. The first
 * argument of the desaturate function is the amount by how much the color
 * intensity should be decreased.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: desaturate(0.2, '#CCCD64'),
 *   background: desaturate('0.2', 'rgba(204,205,100,0.7)'),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${desaturate(0.2, '#CCCD64')};
 *   background: ${desaturate('0.2', 'rgba(204,205,100,0.7)')};
 * `
 *
 * // CSS in JS Output
 * element {
 *   background: "#b8b979";
 *   background: "rgba(184,185,121,0.7)";
 * }
 */

function desaturate(amount, color) {
  var hslColor = parseToHsl(color);
  return toColorString(_extends$7({}, hslColor, {
    saturation: guard(0, 1, hslColor.saturation - parseFloat(amount))
  }));
} // prettier-ignore


var curriedDesaturate =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(desaturate);

/**
 * Returns a string value for the lightened color.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: lighten(0.2, '#CCCD64'),
 *   background: lighten('0.2', 'rgba(204,205,100,0.7)'),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${lighten(0.2, '#FFCD64')};
 *   background: ${lighten('0.2', 'rgba(204,205,100,0.7)')};
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "#e5e6b1";
 *   background: "rgba(229,230,177,0.7)";
 * }
 */

function lighten(amount, color) {
  var hslColor = parseToHsl(color);
  return toColorString(_extends$7({}, hslColor, {
    lightness: guard(0, 1, hslColor.lightness + parseFloat(amount))
  }));
} // prettier-ignore


var curriedLighten =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(lighten);

/**
 * Mixes the two provided colors together by calculating the average of each of the RGB components weighted to the first color by the provided weight.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: mix(0.5, '#f00', '#00f')
 *   background: mix(0.25, '#f00', '#00f')
 *   background: mix('0.5', 'rgba(255, 0, 0, 0.5)', '#00f')
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${mix(0.5, '#f00', '#00f')};
 *   background: ${mix(0.25, '#f00', '#00f')};
 *   background: ${mix('0.5', 'rgba(255, 0, 0, 0.5)', '#00f')};
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "#7f007f";
 *   background: "#3f00bf";
 *   background: "rgba(63, 0, 191, 0.75)";
 * }
 */

function mix(weight, color, otherColor) {
  var parsedColor1 = parseToRgb(color);

  var color1 = _extends$7({}, parsedColor1, {
    alpha: typeof parsedColor1.alpha === 'number' ? parsedColor1.alpha : 1
  });

  var parsedColor2 = parseToRgb(otherColor);

  var color2 = _extends$7({}, parsedColor2, {
    alpha: typeof parsedColor2.alpha === 'number' ? parsedColor2.alpha : 1 // The formular is copied from the original Sass implementation:
    // http://sass-lang.com/documentation/Sass/Script/Functions.html#mix-instance_method

  });

  var alphaDelta = color1.alpha - color2.alpha;
  var x = parseFloat(weight) * 2 - 1;
  var y = x * alphaDelta === -1 ? x : x + alphaDelta;
  var z = 1 + x * alphaDelta;
  var weight1 = (y / z + 1) / 2.0;
  var weight2 = 1 - weight1;
  var mixedColor = {
    red: Math.floor(color1.red * weight1 + color2.red * weight2),
    green: Math.floor(color1.green * weight1 + color2.green * weight2),
    blue: Math.floor(color1.blue * weight1 + color2.blue * weight2),
    alpha: color1.alpha + (color2.alpha - color1.alpha) * (parseFloat(weight) / 1.0)
  };
  return rgba(mixedColor);
} // prettier-ignore


var curriedMix =
/*#__PURE__*/
curry
/* ::<number | string, string, string, string> */
(mix);

/**
 * Increases the opacity of a color. Its range for the amount is between 0 to 1.
 *
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: opacify(0.1, 'rgba(255, 255, 255, 0.9)');
 *   background: opacify(0.2, 'hsla(0, 0%, 100%, 0.5)'),
 *   background: opacify('0.5', 'rgba(255, 0, 0, 0.2)'),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${opacify(0.1, 'rgba(255, 255, 255, 0.9)')};
 *   background: ${opacify(0.2, 'hsla(0, 0%, 100%, 0.5)')},
 *   background: ${opacify('0.5', 'rgba(255, 0, 0, 0.2)')},
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "#fff";
 *   background: "rgba(255,255,255,0.7)";
 *   background: "rgba(255,0,0,0.7)";
 * }
 */

function opacify(amount, color) {
  var parsedColor = parseToRgb(color);
  var alpha = typeof parsedColor.alpha === 'number' ? parsedColor.alpha : 1;

  var colorWithAlpha = _extends$7({}, parsedColor, {
    alpha: guard(0, 1, (alpha * 100 + parseFloat(amount) * 100) / 100)
  });

  return rgba(colorWithAlpha);
} // prettier-ignore


var curriedOpacify =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(opacify);

/**
 * Increases the intensity of a color. Its range is between 0 to 1. The first
 * argument of the saturate function is the amount by how much the color
 * intensity should be increased.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: saturate(0.2, '#CCCD64'),
 *   background: saturate('0.2', 'rgba(204,205,100,0.7)'),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${saturate(0.2, '#FFCD64')};
 *   background: ${saturate('0.2', 'rgba(204,205,100,0.7)')};
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "#e0e250";
 *   background: "rgba(224,226,80,0.7)";
 * }
 */

function saturate(amount, color) {
  var hslColor = parseToHsl(color);
  return toColorString(_extends$7({}, hslColor, {
    saturation: guard(0, 1, hslColor.saturation + parseFloat(amount))
  }));
} // prettier-ignore


var curriedSaturate =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(saturate);

/**
 * Sets the hue of a color to the provided value. The hue range can be
 * from 0 and 359.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: setHue(42, '#CCCD64'),
 *   background: setHue('244', 'rgba(204,205,100,0.7)'),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${setHue(42, '#CCCD64')};
 *   background: ${setHue('244', 'rgba(204,205,100,0.7)')};
 * `
 *
 * // CSS in JS Output
 * element {
 *   background: "#cdae64";
 *   background: "rgba(107,100,205,0.7)";
 * }
 */

function setHue(hue, color) {
  return toColorString(_extends$7({}, parseToHsl(color), {
    hue: parseFloat(hue)
  }));
} // prettier-ignore


var curriedSetHue =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(setHue);

/**
 * Sets the lightness of a color to the provided value. The lightness range can be
 * from 0 and 1.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: setLightness(0.2, '#CCCD64'),
 *   background: setLightness('0.75', 'rgba(204,205,100,0.7)'),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${setLightness(0.2, '#CCCD64')};
 *   background: ${setLightness('0.75', 'rgba(204,205,100,0.7)')};
 * `
 *
 * // CSS in JS Output
 * element {
 *   background: "#4d4d19";
 *   background: "rgba(223,224,159,0.7)";
 * }
 */

function setLightness(lightness, color) {
  return toColorString(_extends$7({}, parseToHsl(color), {
    lightness: parseFloat(lightness)
  }));
} // prettier-ignore


var curriedSetLightness =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(setLightness);

/**
 * Sets the saturation of a color to the provided value. The lightness range can be
 * from 0 and 1.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: setSaturation(0.2, '#CCCD64'),
 *   background: setSaturation('0.75', 'rgba(204,205,100,0.7)'),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${setSaturation(0.2, '#CCCD64')};
 *   background: ${setSaturation('0.75', 'rgba(204,205,100,0.7)')};
 * `
 *
 * // CSS in JS Output
 * element {
 *   background: "#adad84";
 *   background: "rgba(228,229,76,0.7)";
 * }
 */

function setSaturation(saturation, color) {
  return toColorString(_extends$7({}, parseToHsl(color), {
    saturation: parseFloat(saturation)
  }));
} // prettier-ignore


var curriedSetSaturation =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(setSaturation);

/**
 * Shades a color by mixing it with black. `shade` can produce
 * hue shifts, where as `darken` manipulates the luminance channel and therefore
 * doesn't produce hue shifts.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: shade(0.25, '#00f')
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${shade(0.25, '#00f')};
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "#00003f";
 * }
 */

function shade(percentage, color) {
  return curriedMix(parseFloat(percentage), 'rgb(0, 0, 0)', color);
} // prettier-ignore


var curriedShade =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(shade);

/**
 * Tints a color by mixing it with white. `tint` can produce
 * hue shifts, where as `lighten` manipulates the luminance channel and therefore
 * doesn't produce hue shifts.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: tint(0.25, '#00f')
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${tint(0.25, '#00f')};
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "#bfbfff";
 * }
 */

function tint(percentage, color) {
  return curriedMix(parseFloat(percentage), 'rgb(255, 255, 255)', color);
} // prettier-ignore


var curriedTint =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(tint);

/**
 * Decreases the opacity of a color. Its range for the amount is between 0 to 1.
 *
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: transparentize(0.1, '#fff');
 *   background: transparentize(0.2, 'hsl(0, 0%, 100%)'),
 *   background: transparentize('0.5', 'rgba(255, 0, 0, 0.8)'),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${transparentize(0.1, '#fff')};
 *   background: ${transparentize(0.2, 'hsl(0, 0%, 100%)')},
 *   background: ${transparentize('0.5', 'rgba(255, 0, 0, 0.8)')},
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "rgba(255,255,255,0.9)";
 *   background: "rgba(255,255,255,0.8)";
 *   background: "rgba(255,0,0,0.3)";
 * }
 */

function transparentize(amount, color) {
  var parsedColor = parseToRgb(color);
  var alpha = typeof parsedColor.alpha === 'number' ? parsedColor.alpha : 1;

  var colorWithAlpha = _extends$7({}, parsedColor, {
    alpha: guard(0, 1, (alpha * 100 - parseFloat(amount) * 100) / 100)
  });

  return rgba(colorWithAlpha);
} // prettier-ignore


var curriedTransparentize =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(transparentize);

var _templateObject$g = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$f = taggedTemplateLiteral(['\n    position: relative;\n    display: inline-flex;\n    margin: 0;\n    min-height: inherit;\n    padding: 0.375rem 1.5rem 0.375rem 0;\n\n    input {\n      position: absolute;\n      opacity: 0;\n      &:disabled {\n        & ~ .indicator,\n        & ~ .description {\n          opacity: 0.5;\n        }\n      }\n    }\n    .indicator {\n      border-radius: 0.25rem;\n      flex-shrink: 0;\n      ', '\n    }\n    .description {\n      color: ', ';\n      padding-', ': 0.5rem;\n    }\n    ', '\n  '], ['\n    position: relative;\n    display: inline-flex;\n    margin: 0;\n    min-height: inherit;\n    padding: 0.375rem 1.5rem 0.375rem 0;\n\n    input {\n      position: absolute;\n      opacity: 0;\n      &:disabled {\n        & ~ .indicator,\n        & ~ .description {\n          opacity: 0.5;\n        }\n      }\n    }\n    .indicator {\n      border-radius: 0.25rem;\n      flex-shrink: 0;\n      ', '\n    }\n    .description {\n      color: ', ';\n      padding-', ': 0.5rem;\n    }\n    ', '\n  ']),
    _templateObject3$d = taggedTemplateLiteral(['\n        &:hover .indicator,\n        input:focus + .indicator {\n          border-color: ', ';\n        }\n      '], ['\n        &:hover .indicator,\n        input:focus + .indicator {\n          border-color: ', ';\n        }\n      ']),
    _templateObject4$7 = taggedTemplateLiteral(['\n    background-color: ', ';\n    width: ', ';\n    height: ', ';\n    border: ', ' solid ', ';\n    &::before {\n      content: \'\';\n      border-style: solid;\n      display: block;\n      margin: 0 auto;\n      transform: rotate(45deg);\n      height: calc(', ' * 0.6);\n      width: calc(', ' * 0.4);\n      border-color: ', ';\n      border-width: 0 ', ' ', ' 0;\n    }\n  '], ['\n    background-color: ', ';\n    width: ', ';\n    height: ', ';\n    border: ', ' solid ', ';\n    &::before {\n      content: \'\';\n      border-style: solid;\n      display: block;\n      margin: 0 auto;\n      transform: rotate(45deg);\n      height: calc(', ' * 0.6);\n      width: calc(', ' * 0.4);\n      border-color: ', ';\n      border-width: 0 ', ' ', ' 0;\n    }\n  ']);

var CheckboxStyle = styled__default.label(_templateObject$g, function (_ref) {
  var theme = _ref.theme,
      checked = _ref.checked,
      disabled = _ref.disabled,
      status = _ref.status;
  return styled.css(_templateObject2$f, indicatorStyle(theme, checked, disabled, status), theme.colorFgHeading, theme.dir === 'rtl' ? 'right' : 'left', !disabled && styled.css(_templateObject3$d, curriedLighten(0.1, theme[hoverBorder(status)])));
});
var hoverBorder = function hoverBorder(status) {
  return status ? 'color' + status : 'checkboxCheckedBorderColor';
};

var indicatorStyle = function indicatorStyle(theme, checked, disabled, status) {
  var state = disabled ? 'Disabled' : checked ? 'Checked' : '';
  var size = theme['checkbox' + state + 'Size'];
  var borderSize = theme['checkbox' + state + 'BorderSize'];
  var checkmark = disabled && checked ? 'Disabled' : checked ? 'Checked' : '';

  var borderColor$$1 = theme['checkbox' + state + 'BorderColor'];
  if (disabled) {
    borderColor$$1 = theme['checkboxBorderColor'];
  }
  if (disabled && checked) {
    borderColor$$1 = theme['checkboxCheckedBorderColor'];
  }
  if (status && checked) {
    borderColor$$1 = theme['color' + status];
  }

  return styled.css(_templateObject4$7, theme['checkbox' + state + 'Bg'], size, size, borderSize, borderColor$$1, size, size, theme['checkbox' + checkmark + 'Checkmark'], borderSize, borderSize);
};

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

var Checkbox = function Checkbox(props) {
  var _useState = React.useState(props.checked ? props.checked : false),
      _useState2 = slicedToArray(_useState, 2),
      value = _useState2[0],
      setValue = _useState2[1];

  var uncontrolled = typeof props.onChange === 'function';
  var onChangeHandler = function onChangeHandler() {
    uncontrolled && props.onChange(!value);
    setValue(!value);
  };

  return React__default.createElement(
    CheckboxStyle,
    {
      disabled: props.disabled,
      checked: uncontrolled ? value : props.checked,
      status: props.status,
      className: props.className,
      style: props.style
    },
    uncontrolled ? React__default.createElement('input', {
      type: 'checkbox',
      disabled: props.disabled,
      onBlur: props.onBlur,
      checked: value,
      onChange: onChangeHandler
    }) : React__default.createElement('input', {
      type: 'checkbox',
      disabled: props.disabled,
      onBlur: props.onBlur
    }),
    React__default.createElement('span', { className: 'indicator' }),
    React__default.createElement(
      'span',
      { className: 'description' },
      props.children
    )
  );
};

Checkbox.propTypes = {
  onChange: PropTypes.func,
  onBlur: PropTypes.func,
  checked: PropTypes.bool,
  disabled: PropTypes.bool,
  className: PropTypes.string,
  style: PropTypes.string,
  status: colorState
};

var _templateObject$h = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$g = taggedTemplateLiteral(['\n    text-transform: uppercase;\n    letter-spacing: 0.4px;\n    border: 2px solid transparent;\n    transition: none;\n    cursor: pointer;\n    -webkit-appearance: none;\n    -moz-appearance: none;\n    text-align: center;\n    text-decoration: none;\n    display: inline-block;\n    white-space: nowrap;\n    vertical-align: middle;\n    user-select: none;\n\n    color: ', ';\n    font-weight: ', ';\n    font-family: ', ';\n    cursor: ', ';\n    ', '\n\n    &:hover,\n    &:focus {\n      text-decoration: none;\n    }\n\n    ', '\n\n    ', '\n\n\n    ', '\n\n\n    ', '\n\n    ', '\n  '], ['\n    text-transform: uppercase;\n    letter-spacing: 0.4px;\n    border: 2px solid transparent;\n    transition: none;\n    cursor: pointer;\n    -webkit-appearance: none;\n    -moz-appearance: none;\n    text-align: center;\n    text-decoration: none;\n    display: inline-block;\n    white-space: nowrap;\n    vertical-align: middle;\n    user-select: none;\n\n    color: ', ';\n    font-weight: ', ';\n    font-family: ', ';\n    cursor: ', ';\n    ', '\n\n    &:hover,\n    &:focus {\n      text-decoration: none;\n    }\n\n    ', '\n\n    ', '\n\n\n    ', '\n\n\n    ', '\n\n    ', '\n  ']),
    _templateObject3$e = taggedTemplateLiteral(['\n        &:focus,\n        &:hover,\n        &:active,\n        &.focus,\n        &.hover,\n        &.active {\n          color: ', ';\n          cursor: ', ';\n        }\n      '], ['\n        &:focus,\n        &:hover,\n        &:active,\n        &.focus,\n        &.hover,\n        &.active {\n          color: ', ';\n          cursor: ', ';\n        }\n      ']),
    _templateObject4$8 = taggedTemplateLiteral(['\n        padding: ', ' ', ';\n        font-size: ', ';\n        line-height: ', ';\n        border-radius: ', ';\n      '], ['\n        padding: ', ' ', ';\n        font-size: ', ';\n        line-height: ', ';\n        border-radius: ', ';\n      ']),
    _templateObject5$5 = taggedTemplateLiteral(['\n        border-radius: ', ';\n      '], ['\n        border-radius: ', ';\n      ']),
    _templateObject6$2 = taggedTemplateLiteral(['\n        ', '\n\n        &:focus,\n        &.focus {\n          ', '\n        }\n        &:hover,\n        &.hover {\n          color: ', ';\n          background-color: ', ';\n          border-color: transparent;\n        }\n        &:active,\n        &.active,\n        &:active:focus {\n          color: ', ';\n          background-color: ', ';\n          border-color: transparent;\n          box-shadow: none;\n        }\n\n        &:disabled,\n        &.disabled {\n          opacity: ', ';\n          cursor: not-allowed;\n        }\n\n\n        ', '\n\n/* hero button start */\n      ', '\n\n      '], ['\n        ', '\n\n        &:focus,\n        &.focus {\n          ', '\n        }\n        &:hover,\n        &.hover {\n          color: ', ';\n          background-color: ', ';\n          border-color: transparent;\n        }\n        &:active,\n        &.active,\n        &:active:focus {\n          color: ', ';\n          background-color: ', ';\n          border-color: transparent;\n          box-shadow: none;\n        }\n\n        &:disabled,\n        &.disabled {\n          opacity: ', ';\n          cursor: not-allowed;\n        }\n\n\n        ', '\n\n/* hero button start */\n      ', '\n\n      ']),
    _templateObject7$1 = taggedTemplateLiteral(['\n                border: 2px solid ', ';\n                color: ', ';\n                background-color: ', ';\n              '], ['\n                border: 2px solid ', ';\n                color: ', ';\n                background-color: ', ';\n              ']),
    _templateObject8$1 = taggedTemplateLiteral(['\n                  border-color: ', ';\n                  box-shadow: none;\n                '], ['\n                  border-color: ', ';\n                  box-shadow: none;\n                ']),
    _templateObject9$1 = taggedTemplateLiteral(['\n                  color: ', ';\n                  background-color: ', ';\n                  border-color: transparent;\n                  box-shadow: none;\n                '], ['\n                  color: ', ';\n                  background-color: ', ';\n                  border-color: transparent;\n                  box-shadow: none;\n                ']),
    _templateObject10$1 = taggedTemplateLiteral(['\n            &:focus,\n            &.focus,\n            &:hover,\n            &.hover,\n            &:active,\n            &.active {\n              color: ', ';\n            }\n          '], ['\n            &:focus,\n            &.focus,\n            &:hover,\n            &.hover,\n            &:active,\n            &.active {\n              color: ', ';\n            }\n          ']),
    _templateObject11 = taggedTemplateLiteral(['\n          background-image: linear-gradient(\n            to right,\n            ', ',\n            ', '\n          );\n          box-shadow: ', ';\n          text-shadow: ', ';\n          line-height: calc((', ' * 1.25) + 4px);\n          &:focus,\n          &.focus,\n          &:hover,\n          &.hover {\n            background-image: ', ';\n          }\n          &:active,\n          &.active {\n            background-image: ', ';\n            box-shadow: none;\n            border-color: transparent;\n          }\n          ', ';\n        '], ['\n          background-image: linear-gradient(\n            to right,\n            ', ',\n            ', '\n          );\n          box-shadow: ', ';\n          text-shadow: ', ';\n          line-height: calc((', ' * 1.25) + 4px);\n          &:focus,\n          &.focus,\n          &:hover,\n          &.hover {\n            background-image: ', ';\n          }\n          &:active,\n          &.active {\n            background-image: ', ';\n            box-shadow: none;\n            border-color: transparent;\n          }\n          ', ';\n        ']),
    _templateObject12 = taggedTemplateLiteral(['\n  0% {\n      box-shadow: none;\n      opacity: ', ';\n    }\n    50% {\n      box-shadow: 0 0 1rem 0 ', ';\n      opacity: 0.8;\n    }\n    100% {\n      box-shadow: none;\n      opacity: ', ';\n    }\n  '], ['\n  0% {\n      box-shadow: none;\n      opacity: ', ';\n    }\n    50% {\n      box-shadow: 0 0 1rem 0 ', ';\n      opacity: 0.8;\n    }\n    100% {\n      box-shadow: none;\n      opacity: ', ';\n    }\n  ']),
    _templateObject13 = taggedTemplateLiteral(['\n    animation: ', ' 1.5s infinite;\n  '], ['\n    animation: ', ' 1.5s infinite;\n  ']),
    _templateObject14 = taggedTemplateLiteral(['\n  &[type=\'button\'],\n  &[type=\'submit\'] {\n    ', '\n  }\n'], ['\n  &[type=\'button\'],\n  &[type=\'submit\'] {\n    ', '\n  }\n']);

/* eslint-disable indent */

var ButtonStyle = styled.css(_templateObject$h, function (_ref) {
  var theme = _ref.theme,
      shape$$1 = _ref.shape,
      size$$1 = _ref.size,
      status = _ref.status,
      fullWidth = _ref.fullWidth,
      outline = _ref.outline,
      hero = _ref.hero,
      pulse = _ref.pulse;
  return styled.css(_templateObject2$g, theme.btnFg, theme.fontWeightBolder, theme.btnFontFamily, theme.btnCursor, !outline && styled.css(_templateObject3$e, theme.btnFg, theme.btnCursor), size$$1 && styled.css(_templateObject4$8, theme['btnPaddingY' + size$$1], theme['btnPaddingX' + size$$1], theme['btnFontSize' + size$$1], theme.btnLineHeight, theme.btnBorderRadius), shape$$1 && styled.css(_templateObject5$5, theme['btn' + shape$$1 + 'BorderRadius']), pulse && btnPulse(theme['btn' + status + 'Bg'], theme.btnDisabledOpacity), status && styled.css(_templateObject6$2, status === 'Secondary' || outline ? styled.css(_templateObject7$1, theme[color(status)], theme.btnOutlineFg, outline ? 'transparent' : theme.btnSecondaryBg) : 'background-color: ' + theme['btn' + status + 'Bg'] + ';', status === 'Secondary' || outline ? styled.css(_templateObject8$1, curriedTint(percentage(status, outline), theme[color(status)])) : styled.css(_templateObject9$1, theme.btnOutlineHoverFg, curriedTint(percentage(status), theme[color(status)])), theme.btnOutlineHoverFg, curriedTint(percentage(status), theme[color(status)]), theme.btnOutlineHoverFg, curriedShade(percentage(status), theme[color(status)]), theme.btnDisabledOpacity, status === 'Secondary' && styled.css(_templateObject10$1, theme.btnOutlineFg), hero && styled.css(_templateObject11, leftColor(status, theme), theme[color(status)], heroShadow(status, theme), theme.btnHeroTextShadow, theme['btnFontSize' + size$$1], lightGradient(status, theme), darkGradient(status, theme), status === 'Secondary' ? 'border : 2px solid ' + theme.btnSecondaryBorder : 'border: none')), fullWidth && 'width: 100%;');
});

var lightGradient = function lightGradient(status, theme) {
  return 'linear-gradient(to right, ' + curriedTint(0.14, leftColor(status, theme)) + ', ' + curriedTint(0.14, theme[color(status)]) + ');';
};

var darkGradient = function darkGradient(status, theme) {
  return 'linear-gradient(to right, ' + curriedShade(0.14, leftColor(status, theme)) + ', ' + curriedShade(0.14, theme[color(status)]) + ');';
};

var leftColor = function leftColor(status, theme) {
  return curriedAdjustHue(heroPercentage[status], theme[color(status)]);
};

var heroShadow = function heroShadow(status, theme) {
  var middleColor = curriedMix(0.5, curriedAdjustHue(heroPercentage[status], theme[color(status)]), theme[color(status)]);
  var bevel = theme.btnHeroBevelSize + ' ' + curriedShade(0.14, middleColor);
  var glow = theme.btnHeroGlowSize + ' ' + middleColor;
  var shadow = theme.btnHeroShadow;
  var boxShadow = [bevel, glow];
  shadow !== 'none' && boxShadow.push(shadow);
  return boxShadow.join(',');
};

var heroPercentage = {
  Primary: 20,
  Success: 20,
  Warning: 10,
  Info: -10,
  Danger: -20,
  Secondary: 20
};
var percentage = function percentage(status, outline) {
  return status === 'Secondary' || outline ? 0.2 : 0.14;
};

var color = function color(status) {
  return status === 'Secondary' ? 'btnSecondaryBorder' : 'btn' + status + 'Bg';
};

var btnPulse = function btnPulse(color, opacity) {
  var pulse = styled.keyframes(_templateObject12, opacity, color, opacity);
  return styled.css(_templateObject13, pulse);
};

var defaultProps = {
  size: 'MD',
  status: 'Primary'
};

var Button = styled__default.button(_templateObject$h, ButtonStyle);

Button.defaultProps = defaultProps;
Button.propTypes = buttonTypes;

var ButtonLink = styled__default.a(_templateObject$h, ButtonStyle);

ButtonLink.defaultProps = defaultProps;
ButtonLink.propTypes = buttonTypes;

var ButtonInput = styled__default.input(_templateObject14, ButtonStyle);

ButtonInput.defaultProps = _extends({}, defaultProps, { type: 'button' });
ButtonInput.propTypes = _extends({}, buttonTypes, {
  type: PropTypes.oneOf(['button', 'submit'])
});

var _templateObject$i = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$h = taggedTemplateLiteral(['\n    display: block;\n    margin-bottom: 1rem;\n    button {\n      position: relative;\n      width: 100%;\n      text-align: start;\n      overflow: hidden;\n      text-overflow: ellipsis;\n      white-space: nowrap;\n      border: none;\n      transition: all 0.1s;\n      ', '\n\n      &::after {\n        top: 50%;\n        ', ': 0.75rem;\n        position: absolute;\n        display: inline-block;\n        width: 0;\n        height: 0;\n        margin-left: 0.255em;\n        vertical-align: 0.255em;\n        content: \'\';\n        border-top: 0.3em solid;\n        border-right: 0.3em solid transparent;\n        border-bottom: 0;\n        border-left: 0.3em solid transparent;\n      }\n\n      ', '\n    }\n  '], ['\n    display: block;\n    margin-bottom: 1rem;\n    button {\n      position: relative;\n      width: 100%;\n      text-align: start;\n      overflow: hidden;\n      text-overflow: ellipsis;\n      white-space: nowrap;\n      border: none;\n      transition: all 0.1s;\n      ', '\n\n      &::after {\n        top: 50%;\n        ', ': 0.75rem;\n        position: absolute;\n        display: inline-block;\n        width: 0;\n        height: 0;\n        margin-left: 0.255em;\n        vertical-align: 0.255em;\n        content: \'\';\n        border-top: 0.3em solid;\n        border-right: 0.3em solid transparent;\n        border-bottom: 0;\n        border-left: 0.3em solid transparent;\n      }\n\n      ', '\n    }\n  ']),
    _templateObject3$f = taggedTemplateLiteral(['\n            border-', '-left-radius: 0;\n            border-', '-right-radius: 0;\n          '], ['\n            border-', '-left-radius: 0;\n            border-', '-right-radius: 0;\n          ']),
    _templateObject4$9 = taggedTemplateLiteral(['\n    position: absolute;\n    box-sizing: border-box;\n    z-index: 1000;\n    display: flex;\n    width: 100%;\n    height: 100%;\n    min-width: 1px;\n    min-height: 1px;\n    top: 0px;\n    left: 0px;\n    .overlay-pane {\n      position: absolute;\n      pointer-events: auto;\n      display: flex;\n      max-width: 100%;\n      max-height: 100%;\n      box-sizing: border-box;\n      ', '\n\n      ', ' {\n        background-color: ', ';\n        max-height: ', ';\n        margin-bottom: 0;\n        box-shadow: none;\n        .card-body {\n          padding: 0;\n        }\n        ', ' {\n          padding: ', ';\n        }\n        ', '\n        ', '\n        ', ',\n        ', ' {\n          &.disabled {\n            background-color: ', ';\n            opacity: ', ';\n          }\n        }\n      } \n    }\n  '], ['\n    position: absolute;\n    box-sizing: border-box;\n    z-index: 1000;\n    display: flex;\n    width: 100%;\n    height: 100%;\n    min-width: 1px;\n    min-height: 1px;\n    top: 0px;\n    left: 0px;\n    .overlay-pane {\n      position: absolute;\n      pointer-events: auto;\n      display: flex;\n      max-width: 100%;\n      max-height: 100%;\n      box-sizing: border-box;\n      ', '\n\n      ', ' {\n        background-color: ', ';\n        max-height: ', ';\n        margin-bottom: 0;\n        box-shadow: none;\n        .card-body {\n          padding: 0;\n        }\n        ', ' {\n          padding: ', ';\n        }\n        ', '\n        ', '\n        ', ',\n        ', ' {\n          &.disabled {\n            background-color: ', ';\n            opacity: ', ';\n          }\n        }\n      } \n    }\n  ']),
    _templateObject5$6 = taggedTemplateLiteral(['\n            border: ', ' solid ', ';\n\n            ', ':hover, ', '.selected {\n              background-color: ', ';\n              color: ', ';\n            }\n          '], ['\n            border: ', ' solid ', ';\n\n            ', ':hover, ', '.selected {\n              background-color: ', ';\n              color: ', ';\n            }\n          ']),
    _templateObject6$3 = taggedTemplateLiteral(['\n    display: block;\n\n    &.disabled {\n      pointer-events: none;\n    }\n\n    &:hover {\n      cursor: pointer;\n    }\n\n    ', ' {\n      pointer-events: none;\n      .description {\n        color: inherit;\n      }\n    }\n    &&.selected {\n      ', ' {\n        .indicator {\n          border-color: ', ';\n\n          &::before {\n            border-color: ', ';\n          }\n        }\n      }\n    }\n  '], ['\n    display: block;\n\n    &.disabled {\n      pointer-events: none;\n    }\n\n    &:hover {\n      cursor: pointer;\n    }\n\n    ', ' {\n      pointer-events: none;\n      .description {\n        color: inherit;\n      }\n    }\n    &&.selected {\n      ', ' {\n        .indicator {\n          border-color: ', ';\n\n          &::before {\n            border-color: ', ';\n          }\n        }\n      }\n    }\n  ']),
    _templateObject7$2 = taggedTemplateLiteral(['\n  display: block;\n\n  span {\n    padding: 1.125rem 0.5rem;\n    display: block;\n  }\n\n  &.disabled {\n    pointer-events: none;\n  }\n\n  ', ' {\n    padding: 0.75rem 0.75rem 0.75rem 2.5rem;\n  }\n'], ['\n  display: block;\n\n  span {\n    padding: 1.125rem 0.5rem;\n    display: block;\n  }\n\n  &.disabled {\n    pointer-events: none;\n  }\n\n  ', ' {\n    padding: 0.75rem 0.75rem 0.75rem 2.5rem;\n  }\n']);

var SelectStyle = styled__default.div(_templateObject$i, function (_ref) {
  var theme = _ref.theme,
      opened = _ref.opened,
      placement = _ref.placement;
  return styled.css(_templateObject2$h, ButtonStyle, theme.dir === 'rtl' ? 'left' : 'right', opened && placement && styled.css(_templateObject3$f, placement, placement));
});

var SelectCard = styled__default.div(_templateObject$i, function (_ref2) {
  var theme = _ref2.theme,
      placement = _ref2.placement,
      status = _ref2.status,
      position = _ref2.position;
  return styled.css(_templateObject4$9, !position && 'visibility: hidden;', Card, theme.selectBg, theme.selectMaxHeight, Option, theme.selectOptionPadding, status && styled.css(_templateObject5$6, theme.selectBorderWidth, theme['color' + status], Option, Option, theme['color' + status], theme.colorWhite), getBorder(placement), Option, OptionGroup, theme.selectOptionDisabledBg, theme.selectOptionDisabledOpacity);
});

var getBorder = function getBorder(placement) {
  var pos = placement === 'top' ? 'bottom' : 'top';
  return 'border-' + pos + '-left-radius: 0;border-' + pos + '-right-radius: 0;';
};

var Option = styled__default.div(_templateObject$i, function (_ref3) {
  var theme = _ref3.theme;
  return styled.css(_templateObject6$3, CheckboxStyle, CheckboxStyle, theme.selectCheckboxColor, theme.selectCheckmarkColor);
});

var OptionGroup = styled__default.div(_templateObject7$2, Option);

function Select(props) {
  var _useState = React.useState([].concat(toConsumableArray(props.options))),
      _useState2 = slicedToArray(_useState, 2),
      options = _useState2[0],
      setOptions = _useState2[1];

  var _useState3 = React.useState(false),
      _useState4 = slicedToArray(_useState3, 2),
      opened = _useState4[0],
      setOpened = _useState4[1];

  var _useState5 = React.useState('bottom'),
      _useState6 = slicedToArray(_useState5, 2),
      placement$$1 = _useState6[0],
      setPlacement = _useState6[1];

  var _useState7 = React.useState(),
      _useState8 = slicedToArray(_useState7, 2),
      position$$1 = _useState8[0],
      setPosition = _useState8[1];

  var overlayRef = React.useRef();
  var targetRef = React.useRef();

  React.useEffect(function () {
    if (props.value) {
      var newOptions = [].concat(toConsumableArray(options));
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = newOptions[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var option = _step.value;

          if (props.multiple) {
            option.selected = props.value.includes(option.value);
          } else {
            option.selected = props.value === option.value;
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      setOptions(newOptions);
    }
  }, []);

  React.useEffect(function () {
    window.addEventListener('click', onClickHandle);
    if (opened) {
      positionHandle();
      window.addEventListener('resize', positionHandle);
      document.querySelector('.scrollable-container').addEventListener('scroll', positionHandle);
      if (props.eventListener) {
        document.querySelector(props.eventListener).addEventListener('scroll', positionHandle);
      }
    }
    return function () {
      window.removeEventListener('click', onClickHandle);
      if (opened) {
        window.removeEventListener('resize', positionHandle);
        document.querySelector('.scrollable-container').removeEventListener('scroll', positionHandle);
        if (props.eventListener) {
          document.querySelector(props.eventListener).removeEventListener('scroll', positionHandle);
        }
      }
    };
  }, [opened]);

  var positionHandle = function positionHandle() {
    var target = targetRef.current.getBoundingClientRect();
    var overlay = overlayRef.current.getBoundingClientRect();

    var data = {
      placement: 'bottom',
      position: { top: 0, left: target.left, maxHeight: 'none' }
    };

    if (overlay.height > window.innerHeight - target.bottom) {
      if (overlay.height < target.top) {
        data.placement = 'top';
      } else {
        data.position.maxHeight = window.innerHeight - target.bottom;
      }
    }
    data.position.top = data.placement === 'bottom' ? target.bottom : target.top - overlay.height;

    setPosition(data.position);
    setPlacement(data.placement);
  };

  var onClickHandle = function onClickHandle() {
    setOpened(false);
  };

  var onSelectMultiple = function onSelectMultiple(i) {
    var newOptions = [].concat(toConsumableArray(options));
    newOptions[i].selected = !newOptions[i].selected;
    setOptions(newOptions);
    var selectedView = [];
    var _iteratorNormalCompletion2 = true;
    var _didIteratorError2 = false;
    var _iteratorError2 = undefined;

    try {
      for (var _iterator2 = newOptions[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
        var option = _step2.value;

        option.selected && selectedView.push(option.value);
      }
    } catch (err) {
      _didIteratorError2 = true;
      _iteratorError2 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion2 && _iterator2.return) {
          _iterator2.return();
        }
      } finally {
        if (_didIteratorError2) {
          throw _iteratorError2;
        }
      }
    }

    typeof props.onChange === 'function' && props.onChange(selectedView);
  };

  var onSelectHandle = function onSelectHandle(i) {
    var newOptions = [].concat(toConsumableArray(options));
    var _iteratorNormalCompletion3 = true;
    var _didIteratorError3 = false;
    var _iteratorError3 = undefined;

    try {
      for (var _iterator3 = newOptions.keys()[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
        var key = _step3.value;

        newOptions[key].selected = i === key && newOptions[key].value;
      }
    } catch (err) {
      _didIteratorError3 = true;
      _iteratorError3 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion3 && _iterator3.return) {
          _iterator3.return();
        }
      } finally {
        if (_didIteratorError3) {
          throw _iteratorError3;
        }
      }
    }

    typeof props.onChange === 'function' && props.onChange(newOptions[i].value);
    setOptions(newOptions);
    setOpened(false);
  };

  var placeholder = function placeholder() {
    var selectedView = [];

    var _arr = [].concat(toConsumableArray(options));

    for (var _i = 0; _i < _arr.length; _i++) {
      var option = _arr[_i];
      option.selected && selectedView.push(option.label);
    }
    if (selectedView.length <= 0) {
      return props.placeholder;
    } else if (props.customLabel) {
      return props.customLabel;
    } else {
      return selectedView.join(',');
    }
  };

  return React__default.createElement(
    React.Fragment,
    null,
    opened && ReactDOM.createPortal(React__default.createElement(
      SelectCard,
      {
        placement: placement$$1,
        status: props.status,
        position: position$$1
      },
      React__default.createElement(
        'div',
        {
          className: 'overlay-pane',
          style: position$$1 && _extends({}, position$$1),
          ref: overlayRef,
          onClick: function onClick(e) {
            return e.stopPropagation();
          }
        },
        React__default.createElement(
          Card,
          { style: { width: targetRef.current.offsetWidth } },
          React__default.createElement(
            'div',
            { className: 'card-body' },
            options.map(function (option, index) {
              var className = [];
              option.selected && className.push('selected');
              option.disabled && className.push('disabled');
              return props.multiple ? React__default.createElement(
                Option,
                {
                  key: index,
                  className: className.join(' '),
                  onClick: function onClick() {
                    return onSelectMultiple(index);
                  }
                },
                React__default.createElement(
                  Checkbox,
                  { checked: option.selected },
                  option.label
                )
              ) : React__default.createElement(
                Option,
                {
                  key: index,
                  className: className.join(' '),
                  onClick: function onClick() {
                    return onSelectHandle(index);
                  }
                },
                option.label
              );
            })
          )
        )
      )
    ), document.getElementById('overlay-container')),
    React__default.createElement(
      SelectStyle,
      _extends({}, props, { opened: opened, placement: placement$$1 }),
      React__default.createElement(
        'button',
        {
          onClick: function onClick(e) {
            e.stopPropagation();
            setOpened(!opened);
          },
          ref: targetRef
        },
        placeholder()
      )
    )
  );
}
var defaultProps$1 = {
  size: 'MD',
  status: 'Primary'
};

var propTypes = {
  options: PropTypes.arrayOf(PropTypes.shape({
    value: PropTypes.any,
    label: PropTypes.any,
    selected: PropTypes.bool,
    disabled: PropTypes.bool
  })),
  eventListener: PropTypes.string,
  customLabel: PropTypes.string,
  multiple: PropTypes.bool,
  onChange: PropTypes.func,
  value: PropTypes.oneOfType([PropTypes.any, PropTypes.array]),
  placeholder: PropTypes.any
};

Select.defaultProps = defaultProps$1;
Select.propTypes = _extends({}, propTypes, buttonTypes);

var _templateObject$j = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$i = taggedTemplateLiteral(['\n      position: relative;\n      display: inline-flex;\n      margin: 0;\n      min-height: inherit;\n      padding: 0.375rem 1.5rem 0.375rem 0;\n      input {\n        position: absolute;\n        opacity: 0;\n      }\n      ', '\n      .indicator {\n        border-radius: 50%;\n        flex-shrink: 0;\n        display: flex;\n        justify-content: center;\n        align-items: center;\n        background-color: ', ';\n        width: ', ';\n        height: ', ';\n        border: ', ' solid\n          ', ';\n\n        &::before {\n          content: \'\';\n          transition: all 0.1s;\n          border-radius: 50%;\n          background-color: ', ';\n          height: calc(', ' * 0.6);\n          width: calc(', ' * 0.6);\n          border: solid ', ';\n        }\n      }\n      .description {\n        color: ', ';\n        padding-', ': 0.5rem;\n      }\n      ', '\n        ', '\n    '], ['\n      position: relative;\n      display: inline-flex;\n      margin: 0;\n      min-height: inherit;\n      padding: 0.375rem 1.5rem 0.375rem 0;\n      input {\n        position: absolute;\n        opacity: 0;\n      }\n      ', '\n      .indicator {\n        border-radius: 50%;\n        flex-shrink: 0;\n        display: flex;\n        justify-content: center;\n        align-items: center;\n        background-color: ', ';\n        width: ', ';\n        height: ', ';\n        border: ', ' solid\n          ', ';\n\n        &::before {\n          content: \'\';\n          transition: all 0.1s;\n          border-radius: 50%;\n          background-color: ', ';\n          height: calc(', ' * 0.6);\n          width: calc(', ' * 0.6);\n          border: solid ', ';\n        }\n      }\n      .description {\n        color: ', ';\n        padding-', ': 0.5rem;\n      }\n      ', '\n        ', '\n    ']),
    _templateObject3$g = taggedTemplateLiteral(['\n          .indicator,\n          .description {\n            opacity: 0.5;\n          }\n        '], ['\n          .indicator,\n          .description {\n            opacity: 0.5;\n          }\n        ']),
    _templateObject4$a = taggedTemplateLiteral(['\n          &:hover .indicator {\n            border-color: ', ';\n          }\n        '], ['\n          &:hover .indicator {\n            border-color: ', ';\n          }\n        ']),
    _templateObject5$7 = taggedTemplateLiteral(['\n            .indicator {\n              border-color: ', ';\n            }\n          '], ['\n            .indicator {\n              border-color: ', ';\n            }\n          ']);

var RadioStyle = styled__default.label(_templateObject$j, function (_ref) {
  var theme = _ref.theme,
      checked = _ref.checked,
      disabled = _ref.disabled,
      status = _ref.status;

  var state = checked ? 'Checked' : disabled ? 'Disabled' : '';
  var size$$1 = theme['radio' + state + 'Size'];
  return styled.css(_templateObject2$i, disabled && styled.css(_templateObject3$g), theme['radio' + state + 'Bg'], size$$1, size$$1, theme['radio' + state + 'BorderSize'], theme['radio' + state + 'BorderColor'], theme['radio' + state + 'Checkmark'], size$$1, size$$1, theme['radio' + state + 'Checkmark'], theme.radioFg, theme.dir === 'rtl' ? 'right' : 'left', !disabled && styled.css(_templateObject4$a, theme[hoverBorder$1(status)]), checked && styled.css(_templateObject5$7, theme[hoverBorder$1(status)]));
});
var hoverBorder$1 = function hoverBorder(status) {
  return status ? 'color' + status : 'radioCheckedBorderColor';
};

function Radio(props) {
  var _useState = React.useState(props.options),
      _useState2 = slicedToArray(_useState, 2),
      options = _useState2[0],
      setOptions = _useState2[1];

  var onClickHandler = function onClickHandler(value) {
    var updateOptions = [].concat(toConsumableArray(options));
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = updateOptions[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var option = _step.value;

        option.checked = option.value === value;
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    setOptions(updateOptions);
    props.onChange(value);
  };

  return options.map(function (option) {
    return React__default.createElement(
      RadioStyle,
      {
        status: option.status,
        checked: option.checked,
        disabled: option.disabled || props.disabled,
        key: option.value,
        className: props.className
      },
      React__default.createElement('input', {
        type: 'radio',
        name: props.name,
        disabled: option.disabled || props.disabled,
        onClick: function onClick() {
          return onClickHandler(option.value);
        }
      }),
      React__default.createElement('span', { className: 'indicator' }),
      React__default.createElement(
        'span',
        { className: 'description' },
        option.label
      )
    );
  });
}

Radio.propTypes = {
  name: PropTypes.string,
  disabled: PropTypes.bool,
  onChange: PropTypes.func.isRequired,
  options: PropTypes.arrayOf(PropTypes.shape({
    value: PropTypes.any.isRequired,
    label: PropTypes.any.isRequired,
    checked: PropTypes.bool,
    disabled: PropTypes.bool,
    status: colorState
  }).isRequired).isRequired
};

var _templateObject$k = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$j = taggedTemplateLiteral(['\n    font-size: ', ';\n    background: ', ';\n    border-radius: ', ';\n    box-shadow: ', ';\n    display: flex;\n    flex-direction: column;\n    position: relative;\n    height: 100%;\n    header {\n      color: ', ';\n      padding: ', ';\n      border-bottom: 1px solid ', ';\n      border-top-left-radius: ', ';\n      border-top-right-radius: ', ';\n      font-weight: ', ';\n    }\n\n    .scrollable {\n      overflow: auto;\n      flex: 1;\n    }\n\n    .messages {\n      padding: ', ';\n      overflow-y: auto;\n      overflow-x: hidden;\n      display: flex;\n      flex-shrink: 0;\n      flex-direction: column;\n    }\n\n    .no-messages {\n      font-size: 0.875rem;\n      text-align: center;\n    }\n\n    ', '\n    ', '\n  '], ['\n    font-size: ', ';\n    background: ', ';\n    border-radius: ', ';\n    box-shadow: ', ';\n    display: flex;\n    flex-direction: column;\n    position: relative;\n    height: 100%;\n    header {\n      color: ', ';\n      padding: ', ';\n      border-bottom: 1px solid ', ';\n      border-top-left-radius: ', ';\n      border-top-right-radius: ', ';\n      font-weight: ', ';\n    }\n\n    .scrollable {\n      overflow: auto;\n      flex: 1;\n    }\n\n    .messages {\n      padding: ', ';\n      overflow-y: auto;\n      overflow-x: hidden;\n      display: flex;\n      flex-shrink: 0;\n      flex-direction: column;\n    }\n\n    .no-messages {\n      font-size: 0.875rem;\n      text-align: center;\n    }\n\n    ', '\n    ', '\n  ']),
    _templateObject3$h = taggedTemplateLiteral(['\n        header {\n          background-color: ', ';\n          color: ', ';\n        }\n        ', ' button.btn {\n          background-color: ', ';\n          ', '\n        }\n      '], ['\n        header {\n          background-color: ', ';\n          color: ', ';\n        }\n        ', ' button.btn {\n          background-color: ', ';\n          ', '\n        }\n      ']),
    _templateObject4$b = taggedTemplateLiteral(['\n              border: 1px solid ', ';\n              color: ', ';\n            '], ['\n              border: 1px solid ', ';\n              color: ', ';\n            ']),
    _templateObject5$8 = taggedTemplateLiteral(['\n    display: flex;\n    flex-direction: column;\n    padding: ', ';\n    border-top: 1px solid ', ';\n    .message-row {\n      flex-direction: row;\n      display: flex;\n    }\n    input {\n      flex: 1;\n      padding: 1.25rem 1.5rem;\n      border-radius: 2rem;\n      border: 1px solid ', ';\n      background: ', ';\n      color: ', ';\n      outline: none;\n      box-sizing: border-box;\n      ', ' \n      &::placeholder {\n        color: ', ';\n      }\n    }\n\n    button.btn {\n      border-radius: 3rem;\n      border-top-', '-radius: 0;\n      border-bottom-', '-radius: 0;\n      padding: 0 1.5rem;\n\n      ', '\n    }\n\n    ', ' \n\n    .dropped-files {\n      display: flex;\n      flex-direction: row;\n      margin-bottom: 0.5rem;\n      flex-wrap: wrap;\n\n      div {\n        background-size: cover;\n        width: 3rem;\n        height: 3rem;\n        border-radius: 0.5rem;\n        margin-', ': 0.5rem;\n        margin-bottom: 0.5rem;\n        border: 1px solid ', ';\n        text-align: center;\n        line-height: 3rem;\n        font-size: 2rem;\n        color: ', ';\n        position: relative;\n\n        .remove {\n          position: absolute;\n          right: -0.5rem;\n          top: -0.875rem;\n          font-size: 0.875rem;\n          line-height: 1;\n          cursor: pointer;\n        }\n      }\n    }\n  '], ['\n    display: flex;\n    flex-direction: column;\n    padding: ', ';\n    border-top: 1px solid ', ';\n    .message-row {\n      flex-direction: row;\n      display: flex;\n    }\n    input {\n      flex: 1;\n      padding: 1.25rem 1.5rem;\n      border-radius: 2rem;\n      border: 1px solid ', ';\n      background: ', ';\n      color: ', ';\n      outline: none;\n      box-sizing: border-box;\n      ', ' \n      &::placeholder {\n        color: ', ';\n      }\n    }\n\n    button.btn {\n      border-radius: 3rem;\n      border-top-', '-radius: 0;\n      border-bottom-', '-radius: 0;\n      padding: 0 1.5rem;\n\n      ', '\n    }\n\n    ', ' \n\n    .dropped-files {\n      display: flex;\n      flex-direction: row;\n      margin-bottom: 0.5rem;\n      flex-wrap: wrap;\n\n      div {\n        background-size: cover;\n        width: 3rem;\n        height: 3rem;\n        border-radius: 0.5rem;\n        margin-', ': 0.5rem;\n        margin-bottom: 0.5rem;\n        border: 1px solid ', ';\n        text-align: center;\n        line-height: 3rem;\n        font-size: 2rem;\n        color: ', ';\n        position: relative;\n\n        .remove {\n          position: absolute;\n          right: -0.5rem;\n          top: -0.875rem;\n          font-size: 0.875rem;\n          line-height: 1;\n          cursor: pointer;\n        }\n      }\n    }\n  ']),
    _templateObject6$4 = taggedTemplateLiteral(['\n        border-top-', '-radius: 0;\n        border-bottom-', '-radius: 0;\n      '], ['\n        border-top-', '-radius: 0;\n        border-bottom-', '-radius: 0;\n      ']),
    _templateObject7$3 = taggedTemplateLiteral(['\n          font-size: 3rem;\n          line-height: 1;\n          padding: 0 1.25rem 0 0.875rem;\n          text-align: center;\n        '], ['\n          font-size: 3rem;\n          line-height: 1;\n          padding: 0 1.25rem 0 0.875rem;\n          text-align: center;\n        ']),
    _templateObject8$2 = taggedTemplateLiteral(['\n        input {\n          border: 1px dashed ', ';\n          box-shadow: 0 0 0 4px ', ';\n          &::placeholder {\n            color: ', ';\n          }\n        }\n      '], ['\n        input {\n          border: 1px dashed ', ';\n          box-shadow: 0 0 0 4px ', ';\n          &::placeholder {\n            color: ', ';\n          }\n        }\n      ']),
    _templateObject9$2 = taggedTemplateLiteral(['\n    margin-bottom: 1.5rem;\n    display: flex;\n    flex-direction: row;\n    .message {\n      flex: 1;\n    }\n    .avatar {\n      border-radius: 50%;\n      flex-shrink: 0;\n      background: ', ';\n      background-position: center;\n      background-size: 3.4rem 2.6rem;\n      background-repeat: no-repeat;\n      width: 2.5rem;\n      height: 2.5rem;\n      text-align: center;\n      line-height: 2.5rem;\n      font-size: 0.875rem;\n      color: white;\n    }\n    ', '\n  '], ['\n    margin-bottom: 1.5rem;\n    display: flex;\n    flex-direction: row;\n    .message {\n      flex: 1;\n    }\n    .avatar {\n      border-radius: 50%;\n      flex-shrink: 0;\n      background: ', ';\n      background-position: center;\n      background-size: 3.4rem 2.6rem;\n      background-repeat: no-repeat;\n      width: 2.5rem;\n      height: 2.5rem;\n      text-align: center;\n      line-height: 2.5rem;\n      font-size: 0.875rem;\n      color: white;\n    }\n    ', '\n  ']),
    _templateObject10$2 = taggedTemplateLiteral(['\n      flex-direction: row-reverse;\n      .message {\n        margin-left: 0;\n        margin-', ': 0.5rem;\n        margin-', ': 3rem;\n      }\n      ', ' {\n        align-items: flex-end;\n        .sender {\n          text-align: ', ';\n        }\n        .text {\n          border-top-', '-radius: 0;\n          background: ', ';\n          color: ', ';\n        }\n      }\n      ', ' {\n        align-items: flex-end;\n      }\n    '], ['\n      flex-direction: row-reverse;\n      .message {\n        margin-left: 0;\n        margin-', ': 0.5rem;\n        margin-', ': 3rem;\n      }\n      ', ' {\n        align-items: flex-end;\n        .sender {\n          text-align: ', ';\n        }\n        .text {\n          border-top-', '-radius: 0;\n          background: ', ';\n          color: ', ';\n        }\n      }\n      ', ' {\n        align-items: flex-end;\n      }\n    ']),
    _templateObject11$1 = taggedTemplateLiteral(['\n      .message {\n        margin-', ': 0.5rem;\n        margin-', ': 3rem;\n      }\n      ', ' {\n        align-items: flex-start;\n        .text {\n          border-top-', '-radius: 0;\n          background: ', ';\n          color: ', ';\n        }\n      }\n      ', ' {\n        align-items: flex-start;\n      }\n    '], ['\n      .message {\n        margin-', ': 0.5rem;\n        margin-', ': 3rem;\n      }\n      ', ' {\n        align-items: flex-start;\n        .text {\n          border-top-', '-radius: 0;\n          background: ', ';\n          color: ', ';\n        }\n      }\n      ', ' {\n        align-items: flex-start;\n      }\n    ']),
    _templateObject12$1 = taggedTemplateLiteral(['\n    display: flex;\n    flex-direction: column;\n    .sender {\n      font-size: 0.875rem;\n      color: ', ';\n      margin-bottom: 0.5rem;\n    }\n    p {\n      word-wrap: break-word;\n      word-break: break-all;\n      max-width: 100%;\n      margin: 0;\n    }\n    .text {\n      padding: 1rem;\n      border-radius: 0.5rem;\n    }\n  '], ['\n    display: flex;\n    flex-direction: column;\n    .sender {\n      font-size: 0.875rem;\n      color: ', ';\n      margin-bottom: 0.5rem;\n    }\n    p {\n      word-wrap: break-word;\n      word-break: break-all;\n      max-width: 100%;\n      margin: 0;\n    }\n    .text {\n      padding: 1rem;\n      border-radius: 0.5rem;\n    }\n  ']),
    _templateObject13$1 = taggedTemplateLiteral(['\n    display: flex;\n    flex-direction: column;\n    a {\n      color: ', ';\n      background: ', ';\n      font-size: 4rem;\n      text-align: center;\n      border: 1px solid ', ';\n      width: 10rem;\n      height: 10rem;\n      overflow: hidden;\n      display: flex;\n      justify-content: center;\n      align-items: center;\n      flex-shrink: 0;\n      border-radius: 0.5rem;\n      &:hover,\n      &:focus {\n        text-decoration: none;\n        color: ', ';\n      }\n      div {\n        background-size: cover;\n        width: 100%;\n        height: 100%;\n      }\n    }\n    ', ' {\n      display: block;\n      margin-bottom: 0.5rem;\n    }\n    .message-content-group {\n      display: flex;\n      flex-direction: row;\n      justify-content: flex-end;\n      flex-wrap: wrap;\n      a {\n        margin-', ': 1rem;\n        margin-bottom: 1rem;\n        width: 5rem;\n        height: 5rem;\n      }\n    }\n  '], ['\n    display: flex;\n    flex-direction: column;\n    a {\n      color: ', ';\n      background: ', ';\n      font-size: 4rem;\n      text-align: center;\n      border: 1px solid ', ';\n      width: 10rem;\n      height: 10rem;\n      overflow: hidden;\n      display: flex;\n      justify-content: center;\n      align-items: center;\n      flex-shrink: 0;\n      border-radius: 0.5rem;\n      &:hover,\n      &:focus {\n        text-decoration: none;\n        color: ', ';\n      }\n      div {\n        background-size: cover;\n        width: 100%;\n        height: 100%;\n      }\n    }\n    ', ' {\n      display: block;\n      margin-bottom: 0.5rem;\n    }\n    .message-content-group {\n      display: flex;\n      flex-direction: row;\n      justify-content: flex-end;\n      flex-wrap: wrap;\n      a {\n        margin-', ': 1rem;\n        margin-bottom: 1rem;\n        width: 5rem;\n        height: 5rem;\n      }\n    }\n  ']),
    _templateObject14$1 = taggedTemplateLiteral(['\n    p.quote {\n      font-style: italic;\n      font-size: 0.875rem;\n      background: ', ';\n      color: ', ';\n      padding: 1rem;\n      border-radius: 0.5rem;\n      margin-bottom: 0.5rem;\n    }\n    .sender {\n      font-size: 0.875rem;\n      color: ', ';\n      margin-bottom: 0.5rem;\n    }\n  '], ['\n    p.quote {\n      font-style: italic;\n      font-size: 0.875rem;\n      background: ', ';\n      color: ', ';\n      padding: 1rem;\n      border-radius: 0.5rem;\n      margin-bottom: 0.5rem;\n    }\n    .sender {\n      font-size: 0.875rem;\n      color: ', ';\n      margin-bottom: 0.5rem;\n    }\n  ']);

var ChatStyle = styled__default.div(_templateObject$k, function (_ref) {
  var theme = _ref.theme,
      size = _ref.size,
      status = _ref.status;
  return styled.css(_templateObject2$j, theme.chatFontSize, theme.chatBg, theme.chatBorderRadius, theme.chatShadow, theme.chatFg, theme.chatPadding, theme.chatSeparator, theme.chatBorderRadius, theme.chatBorderRadius, theme.fontWeightBolder, theme.chatPadding, size && 'height: ' + theme['chatHeight' + size] + ';', status && styled.css(_templateObject3$h, theme['chat' + status + 'Bg'], theme['chat' + status + 'Fg'], FormStyle, theme['chat' + status + 'Bg'], status === 'Disabled' && styled.css(_templateObject4$b, theme.chatFormBorder, theme.chatDisabledFg)));
});

var FormStyle = styled__default.div(_templateObject$k, function (_ref2) {
  var theme = _ref2.theme,
      fileOver = _ref2.fileOver,
      showButton = _ref2.showButton,
      buttonIcon = _ref2.buttonIcon;
  return styled.css(_templateObject5$8, theme.chatPadding, theme.chatSeparator, theme.chatFormBorder, theme.chatFormBg, theme.chatFormFg, showButton && styled.css(_templateObject6$4, theme.dir === 'rtl' ? 'left' : 'right', theme.dir === 'rtl' ? 'left' : 'right'), theme.chatFormPlaceholderFg, theme.dir === 'rtl' ? 'right' : 'left', theme.dir === 'rtl' ? 'right' : 'left', buttonIcon && styled.css(_templateObject7$3), fileOver && styled.css(_templateObject8$2, theme.chatFormActiveBorder, theme.chatFormBg, theme.chatFormFg), theme.dir === 'rtl' ? 'left' : 'right', theme.chatFormFg, theme.chatFormFg);
});

var MessageStyle = styled__default.div(_templateObject$k, function (_ref3) {
  var theme = _ref3.theme,
      reply = _ref3.reply;
  return styled.css(_templateObject9$2, theme.chatMessageAvatarBg, reply ? styled.css(_templateObject10$2, theme.dir === 'rtl' ? 'left' : 'right', theme.dir === 'rtl' ? 'right' : 'left', MessageTextStyle, theme.dir === 'rtl' ? 'left' : 'right', theme.dir === 'rtl' ? 'left' : 'right', theme.chatMessageReplyBg, theme.chatMessageReplyFg, MessageFileStyle) : styled.css(_templateObject11$1, theme.dir === 'rtl' ? 'right' : 'left', theme.dir === 'rtl' ? 'left' : 'right', MessageTextStyle, theme.dir === 'rtl' ? 'right' : 'left', theme.chatMessageBg, theme.chatMessageFg, MessageFileStyle));
});

var MessageTextStyle = styled__default.div(_templateObject$k, function (_ref4) {
  var theme = _ref4.theme;
  return styled.css(_templateObject12$1, theme.chatMessageSenderFg);
});

var MessageFileStyle = styled__default.div(_templateObject$k, function (_ref5) {
  var theme = _ref5.theme;
  return styled.css(_templateObject13$1, theme.chatMessageFileFg, theme.chatMessageFileBg, theme.chatMessageFileFg, theme.chatMessageFileFg, MessageTextStyle, theme.dir === 'rtl' ? 'left' : 'right');
});

var MessageQuoteStyle = styled__default.div(_templateObject$k, function (_ref6) {
  var theme = _ref6.theme;
  return styled.css(_templateObject14$1, theme.chatMessageQuoteBg, theme.chatMessageQuoteFg, theme.chatMessageSenderFg);
});

function MessageText(props) {
  return React__default.createElement(
    MessageTextStyle,
    null,
    (props.sender || props.date) && React__default.createElement(
      'p',
      { className: 'sender' },
      props.sender,
      ' ',
      React__default.createElement(
        'time',
        null,
        props.date
      )
    ),
    props.message && React__default.createElement(
      'p',
      { className: 'text' },
      ' ',
      props.message
    )
  );
}

function MessageFile(props) {
  var isImages = function isImages(file) {
    return ['image/png', 'image/jpeg', 'image/gif'].includes(file.type);
  };
  var readyFiles = function readyFiles() {
    return props.files.map(function (file) {
      var isImage = isImages(file);
      return _extends({}, file, {
        urlStyle: isImage && 'url(' + file.url + ')',
        isImage: isImage
      });
    });
  };

  return React__default.createElement(
    MessageFileStyle,
    null,
    React__default.createElement(MessageText, {
      sender: props.sender,
      message: props.message,
      date: props.date
    }),
    readyFiles().length > 1 ? React__default.createElement(
      'div',
      { className: 'message-content-group' },
      readyFiles().map(function (file, index) {
        return React__default.createElement(
          'a',
          {
            key: index,
            href: file.url,
            target: '_blank',
            rel: 'noopener noreferrer'
          },
          !file.urlStyle && React__default.createElement('span', { className: file.icon }),
          file.isImage && React__default.createElement('div', { style: { backgroundImage: file.urlStyle } })
        );
      })
    ) : readyFiles().length === 1 && React__default.createElement(
      'a',
      {
        href: readyFiles()[0].url,
        target: '_blank',
        rel: 'noopener noreferrer'
      },
      !readyFiles()[0].urlStyle && React__default.createElement('span', { className: readyFiles()[0].icon }),
      readyFiles()[0].isImage && React__default.createElement('div', { style: { backgroundImage: readyFiles()[0].urlStyle } })
    )
  );
}

function MessageMap(props) {
  var file = {
    url: 'https://maps.googleapis.com/maps/api/staticmap?center=' + props.latitude + ',' + props.longitude + '&zoom=12&size=400x400&key=' + props.mapKey,
    type: 'image/png',
    icon: props.icon
  };
  return React__default.createElement(MessageFile, {
    sender: props.sender,
    message: props.message,
    date: props.date,
    files: [file]
  });
}

function MessageQuote(props) {
  return React__default.createElement(
    MessageQuoteStyle,
    null,
    (props.sender || props.date) && React__default.createElement(
      'p',
      { className: 'sender' },
      props.sender,
      ' ',
      React__default.createElement(
        'time',
        null,
        props.date
      )
    ),
    React__default.createElement(
      'p',
      { className: 'quote' },
      props.quote
    ),
    React__default.createElement(MessageText, { message: props.message })
  );
}

function Messages(props) {
  var scrollRef = React.useRef();
  React.useEffect(function () {
    scrollRef.current.scrollTo(0, scrollRef.current.scrollHeight);
  }, [props.messages]);
  var getMessageComponent = function getMessageComponent(msg) {
    switch (msg.type) {
      case 'file':
        return React__default.createElement(MessageFile, {
          sender: msg.sender,
          message: msg.message,
          date: msg.date,
          files: msg.files
        });
      case 'map':
        return React__default.createElement(MessageMap, {
          sender: msg.sender,
          message: msg.message,
          date: msg.date,
          latitude: msg.latitude,
          longitude: msg.longitude,
          mapKey: props.mapKey
        });
      case 'quote':
        return React__default.createElement(MessageQuote, {
          sender: msg.sender,
          message: msg.message,
          date: msg.date,
          quote: msg.quote
        });

      default:
        return React__default.createElement(MessageText, {
          sender: msg.sender,
          message: msg.message,
          date: msg.date
        });
    }
  };
  var getInitials = function getInitials(name) {
    if (name) {
      var names = name.split(' ');

      return names.map(function (n) {
        return n.charAt(0);
      }).splice(0, 2).join('').toUpperCase();
    }

    return '';
  };
  return React__default.createElement(
    'div',
    { className: 'scrollable', ref: scrollRef },
    React__default.createElement(
      'div',
      { className: 'messages' },
      props.messages.map(function (msg, index) {
        return React__default.createElement(
          MessageStyle,
          { reply: msg.reply, key: index },
          !msg.reply && React__default.createElement(
            'div',
            {
              className: 'avatar',
              style: { backgroundImage: 'url(' + msg.avatar + ')' }
            },
            !msg.avatar && getInitials(msg.sender)
          ),
          React__default.createElement(
            'div',
            { className: 'message' },
            getMessageComponent(msg)
          )
        );
      }),
      !props.messages.length && React__default.createElement(
        'p',
        { className: 'no-messages' },
        props.noMessages ? props.noMessages : 'No messages yet.'
      )
    )
  );
}
Messages.propTypes = {
  messages: PropTypes.arrayOf(PropTypes.shape({
    sender: PropTypes.string,
    message: PropTypes.string,
    date: PropTypes.string,
    files: PropTypes.arrayOf(PropTypes.shape({
      url: PropTypes.string,
      icon: PropTypes.string,
      type: PropTypes.string
    })),
    quote: PropTypes.string,
    latitude: PropTypes.number,
    longitude: PropTypes.number,
    avatar: PropTypes.string,
    type: PropTypes.oneOf(['text', 'file', 'map', 'quote'])
  }))
};

function ChatForm(props) {
  var _useState = React.useState(''),
      _useState2 = slicedToArray(_useState, 2),
      message = _useState2[0],
      setMessage = _useState2[1];

  var _useState3 = React.useState([]),
      _useState4 = slicedToArray(_useState3, 2),
      files = _useState4[0],
      setFiles = _useState4[1];

  var _useState5 = React.useState(false),
      _useState6 = slicedToArray(_useState5, 2),
      fileOver = _useState6[0],
      setFileOver = _useState6[1];

  var formRef = React.useRef();

  React.useEffect(function () {
    formRef.current.addEventListener('drop', onDropFile);
    formRef.current.addEventListener('dragover', onDragOver);
    formRef.current.addEventListener('dragleave', onDragLeave);
    return function () {
      formRef.current.removeEventListener('drop', onDropFile);
      formRef.current.removeEventListener('dragover', onDragOver);
      formRef.current.removeEventListener('dragleave', onDragLeave);
    };
  }, [files]);

  var onDragOver = function onDragOver() {
    setFileOver(true);
  };
  var onDragLeave = function onDragLeave() {
    setFileOver(false);
  };

  var onDropFile = function onDropFile(e) {
    if (props.dropFiles) {
      e.preventDefault();
      e.stopPropagation();

      setFileOver(false);

      if (e.dataTransfer && e.dataTransfer.files) {
        var droppedFiles = [].concat(toConsumableArray(files));

        var _loop = function _loop(file) {
          var res = file;

          if (props.imgDropTypes.includes(file.type)) {
            var fr = new FileReader();
            fr.onload = function (event) {
              res.src = event.target.result;
              res.urlStyle = 'url(' + res.src + ')';
            };

            fr.readAsDataURL(file);
          }
          droppedFiles.push(res);
        };

        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = e.dataTransfer.files[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var file = _step.value;

            _loop(file);
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }

        setTimeout(function () {
          setFiles(droppedFiles);
        }, 500);
      }
    }
  };

  var removeFile = function removeFile(file) {
    var droppedFiles = [].concat(toConsumableArray(files));
    var index = droppedFiles.indexOf(file);
    if (index >= 0) {
      droppedFiles.splice(index, 1);
    }
    setFiles(droppedFiles);
  };

  var sendMessage = function sendMessage() {
    if (files.length || String(message).trim().length) {
      typeof props.onSend === 'function' && props.onSend({ message: message, files: files });
      setMessage('');
      setFiles([]);
    }
  };

  return React__default.createElement(
    'div',
    { className: 'form', ref: formRef },
    React__default.createElement(
      FormStyle,
      {
        fileOver: fileOver,
        buttonIcon: props.buttonIcon,
        showButton: props.showButton
      },
      React__default.createElement(
        'div',
        { className: 'dropped-files' },
        files.map(function (file, index) {
          return file.urlStyle ? React__default.createElement(
            'div',
            { key: index, style: { backgroundImage: file.urlStyle } },
            React__default.createElement(
              'span',
              { className: 'remove', onClick: function onClick() {
                  return removeFile(file);
                } },
              '\xD7'
            )
          ) : React__default.createElement(
            'div',
            { key: index, className: props.filesIcon },
            React__default.createElement(
              'span',
              { className: 'remove', onClick: function onClick() {
                  return removeFile(file);
                } },
              '\xD7'
            )
          );
        })
      ),
      React__default.createElement(
        'div',
        { className: 'message-row' },
        React__default.createElement('input', {
          type: 'text',
          value: message,
          onChange: function onChange(e) {
            return setMessage(e.target.value);
          },
          placeholder: fileOver ? props.fileOverPlaceholder : props.placeholder,
          onKeyUp: function onKeyUp(e) {
            e.preventDefault();
            if (e.key === 'Enter') {
              sendMessage();
            }
          }
        }),
        React__default.createElement(
          'button',
          { className: 'btn', onClick: sendMessage },
          props.buttonIcon ? React__default.createElement('span', { className: props.buttonIcon }) : props.buttonTitle
        )
      )
    )
  );
}
ChatForm.defaultProps = {
  imgDropTypes: ['image/png', 'image/jpeg', 'image/gif'],
  showButton: true,
  dropFiles: false,
  buttonTitle: 'Send',
  placeholder: 'Type a message',
  fileOverPlaceholder: 'Drop file to send'
};
ChatForm.propTypes = {
  imgDropTypes: PropTypes.array,
  message: PropTypes.string,
  buttonTitle: PropTypes.string,
  buttonIcon: PropTypes.string,
  showButton: PropTypes.bool,
  dropFiles: PropTypes.bool,
  onSend: PropTypes.func,
  placeholder: PropTypes.string,
  fileOverPlaceholder: PropTypes.string,
  filesIcon: PropTypes.string
};

function Chat(props) {
  return React__default.createElement(
    ChatStyle,
    props,
    React__default.createElement(
      'header',
      null,
      props.title
    ),
    props.children
  );
}
Chat.defaultProps = {
  size: 'LG',
  status: 'Primary'
};
Chat.propTypes = {
  title: PropTypes.string,
  size: size,
  status: colorState
};

var _templateObject$l = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$k = taggedTemplateLiteral(['\n    font-size: ', ';\n    font-family: ', ';\n    line-height: ', ';\n    display: flex;\n    align-items: center;\n  '], ['\n    font-size: ', ';\n    font-family: ', ';\n    line-height: ', ';\n    display: flex;\n    align-items: center;\n  ']),
    _templateObject3$i = taggedTemplateLiteral(['\n      padding: 0 ', ';\n      display: flex;\n      flex-wrap: wrap;\n      align-items: center;\n      position: relative;\n      ', '\n\n      &:first-child {\n        ', '\n      }\n\n      a.icon-container {\n        &:hover,\n        &:focus {\n          text-decoration: none;\n        }\n      }\n\n      i.control-icon {\n        &:hover {\n          cursor: pointer;\n        }\n        color: ', ';\n      }\n\n      ', '\n\n        ', '\n        ', '\n        \n      border-', ': 1px solid \n      ', ';\n      background: transparent;\n'], ['\n      padding: 0 ', ';\n      display: flex;\n      flex-wrap: wrap;\n      align-items: center;\n      position: relative;\n      ', '\n\n      &:first-child {\n        ', '\n      }\n\n      a.icon-container {\n        &:hover,\n        &:focus {\n          text-decoration: none;\n        }\n      }\n\n      i.control-icon {\n        &:hover {\n          cursor: pointer;\n        }\n        color: ', ';\n      }\n\n      ', '\n\n        ', '\n        ', '\n        \n      border-', ': 1px solid \n      ', ';\n      background: transparent;\n']),
    _templateObject4$c = taggedTemplateLiteral(['\n          justify-content: center;\n          width: 100%;\n        '], ['\n          justify-content: center;\n          width: 100%;\n        ']),
    _templateObject5$9 = taggedTemplateLiteral(['\n          height: ', ';\n          i.control-icon {\n            font-size: ', ';\n          }\n        '], ['\n          height: ', ';\n          i.control-icon {\n            font-size: ', ';\n          }\n        ']),
    _templateObject6$5 = taggedTemplateLiteral(['\n            & > * {\n              opacity: 0.5;\n            }\n            cursor: not-allowed;\n\n            a,\n            i {\n              cursor: not-allowed !important;\n            }\n          '], ['\n            & > * {\n              opacity: 0.5;\n            }\n            cursor: not-allowed;\n\n            a,\n            i {\n              cursor: not-allowed !important;\n            }\n          ']),
    _templateObject7$4 = taggedTemplateLiteral(['\n            i.control-icon {\n              color: ', ';\n            }\n\n            border-', ': 1px solid \n            ', ';\n          '], ['\n            i.control-icon {\n              color: ', ';\n            }\n\n            border-', ': 1px solid \n            ', ';\n          ']);

/* eslint-disable indent */

var ActionsStyle = styled__default.div(_templateObject$l, function (_ref) {
  var theme = _ref.theme;
  return styled.css(_templateObject2$k, theme.actionsFontSize, theme.actionsFontFamily, theme.actionsLineHeight);
});

var ActionStyle = styled__default.div(_templateObject$l, function (_ref2) {
  var theme = _ref2.theme,
      fullWidth = _ref2.fullWidth,
      disabled = _ref2.disabled,
      size = _ref2.size,
      inverse = _ref2.inverse;
  return styled.css(_templateObject3$i, theme.actionsPadding, fullWidth && styled.css(_templateObject4$c), theme.dir === 'rtl' ? 'border-right: none !important;' : 'border-left: none !important;', theme.actionsFg, size && styled.css(_templateObject5$9, theme['actionsSize' + size], theme['actionsSize' + size]), disabled && styled.css(_templateObject6$5), inverse && styled.css(_templateObject7$4, theme.actionsBg, theme.dir === 'rtl' ? 'right' : 'left', theme.actionsSeparator), theme.dir === 'rtl' ? 'right' : 'left', theme.actionsSeparator);
});

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

function Actions(_ref) {
  var actions = _ref.actions,
      className = _ref.className,
      style = _ref.style,
      fullWidth = _ref.fullWidth,
      size$$1 = _ref.size,
      inverse = _ref.inverse,
      Link = _ref.Link;

  return React__default.createElement(
    ActionsStyle,
    { className: className, style: style },
    actions.map(function (action, index) {
      return React__default.createElement(
        ActionStyle,
        {
          key: index,
          fullWidth: fullWidth,
          size: size$$1,
          inverse: inverse,
          disabled: action.disabled
        },
        action.icon ? action.link ? React__default.createElement(
          Link,
          _extends({}, action.link, {
            className: 'icon-container'
          }, action.events),
          React__default.createElement('i', { className: 'control-icon ' + action.icon })
        ) : React__default.createElement(
          'a',
          _extends({ className: 'icon-container' }, action.events),
          React__default.createElement('i', { className: 'control-icon ' + action.icon })
        ) : action.content,
        action.badge && React__default.createElement(
          Badge,
          {
            status: action.badge.status,
            position: action.badge.position
          },
          action.badge.title
        )
      );
    })
  );
}

Actions.propTypes = {
  classNames: PropTypes.string,
  style: PropTypes.object,
  fullWidth: PropTypes.bool,
  size: PropTypes.oneOf(['SM', 'MD', 'LG']),
  inverse: PropTypes.bool,
  actions: PropTypes.arrayOf(PropTypes.shape({
    icon: PropTypes.string,
    content: PropTypes.any,
    disabled: PropTypes.bool,
    badge: badge
  })).isRequired
};

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

var Item = function Item(_ref) {
  var item = _ref.item,
      toggleSidebar = _ref.toggleSidebar,
      toggleSubMenu = _ref.toggleSubMenu,
      selectItem = _ref.selectItem,
      id = _ref.id,
      Link = _ref.Link;

  React.useEffect(function () {
    var link = window.location.pathname;
    if (link === item.link || link === item.link + '/' || link + '/' === item.link) {
      selectItem(id);
    }
  }, []);

  var isActive = function isActive(_ref2) {
    var isCurrent = _ref2.isCurrent;

    isCurrent && !item.selected && selectItem(id);
  };

  var handleToggleSubMenu = function handleToggleSubMenu() {
    toggleSubMenu(item);
  };

  return React__default.createElement(
    ItemStyle$1,
    { className: item.group ? 'menu-item menu-group' : 'menu-item' },
    item.group ? React__default.createElement(
      'span',
      null,
      item.icon && React__default.createElement('i', { className: 'menu-icon ' + item.icon }),
      item.title
    ) : item.link && !item.children ? React__default.createElement(
      Link,
      {
        to: item.link,
        getProps: isActive,
        title: item.title,
        target: item.target,
        className: item.selected ? 'active' : '',
        onClick: toggleSidebar
      },
      React__default.createElement('i', { className: 'menu-icon ' + item.icon }),
      React__default.createElement(
        'span',
        { className: 'menu-title' },
        item.title
      )
    ) : item.url && !item.children ? React__default.createElement(
      'a',
      { href: item.url, target: item.target, title: item.title },
      React__default.createElement('i', { className: 'menu-icon ' + item.icon }),
      React__default.createElement(
        'span',
        { className: 'menu-title' },
        item.title
      )
    ) : item.children ? React__default.createElement(
      React.Fragment,
      null,
      React__default.createElement(
        'a',
        {
          href: item.link,
          title: item.title,
          onClick: function onClick(e) {
            e.preventDefault();
            handleToggleSubMenu();
          },
          className: item.selected ? 'active' : ''
        },
        React__default.createElement('i', { className: 'menu-icon ' + item.icon }),
        React__default.createElement(
          'span',
          { className: 'menu-title' },
          item.title
        ),
        React__default.createElement(
          'i',
          { className: 'chevron' },
          item.expanded ? React__default.createElement(ArrowDown$1, null) : React__default.createElement(ArrowLeft$1, null)
        )
      ),
      React__default.createElement(
        'ul',
        {
          className: item.expanded ? 'menu-items expanded' : 'menu-items collapsed'
        },
        item.children.map(function (item2, index) {
          return !item.hidden && React__default.createElement(Item, {
            key: index,
            item: item2,
            id: id + ',' + index,
            Link: Link,
            selectItem: selectItem,
            toggleSidebar: toggleSidebar,
            toggleSubMenu: toggleSubMenu
          });
        })
      )
    ) : ''
  );
};

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

var Menu = React.forwardRef(function (props, ref) {
  var _useState = React.useState(props.items),
      _useState2 = slicedToArray(_useState, 2),
      items = _useState2[0],
      setItems = _useState2[1];

  React.useImperativeHandle(ref, function () {
    return {
      collapseAll: function collapseAll() {
        setItems(toggleSubMenu([].concat(toConsumableArray(items)), false));
      },
      expandAll: function expandAll() {
        setItems(toggleSubMenu([].concat(toConsumableArray(items)), true));
      }
    };
  }, [items]);

  var onSelectItem = function onSelectItem(index) {
    var indexArray = Number.isInteger(index) ? [index] : index.split(',');
    setItems(updateSelected([].concat(toConsumableArray(items)), indexArray));
  };

  var updateSelected = function updateSelected(updateItems, ia) {
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = updateItems.keys()[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var i = _step.value;

        var state = i === Number(ia[0]);
        updateItems[i].selected = state;
        if (state) {
          updateItems[i].expanded = true;
        }
        if (updateItems[i].children) {
          if (state) {
            updateSelected(updateItems[i].children, ia.splice(1));
          } else {
            updateSelected(updateItems[i].children, []);
          }
        }
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    return updateItems;
  };

  var onToggleSubMenu = function onToggleSubMenu(item) {
    setItems(toggleSubMenu([].concat(toConsumableArray(items)), item));
  };

  var toggleSubMenu = function toggleSubMenu(updateItems, action) {
    var _iteratorNormalCompletion2 = true;
    var _didIteratorError2 = false;
    var _iteratorError2 = undefined;

    try {
      for (var _iterator2 = updateItems[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
        var item = _step2.value;

        if (typeof action === 'boolean') {
          item.expanded = action;
        } else if (item === action) {
          item.expanded = !item.expanded;
          break;
        }
        if (item.children) {
          toggleSubMenu(item.children, action);
        }
      }
    } catch (err) {
      _didIteratorError2 = true;
      _iteratorError2 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion2 && _iterator2.return) {
          _iterator2.return();
        }
      } finally {
        if (_didIteratorError2) {
          throw _iteratorError2;
        }
      }
    }

    return updateItems;
  };

  return React__default.createElement(
    MenuStyle,
    { className: props.className, style: props.style },
    React__default.createElement(
      'ul',
      { className: 'menu-items' },
      items.map(function (item, index) {
        return !item.hidden && React__default.createElement(Item, {
          key: index,
          id: index,
          item: item,
          Link: props.Link,
          selectItem: function selectItem(i) {
            return onSelectItem(i);
          },
          toggleSidebar: props.toggleSidebar,
          toggleSubMenu: function toggleSubMenu(item) {
            return onToggleSubMenu(item);
          }
        });
      })
    )
  );
});

Menu.propTypes = {
  items: menuItemsType,
  toggleSidebar: PropTypes.func,
  Link: PropTypes.object.isRequired,
  className: PropTypes.string,
  style: PropTypes.string
};

var _templateObject$m = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$l = taggedTemplateLiteral(['\n    html {\n      box-sizing: border-box;\n      font-size: 14px;\n      direction: ', ';\n    }\n    *,\n    *:before,\n    *:after {\n      box-sizing: inherit;\n    }\n    body {\n      margin: 0;\n      padding: 0;\n      text-align: ', ';\n      -webkit-font-smoothing: antialiased;\n    }\n    #oah-layout.with-search .scrollable-container {\n      position: relative;\n      z-index: 0;\n    }\n    #oah-layout.rotate-layout {\n      position: fixed;\n      overflow: hidden;\n      width: 100%;\n\n      .scrollable-container {\n        position: relative;\n        z-index: 10001;\n\n        transition: transform 0.5s cubic-bezier(0.2, 1, 0.3, 1);\n      }\n\n      &.with-search .scrollable-container {\n        transition: transform 0.5s cubic-bezier(0.2, 1, 0.3, 1);\n        transform-origin: 50vw 50vh;\n        transform: perspective(1000px) translate3d(0, 50vh, 0)\n          rotate3d(1, 0, 0, 30deg);\n        pointer-events: none;\n      }\n    }\n    #oah-layout.column-curtain.with-search .layout {\n      pointer-events: none;\n    }\n    #oah-layout.curtain .scrollable-container {\n      position: relative;\n      z-index: 0;\n    }\n    #oah-layout.modal-drop {\n      .layout {\n        position: relative;\n        transition: transform 0.4s, opacity 0.4s;\n        transition-timing-function: cubic-bezier(0.4, 0, 0.2, 1);\n      }\n      &.with-search .layout {\n        opacity: 0;\n        transform: scale3d(0.9, 0.9, 1);\n        pointer-events: none;\n      }\n    }\n\n    #oah-layout.modal-half {\n      .layout {\n        transition: transform 0.6s, opacity 0.6s;\n        transition-timing-function: cubic-bezier(0.2, 1, 0.3, 1);\n      }\n      &.with-search {\n        .layout {\n          transform: scale3d(0.8, 0.8, 1);\n          pointer-events: none;\n        }\n      }\n    }\n\n    #oah-layout.modal-move {\n      .layout {\n        transition: transform 0.5s;\n      }\n      &.with-search {\n        .layout {\n          transform: scale3d(0.8, 0.8, 1);\n          pointer-events: none;\n        }\n      }\n    }\n    *::-webkit-scrollbar {\n      width: ', ';\n      height: ', ';\n    }\n\n    *::-webkit-scrollbar-thumb {\n      background: ', ';\n      cursor: pointer;\n      border-radius: ', ';\n    }\n\n    *::-webkit-scrollbar-track {\n      background: ', ';\n    }\n  '], ['\n    html {\n      box-sizing: border-box;\n      font-size: 14px;\n      direction: ', ';\n    }\n    *,\n    *:before,\n    *:after {\n      box-sizing: inherit;\n    }\n    body {\n      margin: 0;\n      padding: 0;\n      text-align: ', ';\n      -webkit-font-smoothing: antialiased;\n    }\n    #oah-layout.with-search .scrollable-container {\n      position: relative;\n      z-index: 0;\n    }\n    #oah-layout.rotate-layout {\n      position: fixed;\n      overflow: hidden;\n      width: 100%;\n\n      .scrollable-container {\n        position: relative;\n        z-index: 10001;\n\n        transition: transform 0.5s cubic-bezier(0.2, 1, 0.3, 1);\n      }\n\n      &.with-search .scrollable-container {\n        transition: transform 0.5s cubic-bezier(0.2, 1, 0.3, 1);\n        transform-origin: 50vw 50vh;\n        transform: perspective(1000px) translate3d(0, 50vh, 0)\n          rotate3d(1, 0, 0, 30deg);\n        pointer-events: none;\n      }\n    }\n    #oah-layout.column-curtain.with-search .layout {\n      pointer-events: none;\n    }\n    #oah-layout.curtain .scrollable-container {\n      position: relative;\n      z-index: 0;\n    }\n    #oah-layout.modal-drop {\n      .layout {\n        position: relative;\n        transition: transform 0.4s, opacity 0.4s;\n        transition-timing-function: cubic-bezier(0.4, 0, 0.2, 1);\n      }\n      &.with-search .layout {\n        opacity: 0;\n        transform: scale3d(0.9, 0.9, 1);\n        pointer-events: none;\n      }\n    }\n\n    #oah-layout.modal-half {\n      .layout {\n        transition: transform 0.6s, opacity 0.6s;\n        transition-timing-function: cubic-bezier(0.2, 1, 0.3, 1);\n      }\n      &.with-search {\n        .layout {\n          transform: scale3d(0.8, 0.8, 1);\n          pointer-events: none;\n        }\n      }\n    }\n\n    #oah-layout.modal-move {\n      .layout {\n        transition: transform 0.5s;\n      }\n      &.with-search {\n        .layout {\n          transform: scale3d(0.8, 0.8, 1);\n          pointer-events: none;\n        }\n      }\n    }\n    *::-webkit-scrollbar {\n      width: ', ';\n      height: ', ';\n    }\n\n    *::-webkit-scrollbar-thumb {\n      background: ', ';\n      cursor: pointer;\n      border-radius: ', ';\n    }\n\n    *::-webkit-scrollbar-track {\n      background: ', ';\n    }\n  ']);

var GlobalStyle = styled.css(_templateObject$m, function (_ref) {
  var theme = _ref.theme;
  return styled.css(_templateObject2$l, theme.dir && theme.dir, theme.dir === 'rtl' ? 'right' : 'left', theme.scrollbarWidth, theme.scrollbarWidth, theme.scrollbarFg, theme.scrollbarThumbRadius, theme.scrollbarBg);
});

var _templateObject$n = taggedTemplateLiteral(['\n  position: absolute;\n  pointer-events: auto;\n  box-sizing: border-box;\n  z-index: 1000;\n  display: flex;\n  max-width: 100%;\n  max-height: 100%;\n'], ['\n  position: absolute;\n  pointer-events: auto;\n  box-sizing: border-box;\n  z-index: 1000;\n  display: flex;\n  max-width: 100%;\n  max-height: 100%;\n']);

var OverlayStyle = styled__default.div(_templateObject$n);

function Overlay(props) {
  var _useState = React.useState(),
      _useState2 = slicedToArray(_useState, 2),
      parent = _useState2[0],
      setParent = _useState2[1];

  React.useEffect(function () {
    var overlayParent = document.getElementById('overlay-container');
    setParent(overlayParent);
  }, []);
  return parent !== undefined && ReactDOM.createPortal(React__default.createElement(
    OverlayStyle,
    props,
    props.children
  ), parent);
}

Overlay.propTypes = {
  children: PropTypes.node
};

var _templateObject$o = taggedTemplateLiteral(['\n  display: block;\n  position: fixed;\n  z-index: 1050;\n  top: 0;\n  left: 50%;\n  overflow: hidden;\n  width: 50%;\n  height: 100vh;\n  pointer-events: none;\n\n  &::before {\n    content: \'\';\n    position: absolute;\n    top: 0;\n    left: 0;\n    width: 100%;\n    height: 100%;\n    transform: scale3d(0, 1, 1);\n    transform-origin: 0 50%;\n    transition: transform 0.3s;\n    transition-timing-function: cubic-bezier(0.86, 0, 0.07, 1);\n  }\n\n  .search {\n    position: relative;\n    padding: 2.5rem 1.5rem 0;\n    background: transparent;\n\n    button {\n      position: absolute;\n      top: 2rem;\n      ', '\n      font-size: 2.5rem;\n      opacity: 0;\n      transition: opacity 0.5s;\n    }\n\n    .form {\n      width: 85%;\n      transform: translate3d(-150%, 0, 0);\n      transition: transform 0.3s;\n    }\n\n    input {\n      font-size: 2.5rem;\n      width: 100%;\n    }\n\n    span {\n      font-size: 85%;\n    }\n  }\n\n  &.show {\n    pointer-events: auto;\n\n    &::before {\n      transform: scale3d(1, 1, 1);\n    }\n\n    .search {\n      .form {\n        transform: translate3d(0, 0, 0);\n        transition-delay: 0.15s;\n        transition-timing-function: cubic-bezier(0.86, 0, 0.07, 1);\n      }\n\n      button {\n        opacity: 1;\n        z-index: 100;\n      }\n    }\n  }\n\n  @media screen and (max-width: 40rem) {\n    span {\n      width: 90%;\n    }\n\n    input {\n      font-size: 2rem;\n      width: 90%;\n    }\n  }\n'], ['\n  display: block;\n  position: fixed;\n  z-index: 1050;\n  top: 0;\n  left: 50%;\n  overflow: hidden;\n  width: 50%;\n  height: 100vh;\n  pointer-events: none;\n\n  &::before {\n    content: \'\';\n    position: absolute;\n    top: 0;\n    left: 0;\n    width: 100%;\n    height: 100%;\n    transform: scale3d(0, 1, 1);\n    transform-origin: 0 50%;\n    transition: transform 0.3s;\n    transition-timing-function: cubic-bezier(0.86, 0, 0.07, 1);\n  }\n\n  .search {\n    position: relative;\n    padding: 2.5rem 1.5rem 0;\n    background: transparent;\n\n    button {\n      position: absolute;\n      top: 2rem;\n      ', '\n      font-size: 2.5rem;\n      opacity: 0;\n      transition: opacity 0.5s;\n    }\n\n    .form {\n      width: 85%;\n      transform: translate3d(-150%, 0, 0);\n      transition: transform 0.3s;\n    }\n\n    input {\n      font-size: 2.5rem;\n      width: 100%;\n    }\n\n    span {\n      font-size: 85%;\n    }\n  }\n\n  &.show {\n    pointer-events: auto;\n\n    &::before {\n      transform: scale3d(1, 1, 1);\n    }\n\n    .search {\n      .form {\n        transform: translate3d(0, 0, 0);\n        transition-delay: 0.15s;\n        transition-timing-function: cubic-bezier(0.86, 0, 0.07, 1);\n      }\n\n      button {\n        opacity: 1;\n        z-index: 100;\n      }\n    }\n  }\n\n  @media screen and (max-width: 40rem) {\n    span {\n      width: 90%;\n    }\n\n    input {\n      font-size: 2rem;\n      width: 90%;\n    }\n  }\n']);

var columnCurtain = styled.css(_templateObject$o, function (_ref) {
  var theme = _ref.theme;
  return theme.dir === 'rtl' ? 'left: 3rem;' : 'right: 3rem;';
});

var _templateObject$p = taggedTemplateLiteral(['\n  .search {\n    position: fixed;\n    z-index: 1050;\n    top: 0;\n    left: 100%;\n    overflow: hidden;\n    height: 100vh;\n    width: 100%;\n    padding: 3rem;\n    pointer-events: none;\n    transition: transform 0.3s;\n    transition-delay: 0.4s;\n    transition-timing-function: ease-out;\n\n    &::after {\n      content: \'\';\n      position: absolute;\n      top: 0;\n      left: 0;\n      width: 100%;\n      height: 100%;\n      transition: transform 0.3s;\n      transition-timing-function: ease-out;\n    }\n\n    button {\n      font-size: 2.5rem;\n      position: absolute;\n      top: 3rem;\n      ', '\n      transition: opacity 0.1s;\n      transition-delay: 0.3s;\n    }\n\n    .form {\n      width: 50%;\n      opacity: 0;\n      transform: scale3d(0.8, 0.8, 1);\n      transition: opacity 0.5s, transform 0.5s;\n    }\n\n    input {\n      width: 100%;\n      font-size: 6vw;\n    }\n  }\n\n  &.show {\n    .search {\n      width: 100%;\n      pointer-events: auto;\n      transform: translate3d(-100%, 0, 0);\n      transition-delay: 0s;\n\n      &::after {\n        transform: translate3d(100%, 0, 0);\n        transition-delay: 0.4s;\n      }\n\n      button {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n\n      .form {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n    }\n  }\n\n  @media screen and (max-width: 40em) {\n    span {\n      width: 90%;\n    }\n\n    input {\n      font-size: 2em;\n      width: 90%;\n    }\n  }\n'], ['\n  .search {\n    position: fixed;\n    z-index: 1050;\n    top: 0;\n    left: 100%;\n    overflow: hidden;\n    height: 100vh;\n    width: 100%;\n    padding: 3rem;\n    pointer-events: none;\n    transition: transform 0.3s;\n    transition-delay: 0.4s;\n    transition-timing-function: ease-out;\n\n    &::after {\n      content: \'\';\n      position: absolute;\n      top: 0;\n      left: 0;\n      width: 100%;\n      height: 100%;\n      transition: transform 0.3s;\n      transition-timing-function: ease-out;\n    }\n\n    button {\n      font-size: 2.5rem;\n      position: absolute;\n      top: 3rem;\n      ', '\n      transition: opacity 0.1s;\n      transition-delay: 0.3s;\n    }\n\n    .form {\n      width: 50%;\n      opacity: 0;\n      transform: scale3d(0.8, 0.8, 1);\n      transition: opacity 0.5s, transform 0.5s;\n    }\n\n    input {\n      width: 100%;\n      font-size: 6vw;\n    }\n  }\n\n  &.show {\n    .search {\n      width: 100%;\n      pointer-events: auto;\n      transform: translate3d(-100%, 0, 0);\n      transition-delay: 0s;\n\n      &::after {\n        transform: translate3d(100%, 0, 0);\n        transition-delay: 0.4s;\n      }\n\n      button {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n\n      .form {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n    }\n  }\n\n  @media screen and (max-width: 40em) {\n    span {\n      width: 90%;\n    }\n\n    input {\n      font-size: 2em;\n      width: 90%;\n    }\n  }\n']);

var curtain = styled.css(_templateObject$p, function (_ref) {
  var theme = _ref.theme;
  return theme.dir === 'rtl' ? 'left: 3rem;' : 'right: 3rem;';
});

var _templateObject$q = taggedTemplateLiteral(['\n  0% {\n    opacity: 1;\n    transform: scale3d(1, 0, 1);\n  }\n  50% {\n    transform: scale3d(1, 1, 1);\n    transform-origin: 50% 0;\n    transition-timing-function: ease-out;\n  }\n  50.1% {\n    transform-origin: 50% 100%;\n    transition-timing-function: ease-out;\n  }\n  100% {\n    opacity: 1;\n    transform: scale3d(1, 0, 1);\n    transform-origin: 50% 100%;\n    transition-timing-function: ease-out;\n  }   \n'], ['\n  0% {\n    opacity: 1;\n    transform: scale3d(1, 0, 1);\n  }\n  50% {\n    transform: scale3d(1, 1, 1);\n    transform-origin: 50% 0;\n    transition-timing-function: ease-out;\n  }\n  50.1% {\n    transform-origin: 50% 100%;\n    transition-timing-function: ease-out;\n  }\n  100% {\n    opacity: 1;\n    transform: scale3d(1, 0, 1);\n    transform-origin: 50% 100%;\n    transition-timing-function: ease-out;\n  }   \n']),
    _templateObject2$m = taggedTemplateLiteral(['\n  .search {\n    display: flex;\n    flex-direction: column;\n    justify-content: center;\n    align-items: center;\n    text-align: center;\n    z-index: 1050;\n    position: fixed;\n    top: 0;\n    left: 0;\n    width: 100%;\n    height: 100vh;\n    background: 0 0;\n    pointer-events: none;\n\n    &::before {\n      content: \'\';\n      position: absolute;\n      top: 0;\n      right: 0;\n      width: 100%;\n      height: 100%;\n      opacity: 0;\n      transition: opacity 0.4s;\n    }\n\n    button {\n      font-size: 2.5rem;\n      position: absolute;\n      top: 3rem;\n      ', '\n      display: block;\n      opacity: 0;\n      transition: opacity 0.4s;\n    }\n\n    .form {\n      position: relative;\n      margin: 5rem 0 2rem;\n    }\n\n    input {\n      font-size: 6vw;\n      width: 60%;\n      padding: 0.25rem;\n      text-align: center;\n      opacity: 0;\n      transition: opacity 0.4s;\n    }\n\n    span {\n      position: relative;\n      z-index: 9;\n      display: block;\n      width: 60%;\n      padding: 0.85rem 0;\n      opacity: 0;\n      transform: translate3d(0, -50px, 0);\n      transition: opacity 0.4s, transform 0.4s;\n    }\n\n    .form-content {\n      position: relative;\n      z-index: 10;\n      overflow: hidden;\n      transform: translate3d(0, -50px, 0);\n      transition: transform 0.4s;\n\n      &::after {\n        content: \'\';\n        position: absolute;\n        top: 0;\n        left: 20%;\n        width: 60%;\n        height: 105%;\n        opacity: 0;\n        transform-origin: 50% 0;\n      }\n    }\n  }\n\n  &.show {\n    .search {\n      pointer-events: auto;\n\n      &::before {\n        opacity: 1;\n      }\n\n      button {\n        opacity: 1;\n      }\n\n      .form-content {\n        transform: translate3d(0, 0, 0);\n        transition: none;\n\n        &::after {\n          animation: ', ' 0.8s cubic-bezier(0.4, 0, 0.2, 1) forwards;\n        }\n      }\n\n      input {\n        opacity: 1;\n        transition: opacity 0s 0.4s;\n      }\n\n      span {\n        opacity: 1;\n        transform: translate3d(0, 0, 0);\n        transition-delay: 0.4s;\n        transition-timing-function: ease-out;\n      }\n    }\n  }\n\n  @media screen and (max-width: 40rem) {\n    .form {\n      margin: 2rem 0;\n    }\n\n    input {\n      width: 100%;\n      left: 0;\n    }\n  }\n'], ['\n  .search {\n    display: flex;\n    flex-direction: column;\n    justify-content: center;\n    align-items: center;\n    text-align: center;\n    z-index: 1050;\n    position: fixed;\n    top: 0;\n    left: 0;\n    width: 100%;\n    height: 100vh;\n    background: 0 0;\n    pointer-events: none;\n\n    &::before {\n      content: \'\';\n      position: absolute;\n      top: 0;\n      right: 0;\n      width: 100%;\n      height: 100%;\n      opacity: 0;\n      transition: opacity 0.4s;\n    }\n\n    button {\n      font-size: 2.5rem;\n      position: absolute;\n      top: 3rem;\n      ', '\n      display: block;\n      opacity: 0;\n      transition: opacity 0.4s;\n    }\n\n    .form {\n      position: relative;\n      margin: 5rem 0 2rem;\n    }\n\n    input {\n      font-size: 6vw;\n      width: 60%;\n      padding: 0.25rem;\n      text-align: center;\n      opacity: 0;\n      transition: opacity 0.4s;\n    }\n\n    span {\n      position: relative;\n      z-index: 9;\n      display: block;\n      width: 60%;\n      padding: 0.85rem 0;\n      opacity: 0;\n      transform: translate3d(0, -50px, 0);\n      transition: opacity 0.4s, transform 0.4s;\n    }\n\n    .form-content {\n      position: relative;\n      z-index: 10;\n      overflow: hidden;\n      transform: translate3d(0, -50px, 0);\n      transition: transform 0.4s;\n\n      &::after {\n        content: \'\';\n        position: absolute;\n        top: 0;\n        left: 20%;\n        width: 60%;\n        height: 105%;\n        opacity: 0;\n        transform-origin: 50% 0;\n      }\n    }\n  }\n\n  &.show {\n    .search {\n      pointer-events: auto;\n\n      &::before {\n        opacity: 1;\n      }\n\n      button {\n        opacity: 1;\n      }\n\n      .form-content {\n        transform: translate3d(0, 0, 0);\n        transition: none;\n\n        &::after {\n          animation: ', ' 0.8s cubic-bezier(0.4, 0, 0.2, 1) forwards;\n        }\n      }\n\n      input {\n        opacity: 1;\n        transition: opacity 0s 0.4s;\n      }\n\n      span {\n        opacity: 1;\n        transform: translate3d(0, 0, 0);\n        transition-delay: 0.4s;\n        transition-timing-function: ease-out;\n      }\n    }\n  }\n\n  @media screen and (max-width: 40rem) {\n    .form {\n      margin: 2rem 0;\n    }\n\n    input {\n      width: 100%;\n      left: 0;\n    }\n  }\n']);

var scaleUpDown = styled.keyframes(_templateObject$q);

var modalDrop = styled.css(_templateObject2$m, function (_ref) {
  var theme = _ref.theme;
  return theme.dir === 'rtl' ? 'left: 3rem;' : 'right: 3rem;';
}, scaleUpDown);

var _templateObject$r = taggedTemplateLiteral(['\n  .search {\n    display: flex;\n    flex-direction: column;\n    justify-content: center;\n    align-items: center;\n    text-align: center;\n    position: fixed;\n    z-index: 1050;\n    top: 0;\n    left: 0;\n    width: 100%;\n    height: 100vh;\n    pointer-events: none;\n    opacity: 0;\n    transition: opacity 0.5s;\n\n    button {\n      position: absolute;\n      top: 3rem;\n      ', '\n      font-size: 2.5rem;\n      opacity: 0;\n      transition: opacity 0.5s;\n    }\n\n    .form {\n      margin: 5rem 0;\n      opacity: 0;\n      transform: scale3d(0.8, 0.8, 1);\n      transition: opacity 0.5s, transform 0.5s;\n    }\n\n    input {\n      font-size: 10vw;\n      width: 75%;\n      transform: scale3d(0, 1, 1);\n      transform-origin: 0 50%;\n      transition: transform 0.3s;\n    }\n  }\n\n  &.show {\n    .search {\n      pointer-events: auto;\n      opacity: 1;\n\n      button {\n        opacity: 1;\n      }\n\n      .form {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n\n      input {\n        transform: scale3d(1, 1, 1);\n        transition-duration: 0.5s;\n      }\n    }\n  }\n\n  @media screen and (max-width: 40rem) {\n    span {\n      text-align: left;\n    }\n  }\n'], ['\n  .search {\n    display: flex;\n    flex-direction: column;\n    justify-content: center;\n    align-items: center;\n    text-align: center;\n    position: fixed;\n    z-index: 1050;\n    top: 0;\n    left: 0;\n    width: 100%;\n    height: 100vh;\n    pointer-events: none;\n    opacity: 0;\n    transition: opacity 0.5s;\n\n    button {\n      position: absolute;\n      top: 3rem;\n      ', '\n      font-size: 2.5rem;\n      opacity: 0;\n      transition: opacity 0.5s;\n    }\n\n    .form {\n      margin: 5rem 0;\n      opacity: 0;\n      transform: scale3d(0.8, 0.8, 1);\n      transition: opacity 0.5s, transform 0.5s;\n    }\n\n    input {\n      font-size: 10vw;\n      width: 75%;\n      transform: scale3d(0, 1, 1);\n      transform-origin: 0 50%;\n      transition: transform 0.3s;\n    }\n  }\n\n  &.show {\n    .search {\n      pointer-events: auto;\n      opacity: 1;\n\n      button {\n        opacity: 1;\n      }\n\n      .form {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n\n      input {\n        transform: scale3d(1, 1, 1);\n        transition-duration: 0.5s;\n      }\n    }\n  }\n\n  @media screen and (max-width: 40rem) {\n    span {\n      text-align: left;\n    }\n  }\n']);

var modalMove = styled.css(_templateObject$r, function (_ref) {
  var theme = _ref.theme;
  return theme.dir === 'rtl' ? 'left: 3rem;' : 'right: 3rem;';
});

var _templateObject$s = taggedTemplateLiteral(['\n  .search {\n    text-align: center;\n    position: fixed;\n    z-index: 1050;\n    top: 0;\n    left: 0;\n    overflow: hidden;\n    width: 100%;\n    height: 100vh;\n    background: none;\n    pointer-events: none;\n\n    &::before {\n      content: \'\';\n      position: absolute;\n      top: 0;\n      left: 0;\n      width: 100%;\n      height: 100%;\n      pointer-events: none;\n      opacity: 0;\n      transition: opacity 0.6s;\n      transition-timing-function: cubic-bezier(0.2, 1, 0.3, 1);\n    }\n\n    button {\n      font-size: 2.5rem;\n      position: absolute;\n      top: 3rem;\n      ', '\n      display: block;\n      z-index: 100;\n      opacity: 0;\n      transform: scale3d(0.8, 0.8, 1);\n      transition: opacity 0.6s, transform 0.6s;\n      transition-timing-function: cubic-bezier(0.2, 1, 0.3, 1);\n    }\n\n    .form-wrapper {\n      position: absolute;\n      display: flex;\n      justify-content: center;\n      align-items: center;\n      width: 100%;\n      height: 50%;\n      transition: transform 0.6s;\n      transition-timing-function: cubic-bezier(0.2, 1, 0.3, 1);\n      transform: translate3d(0, -100%, 0);\n    }\n\n    .form {\n      width: 75%;\n      margin: 0 auto;\n    }\n\n    input {\n      font-size: 7vw;\n      width: 100%;\n    }\n  }\n\n  &.show {\n    .search {\n      pointer-events: auto;\n\n      &::before {\n        opacity: 1;\n      }\n\n      button {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n\n      .form-wrapper {\n        transform: translate3d(0, 0, 0);\n      }\n    }\n  }\n'], ['\n  .search {\n    text-align: center;\n    position: fixed;\n    z-index: 1050;\n    top: 0;\n    left: 0;\n    overflow: hidden;\n    width: 100%;\n    height: 100vh;\n    background: none;\n    pointer-events: none;\n\n    &::before {\n      content: \'\';\n      position: absolute;\n      top: 0;\n      left: 0;\n      width: 100%;\n      height: 100%;\n      pointer-events: none;\n      opacity: 0;\n      transition: opacity 0.6s;\n      transition-timing-function: cubic-bezier(0.2, 1, 0.3, 1);\n    }\n\n    button {\n      font-size: 2.5rem;\n      position: absolute;\n      top: 3rem;\n      ', '\n      display: block;\n      z-index: 100;\n      opacity: 0;\n      transform: scale3d(0.8, 0.8, 1);\n      transition: opacity 0.6s, transform 0.6s;\n      transition-timing-function: cubic-bezier(0.2, 1, 0.3, 1);\n    }\n\n    .form-wrapper {\n      position: absolute;\n      display: flex;\n      justify-content: center;\n      align-items: center;\n      width: 100%;\n      height: 50%;\n      transition: transform 0.6s;\n      transition-timing-function: cubic-bezier(0.2, 1, 0.3, 1);\n      transform: translate3d(0, -100%, 0);\n    }\n\n    .form {\n      width: 75%;\n      margin: 0 auto;\n    }\n\n    input {\n      font-size: 7vw;\n      width: 100%;\n    }\n  }\n\n  &.show {\n    .search {\n      pointer-events: auto;\n\n      &::before {\n        opacity: 1;\n      }\n\n      button {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n\n      .form-wrapper {\n        transform: translate3d(0, 0, 0);\n      }\n    }\n  }\n']);

var modalHalf = styled.css(_templateObject$s, function (_ref) {
  var theme = _ref.theme;
  return theme.dir === 'rtl' ? 'left: 3rem;' : 'right: 3rem;';
});

var _templateObject$t = taggedTemplateLiteral(['\n  display: block;\n\n  .search {\n    display: flex;\n    flex-direction: column;\n    justify-content: center;\n    align-items: center;\n    text-align: center;\n    position: fixed;\n    z-index: 1050;\n    top: 0;\n    left: 0;\n    width: 100%;\n    height: 100vh;\n    pointer-events: none;\n    opacity: 0;\n    transition: opacity 0.5s;\n\n    &::before,\n    &::after {\n      content: \'\';\n      position: absolute;\n      width: calc(100% + 15px);\n      height: calc(100% + 15px);\n      pointer-events: none;\n    }\n\n    &::before {\n      top: 0;\n      left: 0;\n      border-right-width: 0;\n      border-bottom-width: 0;\n      transform: translate3d(-15px, -15px, 0);\n    }\n\n    &::after {\n      right: 0;\n      bottom: 0;\n      border-top-width: 0;\n      border-left-width: 0;\n      transform: translate3d(15px, 15px, 0);\n    }\n\n    button {\n      position: absolute;\n      top: 3rem;\n      ', '\n      font-size: 2.5rem;\n    }\n\n    input {\n      font-size: 10vw;\n      width: 75%;\n    }\n\n    button {\n      opacity: 0;\n      transform: scale3d(0.8, 0.8, 1);\n      transition: opacity 0.5s, transform 0.5s;\n    }\n\n    .form {\n      opacity: 0;\n      transform: scale3d(0.8, 0.8, 1);\n      transition: opacity 0.5s, transform 0.5s;\n    }\n  }\n\n  &.show {\n    .search {\n      pointer-events: auto;\n      opacity: 1;\n\n      &::before,\n      &::after {\n        transform: translate3d(0, 0, 0);\n        transition: transform 0.5s;\n      }\n\n      button {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n\n      .form {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n    }\n  }\n\n  @media screen and (max-width: 40rem) {\n    .form {\n      margin: 5rem 0 1rem;\n    }\n\n    span {\n      text-align: left;\n    }\n  }\n'], ['\n  display: block;\n\n  .search {\n    display: flex;\n    flex-direction: column;\n    justify-content: center;\n    align-items: center;\n    text-align: center;\n    position: fixed;\n    z-index: 1050;\n    top: 0;\n    left: 0;\n    width: 100%;\n    height: 100vh;\n    pointer-events: none;\n    opacity: 0;\n    transition: opacity 0.5s;\n\n    &::before,\n    &::after {\n      content: \'\';\n      position: absolute;\n      width: calc(100% + 15px);\n      height: calc(100% + 15px);\n      pointer-events: none;\n    }\n\n    &::before {\n      top: 0;\n      left: 0;\n      border-right-width: 0;\n      border-bottom-width: 0;\n      transform: translate3d(-15px, -15px, 0);\n    }\n\n    &::after {\n      right: 0;\n      bottom: 0;\n      border-top-width: 0;\n      border-left-width: 0;\n      transform: translate3d(15px, 15px, 0);\n    }\n\n    button {\n      position: absolute;\n      top: 3rem;\n      ', '\n      font-size: 2.5rem;\n    }\n\n    input {\n      font-size: 10vw;\n      width: 75%;\n    }\n\n    button {\n      opacity: 0;\n      transform: scale3d(0.8, 0.8, 1);\n      transition: opacity 0.5s, transform 0.5s;\n    }\n\n    .form {\n      opacity: 0;\n      transform: scale3d(0.8, 0.8, 1);\n      transition: opacity 0.5s, transform 0.5s;\n    }\n  }\n\n  &.show {\n    .search {\n      pointer-events: auto;\n      opacity: 1;\n\n      &::before,\n      &::after {\n        transform: translate3d(0, 0, 0);\n        transition: transform 0.5s;\n      }\n\n      button {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n\n      .form {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n    }\n  }\n\n  @media screen and (max-width: 40rem) {\n    .form {\n      margin: 5rem 0 1rem;\n    }\n\n    span {\n      text-align: left;\n    }\n  }\n']);

var modalZoomin = styled.css(_templateObject$t, function (_ref) {
  var theme = _ref.theme;
  return theme.dir === 'rtl' ? 'left: 3rem;' : 'right: 3rem;';
});

var _templateObject$u = taggedTemplateLiteral(['\n  position: absolute;\n  display: block;\n  width: 100vw;\n  height: 100vh;\n  pointer-events: none;\n  opacity: 0;\n  transition-property: opacity;\n  transition-delay: 0.4s;\n\n  .search {\n    display: flex;\n    flex-direction: column;\n    justify-content: center;\n    align-items: center;\n    text-align: center;\n    z-index: 1050;\n    position: fixed;\n    top: 0;\n    left: 0;\n    width: 100%;\n    height: 50vh;\n    pointer-events: none;\n    opacity: 0;\n    transition: opacity 0.5s;\n    transition-timing-function: cubic-bezier(0.2, 1, 0.3, 1);\n\n    button {\n      position: absolute;\n      top: 3rem;\n      ', '\n      font-size: 2.5rem;\n      opacity: 0;\n      transform: scale3d(0.8, 0.8, 1);\n      transition: opacity 0.5s, transform 0.5s;\n      transition-timing-function: cubic-bezier(0.2, 1, 0.3, 1);\n    }\n\n    .form {\n      margin: 5rem 0;\n      opacity: 0;\n      transform: scale3d(0.7, 0.7, 1);\n      transition: opacity 0.5s, transform 0.5s;\n      transition-timing-function: cubic-bezier(0.2, 1, 0.3, 1);\n    }\n\n    input {\n      font-size: 7vw;\n      width: 75%;\n    }\n  }\n\n  &.show {\n    opacity: 1;\n    transition-delay: 0s;\n\n    .search {\n      pointer-events: auto;\n      opacity: 1;\n\n      button {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n\n      .form {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n    }\n  }\n'], ['\n  position: absolute;\n  display: block;\n  width: 100vw;\n  height: 100vh;\n  pointer-events: none;\n  opacity: 0;\n  transition-property: opacity;\n  transition-delay: 0.4s;\n\n  .search {\n    display: flex;\n    flex-direction: column;\n    justify-content: center;\n    align-items: center;\n    text-align: center;\n    z-index: 1050;\n    position: fixed;\n    top: 0;\n    left: 0;\n    width: 100%;\n    height: 50vh;\n    pointer-events: none;\n    opacity: 0;\n    transition: opacity 0.5s;\n    transition-timing-function: cubic-bezier(0.2, 1, 0.3, 1);\n\n    button {\n      position: absolute;\n      top: 3rem;\n      ', '\n      font-size: 2.5rem;\n      opacity: 0;\n      transform: scale3d(0.8, 0.8, 1);\n      transition: opacity 0.5s, transform 0.5s;\n      transition-timing-function: cubic-bezier(0.2, 1, 0.3, 1);\n    }\n\n    .form {\n      margin: 5rem 0;\n      opacity: 0;\n      transform: scale3d(0.7, 0.7, 1);\n      transition: opacity 0.5s, transform 0.5s;\n      transition-timing-function: cubic-bezier(0.2, 1, 0.3, 1);\n    }\n\n    input {\n      font-size: 7vw;\n      width: 75%;\n    }\n  }\n\n  &.show {\n    opacity: 1;\n    transition-delay: 0s;\n\n    .search {\n      pointer-events: auto;\n      opacity: 1;\n\n      button {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n\n      .form {\n        opacity: 1;\n        transform: scale3d(1, 1, 1);\n      }\n    }\n  }\n']);

var rotateLayout = styled.css(_templateObject$u, function (_ref) {
  var theme = _ref.theme;
  return theme.dir === 'rtl' ? 'left: 3rem;' : 'right: 3rem;';
});

var _templateObject$v = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$n = taggedTemplateLiteral(['\n    button {\n      path {\n        fill: ', ';\n      }\n      margin: 0 auto;\n      padding: 0;\n      cursor: pointer;\n      border: none;\n      background: none;\n\n      &:focus {\n        box-shadow: none;\n        outline: none;\n      }\n    }\n  '], ['\n    button {\n      path {\n        fill: ', ';\n      }\n      margin: 0 auto;\n      padding: 0;\n      cursor: pointer;\n      border: none;\n      background: none;\n\n      &:focus {\n        box-shadow: none;\n        outline: none;\n      }\n    }\n  ']),
    _templateObject3$j = taggedTemplateLiteral(['\n  \n    .search {\n      background: ', ';\n\n      button {\n        g {\n          fill: ', ';\n        }\n        margin: 0;\n        padding: 0;\n        cursor: pointer;\n        border: none;\n        background: none;\n\n        &:focus {\n          box-shadow: none;\n          outline: none;\n        }\n      }\n\n      span {\n        color: ', ';\n        font-size: 90%;\n        font-weight: bold;\n        display: block;\n        width: 75%;\n        margin: 0 auto;\n        padding: 0.85rem 0;\n        text-align: right;\n      }\n\n      input {\n        color: ', ';\n        border-bottom: 4px solid ', ';\n        border-top: 0;\n        border-right: 0;\n        border-left: 0;\n        background: transparent;\n        border-radius: 0;\n        line-height: 1;\n        display: inline-block;\n        box-sizing: border-box;\n        padding: 0.05rem 0;\n        -webkit-appearance: none;\n\n        &::placeholder {\n          color: ', ';\n          opacity: 0.3;\n        }\n        &:focus {\n          outline: none;\n        }\n\n\n        &::-ms-clear {\n          display: none;\n        }\n      }\n    }\n\n    &.rotate-layout {\n      ', '\n      background: ', ';\n    }\n\n    &.modal-zoomin {\n      ', '\n      .search::before,\n      .search::after {\n        border: 1.5rem solid ', ';\n      }\n    }\n\n    &.modal-half {\n      ', '\n      .form-wrapper {\n        background: ', ';\n      }\n      .search::before {\n        background: ', ';\n      }\n    }\n    &.modal-move {\n      ', '\n    }\n\n    &.modal-drop {\n      .form-content::after {\n        background: ', ';\n      }\n      .search::before {\n        background: ', ';\n      }\n      ', '\n    }\n\n    &.curtain {\n      ', '\n      .search::after {\n        background: ', ';\n      }\n      .search {\n        background: ', ';\n      }\n    }\n\n    &.column-curtain {\n      ', '\n      &::before {\n        background: ', ';\n      }\n      &::after {\n        background: transparent;\n      }\n      &.show::after {\n        background: ', ';\n      }\n    }\n  '], ['\n  \n    .search {\n      background: ', ';\n\n      button {\n        g {\n          fill: ', ';\n        }\n        margin: 0;\n        padding: 0;\n        cursor: pointer;\n        border: none;\n        background: none;\n\n        &:focus {\n          box-shadow: none;\n          outline: none;\n        }\n      }\n\n      span {\n        color: ', ';\n        font-size: 90%;\n        font-weight: bold;\n        display: block;\n        width: 75%;\n        margin: 0 auto;\n        padding: 0.85rem 0;\n        text-align: right;\n      }\n\n      input {\n        color: ', ';\n        border-bottom: 4px solid ', ';\n        border-top: 0;\n        border-right: 0;\n        border-left: 0;\n        background: transparent;\n        border-radius: 0;\n        line-height: 1;\n        display: inline-block;\n        box-sizing: border-box;\n        padding: 0.05rem 0;\n        -webkit-appearance: none;\n\n        &::placeholder {\n          color: ', ';\n          opacity: 0.3;\n        }\n        &:focus {\n          outline: none;\n        }\n\n\n        &::-ms-clear {\n          display: none;\n        }\n      }\n    }\n\n    &.rotate-layout {\n      ', '\n      background: ', ';\n    }\n\n    &.modal-zoomin {\n      ', '\n      .search::before,\n      .search::after {\n        border: 1.5rem solid ', ';\n      }\n    }\n\n    &.modal-half {\n      ', '\n      .form-wrapper {\n        background: ', ';\n      }\n      .search::before {\n        background: ', ';\n      }\n    }\n    &.modal-move {\n      ', '\n    }\n\n    &.modal-drop {\n      .form-content::after {\n        background: ', ';\n      }\n      .search::before {\n        background: ', ';\n      }\n      ', '\n    }\n\n    &.curtain {\n      ', '\n      .search::after {\n        background: ', ';\n      }\n      .search {\n        background: ', ';\n      }\n    }\n\n    &.column-curtain {\n      ', '\n      &::before {\n        background: ', ';\n      }\n      &::after {\n        background: transparent;\n      }\n      &.show::after {\n        background: ', ';\n      }\n    }\n  ']);

var SearchStyle = styled__default.div(_templateObject$v, function (_ref) {
  var theme = _ref.theme;
  return styled.css(_templateObject2$n, theme.searchBtnOpenFg);
});

var SearchFieldStyle = styled__default.div(_templateObject$v, function (_ref2) {
  var theme = _ref2.theme;
  return styled.css(_templateObject3$j, theme.searchBg, theme.searchBtnCloseFg, theme.searchInfo, theme.searchText, theme.searchDash, theme.searchPlaceholder, rotateLayout, theme.searchBg, modalZoomin, theme.searchBgSecondary, modalHalf, theme.searchBg, theme.searchBgSecondary, modalMove, theme.searchDash, theme.searchBg, modalDrop, curtain, theme.searchBg, theme.searchBg, columnCurtain, theme.searchBg, theme.searchBgSecondary);
});

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

function Search$1(props) {
  var _useState = React.useState(''),
      _useState2 = slicedToArray(_useState, 2),
      value = _useState2[0],
      setValue = _useState2[1];

  var _useState3 = React.useState(),
      _useState4 = slicedToArray(_useState3, 2),
      show = _useState4[0],
      setShow = _useState4[1];

  var inputRef = React.useRef();
  var layout = React.useContext(layoutContext);

  React.useEffect(function () {
    if (show === 'show') {
      inputRef.current.focus();
    } else if (show === undefined) {
      layout.removeClass([props.type]);
    }
  }, [show]);

  var handleOpen = function handleOpen() {
    setShow('');
    layout.addClass([props.type, 'with-search']);
    setTimeout(function () {
      setShow('show');
    }, 50);
  };

  var handleClose = function handleClose() {
    layout.removeClass(['with-search']);
    setShow('');
    setTimeout(function () {
      setShow(undefined);
    }, 200);
  };

  var onChangeHandle = function onChangeHandle(e) {
    typeof props.onChange === 'function' && props.onChange(e.target.value);
    setValue(e.target.value);
  };

  return React__default.createElement(
    SearchStyle,
    { className: props.className },
    React__default.createElement(
      'button',
      { onClick: handleOpen },
      React__default.createElement(SearchIcon, null)
    ),
    show !== undefined && React__default.createElement(
      Overlay,
      null,
      React__default.createElement(
        SearchFieldStyle,
        { className: props.type + ' ' + show },
        React__default.createElement(
          'div',
          {
            className: 'search',
            onKeyUp: function onKeyUp(e) {
              e.preventDefault();
              e.key === 'Escape' && handleClose();
            }
          },
          React__default.createElement(
            'button',
            { onClick: handleClose },
            React__default.createElement(CloseCircled$1, null)
          ),
          React__default.createElement(
            'div',
            { className: 'form-wrapper' },
            React__default.createElement(
              'div',
              { className: 'form' },
              React__default.createElement(
                'div',
                { className: 'form-content' },
                React__default.createElement('input', {
                  ref: inputRef,
                  onKeyUp: function onKeyUp(e) {
                    e.preventDefault();
                    if (e.key === 'Enter') {
                      handleClose();
                      props.submit(value);
                    }
                  },
                  onChange: onChangeHandle,
                  placeholder: props.placeholder,
                  className: 'search-input',
                  autoComplete: 'off',
                  tabIndex: '-1',
                  value: value
                })
              ),
              React__default.createElement(
                'span',
                { className: 'info' },
                props.hint
              )
            )
          )
        )
      )
    )
  );
}
Search$1.propTypes = {
  hint: PropTypes.string,
  placeholder: PropTypes.string,
  submit: PropTypes.func.isRequired,
  onChange: PropTypes.func,
  type: PropTypes.oneOf(['rotate-layout', 'modal-zoomin', 'modal-move', 'modal-drop', 'modal-half', 'curtain', 'column-curtain']).isRequired
};

var _templateObject$w = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$o = taggedTemplateLiteral(['\n    font-size: ', ';\n    line-height: ', ';\n    display: flex;\n\n    .user-container {\n      position: relative;\n      display: flex;\n      align-items: center;\n    }\n\n    .user-picture {\n      background: ', ';\n      border: solid 2px ', ';\n      position: relative;\n      border-radius: 50%;\n      flex-shrink: 0;\n      ', '\n\n      &.background {\n        color: ', ';\n        display: flex;\n        align-items: center;\n        justify-content: center;\n        ', '\n      }\n      &.image {\n      ', '\n        background-size: cover;\n        background-repeat: no-repeat;\n      }\n    }\n\n    .user-name {\n      font-family: ', ';\n    }\n\n    .user-title {\n      font-size: 0.75rem;\n    }\n\n    .user-name,\n    .user-title {\n      text-align: ', ';\n    }\n\n    .info-container {\n      margin-', ': 0.5rem;\n    }\n\n    &.inverse {\n      .user-picture {\n        background: ', ';\n\n        &.background {\n          color: ', ';\n        }\n      }\n    }\n  '], ['\n    font-size: ', ';\n    line-height: ', ';\n    display: flex;\n\n    .user-container {\n      position: relative;\n      display: flex;\n      align-items: center;\n    }\n\n    .user-picture {\n      background: ', ';\n      border: solid 2px ', ';\n      position: relative;\n      border-radius: 50%;\n      flex-shrink: 0;\n      ', '\n\n      &.background {\n        color: ', ';\n        display: flex;\n        align-items: center;\n        justify-content: center;\n        ', '\n      }\n      &.image {\n      ', '\n        background-size: cover;\n        background-repeat: no-repeat;\n      }\n    }\n\n    .user-name {\n      font-family: ', ';\n    }\n\n    .user-title {\n      font-size: 0.75rem;\n    }\n\n    .user-name,\n    .user-title {\n      text-align: ', ';\n    }\n\n    .info-container {\n      margin-', ': 0.5rem;\n    }\n\n    &.inverse {\n      .user-picture {\n        background: ', ';\n\n        &.background {\n          color: ', ';\n        }\n      }\n    }\n  ']),
    _templateObject3$k = taggedTemplateLiteral(['\n          height: ', ';\n          width: ', ';\n          ', '\n        '], ['\n          height: ', ';\n          width: ', ';\n          ', '\n        ']);

var UserStyle = styled__default.div(_templateObject$w, function (_ref) {
  var theme = _ref.theme,
      size = _ref.size,
      image = _ref.image,
      color = _ref.color;
  return styled.css(_templateObject2$o, theme.userFontSize, theme.userLineHeight, theme.userBg, theme.userFgHighlight, size && styled.css(_templateObject3$k, theme['userSize' + size], theme['userSize' + size], size === 'Small' && 'font-size: 80%;'), theme.userFg, color && 'background-color: ' + color + ';', image && 'background-image: ' + image + ';', theme.userFontFamilySecondary, theme.dir === 'rtl' ? 'right' : 'left', theme.dir === 'rtl' ? 'right' : 'left', theme.userFg, theme.userBg);
});

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

function User(props) {
  var getInitials = function getInitials() {
    if (props.name) {
      var names = props.name.split(' ');

      return names.map(function (n) {
        return n.charAt(0);
      }).splice(0, 2).join('').toUpperCase();
    }

    return '';
  };
  return React__default.createElement(
    UserStyle,
    props,
    React__default.createElement(
      'div',
      { className: 'user-container' },
      React__default.createElement(
        'div',
        {
          className: 'user-picture ' + (props.image ? 'image' : 'background')
        },
        !props.image && props.showInitials && getInitials(),
        props.badge && React__default.createElement(
          Badge,
          { status: props.badge.status, position: props.badge.position },
          props.badge.title
        )
      ),
      !props.onlyPicture && React__default.createElement(
        'div',
        { className: 'info-container' },
        React__default.createElement(
          'div',
          { className: 'user-name' },
          props.name
        ),
        React__default.createElement(
          'div',
          { className: 'user-title' },
          props.title
        )
      )
    )
  );
}
User.defaultProps = {
  size: 'MD',
  showInitials: true
};

User.propTypes = {
  size: PropTypes.oneOf(['SM', 'MD', 'LG', 'XL']),
  name: PropTypes.string,
  title: PropTypes.string,
  color: PropTypes.string,
  image: PropTypes.string,
  showInitials: PropTypes.bool,
  onlyPicture: PropTypes.bool,
  inverse: PropTypes.bool,
  badge: PropTypes.object
};

var _templateObject$x = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$p = taggedTemplateLiteral(['\n    display: flex;\n    flex-direction: column;\n    position: relative;\n\n    font-size: ', ';\n    line-height: ', ';\n    font-weight: ', ';\n\n    background: ', ';\n    color: ', ';\n    margin-bottom: ', ';\n    border-radius: ', ';\n    box-shadow: ', ';\n    padding: ', ';\n\n    ', '\n\n    ', '\n\n    ', '\n\n    ', '\n\n    .close {\n      padding: ', ';\n      font-size: 1.5rem;\n      line-height: 1;\n      cursor: pointer;\n      font-family: monospace;\n\n      position: absolute;\n      top: 0;\n      ', ': 0;\n      color: inherit;\n      background-color: transparent;\n      border: 0;\n      -webkit-appearance: none;\n    }\n    ', '\n  '], ['\n    display: flex;\n    flex-direction: column;\n    position: relative;\n\n    font-size: ', ';\n    line-height: ', ';\n    font-weight: ', ';\n\n    background: ', ';\n    color: ', ';\n    margin-bottom: ', ';\n    border-radius: ', ';\n    box-shadow: ', ';\n    padding: ', ';\n\n    ', '\n\n    ', '\n\n    ', '\n\n    ', '\n\n    .close {\n      padding: ', ';\n      font-size: 1.5rem;\n      line-height: 1;\n      cursor: pointer;\n      font-family: monospace;\n\n      position: absolute;\n      top: 0;\n      ', ': 0;\n      color: inherit;\n      background-color: transparent;\n      border: 0;\n      -webkit-appearance: none;\n    }\n    ', '\n  ']),
    _templateObject3$l = taggedTemplateLiteral(['\n        background-color: ', ';\n        color: ', ';\n      '], ['\n        background-color: ', ';\n        color: ', ';\n      ']),
    _templateObject4$d = taggedTemplateLiteral(['\n        border-top-style: solid;\n        border-top-width: ', ';\n        border-top-color: ', ';\n      '], ['\n        border-top-style: solid;\n        border-top-width: ', ';\n        border-top-color: ', ';\n      ']),
    _templateObject5$a = taggedTemplateLiteral(['\n        border: 2px solid ', ';\n      '], ['\n        border: 2px solid ', ';\n      ']),
    _templateObject6$6 = taggedTemplateLiteral(['\n        padding-right: ', ';\n      '], ['\n        padding-right: ', ';\n      ']);

var AlertStyle = styled__default.div(_templateObject$x, function (_ref) {
  var theme = _ref.theme,
      size$$1 = _ref.size,
      status = _ref.status,
      accent = _ref.accent,
      outline = _ref.outline,
      closable = _ref.closable;
  return styled.css(_templateObject2$p, theme.alertFontSize, theme.alertLineHeight, theme.alertFontWeight, theme.alertBg, theme.alertOutlineFg, theme.alertMargin, theme.alertBorderRadius, theme.alertShadow, theme.alertPadding, size$$1 && 'height: ' + theme['alertHeight' + size$$1] + ';', status && styled.css(_templateObject3$l, theme['alert' + status + 'Bg'], status === 'Disabled' ? theme.alertDisabledFg : theme.alertFg), accent && styled.css(_templateObject4$d, theme.alertBorderRadius, theme['alert' + accent + 'Bg']), outline && styled.css(_templateObject5$a, theme['alert' + outline + 'Bg']), theme.alertPadding, theme.dir === 'rtl' ? 'left' : 'right', closable && styled.css(_templateObject6$6, theme.alertClosablePadding));
});

function Alert(props) {
  return React__default.createElement(
    AlertStyle,
    props,
    props.closable && React__default.createElement(
      'button',
      {
        onClick: props.onClose,
        type: 'button',
        className: 'close',
        'aria-label': 'Close'
      },
      React__default.createElement(
        'span',
        { 'aria-hidden': 'true' },
        '\xD7'
      )
    ),
    props.children
  );
}
var status = PropTypes.oneOf([].concat(toConsumableArray(statusArray), ['Active', 'Disabled']));
Alert.propTypes = {
  size: size,
  status: status,
  accent: status,
  outline: status,
  closable: PropTypes.bool,
  onClose: PropTypes.func
};

var _templateObject$y = taggedTemplateLiteral(['\n  0% {\n    transform: rotate(0deg);\n  }\n  40% {\n    transform: rotate(230deg);\n  }\n  100% {\n    transform: rotate(360deg);\n  }\n'], ['\n  0% {\n    transform: rotate(0deg);\n  }\n  40% {\n    transform: rotate(230deg);\n  }\n  100% {\n    transform: rotate(360deg);\n  }\n']),
    _templateObject2$q = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject3$m = taggedTemplateLiteral(['\n    opacity: 1;\n    position: absolute;\n    border-radius: inherit;\n    top: 0;\n    right: 0;\n    left: 0;\n    bottom: 0;\n    overflow: hidden;\n    z-index: 999;\n    display: flex;\n    justify-content: center;\n    align-items: center;\n    visibility: visible;\n    background-color: ', ';\n     ', ';\n    }\n\n    .spin-circle {\n      animation: ', ' 0.8s infinite linear;\n      border-radius: 50%;\n      border-style: solid;\n      border-width: 0.125em;\n      width: 1em;\n      height: 1em;\n      border-left-color: ', ';\n      border-top-color: ', ';\n      border-bottom-color: ', ';\n      ', '\n    }\n\n    .message {\n      margin-left: 0.5rem;\n      line-height: 1rem;\n      font-size: 1rem;\n      color: ', ';\n    }\n  '], ['\n    opacity: 1;\n    position: absolute;\n    border-radius: inherit;\n    top: 0;\n    right: 0;\n    left: 0;\n    bottom: 0;\n    overflow: hidden;\n    z-index: 999;\n    display: flex;\n    justify-content: center;\n    align-items: center;\n    visibility: visible;\n    background-color: ', ';\n     ', ';\n    }\n\n    .spin-circle {\n      animation: ', ' 0.8s infinite linear;\n      border-radius: 50%;\n      border-style: solid;\n      border-width: 0.125em;\n      width: 1em;\n      height: 1em;\n      border-left-color: ', ';\n      border-top-color: ', ';\n      border-bottom-color: ', ';\n      ', '\n    }\n\n    .message {\n      margin-left: 0.5rem;\n      line-height: 1rem;\n      font-size: 1rem;\n      color: ', ';\n    }\n  ']);

var spin = styled.keyframes(_templateObject$y);

var SpinnerStyle = styled__default.div(_templateObject2$q, function (_ref) {
  var theme = _ref.theme,
      size$$1 = _ref.size,
      status = _ref.status;
  return styled.css(_templateObject3$m, theme.spinnerBg, size$$1 && 'font-size: ' + theme['spinner' + size$$1], spin, theme.spinnerCircleBg, theme.spinnerCircleBg, theme.spinnerCircleBg, status && 'border-right-color: ' + theme['spinner' + status + 'Bg'] + ';', theme.spinnerFg);
});

function Spinner(props) {
  return React__default.createElement(
    SpinnerStyle,
    props,
    React__default.createElement('span', { className: 'spin-circle' }),
    React__default.createElement(
      'span',
      { className: 'message' },
      props.children
    )
  );
}
Spinner.propTypes = {
  size: size,
  status: PropTypes.oneOf([].concat(toConsumableArray(statusArray), ['Active', 'Disabled']))
};

var _templateObject$z = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$r = taggedTemplateLiteral(['\n    overflow: hidden;\n    display: block;\n    height: ', ';\n    border-radius: ', ';\n    background-color: ', ';\n    .progress-value {\n      height: 100%;\n      width: ', '%;\n      text-align: center;\n      overflow: hidden;\n      background-color: ', ';\n      color: ', ';\n      font-size: ', ';\n      font-weight: ', ';\n      line-height: ', ';\n      transition-duration: ', ';\n      transition-property: width, background-color;\n    }\n  '], ['\n    overflow: hidden;\n    display: block;\n    height: ', ';\n    border-radius: ', ';\n    background-color: ', ';\n    .progress-value {\n      height: 100%;\n      width: ', '%;\n      text-align: center;\n      overflow: hidden;\n      background-color: ', ';\n      color: ', ';\n      font-size: ', ';\n      font-weight: ', ';\n      line-height: ', ';\n      transition-duration: ', ';\n      transition-property: width, background-color;\n    }\n  ']);

var ProgressStyle = styled__default.div(_templateObject$z, function (_ref) {
  var theme = _ref.theme,
      size$$1 = _ref.size,
      status = _ref.status,
      value = _ref.value;
  return styled.css(_templateObject2$r, theme['progressBarHeight' + size$$1], theme.progressBarRadius, theme.progressBarBg, value, theme['progressBar' + status + 'Bg'], theme.progressBarFontColor, theme['progressBarFontSize' + size$$1], theme.progressBarFontWeight, theme.progressBarLineHeight, theme.progressBarAnimationDuration);
});

function Progress(props) {
  return React__default.createElement(
    ProgressStyle,
    props,
    React__default.createElement(
      'div',
      { className: 'progress-value' },
      props.displayValue && React__default.createElement(
        'span',
        null,
        props.value,
        '%'
      ),
      props.children
    )
  );
}

Progress.defaultProps = {
  size: 'MD',
  status: 'Default',
  value: 0
};

Progress.propTypes = {
  size: PropTypes.oneOf(['XS', 'SM', 'MD', 'LG', 'XL']),
  status: PropTypes.oneOf([].concat(toConsumableArray(statusArray), ['Default'])),
  value: PropTypes.number,
  displayValue: PropTypes.bool
};

var _templateObject$A = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$s = taggedTemplateLiteral(['\n      position: absolute;\n      box-sizing: border-box;\n      z-index: 1000;\n      display: flex;\n      width: 100%;\n      height: 100%;\n      min-width: 1px;\n      min-height: 1px;\n      top: 0px;\n      left: 0px;\n      .overlay-pane {\n        ', '\n        position: absolute;\n        pointer-events: auto;\n        display: flex;\n        max-width: 100%;\n        max-height: 100%;\n        box-sizing: border-box;\n        ', '\n        .popover {\n          border: 2px solid ', ';\n          border-radius: ', ';\n          background: ', ';\n          box-shadow: ', ';\n\n          .primitive-overlay {\n            color: ', ';\n            padding: 0.75rem 1rem;\n          }\n\n          .arrow {\n            position: absolute;\n            width: 0;\n            height: 0;\n            border-left: ', 'px solid transparent;\n            border-right: ', 'px solid transparent;\n            border-bottom: ', 'px solid ', ';\n\n            &::after {\n              position: absolute;\n              content: \' \';\n              width: 0;\n              height: 0;\n              top: 3px;\n              left: calc(50% - ', 'px);\n              border-left: ', 'px solid transparent;\n              border-right: ', 'px solid transparent;\n              border-bottom: ', 'px solid ', ';\n              clip-path: inset(0 0 2px);\n            }\n          }\n          ', '\n        }\n      }\n    '], ['\n      position: absolute;\n      box-sizing: border-box;\n      z-index: 1000;\n      display: flex;\n      width: 100%;\n      height: 100%;\n      min-width: 1px;\n      min-height: 1px;\n      top: 0px;\n      left: 0px;\n      .overlay-pane {\n        ', '\n        position: absolute;\n        pointer-events: auto;\n        display: flex;\n        max-width: 100%;\n        max-height: 100%;\n        box-sizing: border-box;\n        ', '\n        .popover {\n          border: 2px solid ', ';\n          border-radius: ', ';\n          background: ', ';\n          box-shadow: ', ';\n\n          .primitive-overlay {\n            color: ', ';\n            padding: 0.75rem 1rem;\n          }\n\n          .arrow {\n            position: absolute;\n            width: 0;\n            height: 0;\n            border-left: ', 'px solid transparent;\n            border-right: ', 'px solid transparent;\n            border-bottom: ', 'px solid ', ';\n\n            &::after {\n              position: absolute;\n              content: \' \';\n              width: 0;\n              height: 0;\n              top: 3px;\n              left: calc(50% - ', 'px);\n              border-left: ', 'px solid transparent;\n              border-right: ', 'px solid transparent;\n              border-bottom: ', 'px solid ', ';\n              clip-path: inset(0 0 2px);\n            }\n          }\n          ', '\n        }\n      }\n    ']),
    _templateObject3$n = taggedTemplateLiteral(['\n        .arrow {\n          left: ', 'px;\n          top: calc(50% - ', 'px);\n          transform: rotate(270deg);\n        }\n      '], ['\n        .arrow {\n          left: ', 'px;\n          top: calc(50% - ', 'px);\n          transform: rotate(270deg);\n        }\n      ']),
    _templateObject4$e = taggedTemplateLiteral(['\n        .arrow {\n          right: ', 'px;\n          top: calc(50% - ', 'px);\n          transform: rotate(90deg);\n        }\n      '], ['\n        .arrow {\n          right: ', 'px;\n          top: calc(50% - ', 'px);\n          transform: rotate(90deg);\n        }\n      ']),
    _templateObject5$b = taggedTemplateLiteral(['\n        .arrow {\n          bottom: calc(-', 'px + 1px);\n          left: calc(50% - ', 'px);\n          transform: rotate(180deg);\n        }\n      '], ['\n        .arrow {\n          bottom: calc(-', 'px + 1px);\n          left: calc(50% - ', 'px);\n          transform: rotate(180deg);\n        }\n      ']),
    _templateObject6$7 = taggedTemplateLiteral(['\n        .arrow {\n          top: calc(-', 'px + 2px);\n          left: calc(50% - ', 'px);\n        }\n      '], ['\n        .arrow {\n          top: calc(-', 'px + 2px);\n          left: calc(50% - ', 'px);\n        }\n      ']);

var PopoverStyle = styled__default.div(_templateObject$A, function (_ref) {
  var theme = _ref.theme,
      placement = _ref.placement,
      position = _ref.position;

  var arrowSize = theme.popoverArrowSize;
  var arrowRound = Math.round(-arrowSize - arrowSize / 2 + 1);

  return styled.css(_templateObject2$s, overlayPane(placement), !position && 'visibility: hidden;', theme.popoverBorder, theme.popoverBorderRadius, theme.popoverBg, theme.popoverShadow, theme.popoverFg, arrowSize, arrowSize, arrowSize, theme.popoverBorder, arrowSize, arrowSize, arrowSize, arrowSize, theme.popoverBg, placementArrow(placement, arrowSize, arrowRound));
});
var overlayPane = function overlayPane(placement) {
  switch (placement) {
    case 'right':
      return 'transform: translateX(15px);';
    case 'left':
      return 'transform: translateX(-15px);';
    case 'top':
      return 'transform: translateY(-15px);';
    case 'bottom':
      return 'transform: translateY(15px);';
  }
};
var placementArrow = function placementArrow(placement, arrowSize, arrowRound) {
  switch (placement) {
    case 'right':
      return styled.css(_templateObject3$n, arrowRound, arrowSize / 2);
    case 'left':
      return styled.css(_templateObject4$e, arrowRound, arrowSize / 2);
    case 'top':
      return styled.css(_templateObject5$b, arrowSize, arrowSize);
    case 'bottom':
      return styled.css(_templateObject6$7, arrowSize, arrowSize);
  }
};

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

function usePopoverPosition(props, targetRef, overlayRef) {
  var layout = React.useContext(layoutContext);

  var _useState = React.useState(),
      _useState2 = slicedToArray(_useState, 2),
      position = _useState2[0],
      setPosition = _useState2[1];

  var _useState3 = React.useState(false),
      _useState4 = slicedToArray(_useState3, 2),
      show = _useState4[0],
      setShow = _useState4[1];

  var _useState5 = React.useState(),
      _useState6 = slicedToArray(_useState5, 2),
      placement = _useState6[0],
      setPlacement = _useState6[1];

  React.useEffect(function () {
    if (show) {
      positionHandle();
      window.addEventListener('resize', positionHandle);
      document.querySelector('.scrollable-container').addEventListener('scroll', positionHandle);
      if (props.eventListener) {
        document.querySelector(props.eventListener).addEventListener('scroll', positionHandle);
      }

      return function () {
        window.removeEventListener('resize', positionHandle);
        document.querySelector('.scrollable-container').removeEventListener('scroll', positionHandle);
        if (props.eventListener) {
          document.querySelector(props.eventListener).removeEventListener('scroll', positionHandle);
        }
      };
    }
  }, [show, overlayRef.current]);

  var positionHandle = function positionHandle() {
    var placement = getPhysicalPosition(layout.dir, props.placement);
    var data = getAdjustmentPlacement(placement, targetRef, overlayRef);
    setPosition(data.position);
    setPlacement(data.placement);
  };

  return [position, placement, show, setShow];
}

var getAdjustmentPlacement = function getAdjustmentPlacement(placement, targetRef, overlayRef) {
  var key = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 1;

  var target = targetRef.current.getBoundingClientRect();
  var overlay = overlayRef.current.getBoundingClientRect();

  if (key > 4) {
    var maxPlacement = getMaxPlacement(target, overlay);
    var _position = getPositionOfPlacement(maxPlacement, target, overlay);
    return { placement: maxPlacement, position: _position };
  }
  var position = getPositionOfPlacement(placement, target, overlay);
  var topBottom = position.top < 0 || position.bottom < 0;
  var leftRight = position.left < 0 || position.right < 0;
  switch (placement) {
    case 'left':
      if (position.left - 15 < 0 || topBottom) {
        return getAdjustmentPlacement('top', targetRef, overlayRef, key + 1);
      }
      break;
    case 'top':
      if (position.top - 15 < 0 || leftRight) {
        return getAdjustmentPlacement('right', targetRef, overlayRef, key + 1);
      }
      break;
    case 'right':
      if (window.innerWidth - position.left - 15 < overlay.width || topBottom) {
        return getAdjustmentPlacement('bottom', targetRef, overlayRef, key + 1);
      }
      break;
    case 'bottom':
      if (window.innerHeight - position.top - 15 < overlay.height || leftRight) {
        return getAdjustmentPlacement('left', targetRef, overlayRef, key + 1);
      }
      break;
  }
  return { placement: placement, position: position };
};

var getMaxPlacement = function getMaxPlacement(target, overlay) {
  var positions = {
    top: target.top - overlay.height,
    bottom: window.innerHeight - target.bottom - overlay.height,
    left: target.left - overlay.width,
    right: window.innerWidth - target.right - overlay.width
  };
  var arr = Object.values(positions);
  var max = Math.max.apply(Math, toConsumableArray(arr));
  for (var key in positions) {
    if (positions.hasOwnProperty(key) && positions[key] === max) {
      return key;
    }
  }
};

var getPositionOfPlacement = function getPositionOfPlacement(placement, target, overlay) {
  var topBottom = {
    top: target.top + target.height / 2 - overlay.height / 2,
    bottom: window.innerHeight - (target.top + target.height / 2 + overlay.height / 2)
  };
  var leftRight = {
    left: target.left + (target.width / 2 - overlay.width / 2),
    right: window.innerWidth - (target.left + target.width / 2 + overlay.width / 2)
  };
  switch (placement) {
    case 'left':
      return _extends({
        left: target.left - overlay.width
      }, topBottom);
    case 'right':
      return _extends({
        left: target.right
      }, topBottom);
    case 'top':
      return _extends({
        top: target.top - overlay.height
      }, leftRight);
    case 'bottom':
      return _extends({
        top: target.bottom
      }, leftRight);
  }
};

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

function Popover(props) {
  var overlayRef = React.useRef();
  var targetRef = React.useRef();

  var _usePopoverPosition = usePopoverPosition(props, targetRef, overlayRef),
      _usePopoverPosition2 = slicedToArray(_usePopoverPosition, 4),
      position$$1 = _usePopoverPosition2[0],
      placement$$1 = _usePopoverPosition2[1],
      show = _usePopoverPosition2[2],
      setShow = _usePopoverPosition2[3];

  return React__default.createElement(
    React.Fragment,
    null,
    show && ReactDOM.createPortal(React__default.createElement(
      PopoverStyle,
      { position: position$$1, placement: placement$$1 },
      React__default.createElement(
        'div',
        {
          className: 'overlay-pane',
          style: position$$1 && { top: position$$1.top, left: position$$1.left },
          ref: overlayRef
        },
        React__default.createElement(
          'div',
          { className: 'popover' },
          React__default.createElement('span', { className: 'arrow' }),
          typeof props.overlay === 'string' ? React__default.createElement(
            'div',
            { className: 'primitive-overlay' },
            props.overlay
          ) : props.overlay
        )
      )
    ), document.getElementById('overlay-container')),
    React__default.createElement(
      'div',
      {
        style: props.style,
        className: props.className,
        ref: targetRef,
        onFocus: function onFocus() {
          return props.trigger === 'focus' && setShow(true);
        },
        onBlur: function onBlur() {
          return props.trigger === 'focus' && setShow(false);
        },
        onClick: function onClick() {
          return props.trigger === 'click' && setShow(!show);
        },
        onMouseEnter: function onMouseEnter() {
          return props.trigger === 'hover' && setShow(true);
        },
        onMouseLeave: function onMouseLeave() {
          return props.trigger === 'hover' && setShow(false);
        }
      },
      props.children
    )
  );
}

Popover.propTypes = {
  eventListener: PropTypes.string,
  trigger: trigger.isRequired,
  placement: placement.isRequired,
  overlay: PropTypes.any.isRequired,
  children: PropTypes.node.isRequired,
  style: PropTypes.object,
  className: PropTypes.string
};

var _templateObject$B = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$t = taggedTemplateLiteral(['\n      position: absolute;\n      box-sizing: border-box;\n      z-index: 1000;\n      display: flex;\n      width: 100%;\n      height: 100%;\n      min-width: 1px;\n      min-height: 1px;\n      top: 0px;\n      left: 0px;\n      .overlay-pane {\n        ', '\n        position: absolute;\n        pointer-events: auto;\n        display: flex;\n        max-width: 100%;\n        max-height: 100%;\n        box-sizing: border-box;\n        ', '\n        .tooltip {\n          background: ', ';\n          z-index: 10000;\n          border-radius: 5px;\n          .content {\n            padding: 0.5rem 1.25rem;\n            display: flex;\n            align-items: center;\n            font-size: ', ';\n            color: ', ';\n          }\n\n          .arrow {\n            position: absolute;\n            width: 0;\n            height: 0;\n            border-bottom: ', 'px solid ', ';\n            border-left: ', 'px solid transparent;\n            border-right: ', 'px solid transparent;\n          }\n\n          .icon {\n            font-size: 1.25rem;\n          }\n\n          span {\n            line-height: 1.25rem;\n          }\n\n          .icon + span {\n            margin-left: 0.5rem;\n          }\n          ', '\n        }\n      }\n    '], ['\n      position: absolute;\n      box-sizing: border-box;\n      z-index: 1000;\n      display: flex;\n      width: 100%;\n      height: 100%;\n      min-width: 1px;\n      min-height: 1px;\n      top: 0px;\n      left: 0px;\n      .overlay-pane {\n        ', '\n        position: absolute;\n        pointer-events: auto;\n        display: flex;\n        max-width: 100%;\n        max-height: 100%;\n        box-sizing: border-box;\n        ', '\n        .tooltip {\n          background: ', ';\n          z-index: 10000;\n          border-radius: 5px;\n          .content {\n            padding: 0.5rem 1.25rem;\n            display: flex;\n            align-items: center;\n            font-size: ', ';\n            color: ', ';\n          }\n\n          .arrow {\n            position: absolute;\n            width: 0;\n            height: 0;\n            border-bottom: ', 'px solid ', ';\n            border-left: ', 'px solid transparent;\n            border-right: ', 'px solid transparent;\n          }\n\n          .icon {\n            font-size: 1.25rem;\n          }\n\n          span {\n            line-height: 1.25rem;\n          }\n\n          .icon + span {\n            margin-left: 0.5rem;\n          }\n          ', '\n        }\n      }\n    ']),
    _templateObject3$o = taggedTemplateLiteral(['\n        .content {\n          flex-direction: row-reverse;\n        }\n        .icon + span {\n          margin-right: 0.5rem;\n        }\n        .arrow {\n          left: ', 'px;\n          top: calc(50% - ', 'px);\n          transform: rotate(270deg);\n        }\n      '], ['\n        .content {\n          flex-direction: row-reverse;\n        }\n        .icon + span {\n          margin-right: 0.5rem;\n        }\n        .arrow {\n          left: ', 'px;\n          top: calc(50% - ', 'px);\n          transform: rotate(270deg);\n        }\n      ']),
    _templateObject4$f = taggedTemplateLiteral(['\n        .arrow {\n          right: ', 'px;\n          top: calc(50% - ', 'px);\n          transform: rotate(90deg);\n        }\n      '], ['\n        .arrow {\n          right: ', 'px;\n          top: calc(50% - ', 'px);\n          transform: rotate(90deg);\n        }\n      ']),
    _templateObject5$c = taggedTemplateLiteral(['\n        .arrow {\n          bottom: calc(-', 'px + 1px);\n          left: calc(50% - ', 'px);\n          transform: rotate(180deg);\n        }\n      '], ['\n        .arrow {\n          bottom: calc(-', 'px + 1px);\n          left: calc(50% - ', 'px);\n          transform: rotate(180deg);\n        }\n      ']),
    _templateObject6$8 = taggedTemplateLiteral(['\n        .arrow {\n          top: calc(-', 'px + 2px);\n          left: calc(50% - ', 'px);\n        }\n      '], ['\n        .arrow {\n          top: calc(-', 'px + 2px);\n          left: calc(50% - ', 'px);\n        }\n      ']);

var TooltipStyle = styled__default.div(_templateObject$B, function (_ref) {
  var theme = _ref.theme,
      status = _ref.status,
      placement = _ref.placement,
      position = _ref.position;

  var arrowSize = 5;
  var color = status ? theme['tooltip' + status + 'Bg'] : theme.tooltipBg;
  var arrowRound = Math.round(-arrowSize - arrowSize / 2 + 1.5);

  return styled.css(_templateObject2$t, overlayPane$1(placement), !position && 'visibility: hidden;', color, theme.tooltipFontSize, status ? theme.tooltipStatusFg : theme.tooltipFg, arrowSize, color, arrowSize, arrowSize, placementArrow$1(placement, arrowSize, arrowRound));
});
var overlayPane$1 = function overlayPane(placement) {
  switch (placement) {
    case 'right':
      return 'transform: translateX(5px);';
    case 'left':
      return 'transform: translateX(-5px);';
    case 'top':
      return 'transform: translateY(-5px);';
    case 'bottom':
      return 'transform: translateY(5px);';
  }
};
var placementArrow$1 = function placementArrow(placement, arrowSize, arrowRound) {
  switch (placement) {
    case 'right':
      return styled.css(_templateObject3$o, arrowRound, arrowSize / 2.5);
    case 'left':
      return styled.css(_templateObject4$f, arrowRound, arrowSize / 2.5);
    case 'top':
      return styled.css(_templateObject5$c, arrowSize, arrowSize);
    case 'bottom':
      return styled.css(_templateObject6$8, arrowSize, arrowSize);
  }
};

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

function Tooltip(props) {
  var overlayRef = React.useRef();
  var targetRef = React.useRef();

  var _usePopoverPosition = usePopoverPosition(props, targetRef, overlayRef),
      _usePopoverPosition2 = slicedToArray(_usePopoverPosition, 4),
      position$$1 = _usePopoverPosition2[0],
      placement$$1 = _usePopoverPosition2[1],
      show = _usePopoverPosition2[2],
      setShow = _usePopoverPosition2[3];

  return React__default.createElement(
    React.Fragment,
    null,
    show && ReactDOM.createPortal(React__default.createElement(
      TooltipStyle,
      {
        position: position$$1,
        placement: placement$$1,
        status: props.status
      },
      React__default.createElement(
        'div',
        {
          className: 'overlay-pane',
          style: position$$1 && { top: position$$1.top, left: position$$1.left },
          ref: overlayRef
        },
        React__default.createElement(
          'div',
          { className: 'tooltip' },
          React__default.createElement('span', { className: 'arrow' }),
          React__default.createElement(
            'div',
            { className: 'content' },
            props.icon && React__default.createElement('i', { className: 'icon ' + props.icon }),
            props.content && React__default.createElement(
              'span',
              null,
              props.content
            )
          )
        )
      )
    ), document.getElementById('overlay-container')),
    React__default.createElement(
      'div',
      {
        style: props.style,
        className: props.className,
        ref: targetRef,
        onFocus: function onFocus() {
          return props.trigger === 'focus' && setShow(true);
        },
        onBlur: function onBlur() {
          return props.trigger === 'focus' && setShow(false);
        },
        onClick: function onClick() {
          return props.trigger === 'click' && setShow(!show);
        },
        onMouseEnter: function onMouseEnter() {
          return props.trigger === 'hover' && setShow(true);
        },
        onMouseLeave: function onMouseLeave() {
          return props.trigger === 'hover' && setShow(false);
        }
      },
      props.children
    )
  );
}

Tooltip.propTypes = {
  eventListener: PropTypes.string,
  trigger: trigger.isRequired,
  placement: placement.isRequired,
  status: PropTypes.oneOf(statusArray),
  icon: PropTypes.string,
  content: PropTypes.string,
  children: PropTypes.node.isRequired,
  style: PropTypes.object,
  className: PropTypes.string
};

var _templateObject$C = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$u = taggedTemplateLiteral(['\n    background-color: ', ';\n    padding: ', ';\n    color: ', ';\n    border: ', ';\n    border-radius: ', ';\n    display: flex;\n    align-items: center;\n    width: 25rem;\n    margin: 0.25rem 0.5rem;\n    opacity: 0.9;\n    transition: all 150ms ease-out;\n    &&.animation{\n      transform: translateX(', '110%);\n      height: 0;\n      margin: 0;\n    }\n\n    .title {\n      font-weight: 800;\n      margin-right: 0.25rem;\n    }\n    > .content-container {\n      line-height: 1.25;\n\n      > .message {\n        font-weight: 300;\n      }\n    }\n    ', '\n    .icon {\n      font-size: 2rem;\n      margin-', ': 1.25rem;\n      padding-right: 0.7rem;\n      padding-left: 0.7rem;\n    }\n    svg {\n      width: 2.5rem;\n      height: 2.5rem;\n    }\n\n    i {\n      border-radius: ', ';\n    }\n\n    ', '\n\n    ', '\n\n    ', '\n  '], ['\n    background-color: ', ';\n    padding: ', ';\n    color: ', ';\n    border: ', ';\n    border-radius: ', ';\n    display: flex;\n    align-items: center;\n    width: 25rem;\n    margin: 0.25rem 0.5rem;\n    opacity: 0.9;\n    transition: all 150ms ease-out;\n    &&.animation{\n      transform: translateX(', '110%);\n      height: 0;\n      margin: 0;\n    }\n\n    .title {\n      font-weight: 800;\n      margin-right: 0.25rem;\n    }\n    > .content-container {\n      line-height: 1.25;\n\n      > .message {\n        font-weight: 300;\n      }\n    }\n    ', '\n    .icon {\n      font-size: 2rem;\n      margin-', ': 1.25rem;\n      padding-right: 0.7rem;\n      padding-left: 0.7rem;\n    }\n    svg {\n      width: 2.5rem;\n      height: 2.5rem;\n    }\n\n    i {\n      border-radius: ', ';\n    }\n\n    ', '\n\n    ', '\n\n    ', '\n  ']),
    _templateObject3$p = taggedTemplateLiteral(['\n        cursor: pointer;\n\n        &:hover {\n          opacity: 1;\n        }\n      '], ['\n        cursor: pointer;\n\n        &:hover {\n          opacity: 1;\n        }\n      ']),
    _templateObject4$g = taggedTemplateLiteral(['\n        .content-container {\n          display: flex;\n          flex-direction: row;\n        }\n        border-color: ', ';\n        padding: calc(', ' / 2) ', ';\n\n        ', '\n      '], ['\n        .content-container {\n          display: flex;\n          flex-direction: row;\n        }\n        border-color: ', ';\n        padding: calc(', ' / 2) ', ';\n\n        ', '\n      ']),
    _templateObject5$d = taggedTemplateLiteral(['\n            color: ', ';\n            background-color: ', ';\n          '], ['\n            color: ', ';\n            background-color: ', ';\n          ']),
    _templateObject6$9 = taggedTemplateLiteral(['\n        ', '\n        border-color: ', ';\n        color: ', ';\n\n        i {\n          background-color: ', ';\n          color: ', ';\n        }\n\n        ', '\n      '], ['\n        ', '\n        border-color: ', ';\n        color: ', ';\n\n        i {\n          background-color: ', ';\n          color: ', ';\n        }\n\n        ', '\n      ']),
    _templateObject7$5 = taggedTemplateLiteral(['\n            .content-container {\n              display: flex;\n              flex-direction: row;\n            }\n          '], ['\n            .content-container {\n              display: flex;\n              flex-direction: row;\n            }\n          ']),
    _templateObject8$3 = taggedTemplateLiteral(['\n            background-image: linear-gradient(\n              to right,\n              ', ',\n              ', '\n            );\n            color: ', ';\n\n            i {\n              background-color: ', ';\n              color: ', ';\n            }\n          '], ['\n            background-image: linear-gradient(\n              to right,\n              ', ',\n              ', '\n            );\n            color: ', ';\n\n            i {\n              background-color: ', ';\n              color: ', ';\n            }\n          ']),
    _templateObject9$3 = taggedTemplateLiteral(['\n  pointer-events: none;\n  top: 0;\n  left: 0;\n  height: 100%;\n  width: 100%;\n  display: flex;\n  position: absolute;\n  z-index: 1000;\n  ', '\n  .overlay-pane {\n    pointer-events: auto;\n    position: static;\n    box-sizing: border-box;\n    z-index: 1000;\n    display: flex;\n    max-width: 100%;\n    max-height: 100%;\n    flex-direction: ', ';\n  }\n'], ['\n  pointer-events: none;\n  top: 0;\n  left: 0;\n  height: 100%;\n  width: 100%;\n  display: flex;\n  position: absolute;\n  z-index: 1000;\n  ', '\n  .overlay-pane {\n    pointer-events: auto;\n    position: static;\n    box-sizing: border-box;\n    z-index: 1000;\n    display: flex;\n    max-width: 100%;\n    max-height: 100%;\n    flex-direction: ', ';\n  }\n']);

var ToastrStyle = styled__default.div(_templateObject$C, function (_ref) {
  var theme = _ref.theme,
      status = _ref.status,
      destroyByClick = _ref.destroyByClick,
      hasIcon = _ref.hasIcon,
      isRight = _ref.isRight;
  return styled.css(_templateObject2$u, theme.toastrBg, theme.toastrPadding, theme.toastrFg, theme.toastrBorder, theme.toastrBorderRadius, !isRight && '-', destroyByClick && styled.css(_templateObject3$p), theme.dir === 'rtl' ? 'left' : 'right', theme.toastrIconRadius, theme.theme !== 'cosmic' && 'box-shadow: ' + theme.toastrShadow + ';', status === 'Default' && styled.css(_templateObject4$g, theme.toastrBorderColor, theme.toastrPadding, theme.toastrPadding, theme.theme === 'cosmic' && styled.css(_templateObject5$d, theme.toastrColorFg, theme.toastrDefaultBackground)), status !== 'Default' && styled.css(_templateObject6$9, !hasIcon && styled.css(_templateObject7$5), theme['color' + status], theme['color' + status], theme['color' + status], theme.colorWhite, theme.theme === 'cosmic' && styled.css(_templateObject8$3, leftColor$1(status, theme), theme['btn' + status + 'Bg'], theme.toastrColorFg, theme.colorWhite, theme['color' + status])));
});

var heroPercentage$1 = {
  Primary: 20,
  Success: 20,
  Warning: 10,
  Info: -10,
  Danger: -20,
  Secondary: 20
};

var leftColor$1 = function leftColor(status, theme) {
  return curriedAdjustHue(heroPercentage$1[status], theme['btn' + status + 'Bg']);
};

var ToastrContainer = styled__default.div(_templateObject9$3, function (_ref2) {
  var position = _ref2.position;

  switch (position) {
    case 'topStart':
      return 'justify-content: flex-start;align-items: flex-start;';
    case 'topEnd':
      return 'justify-content: flex-end;align-items: flex-start;';
    case 'bottomStart':
      return 'justify-content: flex-start;align-items: flex-end;';
    case 'bottomEnd':
      return 'justify-content: flex-end;align-items: flex-end;';
  }
}, function (_ref3) {
  var isTop = _ref3.isTop;
  return isTop ? 'column-reverse' : 'column';
});

function Item$1(props) {
  var _useState = React.useState(true),
      _useState2 = slicedToArray(_useState, 2),
      show = _useState2[0],
      setShow = _useState2[1];

  var _useState3 = React.useState('animation'),
      _useState4 = slicedToArray(_useState3, 2),
      animation = _useState4[0],
      setAnimation = _useState4[1];

  var layout = React.useContext(layoutContext);

  React.useEffect(function () {
    if (props.duration > 0) {
      setTimeout(function () {
        destroyItem();
      }, props.duration);
    }
    if (animation === 'animation') {
      setTimeout(function () {
        setAnimation('');
      }, 10);
    }
  }, []);

  var destroyItem = function destroyItem() {
    setAnimation('animation');
    setTimeout(function () {
      setShow(false);
    }, 100);
  };

  var onClick = function onClick() {
    if (props.destroyByClick) {
      destroyItem();
    }
  };
  return show && ReactDOM.createPortal(React__default.createElement(
    ToastrStyle,
    _extends({
      isRight: isRightPosition(layout.dir, props.position),
      className: animation,
      onClick: onClick
    }, props),
    props.icon && props.hasIcon && React__default.createElement('i', { className: 'icon ' + props.icon }),
    React__default.createElement(
      'div',
      { className: 'content-container' },
      React__default.createElement(
        'span',
        { className: 'title' },
        props.title
      ),
      React__default.createElement(
        'div',
        { className: 'message' },
        props.message
      )
    )
  ), document.getElementById('toastr' + props.position));
}

var Toastr = React.forwardRef(function (props, ref) {
  var _useState = React.useState([]),
      _useState2 = slicedToArray(_useState, 2),
      items = _useState2[0],
      setItems = _useState2[1];

  var _useState3 = React.useState(false),
      _useState4 = slicedToArray(_useState3, 2),
      createParents = _useState4[0],
      setCreateParents = _useState4[1];

  var layout = React.useContext(layoutContext);

  React.useEffect(function () {
    setCreateParents(true);
  }, []);

  React.useImperativeHandle(ref, function () {
    return {
      add: function add(title, message) {
        var option = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

        var options = _extends({}, props.option, option);

        var newItems = [].concat(toConsumableArray(items));
        var push = true;
        if (options.preventDuplicates) {
          var _iteratorNormalCompletion = true;
          var _didIteratorError = false;
          var _iteratorError = undefined;

          try {
            for (var _iterator = newItems[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
              var item = _step.value;

              if (item.title === title && item.message === message) {
                push = false;
              }
            }
          } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }
            } finally {
              if (_didIteratorError) {
                throw _iteratorError;
              }
            }
          }
        }

        if (push) {
          options.position = getLogicalPosition(layout.dir, options.position);

          options.icon = options.icon === undefined && options.icons ? options.icons[options.status] : options.icon;

          newItems.push(_extends({}, options, { title: title, message: message }));
          setItems(newItems);
        }
      }
    };
  }, [items]);

  return React__default.createElement(
    React.Fragment,
    null,
    createParents && ['topStart', 'topEnd', 'bottomStart', 'bottomEnd'].map(function (position$$1) {
      return ReactDOM.createPortal(React__default.createElement(
        ToastrContainer,
        {
          position: position$$1,
          isTop: position$$1 === 'topEnd' || position$$1 === 'topStart'
        },
        React__default.createElement('div', { className: 'overlay-pane', id: 'toastr' + position$$1 })
      ), document.getElementById('overlay-container'));
    }),
    items.map(function (item, index) {
      return React__default.createElement(Item$1, _extends({ key: index }, item));
    })
  );
});

Toastr.defaultProps = {
  option: {
    position: 'topEnd',
    status: 'Primary',
    duration: 3000,
    hasIcon: true,
    destroyByClick: true,
    preventDuplicates: false
  }
};

Toastr.propTypes = {
  option: PropTypes.shape({
    position: position,
    status: PropTypes.oneOf([].concat(toConsumableArray(statusArray), ['Default'])),
    duration: PropTypes.number,
    hasIcon: PropTypes.bool,
    destroyByClick: PropTypes.bool,
    preventDuplicates: PropTypes.bool,
    icons: PropTypes.object
  })
};

var _templateObject$D = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$v = taggedTemplateLiteral(['\n      position: absolute;\n      box-sizing: border-box;\n      z-index: 1000;\n      display: flex;\n      width: 100%;\n      height: 100%;\n      min-width: 1px;\n      min-height: 1px;\n      top: 0px;\n      left: 0px;\n      .overlay-pane {\n        ', '\n        position: absolute;\n        pointer-events: auto;\n        display: flex;\n        max-width: 100%;\n        max-height: 100%;\n        box-sizing: border-box;\n        ', '\n        .context-menu-overlay {\n          border: 2px solid ', ';\n          border-radius: ', ';\n          background: ', ';\n          box-shadow: ', ';\n\n          .arrow {\n            position: absolute;\n            width: 0;\n            height: 0;\n            border-left: ', 'px solid transparent;\n            border-right: ', 'px solid transparent;\n            border-bottom: ', 'px solid ', ';\n\n            &::after {\n              position: absolute;\n              content: \' \';\n              width: 0;\n              height: 0;\n              top: 3px;\n              left: calc(50% - ', 'px);\n              border-left: ', 'px solid transparent;\n              border-right: ', 'px solid transparent;\n              border-bottom: ', 'px solid ', ';\n            }\n          }\n          ', '\n          .context-menu {\n            display: inline;\n            font-size: 0.875rem;\n            line-height: 1.5rem;\n            ul.menu-items {\n              margin: 0;\n              padding: 0.5rem 0;\n\n              .menu-item {\n                border: none;\n                white-space: nowrap;\n\n                &:first-child {\n                  border: none;\n                }\n\n                a {\n                  cursor: pointer;\n                  border-radius: 0;\n                  padding: 0;\n\n                  .menu-icon {\n                    font-size: 1.5rem;\n                    width: auto;\n                  }\n\n                  .menu-title {\n                    padding: 0.375rem 3rem;\n                    ', '\n                  }\n\n                  .menu-icon ~ .menu-title {\n                    padding-', ': 0;\n                  }\n\n                  .menu-icon:first-child {\n                    padding-', ': 1rem;\n                  }\n                }\n              }\n            }\n            .menu-items .menu-item a {\n              color: ', ';\n              font-weight: ', ';\n\n              .menu-icon {\n                color: ', ';\n              }\n\n              &:focus,\n              &:active,\n              &:hover {\n                color: ', ';\n                background: ', ';\n                font-weight: ', ';\n\n                .menu-icon {\n                  color: ', ';\n                }\n              }\n            }\n          }\n        }\n      }\n    '], ['\n      position: absolute;\n      box-sizing: border-box;\n      z-index: 1000;\n      display: flex;\n      width: 100%;\n      height: 100%;\n      min-width: 1px;\n      min-height: 1px;\n      top: 0px;\n      left: 0px;\n      .overlay-pane {\n        ', '\n        position: absolute;\n        pointer-events: auto;\n        display: flex;\n        max-width: 100%;\n        max-height: 100%;\n        box-sizing: border-box;\n        ', '\n        .context-menu-overlay {\n          border: 2px solid ', ';\n          border-radius: ', ';\n          background: ', ';\n          box-shadow: ', ';\n\n          .arrow {\n            position: absolute;\n            width: 0;\n            height: 0;\n            border-left: ', 'px solid transparent;\n            border-right: ', 'px solid transparent;\n            border-bottom: ', 'px solid ', ';\n\n            &::after {\n              position: absolute;\n              content: \' \';\n              width: 0;\n              height: 0;\n              top: 3px;\n              left: calc(50% - ', 'px);\n              border-left: ', 'px solid transparent;\n              border-right: ', 'px solid transparent;\n              border-bottom: ', 'px solid ', ';\n            }\n          }\n          ', '\n          .context-menu {\n            display: inline;\n            font-size: 0.875rem;\n            line-height: 1.5rem;\n            ul.menu-items {\n              margin: 0;\n              padding: 0.5rem 0;\n\n              .menu-item {\n                border: none;\n                white-space: nowrap;\n\n                &:first-child {\n                  border: none;\n                }\n\n                a {\n                  cursor: pointer;\n                  border-radius: 0;\n                  padding: 0;\n\n                  .menu-icon {\n                    font-size: 1.5rem;\n                    width: auto;\n                  }\n\n                  .menu-title {\n                    padding: 0.375rem 3rem;\n                    ', '\n                  }\n\n                  .menu-icon ~ .menu-title {\n                    padding-', ': 0;\n                  }\n\n                  .menu-icon:first-child {\n                    padding-', ': 1rem;\n                  }\n                }\n              }\n            }\n            .menu-items .menu-item a {\n              color: ', ';\n              font-weight: ', ';\n\n              .menu-icon {\n                color: ', ';\n              }\n\n              &:focus,\n              &:active,\n              &:hover {\n                color: ', ';\n                background: ', ';\n                font-weight: ', ';\n\n                .menu-icon {\n                  color: ', ';\n                }\n              }\n            }\n          }\n        }\n      }\n    ']),
    _templateObject3$q = taggedTemplateLiteral(['\n        .arrow {\n          left: ', 'px;\n          top: calc(50% - ', 'px);\n          transform: rotate(270deg);\n        }\n      '], ['\n        .arrow {\n          left: ', 'px;\n          top: calc(50% - ', 'px);\n          transform: rotate(270deg);\n        }\n      ']),
    _templateObject4$h = taggedTemplateLiteral(['\n        .arrow {\n          right: ', 'px;\n          top: calc(50% - ', 'px);\n          transform: rotate(90deg);\n        }\n      '], ['\n        .arrow {\n          right: ', 'px;\n          top: calc(50% - ', 'px);\n          transform: rotate(90deg);\n        }\n      ']),
    _templateObject5$e = taggedTemplateLiteral(['\n        .arrow {\n          bottom: calc(-', 'px + 1px);\n          left: calc(50% - ', 'px);\n          transform: rotate(180deg);\n        }\n      '], ['\n        .arrow {\n          bottom: calc(-', 'px + 1px);\n          left: calc(50% - ', 'px);\n          transform: rotate(180deg);\n        }\n      ']),
    _templateObject6$a = taggedTemplateLiteral(['\n        .arrow {\n          top: calc(-', 'px + 2px);\n          left: calc(50% - ', 'px);\n        }\n      '], ['\n        .arrow {\n          top: calc(-', 'px + 2px);\n          left: calc(50% - ', 'px);\n        }\n      ']);

var ContextMenuStyle = styled__default.div(_templateObject$D, function (_ref) {
  var theme = _ref.theme,
      placement = _ref.placement,
      position = _ref.position;

  var arrowSize = theme.contextMenuArrowSize;
  var arrowContentSize = arrowSize - 2;
  var arrowRound = Math.round(-arrowSize - arrowSize / 2 + 1);

  return styled.css(_templateObject2$v, overlayPane$2(placement), !position && 'visibility: hidden;', theme.contextMenuBorder, theme.contextMenuBorderRadius, theme.contextMenuBg, theme.contextMenuShadow, arrowSize, arrowSize, arrowSize, theme.contextMenuBorder, arrowContentSize, arrowContentSize, arrowContentSize, arrowContentSize, theme.contextMenuBg, placementArrow$2(placement, arrowSize, arrowRound), theme.dir === 'rtl' && 'text-align: right;', theme.dir === 'rtl' ? 'right' : 'left', theme.dir === 'rtl' ? 'right' : 'left', theme.contextMenuFg, theme.fontWeightNormal, theme.contextMenuFg, theme.contextMenuActiveFg, theme.contextMenuActiveBg, theme.fontWeightNormal, theme.contextMenuActiveFg);
});

var overlayPane$2 = function overlayPane(placement) {
  switch (placement) {
    case 'right':
      return 'transform: translateX(15px);';
    case 'left':
      return 'transform: translateX(-15px);';
    case 'top':
      return 'transform: translateY(-15px);';
    case 'bottom':
      return 'transform: translateY(15px);';
  }
};
var placementArrow$2 = function placementArrow(placement, arrowSize, arrowRound) {
  switch (placement) {
    case 'right':
      return styled.css(_templateObject3$q, arrowRound, arrowSize / 2);
    case 'left':
      return styled.css(_templateObject4$h, arrowRound, arrowSize / 2);
    case 'top':
      return styled.css(_templateObject5$e, arrowSize, arrowSize);
    case 'bottom':
      return styled.css(_templateObject6$a, arrowSize, arrowSize);
  }
};

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

function ContextMenu(props) {
  var overlayRef = React.useRef();
  var targetRef = React.useRef();

  var _usePopoverPosition = usePopoverPosition(props, targetRef, overlayRef),
      _usePopoverPosition2 = slicedToArray(_usePopoverPosition, 4),
      position$$1 = _usePopoverPosition2[0],
      placement$$1 = _usePopoverPosition2[1],
      show = _usePopoverPosition2[2],
      setShow = _usePopoverPosition2[3];

  return React__default.createElement(
    React.Fragment,
    null,
    show && ReactDOM.createPortal(React__default.createElement(
      ContextMenuStyle,
      { position: position$$1, placement: placement$$1 },
      React__default.createElement(
        'div',
        {
          className: 'overlay-pane',
          style: position$$1 && { top: position$$1.top, left: position$$1.left },
          ref: overlayRef
        },
        React__default.createElement(
          'div',
          { className: 'context-menu-overlay' },
          React__default.createElement('span', { className: 'arrow' }),
          React__default.createElement(Menu, {
            className: 'context-menu',
            Link: props.Link,
            items: props.items,
            toggleSidebar: function toggleSidebar() {
              return setShow(false);
            }
          })
        )
      )
    ), document.getElementById('overlay-container')),
    React__default.createElement(
      'div',
      {
        style: props.style,
        className: props.className,
        ref: targetRef,
        onClick: function onClick() {
          return setShow(!show);
        }
      },
      props.children
    )
  );
}

ContextMenu.propTypes = {
  items: menuItemsType,
  eventListener: PropTypes.string,
  placement: placement.isRequired,
  children: PropTypes.node.isRequired,
  Link: PropTypes.object.isRequired,
  style: PropTypes.object,
  className: PropTypes.string
};

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

exports.Actions = Actions;
exports.Menu = Menu;
exports.Badge = Badge;
exports.GlobalStyle = GlobalStyle;
exports.Overlay = Overlay;
exports.Search = Search$1;
exports.User = User;
exports.Alert = Alert;
exports.Spinner = Spinner;
exports.Progress = Progress;
exports.Popover = Popover;
exports.Tooltip = Tooltip;
exports.Toastr = Toastr;
exports.ContextMenu = ContextMenu;
exports.AccordionItem = AccordionItem;
exports.Accordion = Accordion;
exports.Card = Card;
exports.FlipCard = FlipCard;
exports.RevealCard = RevealCard;
exports.Container = Container;
exports.Row = Row;
exports.Col = Col;
exports.Sidebar = Sidebar;
exports.SidebarBody = SidebarBody;
exports.Tabs = Tabs;
exports.Tab = Tab;
exports.Layout = Layout;
exports.LayoutHeader = LayoutHeader;
exports.LayoutContent = LayoutContent;
exports.LayoutFooter = LayoutFooter;
exports.LayoutContainer = LayoutContainer;
exports.LayoutColumns = LayoutColumns;
exports.LayoutStyle = LayoutStyle;
exports.LayoutContext = layoutContext;
exports.List = List;
exports.ListItem = ListItem;
exports.InputGroup = InputGroup;
exports.Checkbox = Checkbox;
exports.Select = Select;
exports.Radio = Radio;
exports.Button = Button;
exports.ButtonLink = ButtonLink;
exports.ButtonInput = ButtonInput;
exports.ButtonStyle = ButtonStyle;
exports.Chat = Chat;
exports.ChatMessages = Messages;
exports.ChatForm = ChatForm;
exports.getPhysicalPosition = getPhysicalPosition;
exports.getLogicalPosition = getLogicalPosition;
exports.isRightPosition = isRightPosition;
exports.isTopPosition = isTopPosition;
